;  $Id: DEVFDHD.ASM 1.32 2003/03/20 17:04:44 thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1992-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:DEVFDHD.ASM
;
; Copyright (c) 1994-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary
;
; This is the initialization code for the combo floppy/hard
; disk driver.
;
; $DOCHISTORY
; 03/29/1999 de  Added FAT32 IOCTL calls
; 02/19/1999 de  Changed parameters to build_bpb() and check_bpb(), they have to
;		 know what FAT type to expect or they will do bad things.
; 02/18/1999 de  Added FAT32 support.  Except as noted above all code
;		 for this support is inside condition USING_FAT32 blocks.
; 02/15/1999 de  Added EBIOS LBA support. Except as noted above all code
;		 for this support is inside condition USING_BIG_DISKS blocks.
; 01/25/1999 bt  SPR 1882
; 07/29/1998 dg  PBEX partitions can now be processed first or last.
; 07/23/1998 de	 Now double buffer int 13h fn 5 (format)
; 08/31/1992 dg  Created by Drew Gislason
;--------------------------------------------------------------------
include use186.inc
include macros.inc
include devhdr.inc
include dostruct.inc
include devfdhd.inc
include profile.inc


WRITES_ENABLED	= 1

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		COMMAND TABLE
;
;  This table lists all the commands this driver supports.
;  All the commands can expect the following registers upon
;  entry.  These regisers are set by a "generic" service
;  routine that ALL internal ROM-DOS device drivers use.
;
;				offset in request header
;	DS	= DGROUP		---
;	AL	= unit			01H
;	AH	= media			0DH
;	ES:DI	= transfer buffer	0EH
;	CX	= count			12H
;	DX	= start			14H
;
cBegCode

	assume	cs:_TEXT, ds:DGROUP

	; "generic" services available to internal devices
	EXTRN	dev_serv:near
	EXTRN	dev_cmd_err:near, dev_err_exit:near
	EXTRN	dev_busy_exit:near, dev_err_cnt:near
	EXTRN	dev_exit:near

	EXTRN	_printf:near
	EXTRN	_con_getkey:near
	EXTRN   _LMULU:near

IF (FLOPX OR FDHDX)	;; _flopx allocates extern data and code for _hardx
IF FLOPX
	extrn  	flopx_init:near
ELSE
	extrn	fdhd_init:near		; moved to DEVFDHDI.ASM
ENDIF
	public	fdhd_media, fdhd_bpb, fdhd_read
IF USING_BIG_DISKS
	public	fdhd_write_verify
ENDIF
	public	fdhd_write, fdhd_removable, fdhd_gen_ioctl
	public	fdhd_getlog, fdhd_setlog, fdhd_query
	public	cmdtbl
ELSE
	extrn   hardx_init:near
	extrn   fdhd_media:near,  fdhd_bpb:near,       fdhd_read:near
IF USING_BIG_DISKS
	extrn	fdhd_write_verify
ENDIF
	extrn   fdhd_write:near,  fdhd_removable:near, fdhd_gen_ioctl:near
	extrn   fdhd_getlog:near, fdhd_setlog:near,    fdhd_query:near
ENDIF
cmdtbl:
IF FLOPX
	dw	flopx_init	; 00H  init
ELSEIF HARDX
	dw	hardx_init	; 00H  init
ELSE
	dw	fdhd_init	; 00H  init
ENDIF
	dw	fdhd_media	; 01H  media check
	dw	fdhd_bpb	; 02H  build a bpb
	dw	dev_cmd_err	; 03H
	dw	fdhd_read	; 04H  device read
	dw	dev_cmd_err	; 05H
	dw	dev_cmd_err	; 06H
	dw	dev_cmd_err  	; 07H

IF WRITES_ENABLED
	dw	fdhd_write	; 08H  write
IF USING_BIG_DISKS
	dw	fdhd_write_verify ; 09H  write/verify supported only with EBIOS
ELSE
	dw	fdhd_write	; 09H  write w/ verify not support
ENDIF
ELSE
	dw	dev_cmd_err  	; 08H  write
	dw	dev_cmd_err  	; 09H  write and verify
ENDIF
	dw	dev_cmd_err	; 0AH
	dw	dev_cmd_err	; 0BH
	dw	dev_cmd_err	; 0CH
	dw	dev_exit	; 0DH  device open
	dw	dev_exit	; 0EH  device close
	dw	fdhd_removable	; 0FH  removable media
	dw	dev_cmd_err	; 10H
	dw	dev_cmd_err	; 11H
	dw	dev_cmd_err	; 12H
	dw	fdhd_gen_ioctl	; 13H  generic ioctl (440DH)
	dw	dev_cmd_err	; 14H
	dw	dev_cmd_err	; 15H
	dw	dev_cmd_err	; 16H
	dw	fdhd_getlog	; 17H  get logical device
	dw	fdhd_setlog	; 18H  set logical device
	dw	fdhd_query	; 19H  query ioctl (4411H)
cmdend:

cEndCode

IF HARDX
cBegData
	assume	cs:_TEXT, ds:DGROUP
	extrn	_ptrsav:dword
cEndData
cBegUData
	assume	cs:_TEXT, ds:DGROUP
	extrn	num_flop_units:byte
cEndUData
ENDIF



;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		DEVICE HEADER
;
;  This is the actual device header.  It must be in RAM
;  so the pointer to the next device driver can change.
;
_DEVDATA segment byte public 'DEVDATA'

	ASSUME CS:_DEVDATA ,DS:_DEVDATA
	EXTRN	dev_fstrat:NEAR, cmd_ptr:DWORD

	; Device Attributes (08C2H)
	; xxxx 1xxx xxxx xxxx	Open/Close/RM
	; xxxx xxxx 1xxx xxxx	Query IOCTL (4411H)
	; xxxx xxxx x1xx xxxx	Generic IOCTL (440CH)
	; xxxx xxxx xxxx xx1x	Driver Supports 32 bit sectors


; The device name according to SYSGEN.ASM
IF     FLOPX
	PUBLIC _flopx
_flopx:
ELSEIF HARDX
	PUBLIC _hardx
_hardx:
ELSE
	PUBLIC _fdhdx
_fdhdx:
ENDIF
	dw	-1,-1		; ptr to next device driver
	dw	08C2H		; device attribute
	dw	dev_fstrat	; strategy routine
IF FLOPX
	dw	flopx_serv	; service routine
ELSEIF HARDX
	dw	hardx_serv
ELSE
	dw	fdhd_serv	; service routine
ENDIF

IF (FLOPX OR FDHDX)
	public	hdr_num_units
	hdr_num_units	DB	0		; unit count
ELSE
	public	hardx_hdr_num_units
	hardx_hdr_num_units db  0		; unit count
ENDIF


IF (HARDX OR FDHDX)
	hdisk		DB	HARDDISK	; 80H
ELSE
			DB	0
ENDIF
			DB	1		; ???
			DB	0		; ???

IF FLOPX
	public	flopx_serv
flopx_serv:
ELSEIF HARDX
	public hardx_serv
hardx_serv:
	push	bx
	push	es

	mov	bx, DGROUP
	mov	es, bx
	assume	es:DGROUP

	mov	al, es:num_flop_units
	les	bx, es:[_ptrsav]
	add	es:[bx][UNIT], al
	mov	al, es:[bx][UNIT]

	pop	es
	pop	bx
	assume	es:nothing
ELSE
	public	fdhd_serv
fdhd_serv:
ENDIF
	; calculate # of commands and where to find cmdtbl
	push	AX
	push	SI
	mov	AH, (OFFSET cmdend - OFFSET cmdtbl)/2
	mov	SI, OFFSET cmdtbl

	; jump to the generic service routine in ROM (CODE SEG)
	jmp	DWORD PTR CS:[cmd_ptr]

_DEVDATA ENDS


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		DATA SEGMENT
;
; NOTE: Floppy Driver Supports a MAXIMUM of 4 Floppies
;
cBegData

	assume	cs:_TEXT, ds:DGROUP

IF (FLOPX OR FDHDX)		;; _flopx allocates extern data for _hardx
	EXTRN	_ptrsav:DWORD
	EXTRN	_flop_chg_msg:BYTE, _flop_chg_off:WORD
	EXTRN	_umb_arena:WORD
	EXTRN   _trustMe:BYTE
	extrn   _paras_total:word
	extrn	_def_volume:byte
	extrn   _def_fatid:byte

; DEBUGGING!
;tempstr	db	"%p:%p, %d",10,0

	; Disk Base Table (INT 1EH), fields that are 0 use the BIOS values
	public	_new_base_table
	_new_base_table	DB	0,0,0,0,3fH,0,0,0,0,0,0

	; HARD-CODED BPB'S
	; NOTE: DO NOT CHANGE THE ORDER OF THESE (used as an array)
		public	FD_bpb, hardbpb
	FC_bpb	BiosParameterBlock <512,1,1,2,112, 360,0FCH,2, 9,1,0>	; 180K disk
	FD_bpb	BiosParameterBlock <512,2,1,2,112, 720,0FDH,2, 9,2,0>	; 360K disk
	FE_bpb	BiosParameterBlock <512,1,1,2, 64, 320,0FEH,1, 8,1,0>	; 160K disk
	FF_bpb	BiosParameterBlock <512,2,1,2,112, 640,0FFH,1, 8,2,0>	; 320K disk
	hardbpb	BiosParameterBlock <512,1,1,2,224,2400,0F9H,7,15,2,0>	; 1.2M disk
		BiosParameterBlock <512,2,1,2,112,1440,0F9H,3, 9,2,0>	; 720K disk
		BiosParameterBlock <512,1,1,2,224,2880,0F0H,9,18,2,0>	; 1.4M disk
		public	hardtraks
	hardtraks	DB 40-1, 80-1, 80-1, 80-1

	; Template for hard disk BPB
	public	hdisk_bpb
	hdisk_bpb BiosParameterBlock <512,0,1,2,512,0,0F8H,0,0,0,0>


IF USING_BIG_DISKS
	; This structure is used to pass LBA address information to a BIOS
	; with Enhanced Disk BIOS interface support (see DOSTRUCT.INC).
	;
		public sEbiosPacket
	sEbiosPacket	DeviceAddressPacket <>
ENDIF

	; This var allows SYSGEN.ASM to access the minimum number of floppies
	;
	public _min_flops
	_min_flops	DB MINFLOPS
ENDIF ;; (FLOPX OR FDHDX)	;; _flopx allocates extern data for _hardx

cEndData



cBegUdata

	assume	cs:_TEXT, ds:DGROUP

IF (FLOPX OR FDHDX)		;; _flopx allocates extern data for _hardx
	EXTRN	drive_table_ptr:WORD
	EXTRN	_bios_err:byte
	extrn	_DMA_buff:byte

	PUBLIC	num_units, base_flop_drive
	PUBLIC	num_flop_units, num_flop_drives, _num_hparts, _num_hdrives

	num_units	DB	?	; total unit count

	; DOS drive number of the first floppy drive (FLOPX/FDHDX unit 0)
	;
	base_flop_drive	DB	?	; 0=A, 1=B, etc..

	; variables for floppies
	; note: "num_flop_units" used in SYSGEN.ASM
	num_flop_drives	DB	?	; # of physical floppy drives
	num_flop_units	DB	?	; # of floppy units (usually 2)
IFDEF SPLITFLOPS
	public	num_extra_flops
	num_extra_flops	DB	?	; # "extra" floppies beyond 2
	public floppies_split
	floppies_split	db	?	; 0 if not, 1 if yes
ENDIF

	; Hard disks only, number of "DOS" partitions
	_num_hparts	DB	?	; total units
	_num_hdrives	DB	?	; total drives

	PUBLIC	_drive_table, _bpbptr

	; The BPB structures (for both FLOPPIES and HD)
	_drive_table	DB	(MAXUNITS * size DriveDataTable) DUP (?)
	_bpbptr		DW	MAXUNITS DUP (?)


	; Hard disks only, record the physical attributes of each disk
	;
		public	_drvparm

	_drvparm 	DB	(MAXHDISKS * size BiosDriveParameters) DUP (?)


	; Temporary variables used in determining track/head/sector
	;
	public	_hhead, _hsect, _htrak, _hdrive, _hunit, _hstart

	_hhead		DB	?
	_hsect		DB	?
	_htrak		DW	?
	_hdrive		DB	?	; BIOS drive #
	_hunit		DB	?	; unit #
	_hstart		DD	?	; always 0 for floppy access

IF USING_BIG_DISKS


	;  This is used to determine if a partition (drive) requires
	;  LBA in order to access the drive.  Note that this determination
	;  can not be solely determined by the partition ID since the
	;  LBA required partition ID types will not be used inside of
	;  an extended partiton whose ID means LBA required.  This variable
	;  is used at init time to help determine which partitions require
	;  LBA.  Its state is later stored in the DDT_dattr field.
	;
	public init_dattr_fLBARequired
	init_dattr_fLBARequired	dw	?


	;  These are temporary variable used when we have to perform a
	;  read/write operation that crosses the LBA boundary
	;
		public	ucNextReadWriteSize	; For reference in map file
	ucNextReadWriteSize	db	?
		public	uCurrentBPS		; For reference in map file
	uCurrentBPS		dw	?
		public	ulFirstLBASector	; For reference in map file
	ulFirstLBASector	dd	?
ENDIF

IF USING_BIG_DISKS
	ucCurEbiosInfoFlags	db	0	; EBDPT_INFO_xxx (DOSTRUCT.INC)
	ucCurEbiosAttributes	db	0	; EBIOS_HAS_xxx (DOSTRUCT.INC)
	ucCurEbiosWriteType	db	0	; 2 if Write/verify else 0
ENDIF
		public MotherPartStart
	MotherPartStart		dd 	0
IF USING_FAT32
        ucCurFatType            db      ?       ; 20h=FAT32, 40h=FAT16, 0=FAT12
        fIsFAT32GenIoctlCall    db      0
ENDIF

	; Faked Dual Floppy variables
	; Default fake_drive to A: during boot
	public	fake_drive
	fake_drive	DB	0	; 0=A, 1=B, etc...
	media_byte	DB	?	; used during getbpb
	temp		DB	?	; used during init

	public _default_HST
	; holds the default (BIOS) Head Settling Time value in the DBT
	; This is the time required between the end of a seek and the
	; start of an actual read/write operation. We can speed up
	; our operations by reducing this delay value when it is safe
	; to do so, as when: 1) We want to do a read and have already
	; read from the drive at least once without any subsequent errors
	; and 2) We want to write to the disk and the heads have already
	; been positioned to the target track.
	;
	_default_HST    db      0Fh

	public fast_reads_OK
	; 1= have successfully read one or more sectors using this DBT
	; and will use the FAST_HST (vs. _default_HST) for reads.
	; 0= encountered an error or changed diskettes.
	fast_reads_OK 	db	0

	; Pass count for HD init to determine which type of partitions
	; we are looking for at a given time.
	;
		public	hd_init_pass
	hd_init_pass	DB	?	; used in HD init

	; internal IOCTL calls
	public	sectlist
	errcnt		DB	?
	fmtcmd		DB	?
	verifysecs	DB	?
	sectlist	DB	4 * MAX_IOCTL_SPT dup (?)
	do_write0	DB	?

	; for restoring on reboot
	public	old19, old1E
	old19		DD	?
	old1E		DD	?

	; see explanation at top of file
IFDEF FLOPCFG
	PUBLIC	_disk_in_drive
	_disk_in_drive	DB	?	; TRUE if floppy disk in the drive
ENDIF

	; These items are for avoiding DMA overruns (across 64K blocks)
	; they are also used to read across tracks
	;
	; NOTE: _DMA_buff is now in DOSASM.ASM
	;
	PUBLIC	_DMA_bpb, _DMA_start, _DMA_num, _DMA_ES, _DMA_bps
	PUBLIC	_DMA_rd

	_DMA_bpb	DW	?	; pointer to BPB in question
	_DMA_start	DW	?	; starting sector
	_DMA_num	DW	?	; number of sectors
	_DMA_ES		DW	?	; ES of transfer buffer
	_DMA_bps	DW	?	; bytes/sector
	_DMA_rd		DB	?	; read or write operation?

	; for change line stuff
	; bios_drive	DB	?	; no longer needed, now test bit 80H

	bios_AX		label word	; do NOT move this field
	bios_sectors	DB	?	; do NOT move this field
	bios_cmd	DB	?	; do NOT move this field
	bios_bps	DW	?
	bios_count	DB	?
	bios_cur_sect	DB	?
	bios_dma	DB	?
	bios_CX		DW	?
	bios_DS		DW	?
	bios_buff	DD	?

ELSE
	; spr1398: The DOS drive number of the first hard drive (HARDX unit 0).
	;
	public base_hard_drive
	base_hard_drive	DB	?	; 0=A, 1=B, etc..
ENDIF ;; (FLOPX OR FDHDX)	;; _flopx allocates extern data for _hardx

cEndUdata


cBegCode

	assume	cs:_TEXT, ds:DGROUP

IF (FLOPX OR FDHDX) 		;; _flopx allocates extern data for _hardx
	c_extrn getDS,near
	c_extrn getDEVDATA,near
	c_extrn	buf_get_scratch,near
	extrn getDGROUP:near
	extrn clk_get_ticks:near
	extrn GetBiosDriveParameterTable:near

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   REMOVABLE MEDIA (function 0FH)
;
;   On Entry
;	AL = unit
;
fdhd_removable:

	ENTER_FUNCTION

	cmp	AL, num_flop_units
	jae	FRHARD

	EXIT_FUNCTION

	jmp	dev_exit	; busy bit FALSE (removable)
FRHARD:

	EXIT_FUNCTION

	jmp	dev_busy_exit	; busy bit TRUE (not removable)


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   GET LOGICAL DEVICE (function 17H)
;
;   On Entry
;	AL = unit
;
fdhd_getlog:

	ENTER_FUNCTION

	;  Determine if there is only one logical device for this unit
	;
	call	getDriveTable	; SI = drive_table for this unit
one_logical_device:
	mov	AL, 0		;  Assume only one logical device
	test	[SI].DDT_dattr, DATTR_SHARES_PHYSICAL_DEVICE
	jz	record_logical_device

	; we have more than 1 unit mapped to a physical drive
	mov	AL, fake_drive
multi_device:
	inc	AL

record_logical_device:
	les	BX, [_ptrsav]
	mov	ES:[BX+UNIT], AL

	EXIT_FUNCTION

	jmp	dev_exit


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  SET LOGICAL DEVICE (function 18H)
;
;  This allows programs on a 1 floppy system to control
;  the "current" drive (A: or B:) of that single floppy.
;
fdhd_setlog:

	ENTER_FUNCTION

	;  Determine if there is only one logical device for this unit
	;
	call	getDriveTable	; SI = drive_table for this unit
	test	[SI].DDT_dattr, DATTR_SHARES_PHYSICAL_DEVICE
	jz	one_logical_device

	; record this unit (in AL)
	call	set_fake_drive

	EXIT_FUNCTION

	jmp	short multi_device


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   QUERY GENERIC IOCTL (function 19H)
;
;   Does this driver support this particular IOCTL function?
;   This call responds to INT 21H, 4410H, 4411H.
;
;   On Entry
;	AL = unit #
;
fdhd_query:

	ENTER_FUNCTION

	; does this driver support the requested function?
	call	get_ioctl_func
	or	DI, DI
	jz	FQ1

	EXIT_FUNCTION

	jmp	dev_exit

	; no, error out
FQ1:	mov	AL, ERR_BADCMD

	EXIT_FUNCTION

	jmp	dev_err_exit


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   GENERIC IOCTL (function 13H)
;
;   This is really a set of subfunctions.  It performs things
;   such as determining disk type, formatting a track, or
;   getting Media ID off of disk.
;
;   On Entry
;	AL = unit
;
	public	fdhd_gen_ioctl
fdhd_gen_ioctl:

	ENTER_FUNCTION

	; determine if this driver has the requested function
	call	get_ioctl_func
	or	DI, DI
	jz	FQ1	; no function, error!

	; we support the function, do it (but don't set the unit if
	; MS-DOS wouldn't -- QAPLPRO diagnostics will insist you insert
	; new floppies if you do).
	;
	cmp	bh, 40h
	je	no_worries

        ; 47h = set access flag
        ; These are dummied in and must actually access disk when implemented
        ;       48h = set media lock state (enh. disk drive spec)
        ;       49h = eject media in drive (enh. disk drive spec)
        ; 4Ah = (MS-DOS 7.0) lock logical volume
        ; 4Bh = (MS-DOS 7.0) lock physical volume
        ;
        cmp     bh, 47h
        jb      must_set_unit
        cmp     ah, 4Bh
        jbe     no_worries

	cmp	bh, 60h
	je	no_worries
	cmp	bh, 62h
	je	must_set_unit
	cmp	bh, 67h
	jbe	no_worries

        ; More new IOCTL calls for DOS v7, these are all dummied or not supported...
        ; 6Ah    (MS-DOS 7.0) unlock logical volume
        ; 6Bh    (MS-DOS 7.0) unlock physical volume
        ; 6Ch    (MS-DOS 7.0) get lock flag
        ; 6Dh    NOT SUPPORTED -- (MS-DOS 7.0) enumerate open files
        ; 6Eh    NOT SUPPORTED -- (MS-DOS 7.0) find swap file
        ; 6Fh    NOT SUPPORTED -- (MS-DOS 7.0) get drive map information
        ; 70h    (MS-DOS 7.0) get current lock state
        ; 71h    NOT SUPPORTED -- (MS-DOS 7.0) get first cluster
        ;
        cmp     bh, 6Ah
        jb      must_set_unit
        cmp     bh, 70h
        jbe     no_worries

    must_set_unit:
	call	set_unit

    no_worries:
	les	BX, [_ptrsav]
	les	BX, ES:[BX+IOCTL]	; get user buffer (originally DS:DX)
					; into ES:BX
	EXIT_FUNCTION

	jmp	word ptr CS:[DI]

;----------------------------
; GENERIC IOCTL CALLS
	public gen_functions
gen_functions label byte
	db	40H			   ; 440DH/0840H
	dw	offset gen_set_parms	   ; Set Block Type/Parameters

	db	41H			   ; 440DH/0841H
	dw	offset gen_write_trak	   ; Write a Trak to Device

	db	42H			   ; 440DH/0842H
	dw	offset gen_fv_tracks	   ; Format/Verify 1 or more Tracks

	db	46H			   ; 440DH/0846H
	dw	offset gen_set_sernum	   ; Set Serial # (5.0+ disks only)

        db      47H                        ; 440DH/0847H
        dw      offset gen_set_access_flag ; Set Access Flag

        ; Functions 48h and 49h are dummied in and must access disk when implemented
        ; for drives/BIOS that support EBIOS removable media support
        ;
        db      48h                                             ; 440Dh/0848h
        dw      offset gen_set_media_lock_state                 ; set media lock state

        db      49h                                             ; 440Dh/0849h
        dw      offset gen_eject_media_in_drive                 ; eject media in drive

        db      4Ah                                             ; 440Dh/084Ah
        dw      offset gen_lock_logical_volume                  ; lock logical volume

        db      4Bh                                             ; 440Dh/084Bh
        dw      offset gen_lock_physical_volume                 ; lock physical volume

	db	60H			   ; 440DH/0860H
	dw	offset gen_get_parms	   ; Get Block Type/Parameters

	db	61H			   ; 440DH/0861H
	dw	offset gen_read_trak	   ; Read a Trak from Device

	db	62H			   ; 440DH/0862H
	dw	offset gen_verify_tracks   ; Verify one or more Tracks

	db	66H			   ; 440DH/0866H
	dw	offset gen_get_sernum	   ; Get Serial # (5.0+ disk only)

        db      67H                        ; 440DH/0867H
	dw	offset gen_get_access_flag ; Get Access Flag

        db      6Ah                                             ; 440Dh/086Ah
        dw      offset gen_unlock_logical_volume                ; unlock logical volume

        db      6Bh                                             ; 440Dh/086Bh
        dw      offset gen_unlock_physical_volume               ; unlock physical volume

        db      6Ch                                             ; 440Dh/086Ch
        dw      offset gen_get_lock_flag                        ; get lock flag

        ; 6Dh    NOT SUPPORTED -- (MS-DOS 7.0) enumerate open files
        ; 6Eh    NOT SUPPORTED -- (MS-DOS 7.0) find swap file
        ; 6Fh    NOT SUPPORTED -- (MS-DOS 7.0) get drive map information

        db      70h                                              ; 440Dh/0870h
        dw      offset gen_get_current_lock_state               ; get current lock state

        ; 71h    NOT SUPPORTED -- (MS-DOS 7.0) get first cluster

        db      0

;----------------------------
;   Convert a category/function code into
;   a function pointer.
;
;   On Exit
;	CS:[DI] = function pointer
;	DI = 0 on error
;
	public get_ioctl_func
get_ioctl_func:

	ENTER_FUNCTION

	; category must be 8 (disk access)
	les	BX, [_ptrsav]
        mov     BX, ES:[BX+MEDIA]       ; get category (CX) -- category in BL, func in BH
IF USING_FAT32
        mov     byte ptr fIsFAT32GenIoctlCall, TRUE
        cmp     bl, 48h                 ; 48h = FAT32 drive
        je      gif_getfunc
        mov     byte ptr fIsFAT32GenIoctlCall, FALSE
ENDIF
        cmp     BL, 8                   ; 08h = any other disk drive type
	jnz	gif_notfound

	; look for the function
gif_getfunc:
	mov	DI, offset gen_functions

gif_nextfunc:
	mov	BL, byte ptr CS:[DI]
	cmp	BL, 0		; 0 terminated list
	jz	gif_notfound
	cmp 	BH, BL		; functions match, we have found it!
	jz	gif_found

        add     DI, 3
	jmp	short gif_nextfunc

gif_notfound:
	xor	DI, DI

	EXIT_FUNCTION

	ret

gif_found:
	inc	DI	; funcptr is 1 byte after function code

	EXIT_FUNCTION

	ret

;------------------------------------------------
;  Get Drive Table for this unit.  Preserves all registers
;  but SI. If we are splitting floppies will re-arrange the
;  array of BPB ptrs in the _bpbptr array, as far as DOS is
;  concerned, this means we are re-arranging our unit numbers.
;  But our int 13h filter addresses the DDTs directly based
;  on the BIOS drive letter and the list of DDTs is not re-ordered
;  (although the DDT.ddt_dos_drive field is updated by the split_flops
;  routine). When DOS passes a unit number we must use that as
;  an index into the BPB ptr array and then subtract that field's
;  offset to get to the start of the correct DDT. If the floppies
;  have not been split up then we can just index into the DDT array
;  directly. Floppies are only split up at the end of the FDHDX init call.
;
;  On Entry
;	AL = unit #
;  On Exit
;	DS:SI = _drive_table for this unit #
;
	public	GetDriveTable
GetDriveTable:

	ENTER_FUNCTION

	push	AX
IFDEF SPLITFLOPS
	cmp	floppies_split, 0
	jne	GDT_not_init
ENDIF
	mov	AH, SIZE DriveDataTable
	mul	AH
	add	AX, GOFFSET _drive_table
	xchg	SI, AX
IFDEF SPLITFLOPS
	jmp	short GDT_done

    GDT_not_init:
	xor	ah, ah
	shl	ax, 1			; get unit number as a word index
	mov	si, GOFFSET _bpbptr	; SI-> start of BPB ptr array array
	add	si, ax			;
	mov	si, [si]		; si -> DDT.ddt_bpb for unit
	sub	si, ddt_bpb		; si -> start of DDT for unit

    GDT_done:
ENDIF
	pop	AX

	EXIT_FUNCTION

	ret

;------------------------------------------------
;  Get/Set Serial Number (440DH, 866H/846H)
;
;  This function reads the disk for a DOS 5.0 style media
;  signature.  This actually READS(440DH/866H) or WRITES
;  (440DH/846H) the disk.
;
;  On Entry
;	AL = unit #
;	ES:BX = user buffer (originally DS:DX)
;
	EXTRN MEMCMP:NEAR
	EXTRN FMEMCPY:NEAR
	EXTRN MEMMOVE:NEAR

gen_set_sernum:
	ENTER_FUNCTION

	call	set_unit

	; make sure disk is accessible
	call	get_serial
	jc	get_ser_failed

	; get ptr to user space
	les	BX, [_ptrsav]		; write media info
	les	BX, ES:[BX+IOCTL]
	inc	BX
	inc	BX			; to user buffer + 2

   ; copy the serial number & fat string from the user buffer to the DDT
   ;
   push  DS
   push  SI
   mov   AL, [_hunit]
   call  GetDriveTable

   mov   AX, ES:[BX]
   mov   word ptr [si].DDT_serial[0], AX
   mov   AX, ES:[BX+2]
   mov   word ptr [si].DDT_serial[2], AX

   mov   AX, ES:[BX+0Fh]
   mov   word ptr [si].DDT_fatstr[0], AX
   mov   AX, ES:[BX+11h]
   mov   word ptr [si].DDT_fatstr[2], AX
   mov   AX, ES:[BX+13h]
   mov   word ptr [si].DDT_fatstr[4], AX
   mov   AX, ES:[BX+15h]
   mov   word ptr [si].DDT_fatstr[6], AX
   pop   SI
   pop   DS

IF USING_FAT32

	; See if this is a FAT32 drive and get the appropriate offset into
	; the boot sector of the disk's serial number
	;
	lea	ax, _DMA_buff.BS_BootSectorInfo.VolumeSerialNumber32
	test	ucCurFatType, DDT_FAT_TYPE_32
    	jnz	SSN_FAT32
	lea	ax, _DMA_buff.BS_BootSectorInfo.VolumeSerialNumber16

    SSN_FAT32:
	; get serial # from user space to ours
	; fmemcpy(void far *dst,void far *src,unsigned len)
	;
	push	DS			; dest: start of media info
	push	AX
	push	ES			; src: user buffer
	push	BX
	mov	AX, BOOT_ID_TOTAL_LEN	; length of all media info
	push	AX
	call	FMEMCPY

ELSE ;; USING_FAT32

	; get serial # from user space to ours
	; fmemcpy(void far *dst,void far *src,unsigned len)
	;
	push	DS			; dest: start of media info
	lea	AX, [_DMA_buff+BOOT_SERIAL]
	push	AX
	push	ES			; src: user buffer
	push	BX
	mov	AX, BOOT_ID_TOTAL_LEN	; length of all media info
	push	AX
	call	FMEMCPY

ENDIF ;; USING_FAT32

	; write out the new serial #
	call	writesector0
	jc	get_ser_failed

	EXIT_FUNCTION

	jmp	dev_exit


gen_get_sernum:
	call	set_unit

	; get the serial # off the disk
	call	get_serial
	jnc	got_sernum

	; read failed, or "FAT" not there.  error out
    get_ser_failed:
	or	ax, ax
	jz	get_ser_cant_read_disk
	mov	al, ERR_BADMEDIA

	EXIT_FUNCTION

	jmp	dev_err_exit

    get_ser_cant_read_disk:
	mov	AL, ERR_NOTREADY

	EXIT_FUNCTION

	jmp	dev_err_exit

	; got it, now return it to use
    got_sernum:
	les	BX, [_ptrsav]		; write media info
	les	BX, ES:[BX+IOCTL]	; to user buffer + 2
	inc	BX
	inc	BX			; (user buff DS:DX via INT 21H)

IF USING_FAT32

	; See if this is a FAT32 drive and get the appropriate offset into
	; the boot sector of the disk's serial number
	;
	lea	ax, _DMA_buff.BS_BootSectorInfo.VolumeSerialNumber32
	test	ucCurFatType, DDT_FAT_TYPE_32
    	jnz	GSN_FAT32
	lea	ax, _DMA_buff.BS_BootSectorInfo.VolumeSerialNumber16

    GSN_FAT32:
	; fmemcpy(void far *dst,void far *src,unsigned len)
	push	ES			; dst = user buffer
	push	BX
	push	DS			; src = start of media info
	push	AX
	mov	AX, BOOT_ID_TOTAL_LEN	; length of media info
	push	AX
	call	FMEMCPY

ELSE ;; USING_FAT32

	; fmemcpy(void far *dst,void far *src,unsigned len)
	push	ES			; dst = user buffer
	push	BX
	push	DS			; src = start of media info
	lea	AX, [_DMA_buff+BOOT_SERIAL]
	push	AX
	mov	AX, BOOT_ID_TOTAL_LEN	; length of media info
	push	AX
	call	FMEMCPY

ENDIF ;; USING_FAT32

	EXIT_FUNCTION

	jmp	dev_exit

	; returns CF set and AX <> 0 if "FAT12   " is not at FATID_STR offset
	; in the boot sector
	; returns CF set and AX == 0 if could not access disk
	;
get_serial:
	call	readsector0	; reads logical sector #0 into _DMA_buff
	mov	ax, 0
	jc	no_serial

IF USING_FAT32

	; See if this is a FAT32 drive and get the appropriate offset into
	; the boot sector of the disk's FAT ID string
	;
	lea	bx, _DMA_buff.BS_BootSectorInfo.FileSystemID32
	test	ucCurFatType, DDT_FAT_TYPE_32
    	jnz	GS_FAT32
	lea	bx, _DMA_buff.BS_BootSectorInfo.FileSystemID16

    GS_FAT32:
	cmp	word ptr [bx], 4146h	; does the string start with "FA"?
	jnz	no_serial

	mov	ax, [bx][2]		; now look for "T1" or "T3"
	and	ah, NOT 2		; turn "T3" into "T1" ("T1" unchanged)
	cmp	ax, 3154h		; so is it "FAT1" or "FAT3"?
	jnz	no_serial

ELSE ;; USING_FAT32
	; is the media info on the disk?
	; bool memcmp(char *str1,char *str2,unsigned len)
	mov	AX, GOFFSET _DMA_buff + BOOT_FATID_STR
	push	AX		; offset of fat message
	mov	AX, GOFFSET _def_fatid
	push	AX		; str2
	mov	AX, 4
	push	AX		; len
	call	MEMCMP
	or	AX, AX
	jnz	no_serial	; 0 = compared identical

ENDIF ;; USING_FAT32

	clc

	EXIT_FUNCTION

	ret

    no_serial:
	stc

	EXIT_FUNCTION

	ret

;------------------------------------------------
;  Get Parameters for Block Device (440DH, 0860h/4860h)
;
;  On Entry
;	AL = unit #
;	ES:BX = user buffer
;
	public	gen_get_parms
gen_get_parms:

	ENTER_FUNCTION

	; get DDT for this unit
	call	getDriveTable		; DS:SI = DrvDataTable structure
	push	SI

	; copy device type data to user space
	mov	DI, BX
	inc	DI			; ES:DI = user buffer+1
	add	SI, ddt_dtype		; DS:SI = device type data
	mov	CX, 5
	cld
	rep	MOVSB

	;  Only return some of the DDT_dattr field
	;
	and	es:[bx+2], DATTR_NOTREMOVABLE OR DATTR_SUPPORTS_CHANGELINE

	; set media type code
	mov	byte ptr ES:[DI], 0
	cmp	byte ptr [SI-5], 0	; device type code, 0=360K
	jnz	not_360K
	inc	byte ptr ES:[DI]
not_360K:
	inc	DI

	; copy the "drive" or "current disk" BPB structure to user space
	; for example, a 360K "disk" might be in a 1.2M "drive"
	pop	SI
	test	byte ptr ES:[BX], 1	; Get BPB for disk or drive?
	jz	disk
	add	SI, ddt_bpb
	jmp	short set_bpb
disk:
	add	SI, ddt_defbpb
set_bpb:
	mov	CX, FAT16_BPB_SIZE	; SIZE BiosParameterBlock
IF USING_FAT32
        cmp     byte ptr fIsFAT32GenIoctlCall, TRUE
        jne     copy_bpb
        mov     cx, SIZE BiosParameterBlock
ENDIF
copy_bpb:
	cld
	rep	MOVSB
;  5-13-02  BT
;
;  Testing demonstrated that MS does not do this.  The reason this code
;  was placed here is unknown
;
IF 0
IF USING_FAT32
        cmp     byte ptr fIsFAT32GenIoctlCall, TRUE
	jne	dealt_with_MS_Format_bug
	mov	di, bx
	mov	ax, word ptr es:[di].DP_Bpb.BPB_num_sec
	or	ax, ax
	jz	dealt_with_MS_Format_bug
	mov	word ptr es:[di].DP_Bpb.BPB_lnumsec, ax
    dealt_with_MS_Format_bug:
ENDIF ;; IF USING_FAT32
ENDIF ;; IF 0
	EXIT_FUNCTION

	jmp	dev_exit


;------------------------------------------------
;  Set Access Flag (440DH, 0847H)
;  Does nothing at all.
;  On Entry
;	   AL = unit #
;	ES:BX = user buffer
gen_set_access_flag:

	ENTER_FUNCTION


	;  Get the DDT for this drive
	;
	call	getDriveTable


	;  Determine the type of request
	;
	cmp	byte ptr ES:[BX+1], 1
	je	MakeDriveAccessable
	cmp	byte ptr ES:[BX+1], 0
	jne	gsaf_done

	;  Clear the bit that marks this drive as invalid

	;
MakeDriveInaccessable:
	or	[si].DDT_dattr, DATTR_INVALID_MEDIA
	jmp	gsaf_done


	;  Clear the bit that marks this drive as invalid
	;
MakeDriveAccessable:
	and	[si].DDT_dattr, NOT DATTR_INVALID_MEDIA

gsaf_done:
	EXIT_FUNCTION

	jmp	dev_exit


;----------------------------
; set media lock state (440DH, 0848h) (enh. disk drive spec)
;  Does nothing at all.
;  On Entry
;	ES:BX = user buffer
gen_set_media_lock_state:

	ENTER_FUNCTION
	EXIT_FUNCTION

	jmp	dev_exit

;----------------------------
; egect media in drive (440DH, 0849h) (enh. disk drive spec)
;  Does nothing at all.
;  On Entry
;	ES:BX = user buffer
gen_eject_media_in_drive:

	ENTER_FUNCTION
	EXIT_FUNCTION

	jmp	dev_exit

;----------------------------
; lock logical volume (440DH, 084Ah) (MS-DOS 7.0)
;  Does nothing at all.
;  On Entry
;	ES:BX = user buffer
gen_lock_logical_volume:

	ENTER_FUNCTION
	EXIT_FUNCTION

	jmp	dev_exit

;----------------------------
; lock physical volume (440DH, 084Bh) (MS-DOS 7.0)
;  Does nothing at all.
;  On Entry
;	ES:BX = user buffer
gen_lock_physical_volume:

	ENTER_FUNCTION
	EXIT_FUNCTION

	jmp	dev_exit

;------------------------------------------------
;  Get Access Flag (440DH, 0867H)
;  Simply moves byte ptr user DS:[DX+1], 1
;
;  On Entry
;	   AL = unit #
;	ES:BX = user buffer
gen_get_access_flag:

	ENTER_FUNCTION

	;  Assume that the drive is accessable
	;
	mov	byte ptr ES:[BX+1], 1


	;  Get the DDT for this drive
	;
	call	getDriveTable


	;  Determine if the drive is accessable
	;
	test	[si].DDT_dattr, DATTR_INVALID_MEDIA
	jz	ggaf_done


	;  Return that the drive is not formmatted
	;
	mov	byte ptr ES:[BX+1], 0

ggaf_done:
	EXIT_FUNCTION

	jmp	dev_exit

;----------------------------
; unlock logical volume  (440DH, 086Ah) (MS-DOS 7.0)
;  Does nothing at all.
;  On Entry
;	ES:BX = user buffer
gen_unlock_logical_volume:

	ENTER_FUNCTION
	EXIT_FUNCTION

	jmp	dev_exit

;----------------------------
; unlock physical volume (440DH, 086Bh) (MS-DOS 7.0)
;  Does nothing at all.
;  On Entry
;	ES:BX = user buffer
gen_unlock_physical_volume:

	ENTER_FUNCTION
	EXIT_FUNCTION

	jmp	dev_exit

;----------------------------
; get lock flag          (440DH, 086Ch) (MS-DOS 7.0)
;  Does nothing at all.
;  On Entry
;	ES:BX = user buffer
gen_get_lock_flag:

	ENTER_FUNCTION
	EXIT_FUNCTION

	jmp	dev_exit

;----------------------------
; get current lock state (440DH, 0870h) (MS-DOS 7.0)
;  Does nothing at all.
;  On Entry
;	ES:BX = user buffer
gen_get_current_lock_state:

	ENTER_FUNCTION
	EXIT_FUNCTION

	jmp	dev_exit

;----------------------------
;  Set Parameters for Block Device (440DH, 0840H)
;
;  On Entry
;	ES:BX = user buffer
;
	public	gen_set_parms
gen_set_parms:

	ENTER_FUNCTION

	; save ROM-DOS' data segment
	;
	push	DS

	; save user buffer (originally in DS:DX)
	;
	push	ES
	push	BX

	; DS:SI = DriveDataTable for this drive
	;
	call	getDriveTable

	; we want DS:SI to point to user buffer and
	;         ES:DI to point to DDT
	;
	push	DS
	push	SI
	pop	DI
	pop	ES		; ES:DI = ptr to DDT
	pop	SI
	pop	DS		; DS:SI = ptr to user buffer

	; TRUE = Use only track layout info
	;
	test	byte ptr DS:[SI], DPSPECFUNC_LAYOUT
	jnz	track_info_only

	; preserve the ptr to user buffer and DDT
	;
	mov	BX, SI
	mov	DX, DI

	; copy the "drive" or "current disk" BPB structure from user space
	; for example, a 360K "disk" might be in a 1.2M "drive"
	;
	test	byte ptr [SI], DPSPECFUNC_DEFBPB
	jz	copy_def_BPB
	add	DI, ddt_bpb	; use "disk" BPB
	jmp	BPB_copy

    copy_def_BPB:
	add	DI, ddt_defbpb	; use "drive" BPB

    BPB_copy:
	add	SI, DP_Bpb
	mov	CX, FAT16_BPB_SIZE	; SIZE BiosParameterBlock
IF USING_FAT32
        cmp     byte ptr fIsFAT32GenIoctlCall, TRUE
        jne     BPB_copy2
        mov     cx, SIZE BiosParameterBlock
    BPB_copy2:
ENDIF
	cld
	rep	MOVSB

	; restore user buffer and DDT ptrs
	;
	mov	SI, BX
	mov	DI, DX

	; Copy device type data from user buffer (DS:SI+1) to DDT (ES:DI)
	;
	; NOTE: Some of the bits in the DDT_dattr field must be preserved.
	;       Only the lower two bits of the DDT_dattr field in the users
	;       structure are copied to the DDT.  The DDT_dattr field must
	;       first mask off the lower two bits so that they can reflect
	;       the callers settings.  This also appears to be where the
	;       DATTR_INVALID_MEDIA bit is turned off in MS.
	;
	inc	SI
	add	DI, ddt_dtype
	movsb
	lodsw
	and     ax, DATTR_NOTREMOVABLE OR DATTR_SUPPORTS_CHANGELINE
	mov	cx, word ptr es:[di]
	AND	cx, NOT (DATTR_INVALID_MEDIA OR DATTR_SUPPORTS_CHANGELINE OR DATTR_NOTREMOVABLE)
	or	ax, cx
	stosw
	movsw

	; restore user buffer and DDT ptrs
	;
	mov	SI, BX
	mov	DI, DX


	;  Clear the bit that marks this drive as invalid
	;
	and	es:[di].DDT_dattr, NOT DATTR_INVALID_MEDIA


	; Copy track information from user buffer
	; Two values are being stored here into one word.
	;
    track_info_only:
	mov	AX, word ptr DS:[SI.DP_Cylinders] ; # of tracks
	mov	word ptr ES:[DI.DDT_dcyl], AX
	mov	AX, word ptr DS:[SI.DP_Bpb.BPB_sec_per_trak]
	mov	word ptr ES:[DI.ddt_bpb.BPB_sec_per_trak], AX

	; restore ROM-DOS' DS
	pop	DS

	EXIT_FUNCTION

	; we're done
	jmp	dev_exit


;------------------------------------------------
; Read Trak (440DH, 0861H)
;
; Input Buffer (ES:BX):
;	00H	special_func	(ignored)
;	01H	head		(0-h)
;	03H	trak		(0-t)
;	05H	start_sect	(0-n in the trak)
;	07H	count		(1-n, at least 1)
;	09H	buffer		(dword ptr)
;
	public	gen_read_trak, gen_write_trak, gen_rdwr_trak
gen_read_trak:

	; we are reading sectors
	mov	SI, OFFSET CS:fdhd_read
	jmp	gen_rdwr_trak

gen_write_trak:
	; we are writing sectors
	mov	SI, OFFSET CS:fdhd_write

gen_rdwr_trak:

	ENTER_FUNCTION

	; save function ptr
	push	SI

	; determine sector based on trak/head/sect
	; start = (trak*total heads + starting head)*spt + starting sector
	;
	call	get_BPBptr		; DS:SI now = BPB structure

	; These fns probably never worked. Math was wrong. Never recorded
	; starting sector, always wrote at starting sector 0.
	;
	mov 	ax, word ptr [si].BPB_sides
	mul	word ptr es:[bx+3]	; dx:ax = heads * starting track
	add	ax, word ptr es:[bx+1]
	adc	dx, 0			; dx:ax = (heads*st. track)+ starting_head
	push	bx
	push	dx
	push	ax
	push	[si].BPB_sec_per_trak
	call	_LMULU
	pop	bx
	add	ax, es:[bx+5]		;
	adc	dx, 0			; DX:AX = starting sector

	; load other starting registers
	mov	CX, ES:[BX+7]		; CX = count
	les	DI, ES:[BX+9]		; ES:DI = buff

	; save buffer
	push	ES
	push	DI

	; get unit into AL
	les	BX, [_ptrsav]
	mov	ES:[BX+START32], ax
	mov	ES:[BX+START32+2], dx	; DX:AX = starting sector
	mov	AL, ES:[BX+UNIT]

	; restore some regs
	pop	DI
	pop	ES			; ES:DI = buffer
	pop	SI			; SI = func ptr (read or write)

	EXIT_FUNCTION

	; go do the real routine
	jmp	SI


;------------------------------------------------
;  Format/Verify Tracks (440DH, 0842H, 0862h)
;
;  This IOCTL call actually has 3 functions, specified in
;  the "SpecialFunction" field:
;	0) Format a single trak/head
;	1) ROM support for format?
;	2) Format multiple trak/heads
;
;  On Entry
;	AL = unit
;	ES:BX = ptr to user buffer (originally in DS:DX)
;
	public	gen_fv_tracks
	public 	gen_verify_tracks
gen_verify_tracks:
gen_fv_tracks:

	ENTER_FUNCTION

IF USING_BIG_DISKS
	mov	ucCurEbiosWriteType, EBIOSDISK_EXT_NOT_A_WRITE_OP
ENDIF
	; DS:SI = drive_table structure
	call	getDriveTable

	; make ES:DI point to user buffer (originally from DS:DX)
	mov	DI, BX

	; Is this SpecialFunction FV_SPECFUNC_ROM?
	cmp	byte ptr ES:[DI.FV_SpecFunc], FVSPECFUNC_RESET
	jnz	format_traks

	; Any ROM support?  Just call reset media
;	call	ResetMedia ; MSDOS does not call the BIOS for this call
	jmp	dev_exit

	; Format (or verify) 1 or more traks
	; HardDisks will ALWAYS verify, not format
	; Floppy Disks may verify or format
format_traks:

	; don't need to set BIOS parameters for hard drives
	;
	test	[_hdrive], HARDDISK
	jnz	SkipResetParms

	; Set the format parameters in the bios for the first format call
	; for the first cylinder,head,and track
	;

	cmp	word ptr es:[di.FV_Cylinder], 0
	jnz	SkipResetParms
	cmp	word ptr es:[di.FV_Head], 0
	jnz	SkipResetParms

	; Set the format parameters
	;

	push	ax
	push	cx
	push	dx
	; set up disk base table (floppies only)
	mov	AL, byte ptr DS:[SI.ddt_bpb.BPB_sec_per_trak]
	call	set_DBT_values		; set dbt.spt and dbt.hst
	mov	fast_reads_OK, 0	; have not yet read with new DBT
	call	ResetMedia
	pop	dx
	pop	cx
	pop	ax

SkipResetParms:

	; determine # of tracks to format/verify
	mov	AL, byte ptr [SI].DDT_Bpb.BPB_sec_per_trak
	cmp	byte ptr ES:[DI.FV_SpecFunc], FVSPECFUNC_FMT_TRACKS
	jnz	only1track
	mul	byte ptr ES:[DI].FV_Tracks

only1track:
	mov	[verifysecs], AL

	; convert trak/head into absolute sector #
	mov	CX, word ptr ES:[DI].FV_Cylinder	; trak
	mov	AX, word ptr ES:[DI].FV_Head	; head
	call	Trak2TrakHeadSect

	; don't actually FORMAT a hard disk, just verify
	test	[_hdrive], HARDDISK
	jnz	verify_tracks

	; set up the sector list (floppies only)
	mov	DL, byte ptr ES:[DI.FV_Cylinder]	; trak
	mov	DH, byte ptr ES:[DI.FV_Head]	; head
	mov	CX, MAX_IOCTL_SPT
	push	DS
	pop	ES
	mov	BX, GOFFSET sectlist
IOFT1:	mov	word ptr ES:[BX], DX
	add	BX, 4
	loop	IOFT1

	; set up disk base table (floppies only)
	mov	AL, byte ptr DS:[SI.ddt_bpb.BPB_sec_per_trak]
	call	set_DBT_values		; set dbt.spt and dbt.hst
	mov	fast_reads_OK, 0	; have not yet read with new DBT

	mov	al, byte ptr _htrak
	mov	[si].ddt_curtrack, al	; update floppy track position

	; Format/Verify the requested trak/head, setting error count to 0.
	;
	mov	AH, BIOSDISK_FORMAT
	jmp	short format_verify

    verify_tracks:
	mov	AH, BIOSDISK_VERIFY

    format_verify:
	mov	[fmtcmd], AH
	mov	[errcnt], 0

	; convert the trak/head into an absolute starting sector
	;
    format_again:
IF USING_BIG_DISKS

	mov	AH, [fmtcmd]
	mov	AL, [verifysecs]
	push	si			; save drive table pointer
	call	MakeBiosDiskRegs	; load BIOS regs or address packet
	mov	BX, GOFFSET sectlist
	sti			; ETR 3367
	int	BIOSDISK
	pop	si   			; restore drive table pointer
	jc	chk_failed

; ES is trashed, so this writes to an improper location.
; However, when corrected to write to the proper location, there are
; still problems. Commented out until a correct solution can be found.
;
;	mov	byte ptr ES:[DI].FV_SpecFunc, 0

ELSE ;; USING_BIG_DISKS

	call	MakeBiosDiskRegs
	mov	BX, GOFFSET sectlist
	mov	AH, [fmtcmd]
	mov	AL, [verifysecs]
	sti			; ETR 3367
	int	BIOSDISK
	jc	chk_failed

ENDIF ;; USING_BIG_DISKS

	; if formatting, make sure to verify
	cmp	[fmtcmd], BIOSDISK_FORMAT
	jz	verify_tracks

	EXIT_FUNCTION

	jmp	dev_exit	; worked!

	; try up to 3 times
chk_failed:
	inc	[errcnt]
	cmp	[errcnt], 3
	jae	fmt_failed
	push	ax
	push	cx
	push	dx
	call	ResetMedia
	pop	dx
	pop	cx
	pop	ax
	jmp	short format_again

	; format failed
fmt_failed:
	xchg	AH, AL		; mov error code into AL
	call	xlat_bios2dev

	EXIT_FUNCTION

	jmp	dev_err_exit

;-------------------------------------------------
;  Call the BIOS to reset the media.  Required when formatting
;  floppies.
;
;  On Entry
;	DS:SI = ddt for this unit
;	[_hdrive] is set to the drive #
;  On Exit
;	trashes AX, CX, DX
;	media has been reset via Int 13H, funcs 0 and 18H
;
	public ResetMedia
ResetMedia proc near

	ENTER_FUNCTION

	; preserve ES:DI since BIOS changes it
	;
	push	ES
	push	DI

	; reset the drive
	;
	xor	AX, AX
	mov	DL, [_hdrive]
	sti			; ETR 3367
	int	BIOSDISK

	; convert # tracks and spt to CX, where CH = highest trak #
	; and CL = spt.
	;
	mov	AX, [SI.DDT_dcyl]
	dec	AX
	mov	CL, 6
	shl	AH, CL
	xchg	CX, AX
	xchg	CH, CL
	add	CL, byte ptr [SI.ddt_bpb.BPB_sec_per_trak]

	; Set BIOS media type
	;
	mov	AH, BIOSDISK_MEDIA
	mov	AL, CL
	mov	DL, [_hdrive]
	clc
	sti			; ETR 3367
	int	BIOSDISK

	; restore ES:DI that BIOS changed
	;
	pop	DI
	pop	ES

	EXIT_FUNCTION

	ret

ResetMedia endp

;-------------------------------------------------
;  Convert a trak/head # into [_htrak], [_hhead], [_hsect].
;  Helper function for Format Track.
;
;  On Entry
;	DS:SI = ddt for this unit
;	AX = head #
;	CX = track #
;  On Exit
;	[_htrak], [_hhead], [_hsect] set.
;
	public	Trak2TrakHeadSect
Trak2TrakHeadSect proc near

	ENTER_FUNCTION

	push	SI

	; make DS:SI point to BPB
	add	SI, ddt_bpb

	; convert "heads" into # sectors
	mul	word ptr DS:[SI.BPB_sec_per_trak]
	push	AX	; heads * spt guaranteed to be 16 bits or less

	; convert "traks" into # sectors
	mov	AX, DS:[SI.BPB_sides]
	mul	word ptr DS:[SI.BPB_sec_per_trak]
	mul	CX		; DX:AX = traks in # sectors

	; abs sectors = traks * (spt * heads) + heads * spt
	pop	CX
	add	AX, CX
	adc	DX, 0		; abs sectors in DX:AX

	; subtract out hidden
	sub	AX, word ptr [SI.BPB_hidden]
	sbb	DX, word ptr [SI.BPB_hidden+2]

	; convert into absolute sector in [_hstart]
	call	Rel2AbsSector

	; convert into trak/head/sector
	xor	AX, AX
        call    calcsec

	pop	SI

	EXIT_FUNCTION

	ret

Trak2TrakHeadSect endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   MEDIA CHECK (function 01H)
;
;
;   Returns  1    not changed (less than 3 seconds have passed)
;   Return   0    unknown     (user might have changed disks)
;   Return  -1    changed     (different media)
;   And sets request_header.TRANS to the returned value, also
;   sets request_header.TRANS+1 to the far pointer value of
;   ddt_volume for the current drive.
;
;
;
;   On Entry
;	DS = DGROUP
;	AH = media
;	AL = unit #
;
fdhd_media:

	ENTER_FUNCTION

	; is the unit a hard disk?
	cmp	AL, num_flop_units
	jb	media_chk_flop

   ;
   ; this unit is a hard disk, and therefore is never changed.
   ; we still need to set up some return information, though...
   ;


    not_changed:
	mov	AL, 1			; disk not changed
    record_media_chg:
	les	BX, _ptrsav
	mov	BYTE PTR es:[BX+TRANS], AL	; has disk changed?

	; At least one program such as stacker calls this
	; function with a request header which is not large
	; enough to write the volume label pointer.  We will
	; avoid writing to memory we don't own. DEVCALL.ASM was correct.
	;
	cmp	byte ptr es:[bx], (TRANS+5)	; offs+stat+ptr = TRANS+1+4
	jb	MediaSkipWriteVolumePtr		; need at least 13h bytes

	push  AX

	mov	[_hunit], AL
	call	getDriveTable	; DS:SI = drive_table

IF USING_FAT32
	mov	al, [si].DDT_FatType
	mov	ucCurFatType, al
ENDIF
IF USING_BIG_DISKS
	mov	al, byte ptr [si].DDT_uEBiosDriveInfoFlags
	mov	ucCurEbiosInfoFlags, al			; B7-B15 reserved (0)
	mov	al, byte ptr [si].DDT_uEBiosDriveAttributes
	mov	ucCurEbiosAttributes, al		; B3-B15 reserved (0)
ENDIF
	mov	al, [si].DDT_bios_drive
	mov	[_hdrive], al

	lea	ax, [si].ddt_volume

	mov	word ptr es:[bx+TRANS+1], AX	; return far ptr to disk.ddt_volume
	mov	word ptr es:[bx+TRANS+3], DS

	pop   AX
    MediaSkipWriteVolumePtr:

	EXIT_FUNCTION
	jmp	dev_exit


	; if media byte different, then disk has been changed
	;
    media_chk_flop:
	call	set_unit		; sets _hunit, _hdrive, and returns AL=[_hunit]
	call	getDriveTable		; DS:SI = drive_table structure
	cmp	AH, [SI.ddt_bpb.BPB_media]	; check to see if same media
	jnz	disk_changed	; media different, disk changed

	; check for Int 13h Func 16h support before using it
	; 09/18/95 - RME
	; assume no hot-swappable floppies: don't call BIOS except on init
	;
	mov	ah, 1				; assume we can't tell
	test	[SI.ddt_dattr], 02h
	jz	check_support_passed
	inc	ah				; but if B1 set, we can

    check_support_passed:
	cmp	AH, 0			; Bad drive - general failure
	jz	get_chg_failed
	cmp	AH, 1			; 2 second rule for floppies w/o chg line
	jz	no_support
	cmp	AH, 2
	jnz	not_changed		; No change if it's a hard drive

	; if drive door opened, disk has changed
	;
	mov	DL, [_hdrive]
	mov	AH, BIOSDISK_CHG
	clc
	sti			; ETR 3367
	int	BIOSDISK
	jnc	not_changed
	cmp	AH, BDISKERR_CHANGED
	jz	disk_changed

    get_chg_failed:
	mov	AL, ERR_NOTREADY
	jmp	dev_err_exit

	; BIOS does NOT support change line status, use ticks
	; if disk has been accessed within 2 seconds, say it has not changed
	;
    no_support:
	call	clk_get_ticks
	sub	DX, word ptr [SI.DDT_ddt_info]
	jc	dont_know		; roll_over, so we don't know
	cmp	DX, TIMEOUTTICKS
	ja	dont_know		; too much time has passed
@@not_changed:        ;short jump target
	jmp	not_changed

	; The disk change line is active, but that doesn't tell us
	; if we have the correct disk in the drive. We have to look
	; at the disk serial numbers to be sure. If we have dirty
	; buffers for a different disk the we have to get that disk
	; back in the drive before we can commit the file(s).
	;
    disk_changed:
	push	ds
	pop	es
	call	get_serial		; read the boot sector into _DMA_buff
	jnc	check_values            ; NC if ok

	or	ax, ax	 		; AX == 0 if couldn't access disk
	jz	dont_know		; AX <> 0 if info bad

   check_values:

IF USING_FAT32

IF USE_186 EQ 0
.386
	push	eax
	mov	eax, _DMA_buff.BS_BootSectorInfo.VolumeSerialNumber32
	test	ucCurFatType, DDT_FAT_TYPE_32
	jnz	MEDIA_CHECK_FAT32

	mov	eax, _DMA_buff.BS_BootSectorInfo.VolumeSerialNumber16

    MEDIA_CHECK_FAT32:
	cmp	eax, [si].ddt_serial
	pop	eax
	je	not_changed
ELSE    ;; USE_186

	push	ax
	push	dx
	mov	dx, word ptr _DMA_buff.BS_BootSectorInfo.VolumeSerialNumber32+2
	mov	ax, word ptr _DMA_buff.BS_BootSectorInfo.VolumeSerialNumber32
	test	ucCurFatType, DDT_FAT_TYPE_32
    	jnz	MEDIA_CHECK_FAT32

	mov	dx, word ptr _DMA_buff.BS_BootSectorInfo.VolumeSerialNumber16+2
	mov	ax, word ptr _DMA_buff.BS_BootSectorInfo.VolumeSerialNumber16

    MEDIA_CHECK_FAT32:
	cmp	dx, word ptr [si].ddt_serial+2
	jne	DONE_MEDIA_CHECK
	cmp	ax, word ptr [si].ddt_serial
    DONE_MEDIA_CHECK:
	pop	dx
	pop	ax
	je	@@not_changed
ENDIF

.8086
ELSE ;; USING_FAT32

	mov	ax, word ptr _DMA_buff[BOOT_SERIAL]	; compare serial numbers
	cmp	ax, word ptr [si].ddt_serial
	jne	changed_for_sure
	mov	ax, word ptr _DMA_buff[BOOT_SERIAL+2]
	cmp	ax, word ptr [si].ddt_serial+2
	je	@@not_changed

ENDIF ;; USING_FAT32

    changed_for_sure:
	mov	AL, -1			; disk has been changed
	jmp	record_media_chg

    dont_know:
	mov	AL, 0			; don't know
	jmp	record_media_chg


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  BUILD A BPB (function 02H)
;
;  Operation:
;	1) get the bpb (off disk or hard-coded)
;	2) Point DGROUP:SI to the BPB structure
;	3) save media type in check structure (_last)
;
;   On Entry
;	AL    = unit #
;	ES:DI = scratch buffer
;	DS    = DGROUP
;
;   On Exit
;	(request header)
;	[MEDIA]	= media for this disk
;	[COUNT]	= dword ptr to BPB
;

	public fdhd_bpb
fdhd_bpb:

	ENTER_FUNCTION

	; are we faking 2 floppies with one?  AL will have unit #
	call	set_unit
	mov	AL, [_hdrive]
	test	AL, 80H
	jnz	return_bpb	; hard disks can't change, BPB is the same

	; Read Sector 0, so we can see the BPB
	;
      	call	readsector0
	jc	return_bpb	; couldn't read disk, use previous BPB

	; check if BPB is valid
	;
	mov	al, [_hunit]
	call	getDriveTable
	mov	cl, [si].DDT_FatType

IF USING_FAT32
	mov	si, GOFFSET _DMA_buff.BS_BootSectorInfo
ELSE	;; USING_FAT32
	mov	SI, GOFFSET _DMA_buff + BOOT_BPB
ENDIF	;; USING_FAT32

	push	si
	push	cx
	call	check_bpb
	pop	cx
	pop	cx
	or	ax, ax
	jz	bad_bpb		; not valid BPB, check for DOS1 disks

	; if this is a floppy drive, then hidden must be false
	;
	test	[_hdrive], HARDDISK
	jnz	hd_hidden_ok

	xor	AX, AX
	mov	word ptr [SI].BPB_hidden, ax
	mov	word ptr [SI].BPB_hidden[2], ax
hd_hidden_ok:

	; at this point DS:SI points to BPB structure from disk
	; point ES:DI to internal BPB structure for this drive
move_bpb:
	push	SI
	push	DS
	pop	ES
	mov	AL, [_hunit]
	call	getDriveTable
	mov	BX, SI			; save ptr to drive_table in BX
	xchg	DI, SI
	add	DI, ddt_bpb    		; ES:DI = dst BPB (in DDT)
	pop	SI			; DS:SI = src BPB (read in from disk)
IF USING_FAT32
	mov	cx, SIZE BiosParameterBlock
	test	ucCurFatType, DDT_FAT_TYPE_32
    	jnz	BPB_HaveSize
	mov	cx, FAT16_BPB_SIZE
    BPB_HaveSize:
ELSE
	mov	CX, FAT16_BPB_SIZE	; SIZE BiosParameterBlock
ENDIF
	cld
	rep	MOVSB

	; void get_fatid(uchar unit, char *boot_sector)
	;
	mov	AX, GOFFSET _DMA_buff
	push	AX
	push	word ptr [_hunit]
	call	get_fatid
	pop	AX
	pop	AX
	jmp	short return_bpb

	; the BPB was garbage! maybe it's a DOS1 style disk?
	; check for media byte in sector 1
	public bad_bpb
bad_bpb:
	call	readsector1
	jc	general_failure

	; is media byte within range of DOS1 disks?
	; If the media byte indicates it is a 720K (or higher capacity) floppy
	; or if it is a hard disk, then admit the error. Otherwise use the
	; BPB from the diskette.
	;
	mov	SI, GOFFSET _DMA_buff
	cmp	byte ptr [SI], 0FCH
	jb	general_failure

	; get hard-coded BPB
	;
	mov	AL, byte ptr [SI]
	sub	AL, 0FCH
	mov	AH, FAT16_BPB_SIZE	; SIZE BiosParameterBlock
	mul	AH
	add	AX, GOFFSET FC_bpb
	xchg	SI, AX
	jmp	short move_bpb

	; the BPB was garbage, signal error to DOS
general_failure:
	mov	AL, 0CH

	EXIT_FUNCTION

	jmp	dev_err_exit

return_bpb:
	mov	AL, [_hunit]
	call	get_BPBptr
	mov	AL, [SI.BPB_media]

	; save the info in the bpb area
	mov	DX, DS
	lds	BX, _ptrsav		; DS:BX ptr to i/o packet
	mov	BYTE PTR [BX+MEDIA], AL
	mov	WORD PTR [BX+COUNT], SI
	mov	WORD PTR [BX+COUNT+2], DX ; DX:DI = bpb

	EXIT_FUNCTION

	jmp	dev_exit


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;  READ AND WRITE FUNCTIONS
;
;  On Entry
;	DS    = DGROUP
;	ES:DI = trans buffer
;	AL    = unit
;	CX    = count
;	DX    = start
;
	PUBLIC	fdhd_read, fdhd_write, fdhd_rdwr

fdhd_read:
IF USING_BIG_DISKS
	mov	ucCurEbiosWriteType, EBIOSDISK_EXT_NOT_A_WRITE_OP
ENDIF
	push	bp
	mov	SI, OFFSET CS:readsector
	push	SI
	mov	[_DMA_rd], 1		; tell DMA routines this is a read
	jmp	SHORT fdhd_rdwr

IF USING_BIG_DISKS

	; We only support write with verify if it is free through EBIOS
	; support.
	;
fdhd_write_verify:
	mov	ucCurEbiosWriteType, EBIOSDISK_EXT_WRITE_AND_VERIFY
	test	ucCurEbiosInfoFlags, EBDPT_INFO_SUPPORTS_VERIFY
    	jnz	short fdhd_write_typed
	;
	; Fall through to normal fdhd_write if EBIOS doesn't support verify
	;
ENDIF

fdhd_write:
IF USING_BIG_DISKS
	mov	ucCurEbiosWriteType, EBIOSDISK_EXT_WRITE_ONLY
ENDIF

    fdhd_write_typed:
	push	bp
	mov	SI, OFFSET CS:writesector
	push	SI
	mov	[_DMA_rd], 0		; tell DMA routines this is a write

fdhd_rdwr:

	ENTER_FUNCTION

IF USING_BIG_DISKS
	mov	ucNextReadWriteSize, 0	; Clear the multipass sector count
ENDIF ; IF USING_BIG_DISKS
	mov	bp, MAX_RETRIES		; track number of retries left in BP

	; set the unit and BIOS drive #
	;
	call	set_unit		; set unit/BIOS drive #


	; Convert the DOS sector number (which is relative to
	; the start of the partition) to an an absolute sector
	; number which is relative to the start of the physical disk.
	; The absolute sector number is stored in the _hstart global variable.
	;
	push	ES
	les	BX, [_ptrsav]		; ES:BX ptr to i/o packet

	; get pointer to DDT for this HardDisk
	mov	AL, [_hunit]
	push	SI
	call	getDriveTable		; DS:SI = ptr to DDT

	mov	AX, ES:[BX+START32]
	mov	DX, ES:[BX+START32+2]	; DX:AX = starting sector

	cmp	[SI].DDT_bpb.BPB_num_sec, 0
	jnz	RangeCheckSmall

RangeCheckBig:
	cmp	dx, word ptr [SI].DDT_bpb.BPB_lnumsec[2]
	jb	RangeCheckDone
	ja	RangeCheckFailed
	cmp	ax, word ptr [SI].DDT_bpb.BPB_lnumsec
	jb	RangeCheckDone
RangeCheckFailed:
	pop	si
	pop	ES
	pop	si
	pop	bp
	mov	al, ERR_SECTORNOTFOUND
	jmp	dev_err_exit

;  This placed here for short jumps to be in range
;
ErrInvalidMedia_add4:
	add	sp, 4
	mov	al, ERR_BADMEDIA
	jmp	dev_err_exit


RangeCheckSmall:
	cmp	dx, 0
	ja	RangeCheckFailed
	cmp	ax, word ptr [SI].DDT_bpb.BPB_num_sec
	jae	RangeCheckFailed

RangeCheckDone:
	pop	si

	call	Rel2AbsSector
	pop	ES

	; set DMA variables, # of sectors within the "current" read/write.
	;
	mov	[_DMA_num], CX		; save # of sectors to rd/wr
	mov	[_DMA_start], 0		; save starting sector

	; move bytes_per_sector into dma_bps (for easy access)
	;
	mov	AL, [_hunit]

	call	getDriveTable
	test	[si].DDT_dattr, DATTR_INVALID_MEDIA
	jnz	ErrInvalidMedia_add4
	add	SI, ddt_bpb		; DS:SI now = BPB structure

	mov	[_DMA_bpb], SI
	push	WORD PTR [SI].BPB_sec_size
	pop	[_DMA_bps]

	; modify DISK BASE TABLE to match BPB
	; (high density floppies only, never less than 9)
	;
	cmp	[_hdrive], 80H
	jae	FR1		; don't set DBT for harddisk access
	mov	AL, BYTE PTR [SI.BPB_sec_per_trak]
	cmp	AL, 9
	jae	FR0
	mov	AL, 9		; if spt less than 9, set it to 9

    FR0:
    	call	set_DBT_values


	; GET HEAD/SECT/TRAK INFO
	;
    FR1:
   	mov	AX, [_DMA_start]
	call	calcsec			; convert sector to sect/trak/head

	; Check for track overrun
	push	ES
	call	_track_overrun
	pop	ES

	; AX = 0 (ON DMA BOUNDARY), AX!=0 (NORMAL READ/WRITE)
	cmp	AX,0
	jnz	FR2	; Normal RD/WR

	; THIS 1 SECTOR CROSSES A 64K (DMA) BOUNDARY
	mov	[_DMA_ES],ES		; save transfer buffer seg

	; IF THIS IS A WRITE OPERATION, WE NEED TO MOVE THE DATA FROM
	; THE "REAL" LOCATION TO A TEMPORARY BUFFER SO AS NOT TO CROSS
	; A 64K (DMA) BOUNDARY
	cmp	[_DMA_rd], 0
	jnz	FRD1			; read operation, skip this part

	push	DS
	mov	SI, DI
	mov	DI, GOFFSET _DMA_buff	; DS:SI = src, ES:DI = dst
	push	DS
	pop	ES
	mov	CX, [_DMA_bps]		; # of bytes to move
	mov	DS, [_DMA_ES]
	cld
	rep	MOVSB
	pop	DS			; get DGROUP back
	mov	DI, SI			; DI points to next "real" location

	; READ THE SECTOR INTO TEMP BUFFER, THEN MOVE TO REAL DESTINATION
	; WE CANNOT READ DIRECTLY TO "REAL" DESTINATION BECAUSE IT
	; CROSSES A DMA BOUNDARY
FRD1:	mov	AX, DS
	mov	ES, AX
	mov	BX, GOFFSET _DMA_buff 	; ES:BX = DMA_buff (temp buffer)
	mov	AL,1

do_dma_readwrite:
	pop	SI			; rd/wr funcptr
	push	ax
	call	SI
	mov	ES, [_DMA_ES]
	jnc	not_dma_io_err

	pop	cx
	call	near ptr io_err
	push	si
	jmp	short do_dma_readwrite

not_dma_io_err:
	pop	ax
	push	SI			; save rd/wr function ptr

	; IF THIS WAS A READ OPERATION, WE NEED TO MOVE THE DATA
	; FROM THE TEMP BUFFER TO THE "REAL" LOCATION
	cmp	[_DMA_rd], 0
	jz	FRD2
	mov	SI, GOFFSET _DMA_buff	; DS:SI = src, ES:DI = dst
	mov	CX, [_DMA_bps]
	cld
	rep	MOVSB

	; UPDATE COUNTERS (DI is already updated by above MOVSB)
FRD2:	inc	[_DMA_start]
	dec	[_DMA_num]
	jmp	SHORT	FR3


	; DO A NORMAL READ/WRITE OPERATION (AX contains # sectors to rd/wr)
FR2:	mov	BX, DI		; ES:BX = buffer

	; UPDATE COUNTERS
	add	[_DMA_start], AX	; increment starting sector
	sub	[_DMA_num], AX		; decrement # sectors left to read
	mov	CX, AX
	mov	DX, [_DMA_bps]
	mul	DX
	add	DI, AX		; add # of bytes into buffer address
	mov	AX, CX

	; DO THE READ/WRITE (AL = # OF SECS, ES:BX = BUFFER)

do_readwrite:
	pop	SI
	push	ax
	call	SI
	jnc	not_io_err

	pop	cx
	call	near ptr io_err
	push	si
	jmp	short do_readwrite

not_io_err:
	pop	ax
	push	SI

	; CHECK IF WE ARE DONE
FR3:	cmp	[_DMA_num], 0
	jz	FR4		; DONE

	; DO ANOTHER READ
	mov	AL, _hunit
	call	get_BPBptr
	jmp	FR1

	; SAVE THE CLOCK TICKS OF LAST RD/WR (see media_chk)
FR4:	pop	SI		; take it off the stack

	test	[_hdrive], 80H	; no need to save ticks for
	jnz	FR5		; a hard disk

	mov	AL, [_hunit]	; get the drive we are acting on
	call	getDriveTable	; get pointer to structure for this unit
	call	clk_get_ticks
	mov	word ptr [SI.DDT_ddt_info], DX
	mov	word ptr [SI.DDT_ddt_info+2], CX

	; Done with the RD/WR operation
FR5:	pop	bp      		; get back caller's BP

	EXIT_FUNCTION

	jmp	dev_exit		; return OK

	; when we get here ah = BIOS err code, es:bx-> buffer, bp = retry count
	; cx = sectors to read/write, on stack:
	; --return IP of read/write function (may be HMA routine or not)
	; --callers bp
	; --stack on entry to fdhd_read/write
	;
io_err:
	push	cx
	mov	AL, AH		; put BIOS error code in AL (from AH)
	push	AX		; save BIOS error code

	mov	DL, [_hdrive]		; BIOS expects unit in DL
	mov	AH,  BIOSDISK_RESET	; reset the drive
	clc
	sti			; ETR 3367
	int	BIOSDISK

	mov	[fast_reads_OK], 0	; use default DBT.HST on next rd/wr
	mov	al, _default_HST
	call	set_DBT_HST		; restore default HST

	mov	al, [_hunit]
	push	si
	call	getDriveTable
	mov	[si].ddt_curtrack, 0	; update floppy track position
	pop	si

	pop	ax			; get BIOS error code back
; ETR 3613 12/28/00 TZD
; A comparison of DOS kernels reveals that the opposition, in this
; particular configuration, retries immediately before returning an
; error -- which works with our customers hardware.
;
;	cmp	ah, BDISKERR_TIMEOUT	; if timeout
;	je	no_more_retries
	cmp	ah, BDISKERR_BAD_COMMAND ; or if bad command
	je  no_more_retries
;	cmp	ah, BDISKERR_CHANGED	; or if diskette changed, don't retry but
;	je  no_more_retries		; generate crit error right away

	dec	bp			; dec the retry count
	jz	no_more_retries		; if zero, have to fail call

	pop	ax			; get back sectors to read/write

	EXIT_FUNCTION

	retn				; try again

no_more_retries:
	call	xlat_bios2dev

	pop	cx			; get sectors to read/write off stack
	pop	cx			; get read/write return IP off stack
	mov	CX, 0			; 0 blocks transferred
	pop	bp			; recover caller's BP

	EXIT_FUNCTION

	jmp	dev_err_cnt		; return error


;-------------------------------
;  Convert a relative sector (as DOS sees it) to an absolute
;  sector on this disk.  On floppies, they are 1 and the
;  same.  On hard disks, the start of the partition must be
;  added in.
;
;  On Entry
;	[_hunit] = unit
;	DX:AX    = starting sector as DOS sees it.
;       (on hard disks, the beginning of the partition must be
;	added in)
;
;  On Exit
;	[_hstart] = Absolute REAL starting sector
;
	public	Rel2AbsSector
Rel2AbsSector:

	ENTER_FUNCTION

	; set [_hstart] to the start of this partition/drive
	; floppies will always have an _hstart of 0
	call	SetHStart

	; now, add in the starting sector requested from the
	; user into [_hstart].
	add	word ptr [_hstart], AX
	adc	word ptr [_hstart+2], DX

	EXIT_FUNCTION

	ret


;-------------------------------
;  Upon Entry
;    AL		= bios (INT 13H) error code
;  Returns
;    DS		= DGROUP
;    AL		= device error code
;    _bios_err	= bios error code
;

;  These errors are listed in Device Error Code order, so
;  that we look up the BIOS error code, then the index #
;  is the Device Error Code.
;
;  Examples
;	BIOS error of 03H == Device error of 00H
;	BIOS error of 80H == Device error of 02H
;
errlist label byte
	db	03H,  01H, 80H, 01H, 10H, 0FFH, 40H, 0FFH	; 0-7
	db	04H, 0FFH, 08H, 08H, 80H, 80H,  80H, 06H	; 8-F
	db  0

	public	xlat_bios2dev
xlat_bios2dev:

	ENTER_FUNCTION

	push	SI

	; get dgroup back and save BIOS error
	call	getDGROUP
	mov	[_bios_err], AL

	; determine device error from BIOS one
	mov	SI, offset CS:errlist
xagain:	cmp	CS:[SI], AL
	jz	xdone
	cmp	byte ptr CS:[SI], 0	; not found, default to
	jz	xdone			; General Failure
	inc	SI
	jmp	xagain

	; set AX to device error code
xdone:	mov	AX, SI
	sub	AX, offset CS:errlist

	; SI is the current rd/wr function
	pop	SI

	; trick below doesn't work if CRC error, missing address mark, etc.
	;
	cmp	al, 0Ah    	; make sure this is a Write Fault
	jnz	haveErrCode	; done if not

	; secial case: ReadFault and WriteFault are the SAME
	; BIOS error code, so we must check WHAT we were doing
	; and set the Device Error Code accordingly
	;
	cmp	SI, OFFSET CS:writesector
	jz	haveErrCode
	inc	AX	; must be a read, so ReadFault

haveErrCode:

	EXIT_FUNCTION

	ret


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  Set [_hstart] to the start of this drive/partition.  For
;  floppies, [_hstart] will always be 0.  For hard disks, [_hstart]
;  will be the absolute sector on which the Boot Sector resides for
;  the given partition.
;
;  Affects no registers.
;
;  On Entry
;    [_hdrive]	= drive #
;    [_unit]	= unit #
;  On Exit
;    [_hstart]	= absolute starting sector of this partition
;
	public	SetHStart
SetHStart:

	ENTER_FUNCTION

	push	AX
	push	DX

	; start with _hstart at 0
	xor	AX, AX
	xor	DX, DX

	; hard disks only, get "_hstart" to start of partition
	test	[_hdrive], HARDDISK
	jz	sethst_not_hd

	; get pointer to DDT for this HardDisk
	mov	AL, [_hunit]
	push	SI
	call	getDriveTable		; DS:SI = ptr to DDT

	; convert starting trak # to an absolute sector #
	; start = sttrak * (heads * spt) + hidden
	mov	AX, [SI.ddt_bpb.BPB_sec_per_trak]
	mul	word ptr [SI.ddt_bpb.BPB_sides]	; AX = (heads * spt)
	mul	word ptr [SI.ddt_sttrak]  ; DX:AX = sttrak * (heads * spt)
	add	AX, word ptr [SI.ddt_bpb.BPB_hidden]
	adc	DX, word ptr [SI.ddt_bpb.BPB_hidden+2]	; add hidden sectors
	pop	SI

	; store starting sector of disk/partition in [_hstart]
sethst_not_hd:
	mov	word ptr [_hstart], AX
	mov	word ptr [_hstart+2], DX

	; restore registers and return
	pop	DX
	pop	AX

	EXIT_FUNCTION

	ret


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  Upon Entry
;    AX		= abs sector # {0,1,...,n}
;    DS:SI	= BPB of disk
;    [_hstart]	= long offset to add to this sector
;
;  Destroys
;    AX,DX
;
;  Returns with
;    [_htrak], [_hhead], [_hsect] filled in
;
	public calcsec
calcsec:
	ENTER_FUNCTION

	push	cx
	xor	DX, DX			; DX:AX = abs sector #
	add	AX, WORD PTR [_hstart]
	adc	DX, WORD PTR [_hstart+2]
	xor	cx, cx
	cmp	dx, [si].BPB_sec_per_trak
	jb	CS_nozerodiv

	; if hstart >= 1000h * spt we will DIVISION BY ZERO without this.
	;
	push	ax
	mov	ax, dx
	mov	dx, cx
	div 	[si].BPB_sec_per_trak
	mov	cx, ax
	pop	ax
	div	[si].BPB_sec_per_trak
	inc	DL
	mov	[_hsect], DL		; DL = remainder = sector {1,2,...,n}
	mov	dx, cx
	jmp	short CS_firstDivDone

    CS_nozerodiv:
	div	[si].BPB_sec_per_trak
	inc	DL
	mov	[_hsect], DL		; DL = remainder = sector {1,2,...,n}
	xor	DX,DX

    CS_firstDivDone:
	div	[SI.BPB_sides]		; sides
	mov	[_hhead],DL		; remainder= head
	mov	[_htrak],AX		; quotient = track #
	pop	cx

	EXIT_FUNCTION

	ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  Upon Entry
;	_hunit  = unit #
;	_hdrive = BIOS drive #
;  Returns
;	_DMA_buff = sector 0 (or 1 as the case may be)
;	carry set if failed, clear if worked
;
readsector1:
	mov	DX, 1
	jmp	short readanysector

writesector0:
	mov	[do_write0], 1
	call	readsector0
	mov	[do_write0], 0
	ret

readsector0:
	mov	[fast_reads_OK], 0	; use default DBT.HST
	mov	DX, 0

readanysector:

	ENTER_FUNCTION

	; set starting sector for this unit
	call	SetHStart

	; convert sector 0 into trak/head/sector
rd0_calc:
	mov	AL, [_hunit]
	call	get_BPBptr
IF USING_BIG_DISKS
	mov 	ax, word ptr [si].BPB_sec_size
	mov	uCurrentBPS, ax			; Save the sector size
ENDIF ; IF USING_BIG_DISKS
	mov	AX, DX
	call	calcsec

	; read sector 0
	mov	CL, 0		; we will be trying up to 3 times
rd0_read:
	push	CX
	mov	AL, 1
	push	DS
	pop	ES
	mov	BX, GOFFSET _DMA_buff
	cmp	[do_write0], 0
	jnz	rd0_write
	call	readsector
	jmp	short rd0_x
rd0_write:
	call	writesector
rd0_x:	jc	rd0_fail
	pop	CX

	EXIT_FUNCTION

	ret

rd0_fail:
	; reset the disk
	mov	DL, [_hdrive]
	mov	AH, BIOSDISK_RESET
	sti			; ETR 3367
	int	BIOSDISK

	mov	[fast_reads_OK], 0	; on reset, must use default DBT
	mov	al, _default_HST
	call	set_DBT_HST	; restore default HST w/out changing flags

	mov	al, [_hunit]
	push	si
	call	getDriveTable
	mov	[si].ddt_curtrack, 0	; update floppy track position
	pop	si

	; try 3 times before giving up
	pop	CX
	inc	CL
	cmp	CL, MAX_RETRIES
	jb	rd0_read
	stc

	EXIT_FUNCTION

	ret

;----------------------------------------------
;  Set DiskBaseTable's  Sectors Per Track field
;  On Entry
;	AL = spt
;  On Exit
;	DBT has been updated to have new SectorsPerTrack and
;       restores the default (BIOS) Head Settling Time (HST) Value.
;	Affects no registers.
;
set_DBT_values	proc near

	ENTER_FUNCTION

	push	ES
	push	BX
	xor	BX, BX
	mov	ES, BX
	mov	BX, BIOSDBT * 4
	les	BX, ES:[BX]
	mov	ES:[BX+SPT_OFFSET], AL
	push	AX
	mov	AL, _default_HST
	mov	ES:[BX+HST_OFFSET], AL
	pop	AX
	pop	BX
	pop	ES

	EXIT_FUNCTION

	ret
set_DBT_values	endp

;----------------------------------------------
;  Set DiskBaseTable's  Head Settling Time (HST) field
;  On Entry
;	AL = head settling time (hst)
;  On Exit
;	DBT has been updated to have new HST
;	Changes NO registers, including flags
;
set_DBT_HST	proc near

	ENTER_FUNCTION

	push	ES
	push	BX
	mov	BX, 0			; don't change any flags!
	mov	ES, BX
	mov	BX, BIOSDBT * 4
	les	BX, ES:[BX]
	mov	ES:[BX+HST_OFFSET], AL
	pop	BX
	pop	ES

	EXIT_FUNCTION

	ret
set_DBT_HST	endp


;----------------------------------------------
;  Updates a floppies current track in its DiskBaseTable
;  On Entry
;	AL = unit
;       AH = new track position
;  On Exit
;       AH = previous track position
;	DBT updated
;
update_floppy_position	proc near

	ENTER_FUNCTION

	push	si
	call	getDriveTable
	xchg	[si].ddt_curtrack, ah
	pop	si

	EXIT_FUNCTION

	ret
update_floppy_position	endp

;-----------------------------------------
;  Upon Entry
;	AL		= # of sectors to read/write
;	ES:BX	= buffer
;	_hhead, _htrak, _hsect	set by calcsec
;	_hdrive			set by user
;
;  Destroys
;	AX,BX,CX,DX
;
;  Returns
;	Data at ES:BX, carry set if failed.
;
	public readsector,writesector
writesector:

	ENTER_FUNCTION

	push	ax
	test	_hdrive, 80h		; if hard disk then no HST worries
	jnz	do_writesector

	; swap the current and target tracks in the drive table for
	; this unit. If the track values are the same then we don't
	; need to wait for the heads to settle (we already have).
	;
	mov	ah, byte ptr _htrak	; if the requested track is not
	mov	al, _hunit		; the same as the current tract
	call	update_floppy_position
	cmp	ah, byte ptr _htrak	; then we must use BIOS' DBT.HST
	jne	do_writesector

	mov	al, FAST_HST		; we're still on the same track
	call	set_DBT_HST		; so we get to go fast

    do_writesector:
	pop	ax
	mov	AH, BIOSDISK_WRITE	; AH=WRITE, AL=# of sectors to write
	jmp	SHORT	RDWR1

readsector:

	ENTER_FUNCTION

	push	ax
	test	_hdrive, 80h		; if hard disk then no HST worries
	jnz	do_readsector

	; update the current track position and see if we have encountered
	; an error or a disk reset since the last read, if so we have
	; to use the BIOS' HST value.
	;
	mov	ah, byte ptr _htrak
	mov	al, _hunit
	call	update_floppy_position
	cmp	byte ptr fast_reads_OK,0 ; see if OK to do fast reads
	mov	byte ptr fast_reads_OK,1 ; hope it will be next time
	je	do_readsector

	mov	al, FAST_HST		; use the faster DBT.HST value
	call	set_DBT_HST

    do_readsector:
	pop	ax
	mov	AH, BIOSDISK_READ	; AH=READ, AL=# of sectors to read

RDWR1:
IF USING_BIG_DISKS
	push	si			; save ptr to DDT for this drive
ENDIF
	call	MakeBiosDiskRegs        ; may change AX,CX,DX,SI,sEbiosPacket

RDWR_again:
	push	ax			; save (possibly converted) cmd/count
	clc
	sti			; ETR 3367
	int	BIOSDISK		; ES:BX = buffer
	push	ax			; save int 13h return status code

	mov	al, _default_HST
	jnc	RDWR3

	pushf				; save BIOS return flags
	cmp	AH, BDISKERR_CHANGED  	; was it a change-line error?
	jnz	RDWR2			; if so set default HST and return

	mov	al, 1			; else use minimum HST on retries

    RDWR2:
	popf				; restore BIOS return flags

    RDWR3:
        call	set_DBT_HST	; restore default HST w/out changing flags
	pop	ax		; get back int 13h status in AX
	pop	CX		; pop saved command, but keep status in AX
IF USING_BIG_DISKS
	pop	si		; restore pointer to this drive's DDT
ENDIF

IF USING_BIG_DISKS
	jc	NO_MULTIPASS
	cmp	ucNextReadWriteSize, 0
	jnz	DO_MULTIPASS

    NO_MULTIPASS:
ENDIF  ; IF USING_BIG_DISKS

	EXIT_FUNCTION

	ret

IF USING_BIG_DISKS
;  Perform the second pass of a multipass read/write operation
;
;
DO_MULTIPASS:

	ENTER_FUNCTION

	;  Put the AX value from before the last INT 13h call, which
	;  is stored in CX, back in AX
	;
	mov	ax, cx

	;  Put the number of LBA sectors remaining to read/write
	;  in the AL register for the MakeBiosDiskRegs()
	;
	mov	al, ucNextReadWriteSize

	;  Adjust the starting sector number in the _hstart variable
	;
	mov	ch, 0
	add	word ptr [_hstart], cx
	adc	word ptr [_hstart+2], 0

	;  Adjust the destination buffer for the read/write
	;
    BUFFER_CALC:
	add	bx, uCurrentBPS
	loop	BUFFER_CALC

	;  Clear the number of sectors left to read/write in the
	;  multipass variable
	;
	mov	ucNextReadWriteSize, cl		; CL zero by loop instruction

	EXIT_FUNCTION

	;  Perform the second part of the multipass read/write operation
	;
	jmp	short RDWR1
ENDIF  ; IF USING_BIG_DISKS


;-----------------------------------------
;  On Entry
;	AH	= BIOS function number (only fns 2,3,4 allowed on EBIOS)
;	AL	= sectors (LBA blocks) to read/write
;	ES:BX 	-> read/write buffer
;	_hstart, _htrak, _hsect, _hhead and _hdrive are set
;
;	If USING_BIG_DISKS then ucCurEBIOSWriteType and ucCurEBIOSAttributes
;	must also be set before the call.
;
;  On Exit
;	if not USING_BIG_DISKS or if there is no BIOS LBA
;	support for the drive and function then:
;
;		CX = trak/sect
;		DX = head/drive #
;               no other general registers are changed!
;
;	but otherwise our local copy of the DeviceAddressPacket
;	(sEbiosPacket) is filled in and:
;
; 		AX = adjusted as appropriate for the EBIOS call.
;		DL = drive number (>=80h)
;		SI = offset of sEbiosPacket in DGROUP
;		     (DS must already be pointing to our data segment).
;
;	Note:
;	Only the extended write function (43h) takes a
;	subfunction number in AL, which is 2 if verifying, 0 or
;	1 if not, and any other value generating an invalid
;	function error in the EBIOS. For efficiency we always load AL
;	with the ucCurEBIOSWriteType value which will be 0 for
;	Read, Verify and Write (without verify) and 2 if the
;	device write and verify routine was called.
;
	public	MakeBiosDiskRegs

IF	USING_BIG_DISKS
IF USE_186 EQ 0
.386
ENDIF
MakeBiosDiskRegs 	proc near

	ENTER_FUNCTION

	; If the BIOS supports LBA operations on this drive, use them.
	; But do a sanity check on the input function numbers first.
	;
	test	ucCurEBIOSAttributes, EBIOS_HAS_LBA_DISK_SUPPORT
IF USE_186 EQ 0
	jz	MBDR_CHS
ELSE
        jnz     MBDR_CHECK_READ
	jmp	MBDR_CHS

    MBDR_CHECK_READ:
ENDIF

	cmp	ah, BIOSDISK_READ
IF USE_186 EQ 0
        jb	MBDR_CHS
ELSE
        jae     MBDR_CHECK_VERIFY
        jmp     MBDR_CHS

    MBDR_CHECK_VERIFY:
ENDIF

	cmp	ah, BIOSDISK_VERIFY
IF USE_186 EQ 0
        ja	MBDR_CHS
ELSE
        jbe     MBDR_LBA
        jmp     MBDR_CHS
ENDIF

    MBDR_LBA:

	cmp	_hdrive, 80h
IF USE_186 EQ 0
        jb	MBDR_CHS
ELSE
        jae     MBDR_LBA_2
        jmp     MBDR_CHS
ENDIF

IF USE_186 EQ 0
	push	ecx
ELSE    ;; USE_186
    MBDR_LBA_2:

        push    dx
	push	cx
ENDIF   ;; USE_186

	;
	;
	push	si
	push	ax
	mov	al, _hdrive
	sub	al, 80h
	call	GetBiosDriveParameterTable
IF USE_186 EQ 0
	mov     ecx, [si.BLP_TotalSectors]
ELSE    ;; USE_186
        mov     dx, word ptr [si.BLP_TotalSectors+2]     ; high word
	mov     cx, word ptr [si.BLP_TotalSectors]       ; low word
ENDIF
	pop	ax
	pop	si


	;  For compatibility with existing cache programs, we do NOT
	;  want to use LBA function calls when the sector is less
	;  than 8Gb.
	;
IF USE_186 EQ 0
	cmp	_hstart, ecx
	jb	MBDR_CHS_CHECK
ELSE    ;; USE_186
        cmp     word ptr _hstart[2], dx
	jb	MBDR_CHS_CHECK
        ja      MBDR_LOAD_SECTOR_NUMBER

        ; upper word of _hstart is equal to dx
        ; must user lower word to verify sector
        cmp     word ptr _hstart, cx
        jb      MBDR_CHS_CHECK

    MBDR_LOAD_SECTOR_NUMBER:
ENDIF   ;; USE_186

	; Load offset of address packet into SI and then load 64-bit
	; sector number into address packet. Under FAT32 only
	; the low 32-bits are significant.
	;
	mov	si, GOFFSET sEbiosPacket

	;  ETR 3943  BT 2-25-02
	;
	;  Set the size of the packet in the first structure entry
	;
	mov	word ptr [si], SIZE sEbiosPacket

IF USE_186 EQ 0
	mov	ecx, _hstart
	mov	sEbiosPacket.DAP_ulStartingLBALow, ecx
ELSE    ;; USE_186
        mov     dx, word ptr _hstart[2]
	mov	cx, word ptr _hstart
        mov     word ptr sEbiosPacket.DAP_ulStartingLBALow[2], dx
	mov	word ptr sEbiosPacket.DAP_ulStartingLBALow, cx
ENDIF   ;; USE_186

	; Get function number and block (sector) write count in AH/AL then
	; 1) adjust function number in AH
	; 2) record block (sector) count to read/write/verify
	; 3) specify write/verify operation if appropriate.
	;
	or	ah, 40h
	mov	sEbiosPacket.DAP_ucBlockCount, al
	mov	al, ucCurEBIOSWriteType

	; get segment:offset of user buffer into packet (this is harmless
	; in the case of the verify operation and saves a jump on the much
	; more frequent read/write calls)
	;
	mov	word ptr sEbiosPacket.DAP_lpBuffer, bx
	mov	word ptr sEbiosPacket.DAP_lpBuffer[2], es

IF USE_186 EQ 0
	pop	ecx
ELSE    ;; USE_186
        pop     cx
        pop     dx
ENDIF   ;; USE_186
	jmp	short MBDR_done

    MBDR_CHS_CHECK:

	;  Determine what the last sector for the read/write
	;
IF USE_186 EQ 0
	mov	ulFirstLBASector, ecx
	xor	ecx, ecx
	mov	cl, al
	add	ecx, _hstart
	dec	ecx

	;  Determine if the last sector number is a required LBA
	;  sector
	;
	cmp	ecx, ulFirstLBASector
	jb	DO_MBDR_CHS

	;  Determine the number of sectors for the read/write that
	;  requires LBA
	;
	sub	ecx, ulFirstLBASector

ELSE    ;; USE_186
        mov     word ptr ulFirstLBASector[2], dx
	mov	word ptr ulFirstLBASector, cx
        xor     cx, cx
        xor     dx, dx
	mov	cl, al
        add     cx, word ptr _hstart
        adc     dx, word ptr _hstart[2]
        sub     cx, 1
        sbb     dx, 0

	;  Determine if the last sector number is a required LBA
	;  sector
	;
        cmp     dx, word ptr ulFirstLBASector[2]
        jb      DO_MBDR_CHS
        ja      MBDR_LBA_NUMSECTS

	cmp	cx, word ptr ulFirstLBASector
	jb	DO_MBDR_CHS

    MBDR_LBA_NUMSECTS:
	;  Determine the number of sectors for the read/write that
	;  requires LBA
	;
        sub     cx, word ptr ulFirstLBASector
        sbb     dx, word ptr ulFirstLBASector[2]
ENDIF   ;; USE_186

	inc	cx

	;  Save the number sectors for the read/write that requires
	;  LBA
	;
	mov	ucNextReadWriteSize, cl

	;  Adjust the number of sectors to read/write using CHS
	;
	sub	al, cl

    DO_MBDR_CHS:
IF USE_186 EQ 0
	pop	ecx
ELSE    ;; USE_186
        pop     cx
        pop     dx
ENDIF   ;; USE_186

    MBDR_CHS:
	mov	DX, [_htrak]
	mov	CL, 06H		; if track>=100H, put extra
	shl	DH, CL		; bits in upper 2 bits of sector
	or	DH, [_hsect]
	mov	CX, DX
	xchg	CH, CL 		; CH = trak, CL=sect
	mov	DH, [_hhead]	; DH = head

    MBDR_done:
	mov	DL, [_hdrive]	; DL = drive (>=80H = "harddisk")

	EXIT_FUNCTION

	ret
MakeBiosDiskRegs 	endp

.8086
ELSE	;; USING_BIG_DISKS

MakeBiosDiskRegs:

	ENTER_FUNCTION

	mov	DX, [_htrak]
	mov	CL, 06H		; if track>=100H, put extra
	shl	DH, CL		; bits in upper 2 bits of sector
	or	DH, [_hsect]
	mov	CX, DX
	xchg	CH, CL 		; CH = trak, CL=sect
	mov	DH, [_hhead]	; DH = head
	mov	DL, [_hdrive]	; DL = drive (80H = harddisk)

	EXIT_FUNCTION

	ret
ENDIF	;; USING_BIG_DISKS

;-----------------------------------------
;  On Entry
;     AL = unit #
;
;  On Exit
;     SI = BPB structure
;
	PUBLIC	get_BPBptr
get_BPBptr:

	ENTER_FUNCTION

	call	getDriveTable
	add	SI, ddt_bpb

	EXIT_FUNCTION

	ret

;----------------------------------------------
;  Set both the "hunit" and "hdrive" variables for floppies
;  and hard disks.  Will also query user if we need to change
;  disks.
;
;  On Entry
;	AL = unit # (as passed from DOS)
;  On Exit
;	AL = "internal" unit #
;	also [_hunit], [_hdrive] set
;
comment " set_unit {}; "
	public set_unit
set_unit proc near ; {

	ENTER_FUNCTION

	push	SI
	push	AX

	; save the unit
	mov	[_hunit], AL

	;  Determine if this is the active unit for this device.
	;
	;  NOTE: Devices that are not shared will also have the active
	;        bit set
	;
	call	getDriveTable	; DS:SI = drive_table
	test	[si].DDT_dattr, DATTR_ACTIVE_UNIT_FOR_SHARED_DEVICE
	jnz     u2d_no_fake

	; record the drive letter so we remember
	call	set_fake_drive

	push	bx		; Save reg values from 'C' functions
	push	cx
	push	dx
	push	es
	push	AX

	; record the drive letter in the change message string
	add	AL, base_flop_drive
	add	AL, 'A'
	mov	BX, GOFFSET _flop_chg_msg
	push	bx	; push address of _flop_chg_msg on stack for printf
	add	BX, _flop_chg_off
	mov	[BX], AL	; change the drive letter in the string

	; explain it to user and wait for a key

	call	_printf
	pop	AX	; clear stack from c function
	call	_con_getkey

	pop	AX
	pop	es
	pop	dx			; get back reg values
	pop	cx
	pop	bx

	; always use unit 0 on 1 floppy system
u2d_faked:
	mov	AL, 0

u2d_no_fake:
	call	getDriveTable	; DS:SI = drive_table

IF USING_FAT32
	mov	al, [si].DDT_FatType
	mov	ucCurFatType, al
ENDIF
IF USING_BIG_DISKS
	mov	al, byte ptr [si].DDT_uEBiosDriveInfoFlags
	mov	ucCurEbiosInfoFlags, al			; B7-B15 reserved (0)
	mov	al, byte ptr [si].DDT_uEBiosDriveAttributes
	mov	ucCurEbiosAttributes, al		; B3-B15 reserved (0)
ENDIF
	mov	al, [si].DDT_bios_drive
	mov	[_hdrive], al

	; return "real" unit # in AL
	;
	pop	AX
	mov	AL, [_hunit]
	pop	SI

	EXIT_FUNCTION

	ret
set_unit endp ; }


;------------------------------------
;  Set the fake drive variable (in BIOS area too)
;
;  On Entry
;	AL = unit #
;    DS:SI = DDT for the unit
;
set_fake_drive:

	ENTER_FUNCTION


	;  Clear the active unit bit for the current shared device
	;
	push	si
	push	ax
	mov	al, fake_drive
	call	getDriveTable	; DS:SI = drive_table
	and	[si].DDT_dattr, NOT DATTR_ACTIVE_UNIT_FOR_SHARED_DEVICE
	pop	ax
	pop	si


	;  Record the active drive and set the active unit bit for
	;  this shared device
	;
	mov	fake_drive, AL
	or	[si].DDT_dattr, DATTR_ACTIVE_UNIT_FOR_SHARED_DEVICE


IFDEF ABSLOC
	; set BIOS location also.  Datalight believes this
	; is bad policy, but some MS programs insist.
	push	ES
	push	BX
	mov	BX, 50H		; 50:4
	mov	ES, BX
	mov	byte ptr ES:[4], AL
	pop	BX
	pop	ES
ENDIF
	EXIT_FUNCTION

	ret


COMMENT ~ ; prototype ;
-----------------------------------------------------------
   Check for TRACK boundaries

   Given a number of sectors to write, return the number
   of sectors that can be written before a track boundary
   will be crossed.  That is, if we have 15 sectors per
   cluster, and we are starting on sector 2, only allow
   up to 14 sectors.

   Also understands the HMA.  Sectors cannot be read
   directly into the HMA, they must be copied.

   Returns the # of sectors.

-----------------------------------------------------------
unsigned track_overrun(unsigned seg)
{}
~
	public	_track_overrun
_track_overrun	proc	near

	ENTER_FUNCTION

	push	BP
	mov	BP, SP

	; /*
	;    ROM-DOS buffers may be in the HMA.  Some Hard
	;    drive DMA controllers and most floppy contollers
	;    cannot read into segment FFFFH. Others cannot read
	;    into a UMB or EMS page. These cases must be double
	;    buffered. Assume FRAME implies UMBs exist.
	; */
	;
	; _umb_arena is initialized to -1. If EMM386 has mapped in
	; UMBs then _umb_arena will hold the segment value of the
	; last block in the MCB chain which will point to the
	; first block in UMB chain.
	;
	mov ax, [_umb_arena]		; if EMM has mapped UMBs
	inc	ax
	jz	no_emm

	dec	ax                      ; then find lowest UMB seg
	push	es
	mov	es, ax
	add	ax, es:[3]
	pop	es
	inc	ax

	cmp	word ptr P[BP], AX	; if buffer seg is not in
	jb	not_high                ; conventional RAM
	xor	AX, AX			; then must split up the call
	jmp	short done_dma_o

no_emm:
	cmp	word ptr P[BP], 0F000h	; if buffer is in the HMA then
	ja	done_dma_o              ; must split up the call

not_high:

	; don't split up rd/wr for SPT on hard disks
IFNDEF SPT_SPLIT_ALL	; see commment in DEVFDHD.INC
	mov	AX, [_DMA_num]
	test	[_hdrive], HARDDISK
	jnz	done_dma_o
ENDIF

	;  maxnum = DMA_bpb->BPB_sec_per_trak - hsect + 1;
	mov	BX, word ptr [_DMA_bpb]
	mov	AL, byte ptr [BX.BPB_sec_per_trak]
	sub	AL, [_hsect]
	inc	AL
	mov	AH, 0

	; if(num > maxnum)
	;    num = maxnum;
	cmp	AX, [_DMA_num]
	jbe	done_dma_o
	mov	AX, [_DMA_num]
	;  }
done_dma_o:
	;  return num;
	pop	BP

	EXIT_FUNCTION

	ret
_track_overrun	endp


COMMENT ~ ; prototype ;
-----------------------------------------------------------
 Test the BPB to make sure it is valid.  Returns TRUE if
 passed, FALSE if failed (in AX).

 NOTE: don't count on a 0xAA55 signature. MSystems TFFS
       puts a zero there.

 NOTE: 	We use the DDT FAT type flag to tell if we are
	dealing with a FAT32 drive. FAT12 and FAT16
	drive types are still determined dynamically
	based on the total number of sectors so that we
	can work with high capacity floppies like
	LS-100s that work with either FAT12 floppies or
	their own proprietary FAT16 diskettes.

 Returns TRUE if valid, FALSE if not
-----------------------------------------------------------
int check_bpb(uchar bDdtFatType, struct BPB * bpb)
{}
~
	public	check_bpb
check_bpb	proc	near

	ENTER_FUNCTION

	push	BP
	mov	BP, SP

DDT_FAT_TYPE	=	4	; [bp+4] is the drive's DDT FAT type
BPB_PTR		=	6	; [bp+6] is a ptr to the BPB to check out


	;  if(!bpb->sides || !bpb->BPB_sec_per_trak || !bpb->BPB_sec_size ||
	;		(bpb->BPB_sec_size&0x7F))
	;    return FALSE;
	mov	BX, [bp+BPB_PTR]		; DS:BX = ptr to BPB
	cmp	word ptr [BX.BPB_sides], 0
	jz	cb_failed
	cmp	word ptr [BX.BPB_sec_per_trak], 0
	jz	cb_failed
	cmp	word ptr [BX.BPB_sec_size], 0
	jz	cb_failed
	test	byte ptr [BX.BPB_sec_size], 7FH
	jnz	cb_failed

	; check for FAT32
	;
IF USING_FAT32
IF USE_186 EQ 0
.386
ENDIF
	test	byte ptr [bp+DDT_FAT_TYPE], DDT_FAT_TYPE_32
	jz	CB_CheckFAT16

   CB_CheckFAT32:
	cmp	[bx].BPB_uFatSectors, 0		; 0 defines a FAT32
	jne	CB_failed

	cmp	[bx].BPB_uDirEntries, 0		; can grow on a FAT32
	jne	CB_failed

IF USE_186 EQ 0
	cmp	[bx].BPB_ulSectorsPerFat, 0	; cannot be 0 if FAT32
	je	CB_failed

	cmp	[bx].BPB_ulRootDirStartCluster, 2  ; min cluster # is 2
	jb	CB_failed

	cmp	[bx].BPB_lnumsec, MIN_FAT32_SECTORS ; must be at least 512M
	jb	CB_failed

ELSE    ;; USE_186
	cmp	word ptr [bx].BPB_ulSectorsPerFat, 0	; cannot be 0 if FAT32
	jne	CB_CheckRootDirStart
        cmp     word ptr [bx].BPB_ulSectorsPerFat[2], 0 ; cannot be 0 if FAT32
        je      CB_failed

   CB_CheckRootDirStart:
        cmp     word ptr [bx].BPB_ulRootDirStartCluster[2], 0
	jne	CB_CheckMinFat32Sectors
	cmp	word ptr [bx].BPB_ulRootDirStartCluster, 2  ; min cluster # is 2
        jb      CB_failed

   CB_CheckMinFat32Sectors:

	cmp	word ptr [bx].BPB_lnumsec[2], MIN_FAT32_SECTORS_H ; must be at least 512M
        jb      CB_failed
        ja      CB_FAT32OK
	cmp	word ptr [bx].BPB_lnumsec, MIN_FAT32_SECTORS_L ; must be at least 512M
	jb	CB_failed

ENDIF   ;; USE_186

   CB_FAT32OK:
    	jmp	short CB_FATSizeOK

    CB_CheckFAT16:
	cmp	word ptr [bx].BPB_uFatSectors, 0	; this defines a FAT32
	je	CB_failed


.8086
ELSE
	test	byte ptr [bp+DDT_FAT_TYPE], DDT_FAT_TYPE_32
	jnz	CB_failed

    CB_CheckFAT16:
	cmp	word ptr [bx].BPB_fat_size, 0	; this defines a FAT32
	je	CB_failed

ENDIF	;; USING_FAT32

	; Make sure sector size is in bounds.  If not, set it
	; to a "normal" value (512 bytes)
	;
    CB_FATSizeOK:
	cmp	word ptr [BX.BPB_sec_size], MAXSECSIZE
	jbe	size_ok
	mov	word ptr [BX.BPB_sec_size], NORMSECSIZE
size_ok:

	; Make sure that lnumsec is not set if numsec is set
	;
	cmp	word ptr [BX.BPB_num_sec], 0
	jz	secs_ok
	xor	AX, AX
	mov	word ptr [BX.BPB_lnumsec], AX
	mov	word ptr [BX.BPB_lnumsec+2], AX
secs_ok:

	; MSDOS insists drives have two FATs.
	; If you say "trust me, it doesn't", we will.
	;
	cmp	byte ptr _trustMe, 0
	ja	cb_hd_num_fats_ok
	mov	[bx].BPB_num_fats, 2

cb_hd_num_fats_ok:
	;  else
	;    return TRUE;
	mov	AX, 1
	jmp	short cb_done
cb_failed:
	xor	AX, AX
cb_done:
	pop	BP

	EXIT_FUNCTION

	ret
check_bpb	endp


;------------------------------------------------------
;  void get_fatid(uchar unit, char *boot_sector)
;
;  On Exit
;	drive_table for this unit is set to serial from
;	boot sector, or "defaults" if none.
;
	public	get_fatid
get_fatid	proc near ; {

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
IF USING_FAT32
	sub	sp, 4
ENDIF
	push	SI
	push	DI

UNIT_NUMBER		=	4
BOOT_SECTOR_PTR		=	6
DDT_FAT_ID		=	4
FAT_ID_DIGITS		=	2

IF USING_FAT32
	mov     al, [bp+UNIT_NUMBER]
	call	getDriveTable
	mov	al, [si].DDT_FatType
	mov	byte ptr [bp-DDT_FAT_ID], al
ENDIF

	; is there a serial # and FAT id?
	;
	mov	di, ds		; es must point to DGROUP
	mov	es, di
	mov	DI, GOFFSET _def_fatid
	mov	SI, [BP+BOOT_SECTOR_PTR]

IF USING_FAT32

	; See if this is a FAT32 drive and get the appropriate offset into
	; the boot sector of the disk's FAT ID string
	;
	mov	ax, BS_BootSectorInfo.FileSystemID32
	mov	word ptr [bp-FAT_ID_DIGITS], '23'		; digits = "32"
	test	byte ptr [bp-DDT_FAT_ID], DDT_FAT_TYPE_32
    	jnz	GFID_CHECK_FAT32

	mov	byte ptr [bp-FAT_ID_DIGITS], '1'		; digits = "12"
	mov	ax, BS_BootSectorInfo.FileSystemID16
	test	byte ptr [bp-DDT_FAT_ID], DDT_FAT_TYPE_16
    	jz	GFID_CHECK_FAT32
	mov	byte ptr [bp-FAT_ID_DIGITS][1], '6'		; digits = "16"

    GFID_CHECK_FAT32:
	add	si, ax
	cmp	word ptr [si], 'AF'	; does the string start with "FA"?
	jnz	no_fatid                ; if not, it's bogus
	cmp	byte ptr [si][2], 'T'	; now look for "T"
	jne	no_fatid
	mov	ax, [si][3]
	cmp	ax, word ptr [bp-FAT_ID_DIGITS]   	; "FAT1" or "FAT3"?
	jnz	no_fatid				; if not, it's bogus

ELSE ;; USING_FAT32
	add	SI, BOOT_FATID_STR
	mov	CX, 4		; just compare the 1st part "FAT1"
	cld
	repz	CMPSB
	jnz	no_fatid
ENDIF ;; USING_FAT32

	; Record the current disk's volume label, serial # and FAT id in the
	; DDT for this drive
	;
	mov	AL, [BP+UNIT_NUMBER]
	call	getDriveTable
	mov	di, si		; move drive_table ptr fm SI into DI
	add	di, DDT_volume
	mov	si, [bp+BOOT_SECTOR_PTR]

IF USING_FAT32
IF USE_186 EQ 0
.386
ENDIF
	; See if this is a FAT32 drive and get the appropriate offset into
	; the boot sector of the disk's Volume Label string
	;
	mov	ax, BS_BootSectorInfo.VolumeLabel32
	test	byte ptr [bp-DDT_FAT_ID], DDT_FAT_TYPE_32
    	jnz	GFID_record_FAT32

	mov	ax, BS_BootSectorInfo.VolumeLabel16

    GFID_record_FAT32:
	add	si, ax  	; copy the boot sector volume label
	mov	cx, BOOT_VOL_LEN
	cld
	rep	movsb           ; DI-> DDT serial #, SI-> boot FAT ID string
	inc	di		; skip NULL after volume

IF USE_186 EQ 0
	push	eax		; copy the boot sector serial number
	mov	eax, [si][-(BOOT_SERIAL_LEN+BOOT_VOL_LEN)]
	mov	[di], eax
	pop	eax
ELSE    ;; USE_186
	push	ax		; copy the boot sector serial number
        push    dx
	mov	ax, word ptr [si][-(BOOT_SERIAL_LEN+BOOT_VOL_LEN)]
        mov     dx, word ptr [si][-(BOOT_SERIAL_LEN+BOOT_VOL_LEN)][2]
	mov	word ptr [di], ax
        mov     word ptr [di+2], dx
        pop     dx
	pop	ax
ENDIF   ;; USE_186
	add	di, 4		; skip over serial number, now at FAT ID string
	mov	cx, BOOT_FATID_LEN
	cld
	rep	MOVSB		; copy the FAT ID string from the boot sec.
.8086
ELSE ;; USING_FAT32

	add	SI, BOOT_VOL_STR
	mov	CX, BOOT_VOL_LEN
	cld
	rep	MOVSB
	inc	DI		; skip past NULL on volume

	mov	SI, [BP+BOOT_SECTOR_PTR]	; serial #
	add	SI, BOOT_SERIAL
	mov	CX, 4
	cld
	rep	MOVSB

	mov	SI, [BP+BOOT_SECTOR_PTR]	; fat ID
	add	SI, BOOT_FATID_STR
	mov	CX, BOOT_FATID_LEN
	cld
	rep	MOVSB

ENDIF ;; USING_FAT32

	jmp	short got_fatid

no_fatid:
	mov	al, [BP+UNIT_NUMBER]
	mov	ah, [bp-DDT_FAT_ID]
	call	init_fatid

got_fatid:
	pop	DI
	pop	SI
	mov	sp, bp
	pop	BP

	EXIT_FUNCTION

	ret
get_fatid	endp ; }

;--------------------------------
;  On Entry
;	AL = unit
;	AH = DDT FAT Type
;  On Exit
;	drive_table for this unit is set to serial "defaults"
;
	public	init_fatid
init_fatid	proc	near ; {

	ENTER_FUNCTION

	push	SI
	push	DI

	mov	bx, '23'           		; bx = "32"
	test	ah, DDT_FAT_TYPE_32
    	jnz	IF_DoIt

	mov	bl, '1'				; bx = "12"
	test	ah, DDT_FAT_TYPE_16
    	jz	IF_DoIt
	mov	bh, '6'				; bx = "16"

    IF_DoIt:
	mov	ah, 0
	call	getDriveTable
	mov	di, si
	add	di, DDT_volume
	mov	si, GOFFSET _def_volume
	mov	cx, BOOT_VOL_LEN
	cld
	rep	movsb
	inc	di		; skip NULL after volume
	xor	ax, ax
	stosw			; put a 0 in the serial number
	stosw
	mov	si, GOFFSET _def_fatid
	mov	cx, BOOT_FATID_LEN
	cld
	rep	movsb
	mov	[si][3-BOOT_FATID_LEN], bx

	pop	di
	pop	si

	EXIT_FUNCTION

	ret
init_fatid	endp ; }

ENDIF ;; (FLOPX OR FDHDX)

cEndCode


cBegData
	assume CS:DGROUP, DS:DGROUP

IF (FLOPX OR FDHDX)
	extrn	_check_enable_hma:near
	extrn	old13:dword
	extrn	reboot13:dword
	extrn	_ROM_DS:word

;---------------------------------------------------------
;  We trap BIOS INT 19H (reboot interrupt) so that the
;  disk base table (1EH) and the disk interrupt (13H)
;  are pointing to the right place for the BIOS to work.
;
	public	hma_int_19
hma_int_19:

	ENTER_FUNCTION

	; restore original INT 13H (Disk I/O)
	xor	AX, AX
	mov	DS, AX
	les	AX, CS:[reboot13]
	mov	DS:[BIOSDISK*4], AX
	mov	DS:[BIOSDISK*4+2], ES

	; restore original INT 1EH (Disk Base Table)
	les	AX, CS:[old1E]
	mov	DS:[BIOSDBT*4], AX
	mov	DS:[BIOSDBT*4+2], ES

	; restore original INT 19H (Reboot)
	les	AX, CS:[old19]
	mov	DS:[BIOSREBOOT*4], AX
	mov	DS:[BIOSREBOOT*4+2], ES

	; restore the original BIOS top of memory value
	;
	mov	DS, CS:[_ROM_DS]
	mov	ax, 40h
	mov	es, ax
	mov	ax, [_paras_total]
	mov	cl, 6
	shr	ax, cl
	mov	es:[13h], ax

	; jump to original reboot handler
	cli

	EXIT_FUNCTION

	jmp	dword ptr CS:[old19]


;---------------------------------------
;  On Entry
;	ES:BX = buffer
;  On Exit
;	AL = # of sectors before next DMA boundary
;	destroys CX
;
max_dma_sectors proc near

	ENTER_FUNCTION

	push	DX

	; we only care about lower 16 bits of 20 bit address
	mov	AX, ES
	mov	CL, 4
	shl	AX, CL
	add	AX, BX		; AX = lower 16 bits of 20 bit addr

	; how many sectors until it wraps?
	jz	all_of_em
	neg	AX
	xor	DX, DX
	div	word ptr [bios_bps]
	jmp	short max_dma_done

all_of_em:
	mov	AL, 80H
max_dma_done:
	pop	DX

	EXIT_FUNCTION

	ret
max_dma_sectors endp

;---------------------------------------------------------
;  We trap BIOS INT 13H (disk interrupt) for 2 reasons:
;  1) DOS must ALWAYS detect change line status.  User may
;     query status via INT 13H directly and DOS wouldn't
;     see it.
;  2) The final buffer destination MAY be in the HMA.
;     Some BIOS' turn off HMA during INT 13H.
;  3) For Curtis ROMDISK, handle DMA 64K boundary, but not
;     track overrun
;
	public	hma_int_13
hma_int_13:

	ENTER_FUNCTION

	; remember the command
	mov	CS:[bios_AX], AX

	cmp	ah, 5         		; if format command
	je	format_op		; double buffer user buffer

	cmp	ah, 7
	je	format_op

	; actually perform the INT 13H
	pushf
	call	dword ptr CS:[old13]

	; reenable the HMA
	pushf
	call	_check_enable_hma
	popf

	; was there a change line error?
	jnc	hma_13_done
	pushf

	; DMA boundary, retry with new values
	cmp	AH, 9
	jz	dma_13_handler

	; DMA boundary, retry with new values
	cmp	AH, 8
	jz	dma_13_handler

	; was it a change-line error?
	cmp	AH, 6
	jnz	hma_13_nochange

	; was error on a floppy?  force a change
	push	SI
	push	AX
	mov	AL, DL
	test	AL, 80H
	jnz	x13
	mov	AH, SIZE DriveDataTable
	mul	AH
	add	AX, GOFFSET _drive_table
	xchg	SI, AX
	mov	byte ptr CS:[SI.ddt_bpb.BPB_media], 0
x13:	pop	AX
	pop	SI
hma_13_nochange:
	popf

hma_13_done:

	EXIT_FUNCTION

	retf	2	; iret, but toss flags from INT 13H call

	; 07-15-98 (DE) SPR  1716
	; We have to make sure that the user specified format buffer does
	; not cross a DMA boundary since not all BIOS can handle this case
	; and may not return an error when they don't. Since it takes as
	; much work to figure out if we are crossing a DMA boundary as to
	; just move the data (N is small), we will always dubble buffer the
	; format data. Since each data element is a power of 2 in size we
	; can copy words.
	;
format_op:

	ENTER_FUNCTION

	push	bx			; save callers es:bx
	push	es			; will restore them after int 13h call

	push	cx			; we'll also trash all these (plus AX)
	push	si			; moving the buffer contents
	push	di
	push	ds

	test	dl, 80h                 ; assume this is a hard disk call
	mov	cx, 512/2		; with a fixed 512 byte format buffer
	jnz	fo_have_buffer_size	; jump if so, else this is a floppy...

	mov	ah, 0			; AL = sectors to format (max=63)
	shl	ax, 1                   ; @es:bx is array of 4 byte strucs
	mov	cx, ax			; one entry for each sector

    fo_have_buffer_size:
	mov	si, bx			; move data from user table to _DMA_buff
	mov	di, es
	mov 	ds, di
	mov	es, cs:[_ROM_DS]	; put format data in our temp buffer
	mov 	di, GOFFSET _DMA_buff
	mov	bx, di			; tell BIOS to look at our buffer
	cld  				; the buffer is 512 bytes long
	rep	movsw			; move words (max bytes <= 512)

	pop	ds			; restore trashed user regs
	pop	di			; except es,bx and ax
	pop	si
	pop	cx

	mov	ax, cs:[bios_AX]	; get back callers AX
	pushf
	call	dword ptr CS:[old13]	; format the track

	pop	es			; restore callers es:bx
	pop	bx

	EXIT_FUNCTION

	retf	2			; return w/ flags returned by int 13h

;---------------------------------------------------------
;  A DMA boundary crossing occurred, loop up to 3 times
;  to read before, during, and after the DMA 64K boundary.
;
dma_13_handler:

	ENTER_FUNCTION

	cmp	byte ptr cs:[bios_AX][1], 04 ; was BIOS call a verify op?
	jne not_verify_op
	popf
	push	bx   		     ; MSDOS uses a single sector buffer
	push	es		     ; but passes the specified sector count
	mov	es, cs:[_ROM_DS]
	mov bx, GOFFSET _DMA_buff
	mov	ax, cs:[bios_AX]
	pushf
	call	dword ptr CS:[old13]
	pop	es
	pop	bx

	EXIT_FUNCTION

	retf	2

not_verify_op:

	ENTER_FUNCTION

	; save user registers
	mov	CS:[bios_DS], DS
	mov	DS, CS:[_ROM_DS]
	mov	[bios_CX], CX
	mov	word ptr [bios_buff], BX
	mov	word ptr [bios_buff+2], ES

	mov	[bios_cur_sect], 0
	mov	[bios_bps], 200H	; assume 512 byte sectors for now

dma_loop:
	popf

	; assume no DMA this read/write
	mov	[bios_dma], 0

	; make ES:BX point to the right place
	call	set_ESBX

	; how many sectors can we read/write this loop?
	call	max_dma_sectors		; how many sectors until next 64K?
	cmp	AL, 0
	jz	crossing_dma
	mov	AH, [bios_sectors]
	sub	AH, [bios_cur_sect]
	cmp	AH, AL
	jae	before_dma
	mov	AL, AH			; num(AL) = min(max_dma,num_left)
before_dma:
	jmp	short no_dma_pre_xfer

	; if WRITING from ES:BX to a DMA boundary, use tempory
	; buffer DMA_buff to do the write.
crossing_dma:
	mov	AL, 1			; 1 sector
	mov	[bios_dma], AL		;
	mov	AH, [bios_cmd]
	cmp	AH, BIOSDISK_READ
	jz	dma_pre_read
	cmp	AH, BIOSDISK_WRITE
	jz	dma_pre_write
	jmp	short no_dma_pre_xfer

	; point ES:BX to DMA_buff (for read)
dma_pre_read:
	push	DS
	pop	ES
	mov	BX, GOFFSET _DMA_buff
	jmp	short no_dma_pre_xfer

	; copy data from ES:BX to DMA_buff.
	; also point ES:BX to DMA_buff (for write)
dma_pre_write:
	push	DS
	push	SI
	push	DI

	mov	CX, [bios_bps]
	push	DS		; xchg	ES,DS
	push	ES
	pop	DS
	pop	ES
	mov	SI, BX			; src offset
	mov	BX, GOFFSET _DMA_buff
	mov	DI, BX			; dst offset
	cld
	rep	movsb

	pop	DI
	pop	SI
	pop	DS
no_dma_pre_xfer:
	mov	AH, [bios_cmd]
	mov	[bios_count], AL

	; update CX to account for this sector
	mov	CX, [bios_CX]
	add	CL, [bios_cur_sect]

	; actually perform the INT 13H
	pushf
	call	dword ptr [old13]

	pushf
	jc	done_dma_loop

	; if READING across a DMA boundary, we used temporary
	; buffer DMA_buff to do the read.  Now copy the data
	; back to user space
	cmp	[bios_dma], 0
	jz	no_dma_post_xfer
	cmp	[bios_cmd], BIOSDISK_READ
	jnz	no_dma_post_xfer

	; copy data from DMA_buff to user space
	push	SI
	push	DI
	mov	CX, [bios_bps]
	mov	SI, GOFFSET _DMA_buff	; src offset
	call	set_ESBX
	mov	DI, BX
	cld
	rep	movsb
	pop	DI
	pop	SI
no_dma_post_xfer:

	; on to the next rdwr, if there are any left
	mov	AL, [bios_count]
	add	[bios_cur_sect], AL
	mov	AL, [bios_cur_sect]
	cmp	AL, [bios_sectors]
	jae	done_dma_loop
	jmp	dma_loop

done_dma_loop:
	popf
	mov	CX, [bios_CX]
	les	BX, [bios_buff]
	mov	DS, [bios_DS]

	EXIT_FUNCTION

	retf	2

;-----------------------------------------------------
;  Sets ES:BX based on "bios_cur_sect" and "bios_buff"
;  Affects no other registers.
;
set_ESBX proc near

	ENTER_FUNCTION

	push	AX
	push	DX

	mov	AL, [bios_cur_sect]
	mov	AH, 0
	mul	[bios_bps]		; changes DX!
	les	BX, [bios_buff]
	add	BX, AX

	pop	DX
	pop	AX

	EXIT_FUNCTION

	ret
set_ESBX endp

ENDIF ;; (FLOPX OR FDHDX)

cEndData

		END
