;  $Id: DEVFDHD.INC 1.6 2003/03/20 17:03:14 thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1994-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   DEVFDHD.INC created 11/04/94  by Drew Gislason

   Copyright (c) 1994-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   Include file for DEVFDHD.ASM and its init module.

---------------------------------------------------------- ~

; This driver may be assembled in any of three ways:
;
; 1) if _FLOPX_ is defined on the command line and/or (FLOPX EQ 1)
;    and (FDHDX EQ 0) then the driver is assembled to provide
;    floppy diskette support ONLY (flopx.obj + flopxi.obj).
;
; 2) if _HARDX_ is defined on the command line and/or (HARDX EQ 1)
;    and (FDHDX EQ 0) then the driver is assembled to provide
;    hard disk support ONLY (hardx.obj + hardxi.obj).
;
; 3) if neither _FLOPX_ nor _HARDX_ is supplied on the assembler
;    command line and (FDHDX EQ 1) then the driver is assembled
;    to provide BOTH floppy and hard disk support in a single
;    device driver (fdhdx.obj + fdhdxi.obj).
;
; having separate hard/floppy drivers allows mechanical hard
; disks to be optional equipment and have various memory disks
; which have their own device drivers and which identify
; themselves as fixed disks (PCMCIA ATA drives) without having
; them change drive letters when the hard disks are added to the
; system.
;
IFDEF _FLOPX_
	FDHDX	=	0
	FLOPX	=	1	; IF (FLOPX OR FDHDX) only floppy support
	HARDX	=	0
ELSE
IFDEF _HARDX_
	FDHDX	=	0
	FLOPX	=	0
	HARDX	=	1	; IF (HARDX OR FDHDX) only hard disk support
ELSE
	FDHDX	=	1	; both floppy and hard disk support
	FLOPX	=	0
	HARDX	=	0
ENDIF
ENDIF


;  The floppy portion of this driver returns a minimum #
;  of floppy drives, even if the physical disk drives do
;  not exist.  This is typically 2 (Drives A: and B: as
;  on a desktop).  Feel free to set this value to 0 or 1.
;
MINFLOPS	EQU 2

;  Each floppy disk, and each hard disk partition are
;  recorded into stuctures within this driver.  The
;  maximum # of units this driver can hold is defined
;  below.  The default maximum is 7, or drives A: - G:
;
MAXUNITS	EQU 8		; max # of device units (default = 7)
MAXHDISKS	EQU 2		; max # of physical hard disks (default = 2)
MAXSECSIZE	EQU 1024	; largest possible w/ this driver
NORMSECSIZE	EQU 512		; "normal" sector size
TIMEOUTTICKS	EQU 39		; at 18.2/sec, approx 2 seconds
MAX_RETRIES	EQU 5		; max retries after failed BIOS read/write

;  If defined, then Floppy driver uses absolute location
;  50:4 to write the "fake_drive" variable on a 1 floppy
;  system.  Some programs WRONGLY use this location rather
;  than DOS calls 440E and 440FH to determine when a single
;  floppy system is faking 2 drives.
;
ABSLOC		EQU 1

IF FDHDX
;  If defined, systems with more than 2 floppies get a
; "split" between the 1st two and the rest of them.  That
; is, FLOPS(0-1), HARD DISK(s), FLOPS(2-n).  This allows
; the hard disk to always begin on unit 2 (drive C:)
SPLITFLOPS	EQU	1
ENDIF

;  If FLOPCFG is enabled both here and in SYSGEN.ASM,
;  ROM-DOS will check to see if a disk is in the Floppy
;  Drive when looking for CONFIG.SYS.  If a disk is in the
;  drive, and that floppy contains a CONFIG.SYS, then it
;  becomes the default drive.
;
; ** normally commented out!  FLOPCFG EQU 1  **

;  If this equate is enabled then, fixed disks are treated like
;  floppies and all read/write requests to the BIOS are guaranteed
;  to never cross a track/head boundary.
;
;  Without this equate defined read/write requests to the Hard
;  Disk are passed straight through without splitting them up.
;  Example:
;
;  Write 20H sectors on a Floppy w/ 0FH Sectors Per Track
;    Int 13H, 030FH
;    Int 13H, 030FH
;    Int 13H, 0302H
;
;  Write 20H sectors to a Hard Disk w/ 0FH Sectors Per Track
;    Int 13H, 0320H
;
; ** normally commented out! SPT_SPLIT_ALL	equ	1    **

; This value, in milliseconds, is used as the Head Settling Time
; (HST) interval on successive reads and on writes within the same
; track. On error or change of diskettes the default (BIOS) value is
; restored.
;
FAST_HST	equ 1
HST_OFFSET	equ 9	; Offset of HST field in the Disk Base Table (DBT)
SPT_OFFSET	EQU 4	; Offset of Sectors per Track field in the DBT

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	BIOS RESOURCES USED
;
;	This area defines all the BIOS calls that this
;	device driver makes.
;
BIOSEQUIP	equ 11H  ; BIOS equipment list
BIOSDISK	equ 13H  ; BIOS disk interrupt
BIOSREBOOT	equ 19H  ; BIOS reboot interrupt
BIOSDBT		equ 1EH  ; Disk Base Table, a pointer, not an interrupt
FASTCHAR	equ 29H  ; DOS video interrupt

; BIOS video functions used
;
BIOSVID_TTY	equ	0EH

; BIOS disk functions used
;
BIOSDISK_RESET	equ	0
BIOSDISK_READ	equ	2
BIOSDISK_WRITE	equ	3
BIOSDISK_VERIFY	equ	4
BIOSDISK_FORMAT	equ	5
BIOSDISK_PARM	equ	8
BIOSDISK_TYPE	equ	15H
BIOSDISK_CHG	equ	16H
BIOSDISK_MEDIA	equ	18H


IF USING_BIG_DISKS

; The following enhanced BIOS functions are used if USING_BIGDISKS
; is defined (see DEVFDHD/DEVFDHDI.ASM, MAKEFILE). The functions are
; defined in the Phoenix BIOS Enhanced Disk Drive Specification v3.0.
; These functions are supported by the BIOS if it returns from int 13h
; fn 41h with EBIOSDISK_SUPPORTS_LBA_PACKETS set in CX.
;
EBIOSDISK_CHECK_PRESENT		equ	41h
EBIOSDISK_EXT_READ		equ	42h
EBIOSDISK_EXT_WRITE		equ	43h
EBIOSDISK_EXT_VERIFY		equ	44h
;; EBIOSDISK_EXT_SEEK      	equ	47h	; not used by ROM-DOS
EBIOSDISK_EXT_GET_PARMS		equ	48h

; Sub-functions specified in AL for the EBIOSDISK_EXT_WRITE function.
;
EBIOSDISK_EXT_NOT_A_WRITE_OP	equ	00h	; used by verify
EBIOSDISK_EXT_WRITE_ONLY	equ	00h
EBIOSDISK_EXT_WRITE_AND_VERIFY	equ	02h

ENDIF	;; USING_BIG_DISKS


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		MACROS, STRUCTURES AND EQUATES
;

HARDMEDIA	EQU	0F8H
HARDDISK	EQU	80H	; The 1st hard drive BIOS drive #
MAX8SPC		EQU	7F80H	; max # of sectors in 12 bit FAT (FF0H * 8)
MAX_IOCTL_SPT	EQU	36	; maximum Sectors Per Trak to Format a
				; Floppy w/ IOCTL calls

IF USING_FAT32

IFNDEF USE_186
USE_186 EQU 0
ENDIF

IF USE_186 EQ 0
.386
ENDIF   ;; USE_186

FAT32_FAT_NYBBLES	=	  8
MIN_FAT32_SPC		=         8	; no less than 8 SPC on a FAT32 drive

; sectors in 512M minimum FAT32 drive
MIN_FAT32_SECTORS	=  ((MIN_FAT32_SECTORS_H SHL 16) + MIN_FAT32_SECTORS_L)
; minimum FAT32 drive sectors @ 16 SPC
MIN_FAT32_16_SPC_DRIVE	=  ((MIN_FAT32_16_SPC_DRIVE_H SHL 16) + MIN_FAT32_16_SPC_DRIVE_L)

MIN_FAT32_SECTORS_L	=  0000h	; sectors in 512M minimum FAT32 drive
MIN_FAT32_SECTORS_H	=  0010h	; sectors in 512M minimum FAT32 drive
MIN_FAT32_16_SPC_DRIVE_L=  0000h	; minimum FAT32 drive sectors @ 16 SPC
MIN_FAT32_16_SPC_DRIVE_H=  0100h	; minimum FAT32 drive sectors @ 16 SPC

.8086
ENDIF ;; USING_FAT32

; Error codes for BIOS int 13h
;
BDISKERR_TIMEOUT	EQU	80H
BDISKERR_SEEK		EQU	40H
BDISKERR_CONTROLLER	EQU	20H
BDISKERR_READ_CRC	EQU	10H
BDISKERR_BAD_MEDIA	EQU	0CH
BDISKERR_DMA_BOUND      EQU	09H
BDISKERR_DMA_SIZE	EQU	08H
BDISKERR_CHANGED	EQU	06H
BDISKERR_SECTOR_MISSING	EQU	04H
BDISKERR_WRT_PROTECT	EQU	03H
BDISKERR_BAD_SECTOR	EQU	02H
BDISKERR_BAD_COMMAND	EQU	01H


IF USING_BIG_DISKS

; Error codes for EBIOS int 13h (drive lock and eject subsets only)
;
; Note: The "lock & eject" is not implemented in this drive. BIOS support
;	is not ubiquitous. If we implement these we will have to translate
;	these BIOS errors to (possibly new) DOS device error codes.
;
EBDISKERR_MEDIA_NOT_LOCKED	equ	0B0h
EBDISKERR_MEDIA_LOCKED		equ	0B1h
EBDISKERR_MEDIA_NOT_REMOVABLE 	equ	0B2h
EBDISKERR_MEDIA_IN_USE		equ	0B3h
EBDISKERR_LOCK_COUNT_EXCEEDED	equ	0B4h
EBDISKERR_VALID_EJECT_FAILED	equ	0B5h
EBDISKERR_MEDIA_READ_PROTECTED	equ	0B6h

ENDIF	;; USING_BIG_DISKS
