;  $Id: DEVFDHDI.ASM 1.33 2003/07/10 20:24:18 thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1994-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:DEVFDHDI.ASM
;
; Copyright (c) 1994-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary
;
; This is the initialization code for the combo floppy/hard
; disk driver.
;
; $DOCHISTORY
; 02/19/1999 de  Changed parameters to build_bpb() and check_bpb, they have to
;		 know what FAT type to expect or they will do bad things.
; 02/18/1999 de  Added FAT32 support.  Except as noted above all code
;		 for this support is inside condition USING_FAT32 blocks.
; 02/15/1999 de  Added EBIOS LBA support. Except as noted above all code
;		 for this support is inside condition USING_BIG_DISKS blocks.
; 09/24/1998 dg  Now find Super-Boot partitions first. Then they get
;                sorted into order after ALL partitions have been found.
; 09/21/1998 dg  Removed all PBEx comments.
; 09/15/1998 dg  Moved the Super-Boot variables to DOSASM.ASM so
;                that the hard disk driver isn't included in all
;                BUILDs of ROM-DOS. DOSCNTRY.C references the
;                variables.
; 08/27/1998 dg  Added Super-Boot capabilities.
; 11/04/1994 dg  Created by Drew Gislason
;
; TODOS:
; 	SuperBoot
;		contrive partition IDs for various possible SuperBoot
;		partitions (FAT16, FAT32, FAT16LBA, FAT32LBA)
;
;	figure out some way to represent "valid disks" (with a bit set?)
;		this must accommodate unformatted and FAT32 drives in FAT16
;		only kernel/device
;	dynamically allocate and initialize DDTs
;
;--------------------------------------------------------------------
include use186.inc
include macros.inc
include devhdr.inc
include dostruct.inc
include devfdhd.inc

HD_PASS_SUPRBOOT	equ 1	; (optional) Super-Boot partitions
HD_PASS_PRIME		equ 2	; Primary bootable partitions only
HD_PASS_NBPRIME		equ 3	; Primary non-bootable partitions only
HD_PASS_EXT		equ 4	; Extended partitions


;--------------------------------------------------------------------
; The Datalight Super-Boot Hidden partitions
;--------------------------------------------------------------------
IFDEF SUPERBOOT	; {

; Defines the Super-Boot drive order "SUPR_ORDER".
; Example:
;  Drive 80h  - contains 1 DOS partition (labeled DOSPART1)
;  Drive 81h  - contains 1 DOS partition (labeled DOSPART2) and 1
;		Super-Boot partition (labeled SUPRBOOT).
;
; with SUPR_FIRST:  SUPRBOOT, DOSPART1, DOSPART2
; with SUPR_MIDDLE: DOSPART1, SUPRBOOT, DOSPART2
; with SUPR_LAST:   DOSPART1, DOSPART2, SUPRBOOT
;
SUPR_FIRST	equ 1	; SUPR drives come before all DOS partitions
SUPR_MIDDLE	equ 2	; SUPR partition is drive D:
SUPR_LAST	equ 3	; SUPR drives follow all DOS partitions

    ; Specify Super-Boot options on the ASM cmdline /DSUPR_ID=98h
    IF 0
	; ID to identify Super-Boot partitions (default 98h)
	SUPR_ID 	equ 98h

	; sort order once all partitions have been found (first,
	; middle, last)
	SUPR_ORDER	equ SUPR_LAST

	; Set to TRUE (1) to instruct the RD kernel to always boot
	; from the Super-Boot partition. Set to FALSE to boot as
	; normal (drive C:)
	BOOT_FROM_SUPER	equ 1
    ENDIF

ENDIF	; SUPERBOOT }


.8086

_DEVDATA segment byte public 'DEVDATA'
IF (FLOPX OR FDHDX)
	extrn	hdr_num_units:byte
ELSE
	extrn	hardx_hdr_num_units:byte
ENDIF
_DEVDATA ends

cBegData
	extrn	reboot13:dword
	extrn	_ptrsav:dword
	extrn	_new_base_table:byte
	extrn	_DMA_buff:byte
	extrn	hdisk_bpb:byte
	extrn	hardtraks:byte
	extrn	FD_bpb:byte
	extrn	hardbpb:byte
IF USING_BIG_DISKS
	extrn	sEbiosPacket:DeviceAddressPacket
ENDIF
	extrn	hma_int_13:near
	extrn	hma_int_19:near
	extrn	_SuperOrder:byte
	extrn	_SuperBoot:byte
	extrn	_SuperID:byte
	extrn	_SuperBootDrive:byte

cEndData

cBegUData
	extrn	MotherPartStart:dword
	extrn	num_units:byte
	extrn	num_flop_units:byte
	extrn	num_flop_drives:byte
	extrn	base_flop_drive:byte
IFDEF SPLITFLOPS
	extrn	num_extra_flops:byte
	extrn   floppies_split:byte
ENDIF
IF HARDX
	extrn	base_hard_drive:byte
ENDIF
	extrn	_num_hparts:byte
	extrn	_num_hdrives:byte
	extrn	_drive_table:byte
	extrn	_bpbptr:word
	extrn	_drvparm:BiosDriveParameters
	extrn	_hhead:byte
	extrn	_hsect:byte
	extrn	_htrak:word
	extrn	_default_HST:byte
	extrn	hd_init_pass:byte
	extrn	sectlist:byte
	extrn	drive_table_ptr:word
	extrn	old13:dword
	extrn	old19:dword
	extrn	old1E:dword

IF USING_BIG_DISKS
	extrn	init_dattr_fLBARequired:word
ENDIF

	; record # of Super-Boot partitions
IFDEF SUPERBOOT
  IF (HARDX OR FDHDX)
	numSuperParts	db	?
  ENDIF
ENDIF ; SUPERBOOT

cEndUData

cBegCode
	assume	cs:_TEXT, ds:DGROUP

	; ROM-DOS functions
	extrn	MEMMOVE:near
	extrn	dev_serv:near
	extrn	dev_cmd_err:near, dev_err_exit:near
	extrn	dev_busy_exit:near, dev_err_cnt:near
	extrn	dev_exit:near
	extrn	getDGROUP:near
	extrn	_buf_get_scratch:near
	extrn	_getDEVDATA:near

	; functions local to floppy/hard driver
	extrn	GetDriveTable:near
	extrn	init_fatid:near
	extrn	get_fatid:near
	extrn	get_BPBptr:near
	extrn	check_bpb:near

IF HARDX	;; flopx allocates extern code/data for hardx
	extrn	set_new_13_handler:near
	extrn	init_type:near
	extrn   _calcspc:near
	extrn   _calcspc32:near
ENDIF

IF USE_186 EQ 1
        extrn   DIV_QL:near
ENDIF   ;; USE_186

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   INITIALIZE DEVICE (function 00H)
;
;   Determines the number of floppies and hard disk
;   partitions.
;
;   On Exit
;	+-------------------------+
;	| 13-Byte header          |
;	+-------------------------+
;  0DH	| BYTE   Number of units  | *	(set by floppy driver)
;	+-------------------------+
;  0EH	| DWORD  End Address      |	(not set: ignored for built-in devs)
;	+-------------------------+
;  12H	| DWORD  Ptr to BPB array | *	(set by floppy driver)
;	+-------------------------+
;

IF FLOPX
	PUBLIC	flopx_init
flopx_init:
ELSEIF HARDX
	PUBLIC	hardx_init
hardx_init:
ELSE
	PUBLIC	fdhd_init
fdhd_init:
ENDIF

IF (FLOPX OR FDHDX)
	; set up drive table ptr
	mov	[drive_table_ptr], GOFFSET _drive_table

	; set up a new INT 13H handler
	call	set_new_13_handler

	; remember the DOS drive number of FLOPX/FDHDX unit 0
	;
	les	BX, [_ptrsav]			; DS:BX ptr to i/o packet
	mov	AL, byte ptr ES:[BX+START+2]	; starting unit #
	mov	[base_flop_drive], AL		; 0=A, 1=B, 2=C, etc..

	; returns the # of drives
	call	flop_init
	add	[num_units], AL
ELSE
	; remember the DOS drive number of HARDX unit 0
	;
	les	BX, [_ptrsav]			; DS:BX ptr to i/o packet
	mov	AL, byte ptr ES:[BX+START+2]	; starting unit #
	mov	[base_hard_drive], AL		; 0=A, 1=B, 2=C, etc..
ENDIF ;; (FLOPX OR FDHDX)

IF (HARDX OR FDHDX)
	; get a "scratch" buffer
	call	_buf_get_scratch

	; hard_init(char far * scratch_buff)
	push	DX
	push	AX
	call	hard_init	; returns # of units
	add	SP, 4
IF HARDX
	or	al, al
	jz	init_no_units

	; record # of units in device driver header
	push	ax
	mov	dx, ds
	call	_getDEVDATA
	mov	DS, AX
	pop	ax
	assume	DS:_DEVDATA
	mov	DS:[hardx_hdr_num_units], AL	; # of hard disk units
	assume	DS:DGROUP
	mov	DS, DX			; get DGROUP back
ENDIF
	xchg	[num_units], AL
	add	[num_units], AL
IF HARDX
	cbw
	mov	bx, GOFFSET _bpbptr
	add	bx, ax
	add	bx, ax
	jmp	short set_x00
ENDIF
ENDIF ;; (HARDX OR FDHDX)
IF (FLOPX OR FDHDX)
	; no units, claim general failure
	cmp	byte ptr [num_units], 0
	jnz	init_ok
ENDIF ;; (FLOPX OR FDHDX)

init_no_units:
	mov	AL, 0CH
	jmp	dev_err_exit

IF (FLOPX OR FDHDX)
init_ok:
	; set "next" pointers of DriveDataTables
	; set unit # for each unit.  Basically, set everything
	; command to both HDs and Floppies in DriveDataTable.
	xor	AX, AX
	mov	BX, GOFFSET _bpbptr
ENDIF

IF HARDX
set_x00:
	; when HARDX gets initialized, FLOPX will have already built
	; (and terminated with an 0FFFFh) its list of DDTs. We need to
	; append the list of HARDX DDTs to the FLOPX list.
	;
	push	ax
	push	bx

	call	getDriveTable	; get hard drive DDT slot
	dec	ax
	js	set_x01		; don't patch floppy DDT if it ain't there

	push	si
	call	getDriveTable	; get last floppy DDT slot
	mov	bx, si
	pop	si
	mov	[bx],si		; append 1st hard drive DDT to floppy DDT list

set_x01:
	pop	bx
	pop	ax
ENDIF

set_x0:	cmp	AL, [num_units]
	jae	set_x9
	call	getDriveTable	; DS:SI pts to DriveTable for this unit
	mov	DX, SI
	add	DX, SIZE DriveDataTable

	push	ax			   ; AX = combined (FLOPX+HARDX) unit #
IF (FLOPX OR FDHDX)
	;
	; To minimize impact of changing FDHDX to operate as FLOPX or HARDX
	; the entire IOSYS drive table array is allocated by FLOPX/FDHDX.
	; We need the combined unit # as an index into that DDT array.
	; For FLOPX and FDHDX the device unit # is coincident with the
	; combined unit #
	;
	add	al, [base_flop_drive]
ELSE
	; (HARDX unit number) + num_flop_units = (combined unit #)
	;
	; The DOS drive number of HARDX unit 0 is passed to the driver
	; by DOS in the request header and recorded in base_hard_drive.
	; Get the DOS drive letter for this HARDX unit number from the
	; combined unit number and the HARDX unit 0 drive number.
	;
	sub	al, [num_flop_units]
	add	al, [base_hard_drive]
ENDIF
	mov	byte ptr [SI.ddt_dos_drive], AL ; set DOS drive # in drive_table
	pop	ax

	mov	word ptr [SI.ddt_nextptr+2], DS
	mov	word ptr [SI.ddt_nextptr], DX
	mov	DX, SI
	add	DX, ddt_bpb
	mov	[BX], DX
	inc	AX			; next unit
	inc	BX
	inc	BX			; next _bpbptr
	jmp	set_x0
set_x9:	mov	word ptr [SI.ddt_nextptr], -1


	; pass info back to DOS in the I/O packet.  Note
	; that we do not need to set up "end address" for
	; built-in drivers.

IF HARDX
	mov	dx, ds
	call	_getDEVDATA
	mov	DS, AX
	assume	DS:_DEVDATA
	mov	cl, DS:[hardx_hdr_num_units]	; # of hard drive units
	assume	DS:DGROUP
	mov	DS, DX			; get DGROUP back
ELSE
	mov	CL, [num_units]
ENDIF
	mov	DX, DS
	lds	BX, _ptrsav			; DS:BX ptr to i/o packet
	mov	BYTE PTR [BX+MEDIA], CL		; units (drives)
	mov	WORD PTR [BX+COUNT], GOFFSET _bpbptr	; ptr to bpb table
	mov	WORD PTR [BX+COUNT+2], DX
IF (FLOPX OR FDHDX)
	; record # of units in device driver header
	call	_getDEVDATA
	mov	DS, AX
	assume	DS:_DEVDATA
	mov	DS:[hdr_num_units], CL	; # of units
	assume	DS:DGROUP
ENDIF
	mov	DS, DX			; get DGROUP back

IF FDHDX
IFDEF SPLITFLOPS
	call	near ptr _split_floppies
ENDIF
ENDIF
	jmp	dev_exit

IF (FDHDX)
IFDEF SPLITFLOPS
comment ~

   MSDOS always reserves the initial two floppy/hard disk device units
   for use by floppies,	regardless of the number of floppies actually
   installed in the machine. If more than two floppies are installed
   then the remaining (n-2) floppies are placed following the hard drives.

   We allow the user to specify the number of FDHDX device units
   that will be reserved for floppies via the MINFLOPS constant
   in DEVFDHD.INC.

   We maintain a drive_table array of DDT structs (DEVFDHD.INC)
   with one entry for each unit. These structs are filled in
   with information from the BIOS as logical drives are
   encountered. The first drive_table entries are for floppies
   and these appear in BIOS drive number order. The floppy
   drive_table entries are followed by the primary hard disk
   partition entries (in BIOS drive number order) followed by
   the remaining extended partitions (ordered first by BIOS
   drive number order then by position on the disk)

   MSDOS compatability requires that we maintain an array of
   ptrs to BPBs with one entry for each unit. These BPB pointers
   reference the ddt_bpb field of the unit's entry in the
   drive_table array. Initially, the order of the BPB ptrs
   corresponds to the order of the drive_table entries.

   A pointer to this array of BPB pointers is returned to DOS on
   return from the device init call. DOS expects the order of
   the pointers to correspond to the device unit number.  To
   account for MINFLOPS and mimic the behaviour of MSDOS, we
   need to move all but the first MINFLOPS number of pointers to
   the end of the BPB ptr array and that is what _split_floppies
   does.

   Note that the DDT.ddt_dos_drive number (DDT.dos_drive in 'C')
   is the sum of the device unit number and the drive letter of
   the device's 0th unit passed by DOS in the request header.
   Reordering the BPB ptrs as done above effectively changes the
   unit numbers of the relocated units and so changes the
   relationship between the FDHDX unit numbers and the BIOS
   drive numbers. Since the DOS drive number is a function of
   the device unit number, the DOS drive numbers in the DDT must
   be updated as a result of the reordering of the unit numbers.

   Whenever we need to access a DDT struct based on a DOS unit number,
   we must use the unit number as an index into the BPB array and
   then adjust the array element value to point to the start of the DDT
   struct as opposed the DDT.ddt_bpb field.

   Example:

	assume MINFLOPS is 1 and that three floppies and two hard drives
	are installed in the system. Before split_floppies is called, the BPB
	ptr array will be:

		[f0][f1][f2][h0][h1]

	where [fn] is a ptr to a floppy BPB and [hk] is a ptr to a hard disk BPB.
	after the call to _split_floppies, the array will be

		[f0][h0][h1][f1][f2]

	to perform the move we dup [fn] and move each of the hard disk BPB
	ptrs down one position then put [fn] back in the array in the
	place were [hk] was just before it was moved. this is done
	for each of the floppy BPB ptrs that need to be moved.

end_comment ~
	public _split_floppies
_split_floppies proc near

	push	si			; save si

	mov	al, [num_flop_units]	; get number of floppies
	sub	al, MINFLOPS		; minus units to reserve
	mov	[num_extra_flops], al	; and put the difference away
	cbw				; convert difference to word
	mov	cx, ax			; and use it as the loop count
	jcxz	floppies_have_been_split; exit if no floppies to move

	mov	al, [num_units]		; get total units
	sub	al, [num_flop_units]	; minus floppies
	cbw				; convert to word
	shl	ax, 1			; convert ptr count to byte count
	mov	bx, ax			; this is len of hdisk ptr block

	mov	si, GOFFSET _bpbptr	; get start of BPB ptr array
	mov	al, MINFLOPS		; and reserved floppy units
	cbw				; convert reserved units to a word
	add	ax, cx			; add in
	dec	ax			; minus one for zero offset
	shl	ax, 1			; times two for bytes in each ptr
	add	si, ax			; point to first floppy ptr to move

split_up_floppies_loop:
	push	cx			; save the loop ctr
	mov	dx, [si]		; and dup the next *floppy to move

	mov	ax, si			; point to the start of the *hdisks
	inc	ax
	inc	ax

	push	bx			; save the block len
	push	dx			; save the *floppy being moved

	push	si			; push the destination ptr
	push	ax			; push the source ptr
	push	bx			; push the block len

	call	MEMMOVE			; move the *hdisk block (PASCAL proc)

	pop	dx			; get back the *floppy being moved
	pop	bx			; get back the block len

	mov	[si][bx], dx		; put the *floppy after the moved blk
	dec	si			; point to the next *floppy to move
	dec	si

	pop	cx			; get back the loop counter
	loop	split_up_floppies_loop	; continue if more *floppies to move

	xor	ax, ax
	add	al, [base_flop_drive]
	mov	bx, GOFFSET _bpbptr
	xor	cx, cx

fixup_DOS_drive_numbers:
	cmp 	cl, [num_units]
	jae	floppies_have_been_split ; all drive numbers were adjusted

	mov	si, [bx]		; get ptr to ddt.ddt_bpb for unit
	sub	si, ddt_bpb		; get ptr to ddt[0] for unit
	mov	[si].ddt_dos_drive, al	; update unit's drive number

	inc	ax			; inc drive number
	inc	bx			; inc ptr to ddt.ddt_bpb
	inc	bx
	inc	cx			; inc unit number
	jmp	short fixup_DOS_drive_numbers

floppies_have_been_split:
	mov	byte ptr floppies_split, 1
	pop	si			; restore si
	retn				; and return
_split_floppies endp
ENDIF ;; SPLITFLOPS
ENDIF ;; (FDHDX)


IF (FLOPX OR FDHDX)
;-------------------------------------------------
;  FLOPPY INIT ROUTINE
;
;  Steps Involved:
;	1) Get # of floppies from equipment list
;	2) Set up fake 2 floppies if needed
;	3) Make initial BPBs and pointers to them
;	4) Figure out drive types for 440DH IOCTL call
;	5) Set up Disk Base Table (BIOS timing) for floppies
;	6) Reset Each Disk
;	7) (optional) Determine if a floppy is in the drive
;
;  Returns
;	# of units for floppy
;
comment " flop_init {}; "
	PUBLIC flop_init
flop_init proc near ; {

	;-----------------------------------------------
	;  Step	1) Get # of floppies from equipment list
	call	get_flops_from_bios
	mov	[num_flop_drives], AL

	;-----------------------------------------------
	;  Step	2) Set up fake 2 floppies if needed
	;  Always at least 2 floppies on a desktop system
	cmp	AL, MINFLOPS
	jae	FI21
	mov	AL, MINFLOPS
FI21:	mov	[num_flop_units], AL

	;------------------------------------------------
	;  Step 3) Figure out drive types for 440DH IOCTL
	xor	AX, AX
FI42:	cmp	AL, [num_flop_units]
	jae	FI51
	push	AX		; save unit #
	call	init_fatid	; set DriveTable "NO NAME" and "FAT12"
	pop	AX
	mov	CX, AX
	call	getDriveTable	; SI = drive_table for this unit
	mov	[SI].DDT_dattr, DATTR_ACTIVE_UNIT_FOR_SHARED_DEVICE
	cmp	CL, [num_flop_drives]
	jb	FI43
	mov	CL, 0		; use BIOS drv 0 for non-existant units
	mov	[SI].DDT_dattr, DATTR_SHARES_PHYSICAL_DEVICE
FI43:
	mov	[SI.DDT_bios_drive], CL
	cmp	al, 0
	jne	FI43B
	push	cx
	mov	cl, [num_flop_drives]
	cmp	cl, [num_flop_units]
	pop	cx
	jae	FI43B
	or	[SI].DDT_dattr, DATTR_SHARES_PHYSICAL_DEVICE
FI43B:

IF USING_BIG_DISKS
	mov	[si].DDT_uEBiosDriveInfoFlags, 0  ; NO ext capabilities for floppy
	mov	[si].DDT_uEBiosDriveAttributes, 0 ; NO ext attributes for floppy
ENDIF
	push	AX		; push "unit" on stack
	push	CX		; push BIOS drive # on stack
	call	init_type	; init_type(uchar drive, uchar unit)
	pop	CX
	pop	AX		; restore unit
	inc	AX
	jmp	short FI42
FI51:

	;------------------------------------------------
	;  Step	4) Make initial BPBs
	xor	AX, AX
	push	DS
	pop	ES		; make sure ES=DS
FI31:	cmp	AL, [num_flop_units]
	jae	FI41
	call	get_BPBptr
	mov	DI, SI
	add	DI, (ddt_defbpb - ddt_bpb)
	xchg	SI, DI
	mov	CX, SIZE BiosParameterBlock
	cld
	rep	MOVSB
	inc	AL
	jmp	FI31
FI41:

	;---------------------------------------------------
	;  Step	5) Set up Disk Base Table (timing) for floppies

	; switch the "old" DBT with our new
	mov	BX, BIOSDBT*4
	mov	DX, DS
	mov	AX, GOFFSET _new_base_table
	mov	SI, GOFFSET old1E
	call	swapint		; old returned in DX:AX
	push	DS
	pop	ES
	mov	DI, GOFFSET _new_base_table ; ES:DI = Disk Base Table
	xchg	SI, AX
	mov	DS, DX			; DS:SI = old DBT

	; copy the "old" DBT, changing some of the fields to "new" values
	cld
	mov	CX, 0BH			; size of Disk Base Table
	mov	ah, byte ptr [si+HST_OFFSET] ; get BIOS HST value

FI52:	lodsb
	cmp	BYTE PTR ES:[DI], 0	; only change non-zero parms
	jz	FI53			; leave the rest the same
	mov	AL, ES:[DI]		; use our parm instead of the BIOS'
FI53:	stosb
	loop	FI52
	call	getDGROUP		; restore DS to ROM-DOS DGROUP
	mov	[_default_HST], ah	; record BIOS head settling time

	;---------------------------------------
	;  Step	6) Reset Each Disk

	; reset each floppy (if there are any)
	xor	AX, AX
FI60:	cmp	AL, [num_flop_drives]
	jae	FI61
	push	AX
	mov	DL, 0
	mov	AH, BIOSDISK_RESET
	sti			; ETR 3367
	int	BIOSDISK
	pop	AX
	inc	AL
	jmp	short FI60
FI61:

	;---------------------------------------
	;  Step 7) (optional) Determine if a floppy is in the drive
	;
	;  This option (explained in SYSGEN and the manual)
	;  tells ROM-DOS to go to the floppy for CONFIG.SYS,
	;  regardless of which is the "boot" drive.
IFDEF FLOPCFG
	public flop_config
flop_config:
	; if no floppy drives, don't DO ANYTHING
	cmp	[num_flop_drives], 0
	jz	FI72

	mov	AL, 0		; unit 0
	call	set_unit	; get BPB for this floppy
	call	readsector0
	jc	FI71

	; a disk is definitely in the drive
	mov	[_disk_in_drive], 1

FI71:	; reset the floppy
	mov	DL, 0
	mov	AH, BIOSDISK_RESET
	sti			; ETR 3367
	int	BIOSDISK
FI72:
ENDIF

	;---------------------------------------
	;  Step 8) Create a sector list for Formatting
	;
	mov	CX, MAX_IOCTL_SPT
	mov	BX, GOFFSET sectlist
	mov	AL, 1
FI81:	add	BX, 2
	mov	byte ptr [BX], AL
	inc	BX
	inc	AL
	mov	byte ptr [BX], 02H	; sector size 200H
	inc	BX
	loop	FI81

	; return the # of units for the floppy driver
	mov	AL, [num_flop_units]
	ret
flop_init endp ; }


;----------------------------------
;  On Exit
;	AL = # of floppy drives (according to BIOS)
;
comment " get_flops_from_bios() {}; "
get_flops_from_bios	proc	near ; {

	; Get # of floppies from equipment list
	; ........ xx......	# of drives (00=1, 01=2, 10=3, 11=4)
	; ........ .......x	are drives present?
	sti			; ETR 3367
	int	BIOSEQUIP
	test	AL, 1		; any drives?
	jz	no_flops
	mov	CL, 6
	shr	AL, CL
	inc	AL		; # of drives
	ret
no_flops:
	mov	AL, 0		; BIOS says no drives
	ret
get_flops_from_bios	endp ; }
ENDIF ;; (FLOPX OR FDHDX)


IF (HARDX OR FDHDX)

; ->:	AL =	Hard Disk Sequence number (BIOS drive number - 80h)
; <-:	SI ->	BiosDeviceParameters for the specified hard drive
;
	public	GetBiosDriveParameterTable
GetBiosDriveParameterTable	proc
	mov	ah, size BiosDriveParameters
	mul	ah
	mov	si, GOFFSET _drvparm
	add	si, ax
	ret
GetBiosDriveParameterTable	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;   The hard disk driver "knows" the size of a hard disk
;   partition even if there is no valid BPB.  The sectors
;   per cluster are calculated based on the maximum # of
;   sectors:
;
;	clusters  sectors  FAT size  spc  size
;	  FF0H     7F80H    12 bit     8  up to 16MB
;	 FFF0H    3FFC0H    16 bit     4  up to 128MB
;	 FFF0H    7FF80H    16 bit     8  up to 256MB
;	 FFF0H    FFF00H    16 bit    16  up to 512MB, etc...
;
;   The search order for hard disk partitions, as defined
;   by MS-DOS, is somewhat convoluted.
;
;   1) Bootable primary partitions 1st
;   2) non-bootable Primary partitions 2nd
;   3) Extended partitions 3rd
;
;   The chart below, which depicts 3 hard disks,
;   order.
;
;       HD1           HD2             HD3
;   +----------+  +------------+  +----------+
;   | Primary  |  |            |  | Primary  |
;   | Primary2 |  |            |  |          |
;   | Extended |  | 3 Extended |  |          |
;   +----------+  +------------+  +----------+
;
;        C:                            E:
;        D:
;        F:          G: H: I:
;
COMMENT ~ ; prototype ;
/*
	Initialize the hard disk driver.  A scratch
	buffer is passed, which can be used along with
	DMA_buff to read the HDs.

	1) Determine Number Of Hard Disks
	2) Read ALL Primary Partitions on ALL Hard Disks
	3) Read ALL Extended Partitions on ALL Hard Disks

	Table Sector
	   A sector containing a Parition Table.  The Table
	   Sector at 0L (start of the disk) is called the
	   Master Boot Record.
	Boot (BPB) Sector
	   Inside of a hard disk partition, this sector
	   may contain a BPB.
*/
int hard_init(void far *scratch)
{}
~
	public hard_init
hard_init	proc	near ; {
	push	BP
	mov	BP, SP
PARTOFF		equ	1BEH
   ;
   ;	{
   ;	register struct hdsize * dp;
   ;	struct partition far * part_ptr;
   ;	int drv;
   ;	ulong partsec;
   ;	unsigned spt;
   ;	unsigned trak;
   ;	int n;
   ;
HI_SCRATCH	= 4		; [BP+4]
HI_PPTR 	= -4		; [BP-4]   struct partition far * part_ptr;
HI_DRV		= -6		; [BP-6]   int drv;
HI_PARTSEC	= -10		; [BP-10]  ulong partsec;
HI_SPT		= -12		; [BP-12]  unsigned spt;
HI_TRAK		= -14		; [BP-14]  unsigned trak;
HI_LASTFOUND	= -16		; [BP-16]  int lastfound;
	sub	SP, 16
	push	SI		; struct hdsize * dp

IFDEF DEBUG_DEVICE_INIT
   ; display a '['
   ;
   push  AX
   push  BX
   mov   ax,0E5Bh
   mov   bx,0
   int   10h
   pop   BX
   pop   AX
ENDIF ; IFDEF DEBUG_DEVICE_INIT

   ;	/* we'll use num_hparts to be numunits */
   ;	num_hparts = num_flop_units;
   ;
   	mov	AL, [num_flop_units]
	mov	byte ptr [_num_hparts], AL
   ;
   ;	/* determine # of hard drives */
   ;	num_hdrives = num_hard_drives();
   ;
	call	near ptr _num_hard_drives
	mov	byte ptr [_num_hdrives], AL
   ;
   ;	if(!num_hdrives)
   ;	   goto done;
   ;
	cmp	byte ptr [_num_hdrives], 0
	jnz	short @1@74
	jmp	hi_done
@1@74:
   ;
   ;	/* determine drive info on each hard drive */
   ;	get_drive_parms(num_hdrives);
   ;
	mov	AL, byte ptr [_num_hdrives]
	cbw
	push	AX
	call	near ptr _get_drive_parms
	pop	AX

	; On 1st pass (optional), do Super-Boot partitions
	; On 2nd pass, do only bootable partitions
	; On 3rd pass, do other primary partitions
	; On 4th pass, do extended partitions
IFDEF SUPERBOOT
	mov	_SuperID, SUPR_ID
	mov	_SuperOrder, SUPR_ORDER
	mov	_SuperBoot, BOOT_FROM_SUPER

	; start on optional Super-Boot pass
	mov	[hd_init_pass], HD_PASS_SUPRBOOT
ELSE
	; start on optional bootable primary partitions pass
	mov	[hd_init_pass], HD_PASS_PRIME
ENDIF

;--------------------------------------------------------------------
; Step 1: find all primary partitions on all drives. Partition type
; is dependant on pass.
;
hi_bootable_while:
	mov	word ptr HI_DRV[BP], 0		; drv = 0

;--------------------------------------------------------------------
; Step2: Loop until all primary partitions of this type are found on
; this drive.
;
hi_prime_while:
	mov	AL, byte ptr HI_DRV[BP]
	cmp	AL, byte ptr [_num_hdrives]
	jae	hi_prime_done
	cmp	byte ptr [_num_hparts], MAXUNITS
	jae	hi_prime_done

   ;
   ;	/* read in 1st Primary DOS Partition on each drive */
   ;	num_hparts += read_all_parts(num_hparts, drv, 0, scratch);
   ;
   	push	word ptr HI_SCRATCH+2[BP]
   	push	word ptr HI_SCRATCH[BP]
   	xor	AX, AX
   	push	AX
   	push	AX
	push	word ptr HI_DRV[BP]
	mov	AL,  [_num_hparts]
	cbw
	push	AX
IF USING_BIG_DISKS
	mov	init_dattr_fLBARequired, 0
ENDIF ;; IF USING_BIG_DISKS
	call	near ptr _read_all_parts
	add	SP, 12
	add	byte ptr [_num_hparts], AL
   ;
   ;	++drv;
   ;
	inc	byte ptr HI_DRV[BP]

   ;
   ;	}  /* done finding Primary drives */
   ;
   	jmp	hi_prime_while
hi_prime_done:

	; on to next pass
	inc	hd_init_pass
	cmp	hd_init_pass, HD_PASS_EXT
	jb	hi_bootable_while
hi_bootable_done:

   ;
   ;	/* Pass 3: find extended DOS partitions */
   ;	for(drv=0; drv<num_hdrives && num_hparts<MAXUNITS; ++drv)
   ;	{
   ;
	mov	word ptr HI_DRV[BP], 0
hi_ext_while:
IF USING_BIG_DISKS
	mov	init_dattr_fLBARequired, 0
ENDIF ;; IF USING_BIG_DISKS
	mov	AL, byte ptr HI_DRV[BP]
	cmp	AL, byte ptr [_num_hdrives]
	jb	hi@1
	jmp	hi_ext_done
hi@1:	cmp	byte ptr [_num_hparts], MAXUNITS
	jb	hi@2
	jmp	hi_ext_done
hi@2:

   	xor	AX, AX
	mov	word ptr MotherPartStart, ax
	mov	word ptr MotherPartStart+2, ax

   ;
   ;	partsec = 0L;
   ;
	mov	word ptr HI_PARTSEC+2[BP], AX
	mov	word ptr HI_PARTSEC[BP], AX
   ;
   ;	dp = drvparm+drv;
   ;
	mov	AL, byte ptr HI_DRV[BP]
	call	GetBiosDriveParameterTable

   ;
   ;	spt = (unsigned)dp->xheads * dp->xspt;
   ;
	mov	AL, byte ptr [SI.BLP_Heads]
	mov	AH, byte ptr [SI.BLP_SectorsPerTrack]
	mul	AH
	mov	word ptr HI_SPT[BP], AX
   ;
   ;	/* go through each extended partition on this HD */
   ;	while(num_hparts < MAXUNITS)
   ;	{
   ;
hi_ext_while2:
	cmp	byte ptr [_num_hparts], MAXUNITS
	jb	hi@e1
	jmp	hi_ext_done2
hi@e1:

   ;
   ;	/* try to read the extended partition sector */
   ;	if(!read_hsec(0x80+drv, partsec, buff))
   ;	   break;
   ;
	push	word ptr HI_SCRATCH+2[BP]
	push	word ptr HI_SCRATCH[BP]
	push	word ptr HI_PARTSEC+2[BP]
	push	word ptr HI_PARTSEC[BP]
	mov	AX, word ptr HI_DRV[BP]
	add	AX, 80H
	push	AX
	call	near ptr _read_hsec
	add	SP,10
	or	AX, AX
	jnz	hi@e2
hi_ext_done2_jp:
	jmp	hi_ext_done2
hi@e2:
   ;
   ;	/* is there an extended partition? */
   ;	if((lastfound=find_part(0, TRUE, scratch)) < 0)
   ;	   break;
   ;
	push	word ptr HI_SCRATCH+2[BP]
	push	word ptr HI_SCRATCH[BP]
	mov	AX, 1
	push	AX
	xor	AX, AX
	push	AX
	call	near ptr _find_part
	add	SP, 8
	mov	HI_LASTFOUND[BP], AX
	cmp	AX, 0
	jl	hi_ext_done2_jp
   ;
   ;	part_ptr = (struct partition far *)(scratch+PARTOFF) + lastfound;
   ;
   	les	BX, dword ptr HI_SCRATCH[BP]
   	add	BX, PARTOFF
   	mov	AL, byte ptr HI_LASTFOUND[BP]
   	mov	AH, 10H
   	mul	AH
	add	BX, AX
	mov	HI_PPTR+2[BP], ES
	mov	HI_PPTR[BP], BX

	; If MotherPartStart is zero then we have not set it yet.
	;
	cmp	word ptr MotherPartStart+2, 0
	jne	GetMotherPartStart
	cmp	word ptr MotherPartStart, 0
	jne	GetMotherPartStart

	mov	ax, word ptr es:[bx + PART_HiddenSectors]
	mov	dx, word ptr es:[bx + PART_HiddenSectors][2]
	mov	word ptr MotherPartStart, ax
	mov	word ptr MotherPartStart+2, dx

	xor	ax, ax
	xor	dx, dx
	jmp	Add_MotherPartStart

    GetMotherPartStart:

	mov	ax, word ptr MotherPartStart
	mov	dx, word ptr MotherPartStart + 2

    Add_MotherPartStart:

	add	ax, word ptr es:[bx + PART_HiddenSectors]
	adc	dx, word ptr es:[bx + PART_HiddenSectors][2]

	mov	word ptr HI_PARTSEC+2[BP], DX
	mov	word ptr HI_PARTSEC[BP], AX

    calc_start_done:

   ;
   ;	/* read all DOS partitions in this extension */
   ;	num_hparts += read_all_parts(num_hparts, drv, partsec, scratch);
   ;
   	push	word ptr HI_SCRATCH+2[BP]
   	push	word ptr HI_SCRATCH[BP]
   	push	DX
   	push	AX
	push	word ptr HI_DRV[BP]
	mov	AL,  [_num_hparts]
	cbw
	push	AX
	call	near ptr _read_all_parts
	add	SP, 12
	add	byte ptr [_num_hparts], AL

;
;  ETR 3818 BT 10-5-01
;
;  The commented out code below would cause ROMDOS to not see entended
;  partitions within extended partitions if there were no DOS partitions
;  inside the first extended partition.
;
;	or	al, al
;	jz	hi_ext_done
;

   ;
   ;	   }
   ;
	jmp	hi_ext_while2
hi_ext_done2:
   ;
   ;	   ++drive;
   ;	}
   ;
	inc	word ptr HI_DRV[BP]
	jmp	hi_ext_while
hi_ext_done:

   ;
   ;	return (num_hparts - num_flop_units);
   ;
hi_done:

	; Reorder Super-Boot partitions, if required.
IFDEF SUPERBOOT	; {
  IF SUPR_ORDER NE SUPR_FIRST

	public	SuperShuffle
    SuperShuffle:

	; nothing to do if no Super-Boot partitions
	cmp	numSuperParts, 0
	jz	@@NoMove

	; determine # of normal DOS (not Super-Boot) partitions
	mov	cl, _num_hparts		; total units
	sub	cl, numSuperParts	; minus super-boot units
	sub	cl, num_flop_units	; minus floppy units

	; nothing to do if no DOS partitions
	cmp	cl, 0
	jz	@@NoMove

	; OK, we need shuffle around the partitions. Questions is, where?
    IF SUPR_ORDER EQ SUPR_MIDDLE
	mov	al, 1		; only move 1 DOS unit
    ELSE
	mov	al, cl		; move all DOS units
    ENDIF

	; shuffle both drive_table and drvparm structures
	push	ax		; # of DOS units to move
	call	SuperSwap
	pop	ax

	; no need to move anything
    @@NoMove:

  ENDIF

	; If we need to boot from the Super-Boot drive (as opposed
	; to from drive C:) record the drive number of the first
	; Super-Boot drive.
  IF BOOT_FROM_SUPER
	public	SuperCalcBoot
    SuperCalcBoot:

    IF SUPR_ORDER NE SUPR_FIRST
	cmp	numSuperParts, 0
	jz	DontSetSuperBoot

	; last puts the Super-Boot drive last
    IF SUPR_ORDER EQ SUPR_LAST
	mov	al, _num_hparts
	sub	al, numSuperParts	; super-drive
    ENDIF

	; middle puts the Super-boot drive at drive D: (if DOS drives)
    IF SUPR_ORDER EQ SUPR_MIDDLE
	mov	al, num_flop_units
	mov	cl, _num_hparts
	sub	cl, numSuperParts
	sub	cl, al			; calc # of DOS drives
	jz	NoDOSDrives		; no DOS drives
	inc	al			; D:
    NoDOSDrives:
    ENDIF

	mov	_SuperBootDrive, al
    DontSetSuperBoot:
    ENDIF ; NE SUPR_FIRST
  ENDIF ; BOOT_FROM_SUPER

ENDIF ; SUPERBOOT }

IFDEF DEBUG_DEVICE_INIT
   ; display a ']'
   ;
   push  AX
   push  BX
   mov   ax,0E5Dh
   mov   bx,0
   int   10h
   pop   BX
   pop   AX
ENDIF ; IFDEF DEBUG_DEVICE_INIT

	; return the # of hard disk units in AX
	mov	AL, byte ptr [_num_hparts]
	sub	AL, [num_flop_units]
	cbw
   ;
   ;	}
   ;
	pop	SI
	mov	SP, BP
	pop	BP
	ret
hard_init	endp ; }

IFDEF SUPERBOOT ; {
  IF SUPR_ORDER NE SUPR_FIRST
;--------------------------------------------------------------------
; $DOCPROC:SuperSwap
;
; Swap entries in the drive_table (DDT) to move the Super-Boot
; partition(s) to their final destination. Already validated that
; there is at least 1 Super-Boot partition, and at least 1 DOS
; partition to move.
;
; On Entry
;	p[bp]		; # DOS units to move
;	_num_hparts	; total units
;	numSuperParts	; # of super-boot partitions
;	num_flop_units	; # of floppy units
; On Exit
;	structures moved accordingly
; Modifies	C Regs
;--------------------------------------------------------------------
	public	SuperSwap
SuperSwap	proc near
	push	bp
	mov	bp, sp
	push	si

	; move the Super-Boot partitions into temporary memory
	mov	ax, offset _DMA_buff
	push	ax			; dst = _DMA_buff
	mov	al, num_flop_units
	call	getDriveTable
	push	si			; src = 1st hard unit
	mov	al, size DriveDataTable
	mul	numSuperParts
	push	ax			; len = # Super-Boot
	call	MEMMOVE

	; move the DOS partitions down
	mov	al, num_flop_units	; dst = 1st hard unit
	call	getDriveTable
	push	si			; dst
	mov	al, num_flop_units
	add	al, numSuperParts	; src = 1st hard unit + # Super-Boot
	call	getDriveTable
	push	si			; src
	mov	al, size DriveDataTable
	mul	byte ptr p[bp]		; len = # DOS units to move
	push	ax
	call	MEMMOVE

	; move the Super-Boot partitions back to DDT space
	mov	al, num_flop_units
	add	al, p[bp]		; dst = 1st hard unit +
	call	getDriveTable		;       # DOS units moved
	push	si			; dst
	mov	ax, offset _DMA_buff
	push	ax			; src = _DMA_buff
	mov	al, size DriveDataTable
	mul	numSuperParts
	push	ax			; len = # Super-Boot
	call	MEMMOVE

	pop	si
	pop	bp
	ret
SuperSwap	endp

  ENDIF ; not last
ENDIF ; SUPERBOOT }


IF USING_BIG_DISKS

; Obtains Enhanced BIOS disk parameters for a given drive, if available.
; The values returned from the EBIOS capabilites check are validated as
; specified by v3.0 of the Phoenix Enhanced Disk BIOS specification.
;
; NOTE: 	This routine will return CF set to indicate an error if
;		the fixed disk subset is not at least supported by the BIOS.
;
; ->:	DL    =	BIOS drive number for which to obtain Enhanced BIOS Info
; <-:	CF    =	Set if error
;	CF    = Clear, EBIOS extensions supported for this drive and
;		AX = EBIOS attributes for drive
;
GetEBIOSDiskAttributes	proc

	push	bx
	push	cx

IFDEF ADDED_RESET
; ETR 3367 - Must perform a reset before function 08h for the correct parameters to
;                    be returned from buggy BIOS/BIOS extensions
;
	push	dx
	xor	ax, ax
	int	13h
	pop	dx
ENDIF ; ADDED_RESET

	mov	ah, EBIOSDISK_CHECK_PRESENT
	mov	bx, 55AAh
	sti			; ETR 3367
	int	BIOSDISK		; call BIOS to check drive function
	jc	GEDA_exit	      	; CF set if not supported

	cmp	bx, 0AA55h		; BH, BL must be exchanged
	stc				; else not implemented correctly
	jnz	GEDA_exit		; if so ok, they're there
	mov	bx, cx                  ; B0 of CX set to indicate availability
	shr	bx, 1			; of hard disk extensions (MUST be there)
	cmc           			; CF clear if fixed disk subset support
	mov	ax, cx			; return EBIOS attributes

    GEDA_exit:
	pop	cx
	pop	bx
	ret
GetEBIOSDiskAttributes	endp

; Obtains Enhanced BIOS disk parameters for a given drive, if available.
; The values returned from the EBIOS capabilites check are validated as
; specified by v3.0 of the Phoenix Enhanced Disk BIOS specification.
;
; ->:	DL    =	BIOS drive number for which to obtain Enhanced BIOS Info
;	DS:SI =	ptr to BiosDriveParameter structure for drive
; <-:	CF    =	Set if error. DDT_uEBiosAttributes = 0.
;	CF    =	Clear if at least Fixed Disk functions are available.
;		If support is available, DDT_EBiosParameters are filled
;		in and DDT_uEBiosAttributes are as returned in CX by BIOS.
;
;
GetEBIOSDiskParameters	proc

	push	si

	mov	[si].BDP_uEBiosAttributes, 0	; assume no EBIOS support

	call	GetEBIOSDiskAttributes		; get EBIOS attributes
	jc	GEDP_exit			; CF set if no support

	mov	[si].BDP_uEBiosAttributes, ax	; save drive ext attributes

IFDEF ADDED_RESET
; ETR 3367 - Must perform a reset before function 08h for the correct parameters to
;                    be returned from buggy BIOS/BIOS extensions
;
	push	dx
	xor	ax, ax
	int	13h
	pop	dx
ENDIF ; ADDED_RESET

	mov	ah, EBIOSDISK_EXT_GET_PARMS	; fill in the ext parms
	add	si, BDP_EBiosParameters		; in the DDT
	mov	word ptr [si].EBDPT_uBufferSize, SIZE EBiosDeviceParameterTable
	sti			; ETR 3367
	int	BIOSDISK			; return CF set on error

    GEDP_exit:
	pop	si
	ret
GetEBIOSDiskParameters	endp

ENDIF ;; USING_BIG_DISKS



comment ~ ; prototype ;
/*
	Fills in the global drvparm structure.
*/
void get_drive_parms(int num_hdrives)
~
	public	_get_drive_parms
_get_drive_parms	proc	near ; {
	push	BP
	mov	BP, SP
	dec	SP
	dec	SP
	push	SI
	push	DI
	mov	DI, word ptr [BP+4]
   ;
   ;	{
   ;	extern struct hdsize drvparm[];
   ;	struct hdsize * dp;
   ;	int drv;
   ;
   ;	for(drv=0; drv<num_hdrives; ++drv)
   ;
	mov	word ptr [bp-2],0
	jmp	short @2@146
@2@50:
   ;
   ;	{
   ;	/* call the BIOS to get the parameters */
   ;	_AH = BIOSDISK_PARM;
   ;	_DL = 0x80 + drv;
   ;	geninterrupt(BIOSDISK);
	mov	DL, byte ptr [BP-2]
IFDEF ADDED_RESET
; ETR 3367 - Must perform a reset before function 08h for the correct parameters to
;                    be returned from buggy BIOS/BIOS extensions
;
	xor	ax,ax
	int	13h
ENDIF ; ADDED_RESET

	mov	AH, BIOSDISK_PARM
	mov	DL, byte ptr [BP-2]
	add	DL, 80H
   	clc
	sti			; ETR 3367
	int	BIOSDISK
   ;
   ;	if(_FLAGS & CARRY)
   ;	{
   ;	   num_hdrives = drv;
   ;	   break;
   ;	}
	jnc	short @2@98
	mov	DI, word ptr [BP-2]
	jmp	short @2@170
@2@98:
   ;
   ;
   ;	/* store them in a structure for each hard drive */
   ;	dp = drvparm+drv;
   ;
	mov	ax, word ptr [bp-2]
	call	GetBiosDriveParameterTable

;;	shl	ax, 1
;;	shl	ax, 1
;;	shl	ax, 1
;;	add	ax, GOFFSET _drvparm
;;	mov	si, ax              		; SI = dp
   ;
   ;	dp->xheads = _DH + 1;
   ;
	inc	dh
	mov	byte ptr [si].BLP_Heads, dh	; DH = heads
   ;
   ;	dp->xspt   = _CX & 0x3F;
   ;
	mov	ax, cx
	and	al, 03Fh
	mov	byte ptr [si].BLP_SectorsPerTrack, al  ; AL = spt
   ;
   ;	dp->xtraks = (dp->xtraks>>8) + ((dp->xtraks&0xC0)<<2) + 1;
   ;
	xchg	ch, cl
	rol	ch, 1
	rol	ch, 1
	and	cx, 3FFh
	inc	cx
	mov	word ptr [si].BLP_Tracks, cx		; CX = tracks

   ;
   ;	dp->xsectors= (long)dp->xtraks * ((unsigned)dp->xheads * dp->xspt);
   ;
	mul	dh
	mul	cx
	mov	word ptr [si].BLP_TotalSectors+2, dx
	mov	word ptr [si].BLP_TotalSectors, ax

IF USING_BIG_DISKS

	mov	dl, byte ptr [BP-2]
	add	dl, 80h
	call	GetEBIOSDiskParameters

ENDIF ;; USING_BIG_DISKS

	inc	word ptr [bp-2]
@2@146:
	cmp	word ptr [bp-2],di
	jl	short @2@50
@2@170:
   ;
   ;		}
   ;	}
   ;
	pop	DI
	pop	SI
	mov	SP, BP
	pop	BP
	ret
_get_drive_parms	endp ; }



comment ~ ; prototype ;
/*
	Return the number of Hard Disk drives (0-3).
*/
int num_hard_drives(void)
~
	public	_num_hard_drives
_num_hard_drives	proc	near ; {
	push	BP
	mov	BP, SP
	push	SI
	push	DI		; The BIOS function BIOSDISK_PARM
				; can trash this variable
   ;
   ;	{
   ;	   _AH = BIOSDISK_PARM;
   ;	   _DL = 0x80;
   ;	   geninterrupt(BIOSDISK);
   ;	   if((_FLAGS & CARRY) || (_DL & 0xFC))
   ;	      return 0;
   ;	   return _DL;
   ;
	mov	DL, 80H

; ETR 3666 BT 3-8-01
;
; This was removed because under the well designed Phoenix BIOS, a reset
; of the hard drives when there is no hard drives starts interpreting the
; bytes at 0:0 (the IVT) as code.  Essentially the machine hangs.
;
;     ETR 3367 - Must perform a reset before function 08h for the correct parameters to
;                be returned from buggy BIOS/BIOS extensions
;
;	push	dx
;	xor	ax, ax
;	int	13h
;	pop	dx
;

	mov	AH, BIOSDISK_PARM
	clc
	sti			; ETR 3367
	int	BIOSDISK
	mov	AX, 0
	jc	no_more_harddisks
	or	dl, dl
	jz	no_more_harddisks	; any hard drives at all?
	cmp	dl, MAXHDISKS
	jbe	num_hard_drives_in_range; limit number of hard drives
	mov	dl, MAXHDISKS		; to static # of _drvparm strucs

	; for( si = 0; si < dl; si++ )

    num_hard_drives_in_range:
	and 	dx, 0FFh
	xor	SI, SI

    check_drive:
	push	DX
	push	SI

	; Ask the BIOS for drive parameters
	mov	DX, SI		; Which drive #?
	or	DX, 80H		; It _is_ a hard drive
IFDEF ADDED_RESET
; ETR 3367 - Must perform a reset before function 08h for the correct parameters to
;                    be returned from buggy BIOS/BIOS extensions
;
	push	dx
	xor	ax, ax
	int	13h
	pop	dx
ENDIF ; ADDED_RESET

	mov	AH, BIOSDISK_PARM
	clc
	sti			; ETR 3367
	int	BIOSDISK

	; Restore our registers that the BIOS trashed
	pop	SI
	pop	DX
	mov	AX, SI

	; If the carry flag is set, or tracks or sectors/track
	; are 0 then this drive is unusable.  Since we can't
	; "skip" bad BIOS drive numbers, we must ignore all
	; drives after the first bad one.
	;
	; NOTE: MSDOS certainly DOES "skip" bad BIOS drive numbers
	;       and we need to figure a reasonable way to do so too.
	;
	jc	no_more_harddisks

	push	cx
	and	cl, 3Fh		; isolate max sector number
	pop	cx		; no sectors?
	jz	no_more_harddisks

	xchg	ch, cl
	rol	ch, 1
	rol	ch, 1
	and	cx, 3FFh	; no tracks
	jz	no_more_harddisks

	; End of for() loop
	inc	SI
	cmp	SI, DX
	jb	check_drive

	; All drives are good, AX needs one last update
	mov	AX, DX

   no_more_harddisks:
   ;
   ;	}
   ;
	pop	DI
	pop	SI
	pop	BP
	ret
_num_hard_drives	endp ; }


comment ~ ; prototype ;
/*
	Read in all DOS partitions defined by the Partition
	table In the specified sector.  The scratch buffer
	and DMA_buff are used to do it.

	Returns # of partitions, or 0 on failure.  A failure
	may simply mean there are no DOS partitions, or may
	be a read or structure error.
*/
int read_all_parts(int part, int drive, ulong sector, char far * scratch)
~
	public	_read_all_parts
_read_all_parts	proc	near ; {
	push	BP
	mov	BP, SP
RAP_PART	= 4
RAP_DRIVE	= 6
RAP_SECTOR	= 8
RAP_SCRATCH	= 12
   ;
   ;	{
   ;	   int gotparts;
   ;	   int lastpart;
   ;
	push	SI	; int gotparts;
	push	DI	; int lastpart;

   ;
   ;	/* read partition table.  give up if table is invalid */
   ;    gotparts = 0;
   ;	if(!read_hsec(drv+0x80,sector,buff))
   ;	   return FALSE;
   ;

IFDEF DEBUG_DEVICE_INIT
   clc
   mov   AX, RAP_SECTOR+2[BP]
   call  bios_putx
   stc
   mov   AX, RAP_SECTOR[BP]
   call  bios_putx
   clc
   mov   AX, RAP_DRIVE[BP]
   call  bios_putx
ENDIF ; IFDEF DEBUG_DEVICE_INIT

   	xor	SI, SI
   	push	RAP_SCRATCH+2[BP]
   	push	RAP_SCRATCH[BP]
   	push	RAP_SECTOR+2[BP]
   	push	RAP_SECTOR[BP]
   	mov	AL, byte ptr RAP_DRIVE[BP]
   	or	AL, 80H
   	mov	AH, 0
   	push	AX
	call	near ptr _read_hsec
	add	SP, 10
	or	AX, AX
	jz	rap_done

   ;
   ;	lastfound = 0;
   ;	while(part < MAXUNITS)
   ;	{
   ;
	xor	DI, DI		; lastfound = 0;
rap_while:
	cmp	word ptr RAP_PART[BP], MAXUNITS
	jge	rap_done

   ;
   ;	/* does a another "DOS" partition exist? */
   ;	if((lastfound = find_part(lastfound, 0, scratch)) < 0)
   ;	   break;
   ;
	push	word ptr RAP_SCRATCH+2[BP]
	push	word ptr RAP_SCRATCH[BP]	; scratch
	xor	AX, AX
	push	AX	; 0 (search for DOS, not EXTended partitions)
	push	DI		; lastfound
	call	near ptr _find_part
	add	SP, 8
	cmp	AX, 0
	jl	rap_done
	mov	DI, AX		; lastfound

   ;
   ;	part_ptr = (struct partition far *)(buff+PARTOFF) + lastfound;
   ;	if(read_part(part, drv+0x80, 0L, part_ptr))
   ;    {
   ;	   ++gotparts;
   ;	   ++part;
   ;	}
   ;
   	les	BX, dword ptr RAP_SCRATCH[BP]
   	mov	AX, DI			; last found
   	mov	AH, 10H
   	mul	AH
   	add	AX, PARTOFF		; AX = part_ptr[lastfound]
	add	BX, AX
   	push	ES
   	push	BX			; far * part_ptr
   	push	word ptr RAP_SECTOR+2[BP]
   	push	word ptr RAP_SECTOR[BP]	; sector
	mov	AL, byte ptr RAP_DRIVE[BP]
	or	AL, 80H
	mov	AH, 0
	push	AX			; drv+80H (uchar)
	push	word ptr RAP_PART[BP]
	call	near ptr _read_part
	add	SP, 12
	or	AX, AX
	jz	rap_done		; read didn't work? give up
	inc	SI			; ++gotparts
	inc	word ptr RAP_PART[BP]	; ++part;

   ;
   ;	++lastfound;
   ;
	inc	DI			; lastfound
   ;
   ;	}
   ;
   	jmp	rap_while
rap_done:
   ;
   ;	return gotparts;
   ;
	mov	AX, SI

   ;
   ;	}
   ;
	pop	DI
	pop	SI
	mov	SP, BP
	pop	BP
	ret
_read_all_parts	endp ; }


comment ~ ; prototype ;
/*
	Read the partition's boot sector
*/
int read_part(int part, uchar drive, ulong sector, struct partition far * part_ptr)
~
	public	_read_part
_read_part	proc	near ; {
	push	BP
	mov	BP, SP
RDP_PART	= 4
RDP_DRIVE	= 6
RDP_SECTOR	= 8
RDP_PPTR	= 12
   ;
   ;	{
   ;
   ;	/* record the partition */
   ;	sector += part_ptr->PART_HiddenSectors;
   ;
	les	BX, dword ptr RDP_PPTR[BP]
	mov	AX, word ptr ES:[BX].PART_HiddenSectors	; part_ptr->PART_HiddenSectors
	mov	DX, word ptr ES:[BX].PART_HiddenSectors[2]
	add	word ptr RDP_SECTOR[BP], AX
	adc	word ptr RDP_SECTOR+2[BP], DX
   ;
   ;	if(!record_part(part, drive, sector, struct partition far * part_ptr))
   ;	   return FALSE;
   ;


	push	es			; part_ptr
	push	bx
	push	word ptr RDP_SECTOR+2[BP]
	push	word ptr RDP_SECTOR[BP]
	push	word ptr RDP_DRIVE[BP]
	push	word ptr RDP_PART[BP]
	call	near ptr _record_part
	add	SP, 12
	or	AX, AX
	jz	short @4@194	; return FALSE, AX already 0
   ;
   ;	return TRUE;
   ;
	mov	AX, 1
@4@194:
   ;
   ;	}
   ;
	mov	SP, BP
	pop	BP
	ret
_read_part	endp ; }

comment ~ ; prototype ;
/*
	Record the partition in the global variables.

	This routine also sets the DDT_dcyl field the drive's drive table
*/
int record_part(int unit, uchar drive, ulong start, struct partition far * part_ptr)
~
	public	_record_part
_record_part	proc	near ; {
	push	BP
	mov	BP, SP
	push	SI
	push	di

PART_TABLE_PTR	= 12	; offset from BP for part_ptr arg
STARTING_SECTOR =  8
DRIVE_NUMBER	=  6
UNIT_NUMBER	=  4

   ;
   ;	{
   ;	extern struct DDT drive_table[];
   ;	extern uchar DMA_buff[];
   ;	extern struct hdsize drvparm[];
   ;
   ;	/* record the drive */
   ;	drive_table[part].stdrive = drive;
   ;

	mov	ax, [bp+UNIT_NUMBER]		; unit #
	call	getDriveTable			; DS:SI now points to tbl
	mov	dl, [bp+DRIVE_NUMBER]		; drive
	mov	[SI].DDT_bios_drive, dl

   ;
   ;	/* set up the BPB for the drive */
   ;	if(!read_hsec(drive,start,(void far *)DMA_buff))
   ;	   return FALSE;
   ;
	push	DS
	mov	AX, GOFFSET _DMA_buff
	push	AX
	push	word ptr [bp+STARTING_SECTOR][2]
	push	word ptr [bp+STARTING_SECTOR]
	mov	AL, [bp+DRIVE_NUMBER]
	mov	AH, 0
	push	AX
	call	near ptr _read_hsec
	add	SP, 10
	or	AX, AX
	jne	short @5@146
	xor	AX, AX
	jmp	@5@170
@5@146:
   ; 	// get ptr to drive parameters (heads, etc.) for this drive
   ;	//
	push	si
	mov	al, [bp+DRIVE_NUMBER]
	sub	al, 80h
	call	GetBiosDriveParameterTable
	mov	di, si
	pop	si

IF USING_BIG_DISKS
	mov	ax, [di].BDP_EBiosParameters.EBDPT_uInfoFlags
	mov	[si].DDT_uEBiosDriveInfoFlags, ax
	mov	ax, [di].BDP_uEBIOSAttributes
	mov	[si].DDT_uEBiosDriveAttributes, ax
ENDIF

	les	bx, [bp+PART_TABLE_PTR] 		; es:bx -> partion table
   	mov	al, [di].BLP_SectorsPerTrack	; get BIOS' sectors per track
   	mul     [di].BLP_Heads	     		; now get (heads*spt) in ax
   	mov	cx, ax				; in cx
   	mov	ax, word ptr es:[bx].PART_SectorCount
   	mov	dx, word ptr es:[bx].PART_SectorCount[2] ; dx:ax = partion sectors

   ;
   ;    drive_table[part].DDT_dcyl = partion_size / (heads * spt)
   ;
   	div	cx				; ax = full cylinders
   	xor	cx, cx				; dx = left over sectors
   	sub	cx, dx				; if last cylinder not full
   	adc	ax, 0				; then increment track count
   	mov	word ptr [si].DDT_dcyl, ax	; and update the ddt

	; Is this a 12, 16 or 32 bit FAT? look to the partition table
	;
	; NOTE: We MUST do this check before calling build_bpb() because
	; 	that routine will call check_bpb() which must know what
	;	sort of FAT type it is dealing with to avoid making
	; 	disastrously dumb decisions. BUT, check_bpb() is
	;	also called after init when the partition table info has
	;	long been discarded so we must use the DDT to make the
	;	FAT type determination for FAT32 drives. FAT12 and FAT16
	;	drive types are still determined dynamically based on
	;	the total number of sectors so that we can work with high
	;	capacity floppies like LS-100s that work with either FAT12
	;	floppies or their own proprietary FAT16 diskettes.
	;
IF USING_FAT32
	cmp	es:[bx].PART_FileSystemID, DOS32
    	je	RP_RecordFAT32

	cmp	es:[bx].PART_FileSystemID, DOS32_LBA
    	jne	RP_CheckFAT16AndFat12

    RP_RecordFAT32:
	or	[SI].DDT_FatType, DDT_FAT_TYPE_32 ; identify 32 bit FAT
	jmp	short RP_KnowFATType

    RP_CheckFAT16AndFat12:
ENDIF
	cmp	es:[bx].PART_FileSystemID, DOS12
   	je	RP_KnowFATType	; [SI].DDT_FatType = 0 for FAT12

    yes_16:
	or	[SI].DDT_FatType, DDT_FAT_TYPE_16 ; identify 16 bit FAT

    RP_KnowFATType:
   ;
   ;	/* set up the device type structure, used by 440DH */
   ;	init_type(drive, part);
   ;
	push	word ptr [BP+UNIT_NUMBER]		; unit
	push	word ptr [BP+DRIVE_NUMBER]		; drive
	call	init_type
	add	SP, 4

   ;
   ;	build_bpb(part, DMA_buff, struct partition far * part_ptr, drvparm+(drive-0x80), start);
   ;
	lea	ax, word ptr [si].DDT_dattr
	push	ax
	push	word ptr [bp+STARTING_SECTOR][2]
	push	word ptr [bp+STARTING_SECTOR]
	mov	al , [si].DDT_FatType
	push	ax
	push	di
	push	word ptr [bp+PART_TABLE_PTR][2]
	push	word ptr [bp+PART_TABLE_PTR]
	mov	AX, GOFFSET _DMA_buff
	push	AX
	mov	AL, [bp+UNIT_NUMBER]
	push	AX
	call	near ptr _build_bpb
	add	SP, 18

	; Returns FALSE if can't build a BPB.
	;
	or	ax, ax
	jz	@5@170

   ;	/* get Volume label, serial number, and FAT IDs */
   ;    void get_fatid(uchar unit, char *boot_sector)
   ;
	mov	AX, GOFFSET _DMA_buff
	push	AX                      ; near ptr to boot sector
	push	word ptr [bp+UNIT_NUMBER]		; unit #
	call	get_fatid
	pop	AX
	pop	AX			; get rid of parms

   ;	/* determine starting track */
   ;	drive_table[part].sttrak = trak;
   ;	drive_table[part].ishd   = 1;
   ;
	mov	AX, [BP+UNIT_NUMBER]		; unit #
	call	getDriveTable			; DS:SI now points to tbl

IF USING_BIG_DISKS

	; Under MSDOS 7.1 The starting track field of the DDT gets set
	; with a non-zero value if the CHS geometry can be trusted.  If
	; this field is zero then the hidden field of the bpb is the
	; physical sector number on the disk.
	;
	; Check if this drive requires LBA, if not then calculate the start
	; using the CHS values.  Otherwise, use the absolute sector value
	;
	test	[si].DDT_dattr, DATTR_LBA_REQUIRED
	jz	CalculateStartingTrack

    ZeroStartingTrack:

	xor	ax, ax
	mov	word ptr [SI].ddt_sttrak, AX
	inc	ax
	mov	word ptr [SI].ddt_ishd, ax
	jmp	short DoneStartingTrack

    CalculateStartingTrack:

	; determine starting trak # WITHIN THE CURRENT PARTITION
	; trak = start / (heads * secPerTrak)
	; SMARTDRV requires these fields
	;
	mov	AX, word ptr [SI].ddt_bpb.BPB_sec_per_trak
	mul	word ptr [SI].ddt_bpb.BPB_sides
	xchg	CX, AX			; CX = (heads * secPerTrak)

	; For the stuff above we needed the start of the logical
	; drive relative to the start of the physical disk which is
	; what the "start" argument has (in sectors). Now we
	; need just the start of the partition to put in "ticks".
	;
	mov	DX, word ptr [bp+STARTING_SECTOR][2] ; get "start" argument
	mov	AX, word ptr [bp+STARTING_SECTOR]

	les	bx, [bp+PART_TABLE_PTR] 	     ; es:bx -> partion table
   	sub	ax, word ptr es:[bx].PART_HiddenSectors
   	sbb	dx, word ptr es:[bx].PART_HiddenSectors[2] ; dx:ax = 1st part sector
	div	CX			; AX = partition's starting track
	mov	word ptr [SI].ddt_sttrak, AX
	mov	word ptr [SI].ddt_ishd, 1

    DoneStartingTrack:

ELSE ; IF USING_BIG_DISKS

	; determine starting trak # WITHIN THE CURRENT PARTITION
	; trak = start / (heads * secPerTrak)
	; SMARTDRV requires these fields
	;
	mov	AX, word ptr [SI].ddt_bpb.BPB_sec_per_trak
	mul	word ptr [SI].ddt_bpb.BPB_sides
	xchg	CX, AX			; CX = (heads * secPerTrak)

	; For the stuff above we needed the start of the logical
	; drive relative to the start of the physical disk which is
	; what the "start" argument has (in sectors). Now we
	; need just the start of the partition to put in "ticks".
	;
	mov	DX, word ptr [bp+STARTING_SECTOR][2] ; get "start" argument
	mov	AX, word ptr [bp+STARTING_SECTOR]

	les	bx, [bp+PART_TABLE_PTR] 	     ; es:bx -> partion table
   	sub	ax, word ptr es:[bx].PART_HiddenSectors
   	sbb	dx, word ptr es:[bx].PART_HiddenSectors[2] ; dx:ax = 1st part sector

	div	CX			; AX = partition's starting track
	mov	word ptr [SI].ddt_sttrak, AX
	mov	word ptr [SI].ddt_ishd, 1

ENDIF ; IF USING_BIG_DISKS

   ;
   ;	return TRUE;
   ;
	mov	AX, 1
@5@170:
   ;
   ;	}
   ;
	pop	di
	pop	SI
	pop	BP
	ret
_record_part	endp ; }


comment ~ ; prototype ;
/*
	Build a BPB based on size of partition.  Will try
	first to retrieve the BPB from the boot sector
	inside the partition or, if that doesn't work, will
	build it based on the number of sectors and file system
	ID byte listed in the partition table.

	NOTE: 	We use the DDT FAT type flag to tell if we are
		dealing with a FAT32 drive. FAT12 and FAT16
		drive types are still determined dynamically
		based on the total number of sectors so that we
		can work with high capacity floppies like
		LS-100s that work with either FAT12 floppies or
		their own proprietary FAT16 diskettes.

*/
bool build_bpb(part, DMA_buff, struct partition far * part_ptr, drvparm+(drive-0x80),uchar bDDTFatType, ulong StartingSector )
~
	public	_build_bpb
_build_bpb	proc	near ; {
	push	BP
	mov	BP, SP

DDT_DEVATTR_PTR =  20	; [bp+18] Address of the DDT_dattr field for this drive
BB_STARTING_SECTOR =  16	; [bp+16]
DDT_FAT_TYPE	=  14	; [bp+14] DDT FAT type for this drive
DRIVE_PARMS	=  12	; [bp+12] near pointer the BIOS drive parameters
PART_TABLE_PTR	=   8	; [bp+8]  far pointer to the partition table
BOOT_SECTOR_BUF =   6	; [bp+6]  near pointer to the boot sector
UNIT_NUMBER	=   4	; [bp+4]  unit number of this hard drive
FAT_NYBBLES     =   2	; [bp-2]  number of nybbles in a FAT entry

	dec	SP
	dec	SP

	push	SI
	push	DI
   	;
   	;	{
   	;	static struct BiosParameterBlock hdisk_bpb	=
   	;	   { 0x200,0,1,2,0x200,0,0xF8,0,0,0,0 };
   	;
   	;	int fatbits;
   	;	struct BiosParameterBlock * bp;
   	;
   	;	/* get a pointer to the BPB inside the boot sector */
   	;	bp = (struct BiosParameterBlock *)(boot+11);
   	;
	mov	DI, word ptr [bp+DRIVE_PARMS]		; DI->BIOS parameters
	mov	SI, word ptr [bp+BOOT_SECTOR_BUF]	; SI->Boot Sector

IF USING_FAT32
	add	si, BS_BootSectorInfo
ELSE
	add	si, BOOT_BPB
ENDIF

	push	si
	push	[bp+DDT_FAT_TYPE]
	call	check_bpb
	pop	si
	pop	si
	or	ax, ax
	jz	BBPB_BuildFAT		; 0 means disk has an invalid BPB
	jmp	BBPB_RecordMediaID	; valid, passed!

    BBPB_BuildFAT:
	;  Record that the media is invalid
	;
	mov	bx, [bp+DDT_DEVATTR_PTR]
	or	word ptr [bx], DATTR_INVALID_MEDIA

   ; This register pair is commonly used throughout build_bpb()
   ;
   les   bx, [bp+PART_TABLE_PTR]

IF USING_FAT32
   ; Load up the partition table (needed for both FAT12/16 and FAT32)
   ; and go check the high word of the sector count.
   ; IR 4050 - Some MS products create a FAT32 disk with a FAT16
   ; partition ID. A quick check here will avoid an overflow later on.
   ;
   cmp   word ptr es:[bx].PART_SectorCount[2], 003Fh
   ja    BBPB_BuildFAT32

IF USE_186 EQ 0
.386
ENDIF   ;; USE_186
	test	byte ptr [bp+DDT_FAT_TYPE], DDT_FAT_TYPE_32
IF USE_186 EQ 0
        jz	BBPB_BuildFAT16
ELSE
        jnz     BBPB_BuildFAT32
        jmp     BBPB_BuildFAT16
ENDIF

	; BPB is invalid for FAT32, AX==0 when we get here. Make sure
	; drive is big enough to support FAT32.
	;
    BBPB_BuildFAT32:

;  The determination to BUILD a FAT32 disk should be by the DDT_FatType
;  bits which are set based on the partition ID.  The code above has
;  already determined that the DDT_FatType indicates that the partitiion
;  ID was a FAT32 type.  We should "trust" that fdisk has done the
;  validation before setting partition ID.
;
IF 0
IF USE_186 EQ 0
	cmp	es:[bx].PART_SectorCount, MIN_FAT32_SECTORS
	jb	BBPB_exit
ELSE    ;; USE_186
        cmp     word ptr es:[bx].PART_SectorCount[2], MIN_FAT32_SECTORS_H
        je      BBPB_CHK_SCLow
        ja      BBPB_FAT32Init
        jmp     BBPB_exit

    BBPB_CHK_SCLow:
        cmp     word ptr es:[bx].PART_SectorCount, MIN_FAT32_SECTORS_L
        jae     BBPB_Fat32Init
        jmp      BBPB_exit

    BBPB_FAT32Init:
ENDIF   ;; USE_186
ENDIF ;; IF 0

IF USE_186 EQ 0
	push	eax
	push	ecx
	push	edx
ELSE    ;; USE_186
        push    ax
        push    bx
        push    cx
        push    dx
ENDIF   ;; USE_186

	; BT 1-10-00
	;
	; We were not initializing these fields of a FAT32 BPB
	;
	mov	word ptr [si].BPB_sec_size, 200h ; assume 512 byte sectors
	mov	word ptr [si].BPB_res_sec, 20h
	mov	byte ptr [si].BPB_num_fats, 2

	;
	; NOTE: BPB_hidden is set using common code for all FAT types
	;       after the BBPB_RecordMediaID label
	;


IF USE_186 EQ 0

        ; get sectors in partition
	mov	eax, es:[bx].PART_SectorCount	; get sectors in partition
	mov	[si].BPB_lnumsec, eax

ELSE ;; USE_186 EQ 0

        ; get sectors in partition
        mov     ax, word ptr es:[bx].PART_SectorCount
        mov     dx, word ptr es:[bx].PART_SectorCount[2]
        mov     word ptr [si].BPB_lnumsec, ax
        mov     word ptr [si].BPB_lnumsec[2], dx

ENDIF ;; USE_186 EQ 0

	xor	cx,  cx				; zero ch,cl
	mov	[si].BPB_uFatSectors, cx	; 32bit FAT sectors
	mov	[si].BPB_uDirEntries, cx	; root can grow
	mov	[si].BPB_num_sec,     cx	; 32bit total sectors

   	mov	cl, [di].BLP_Heads		; get BIOS' number of heads
   	mov	[si].BPB_sides, cx		; save as a word in ddt
   	mov	cl, [di].BLP_SectorsPerTrack	; get BIOS' sectors per track
   	mov	[si].BPB_sec_per_trak, cx	; save as a word in ddt

	; Determine SPC based on total partition sectors then calculate the
	; sectors needed for each FAT using the formula:
	;
	; BPB_ulSectorsPerFat =
	; (((total_sectors/BPB_sec_per_clus)*(bytes_per_entry))/BPB_sec_size
	;
IF USE_186 EQ 0
	push	eax				; sector count
	call	_calcspc32
	mov	[si].BPB_sec_per_clus, al       ; ax= SPC (one of 8,16,32 or 64)
	movzx	ecx, ax                         ; keep high word of ecx 0!
	pop	eax
	xor	edx, edx
	div	ecx				; eax = total usable clusters

	mov	cx, LBA_BLOCK_SIZE 		; assume 512 BPS
	mov	[si].BPB_sec_size, cx           ; Need a FAT entry for each of
	xor	edx, edx                        ; the total clusters, account
	shl	eax, 1				; for each of the 4 bytes in
	rcl	edx, 1				; a FAT32 entry.
	shl	eax, 1
	rcl	edx, 1
	div	ecx				; get number of sectors in FAT

; BT 1-10-00
;
; We seem to be off by one (compared with MSDOS 7.1) when rebuilding
; the BPB from scratch.  So instead of assuming that there is a remainder
; check for one.
;
;	inc	eax                             ; account for probable remainder
;
	or	edx, edx
	jnz	zzz_no_inc
	inc	eax                             ; account for probable remainder
    zzz_no_inc:

	mov	[si].BPB_ulSectorsPerFat, eax	; record FAT32 FAT sectors

ELSE    ;; USE_186
        push    dx
        push    ax
	call	_calcspc32
	mov	[si].BPB_sec_per_clus, al       ; ax= SPC (one of 8,16,32 or 64)
        mov     cx, ax
        pop     ax
        pop     dx

        ; save si and di
        push    si
        push    di

        ; setup the divisor (di:si)
        xor     di, di
        mov     si, cx

        ; setup the dividend (dx, cx, bx, ax)
        ;   dx:ax already point to the lower 32 bits
        mov     bx, dx
        xor     cx, cx
        xor     dx, dx

        ; divide dx:cx:bx:ax by di:si
        call    DIV_QL

        ; restore si, di
        pop     di
        pop     si

	mov	cx, LBA_BLOCK_SIZE 		; assume 512 BPS
	mov	[si].BPB_sec_size, cx           ; Need a FAT entry for each of

        push    si

        ; clear uppper 32 bits
        ;   cannot use CX in the M32 macros, so use SI instead
        xor     si, si
        xor     dx, dx


        M32_SHL bx, ax, 1
        M32_RCL dx, si, 1
        M32_SHL bx, ax, 1
        M32_RCL dx, si, 1


        push    si
        push    di

        ; si contains the value for CX and CX contains the value for SI
        xchg    si, cx
        xor     di, di
        call    DIV_QL                          ; get number of sectors in FAT


;
; We seem to be off by one (compared with MSDOS 7.1) when rebuilding
; the BPB from scratch.  So instead of assuming that there is a remainder
; check for one.
;
        or      di, di
        jnz     zzz_no_inc
        or      si, si
        jnz     zzz_no_inc
        add     ax, 1
        adc     bx, 0
    zzz_no_inc:
        pop     di
        pop     si
        pop     si
        mov     word ptr [si].BPB_ulSectorsPerFat, ax
        mov     word ptr [si].BPB_ulSectorsPerFat[2], bx

ENDIF   ;; USE_186


    	mov	[si].BPB_uExtendedFlags, 0	; extended flags (defined below)
    	mov	[si].BPB_uFileSystemVersion, 0	; File system version number
IF USE_186 EQ 0
    	mov	[si].BPB_ulRootDirStartCluster,2; Root dir start (can move)
ELSE    ;; USE_186
        ; Root dir start (can move)
    	mov	word ptr [si].BPB_ulRootDirStartCluster, 2
    	mov	word ptr [si].BPB_ulRootDirStartCluster[2], 0
ENDIF   ;; USE_186
    	mov	[si].BPB_uFSInfoSector, 1	; sector # of FSINFO struc  (-1 if none)
    	mov	[si].BPB_uBackUpBootSector, 6	; sector # of backup boot sector (-1 if none)
IF USE_186 EQ 0
	mov	dword ptr [si].BPB_reserved, 0
ELSE    ;; USE_186
	mov	word ptr [si].BPB_reserved, 0
	mov	word ptr [si].BPB_reserved[2], 0
ENDIF   ;; USE_186

; BT 1-10-00
;
; We need to zero all 12 bytes of the reserved field.  Not 6 bytes
;
;	mov	word ptr [si].BPB_reserved[4], 0
;
IF USE_186 EQ 0
	mov	dword ptr [si].BPB_reserved[4], 0
	mov	dword ptr [si].BPB_reserved[8], 0

	pop	edx
	pop	ecx
	pop	eax
ELSE
	mov	word ptr [si].BPB_reserved[4], 0
	mov	word ptr [si].BPB_reserved[6], 0
	mov	word ptr [si].BPB_reserved[8], 0
	mov	word ptr [si].BPB_reserved[10], 0

        pop     dx
        pop     cx
        pop     bx
        pop     ax
ENDIF
	jmp	BBPB_RecordMediaID

.8086
ELSE	;; USING_FAT32
   	;
   	; The BPB read from the disk was, for whatever reason, invalid.
   	; We must build one from the information we have.
   	;
	; Make sure we're not dealing with a FAT32 drive (FAT32 BPB).
	;
;	cmp	[si].BPB_fat_size, ax		; AX already returned as 0.
;	jne	BBPB_BuildFAT16
;	jmp	BBPB_exit			; return FALSE if we found a BPB32
;
; FAT32 drives were already filtered out by partition id.  The boot
; sector could be all zeros for a non-formatted partition
;

ENDIF	;; USING_FAT32

   	; common to both FAT16 and FAT12 partitions
	;
    BBPB_BuildFAT16:
	mov	si, GOFFSET hdisk_bpb

   	; Get the partition size in sectors, the head count and the SPT from
	; the partition table entry.
   	;
	mov	ax, word ptr es:[bx].PART_SectorCount	; get sectors in partition
	mov	dx, word ptr es:[bx].PART_SectorCount[2]

   	xor	cx, cx				; zero ch,cl
   	mov	cl, [di].BLP_Heads		; get BIOS' number of heads
   	mov	[si].BPB_sides, cx		; save as a word in ddt

   	mov	cl, [di].BLP_SectorsPerTrack	; get BIOS' sectors per track
   	mov	[si].BPB_sec_per_trak, cx	; save as a word in ddt

	; Is this a "BIG" (32M+) FAT16 partition? If so then make sure that
	; the BPB num_sec field is 0 to indicate that and fill in the 32-bit
	; BPB sector field.
   	;
	or	dx, dx				; if dx >0 then dx:ax >MAX8SPC
	jz	BBPB_146

	mov	[SI].BPB_num_sec, 0
	mov	word ptr [SI].BPB_lnumsec, ax
	mov	word ptr [SI].BPB_lnumsec[2], dx ; record (>64K) sectors
	jmp	short BBPB_170

	; This is a small partition (<64K sectors). Store sector count in
	; the BPB num_sec field to indicate that and make sure lnumsec = 0.
	;
    BBPB_146:
	mov	[SI].BPB_num_sec, ax		; sectors in small partion
	mov	word ptr [SI].BPB_lnumsec, dx
	mov	word ptr [SI].BPB_lnumsec[2], dx ; make sure BPB_lnumsec is 0

	; All FAT12 drives have 8 SPC under ROM-DOS. A FAT12 drive is any
	; any drive with less than (0FF0h*8) total sectors. This is because
	; there are only 0FF0h usable cluster numbers on a FAT12 drive (the
	; rest are reserved for the ters, end-of-FAT-chain marker, to indicate
	; free clusters, bad clusters, etc.)
	;
	or	dx, dx
	jnz	BBPB_170

   	cmp	ax, MAX8SPC
   	ja      BBPB_170

	mov	byte ptr [SI].BPB_sec_per_clus, 8 ; 8 sectors per cluster
	mov	word ptr [BP-FAT_NYBBLES], 3	; 3 nybbles per FAT entry
   	jmp	short BBPB_290

BBPB_170:
	;	/* len > MAX8SPC */
	;
	;	fatbits = 4; (fat nybbles, really)
	;	bp->BPB_sec_per_clus = calcspc(len);
	;
BBPB_242:
	mov	word ptr [BP-FAT_NYBBLES], 4	; 4 nybbles per FAT entry
	push	dx				; high word of sector count
	push	ax				; low word of sector count
	call	_calcspc
	mov	[SI].BPB_sec_per_clus, AL	; sectors per cluster
	or	al, al
	pop	ax				; get back sectors in partition
	pop	dx
	jnz	BBPB_290

	; If BIOS SPC = 0 then it is likely we overflowed the SPC value
	; because the drive is too big for a BPB16.
	;
	xor	ax, ax
	jmp	BBPB_exit

   BBPB_290:
	;
	;    GODLESSGOTO:
	;
	;	bp->BPB_uFatSectors = (((len/bp->BPB_sec_per_clus)*fatbits)/2)/bp->BPB_sec_size+1;
	;
	mov	CL, [SI].BPB_sec_per_clus
	mov	CH, 0
	div	CX		; (len/spc) = clusters (AX)
	mul	word ptr [bp-FAT_NYBBLES]	; * fatbits (nybbles/FAT entry)
	shr	DX, 1		; DX:AX/2 = bytes for fat
	rcr	AX, 1
	div	word ptr [SI].BPB_sec_size
	inc	AX
IF USING_FAT32
	mov	word ptr [si].BPB_uFatSectors, ax
ELSE
	mov	word ptr [si].BPB_fat_size, ax
ENDIF

    BBPB_RecordMediaID:
	;
	;	}
	;
	;  Record any fixed disk media as 0F8h.
	;  If the BPB hidden sectors (boot sector = partition sector + hidden)
	;  are blank then use the numbers from the partition table
	;
   	mov	byte ptr [SI].BPB_media, HARDMEDIA	; always F8H

	; Always update the number of sides and the sectors per track
	; because the BIOS can use different numbers for the same drive
	;
	xor	cx, cx				; zero this register
   	mov	cl, [di].BLP_Heads		; get BIOS' number of heads
   	mov	[si].BPB_sides, cx		; save as a word in ddt
   	mov	cl, [di].BLP_SectorsPerTrack	; get BIOS' sectors per track
   	mov	[si].BPB_sec_per_trak, cx	; save as a word in ddt

	; always use hidden from partition table
	;

IF USING_BIG_DISKS

	; Check if this drive requires LBA, if not then calculate the start
	; using the CHS values.  Otherwise, use the absolute sector value
	;
	push	di
	mov	di, [bp+DDT_DEVATTR_PTR]
	; DI is pointing to DDT_dattr
	test	word ptr [di], DATTR_LBA_REQUIRED
	pop	di
	jnz	SetCorrectHidden

	; This field is set with the value out of the partition table on
	; a non-LBA drive.
	;
	les	bx, [bp+PART_TABLE_PTR]             ; may be extraneous now...
	mov	ax, word ptr es:[bx].PART_HiddenSectors
	mov	word ptr [si].BPB_hidden, ax
	mov	ax, word ptr es:[bx].PART_HiddenSectors[2]
	mov	word ptr [si].BPB_hidden[2], ax
	jmp	short SetHiddenDone

    SetCorrectHidden:

	; This field is set with the physical sector number on an LBA drive
	;
	mov	ax, word ptr [bp+BB_STARTING_SECTOR]
	mov	word ptr [si].BPB_hidden, ax
	mov	ax, word ptr [bp+BB_STARTING_SECTOR+2]
	mov	word ptr [si].BPB_hidden[2], ax

    SetHiddenDone:

ELSE ; IF USING_BIG_DISKS

	; This field is set with the value out of the partition table on
	; a non-LBA drive.
	;
	les	bx, [bp+PART_TABLE_PTR]             ; may be extraneous now...
	mov	ax, word ptr es:[bx].PART_HiddenSectors
	mov	word ptr [si].BPB_hidden, ax
	mov	ax, word ptr es:[bx].PART_HiddenSectors[2]
	mov	word ptr [si].BPB_hidden[2], ax

ENDIF ; IF USING_BIG_DISKS

    	;	/* we have a valid BPB, copy it */
	;	memmove(&bpb[part], bp, sizeof(struct BiosParameterBlock));
	;
   	mov 	di, si			; put src BPBptr in DI
	mov	AL, byte ptr [bp+UNIT_NUMBER]	; unit
	call	get_BPBptr		; returns dst BPBptr in DS:SI
	push	SI			; &bpb[part]  (dest)
	push	DI			; bp          (src)
IF USING_FAT32
	mov	ax, SIZE BiosParameterBlock
	test	byte ptr [bp+DDT_FAT_TYPE], DDT_FAT_TYPE_32
    	jnz	BBPB_CopyCurBPB
	mov	ax, FAT16_BPB_SIZE
    BBPB_CopyCurBPB:
ELSE
	mov	ax, FAT16_BPB_SIZE
ENDIF
	push	AX
	call	MEMMOVE

IF USING_FAT32
IF USE_186 EQ 0
.386
ENDIF   ;; USE_186
	test	byte ptr [bp+DDT_FAT_TYPE], DDT_FAT_TYPE_32
	jnz	BBPB_CurFAT32DefaultsOK

IF USE_186 EQ 0
    	mov	[si].BPB_ulSectorsPerFat, 0	; sectors per FAT
ELSE    ;; USE_186
        mov     word ptr [si].BPB_ulSectorsPerFat, 0
        mov     word ptr [si].BPB_ulSectorsPerFat[2], 0
ENDIF   ;; USE_186
    	mov	[si].BPB_uExtendedFlags, 0	; extended flags (defined below)
    	mov	[si].BPB_uFileSystemVersion, 0	; File system version number
IF USE_186 EQ 0
    	mov	[si].BPB_ulRootDirStartCluster,0; Root dir start (can move)
ELSE    ;; USE_186
        ; Root dir start (can move)
    	mov	word ptr [si].BPB_ulRootDirStartCluster,0
    	mov	word ptr [si].BPB_ulRootDirStartCluster[2],0
ENDIF   ;; USE_186
    	mov	[si].BPB_uFSInfoSector, -1	; sector # of FSINFO struc  (-1 if none)
    	mov	[si].BPB_uBackUpBootSector, -1	; sector # of backup boot sector (-1 if none)
IF USE_186 EQ 0
	mov	dword ptr [si].BPB_reserved, 0
ELSE    ;; USE_186
        mov     word ptr [si].BPB_reserved, 0
        mov     word ptr [si].BPB_reserved[2], 0
ENDIF   ;; USE_186
	mov	word ptr [si].BPB_reserved[4], 0
    BBPB_CurFAT32DefaultsOK:
.8086
ENDIF

	;	/* copy the BPB into the defbpb as well */
	;	memmove(drive_table[part].defbpb, bp, sizeof(struct BiosParameterBlock));
	;
	mov	AL, byte ptr [bp+UNIT_NUMBER]	; unit
	call	getDriveTable		; returns drive_table in SI
	add	SI, ddt_defbpb
	push	SI			; (dest)
	push	DI			; bp (src)
IF USING_FAT32
	mov	ax, SIZE BiosParameterBlock
	test	byte ptr [bp+DDT_FAT_TYPE], DDT_FAT_TYPE_32
    	jnz	BBPB_CopyDefBPB
	mov	ax, FAT16_BPB_SIZE
    BBPB_CopyDefBPB:
ELSE
	mov	ax, FAT16_BPB_SIZE
ENDIF
	push	AX
	call	MEMMOVE

IF USING_FAT32
IF USE_186 EQ 0
.386
ENDIF   ;; USE_186
	test	byte ptr [bp+DDT_FAT_TYPE], DDT_FAT_TYPE_32
	jnz	BBPB_DefFAT32DefaultsOK

IF USE_186 EQ 0
    	mov	[si].BPB_ulSectorsPerFat, 0	; sectors per FAT
ELSE    ;; USE_186
        mov     word ptr [si].BPB_ulSectorsPerFat, 0
        mov     word ptr [SI].BPB_ulSectorsPerFat[2], 0
ENDIF   ;; USE_186
    	mov	[si].BPB_uExtendedFlags, 0	; extended flags (defined below)
    	mov	[si].BPB_uFileSystemVersion, 0	; File system version number
IF USE_186 EQ 0
    	mov	[si].BPB_ulRootDirStartCluster,0; Root dir start (can move)
ELSE    ;; USE_186
        ; Root dir start (can move)
    	mov	word ptr [si].BPB_ulRootDirStartCluster,0
    	mov	word ptr [si].BPB_ulRootDirStartCluster[2],0
ENDIF   ;; USE_186
    	mov	[si].BPB_uFSInfoSector, -1	; sector # of FSINFO struc  (-1 if none)
    	mov	[si].BPB_uBackUpBootSector, -1	; sector # of backup boot sector (-1 if none)
IF USE_186 EQ 0
	mov	dword ptr [si].BPB_reserved, 0
ELSE    ;; USE_186
	mov	word ptr [si].BPB_reserved, 0
        mov     word ptr [si].BPB_reserved[2], 0
ENDIF   ;; USE_186
	mov	word ptr [si].BPB_reserved[4], 0
    BBPB_DefFAT32DefaultsOK:
.8086
ENDIF

    BBPB_DoneOK:
	mov	ax, 1

    BBPB_Exit:
	pop	DI
	pop	SI
	mov	SP, BP
	pop	BP
	ret
_build_bpb	endp ; }


comment ~ ; prototype ;
/*
	Look through the table to find a partition (DOS
	or extended).
	Returns 0-3 if found, -1 if not.
*/
int find_part(int start, int ext, void far * buff)
{}
~
	public	_find_part
_find_part	proc	near ; {
	push	BP
	mov	BP, SP
	push	SI
FP_START	= 4
FP_EXT		= 6
FP_BUFF		= 8
   ;
   ;	{
   ;	int i;
   ;	unsigned char id;
   ;
   ;	/* only look at valid partition sectors */
   ;	if(*(unsigned far *)(buff+0x1FE) != 0xAA55)
   ;	   return ERR;
   ;
	les	BX, dword ptr FP_BUFF[BP]
	cmp	word ptr ES:[BX+1FEH], 0AA55H
	jz	@@go_on_8
	jmp	fp_err
@@go_on_8:

   ;
   ;	/* check each partition entry for DOS signature */
   ;	part_ptr = (struct partition far *)(buff+PARTOFF) + start;
   ;	for(i=start; i<4; ++i)
   ;
	add	BX, PARTOFF
	mov	SI, FP_START[BP]
	mov	AX, SIZE PartitionTableEntry
	mul	SI
	add	BX, AX			; ES:BX now points to partition
	jmp	short @7@314
@7@74:
   ;
   ;	{
   ;	   id = part_ptr->part_id;
   ;
	mov	DL, byte ptr ES:[BX+4]
   ;
   ;	if(ext)
   ;	   { if(id==DOSEXT) return i; }
   ;
	cmp	word ptr FP_EXT[BP], 0
	je	short @7@170
IF USING_FAT32
	cmp	dl, DOSEXT_LBA			; LBA mode extended part ID=0Fh
    	jne	@@go_on_5
	mov	init_dattr_fLBARequired, DATTR_LBA_REQUIRED
	jmp	short FoundExtendedPartition
@@go_on_5:
ENDIF
	cmp	dl, DOSEXT			; extended partition: ID=5
	jne	short TryNextPart

    FoundExtendedPartition:
	jmp	short fp_return_i
@7@170:
   ;
   ;	else
   ;	{
   ;	   if( (hd_init_pass==HD_PASS_PRIME || part_ptr->bootable) &&
   ;	      (id==DOS12 || id==DOS16 || id==DOSBIG) )
   ;	      return i;
   ;	}
   ;

	; at this point, DL contains partition ID
	; ES:BX points to the partition entry


IFDEF SUPERBOOT
	; only look at Super-Boot partitions on the Super-Boot pass
	cmp	hd_init_pass, HD_PASS_SUPRBOOT
	jnz	short LookForPrimary	; not for us

	; if not the expected Super-Boot ID, ignore the partition
	cmp	DL, SUPR_ID
	jnz	short TryNextPart

	; record that we found a Super-Boot partition
	inc	numSuperParts
	jmp	short FoundValidPart
ENDIF

	; look for primary partitions
    LookForPrimary:
	cmp	hd_init_pass, HD_PASS_PRIME ; BOOTABLE primary partitions only
	jz	BootableOnly
	jmp	short NonBootableOnly

	; bootable primary partitions only
	public	BootableOnly
    BootableOnly:
	test	byte ptr ES:[BX], BOOTABLE_PART		; 80H
	jz	TryNextPart		; not bootable, don't use it
	jmp	short BootBitChecksOut

	; non-bootable primary partitions only
    NonBootableOnly:
	cmp	byte ptr ES:[BX], 0
	jnz	TryNextPart		; bootable, don't use it

	; we know boot bit checks out, now check for partition type
    BootBitChecksOut:
	cmp	DL, DOS12			; FAT12 partition, ID=1
	je	short FoundValidPart
	cmp	DL, DOS16			; FAT16 partition, ID=4
	je	short FoundValidPart
IF USING_FAT32
	cmp	DL, DOS32			; FAT32 partition, ID=0Bh
	je	short FoundValidPart
	cmp	DL, DOS32_LBA  			; FAT32 LBA mode,  ID=0Ch
	jne	@@go_on_6
	mov	init_dattr_fLBARequired, DATTR_LBA_REQUIRED
	jmp	short FoundValidPart
@@go_on_6:
	cmp	DL, DOSBIG_LBA			; >32M FAT 16 LBA, ID=0Eh
	jne	@@go_on_7
	mov	init_dattr_fLBARequired, DATTR_LBA_REQUIRED
	jmp	short FoundValidPart
@@go_on_7:
ENDIF
	cmp	DL, DOSBIG			; >32M FAT 16 part, ID=6
	jne	short TryNextPart

    FoundValidPart:
	jmp	short fp_return_i

    TryNextPart:
   ;
   ;	++part_ptr;
   ;
	add	BX, SIZE PartitionTableEntry	; ++part_ptr
	inc	SI				; ++i
@7@314:
	cmp	SI, 4
	jl	short @7@74
   ;
   ;	}
   ;
   ;	return ERR;
   ;
fp_err:
	mov	AX, -1		; return ERR;
   jmp short fp_done
fp_return_i:
   mov   AX,SI       ; return i;
fp_done:
	pop	SI
	pop	BP
	ret
_find_part	endp ; }


comment ~ ; prototype ;
/*
	Read a sector from the hard disk.  Drive is 80H,
	81H, etc...

	Returns 1 if worked, 0 if failed.
*/
int read_hsec(uchar drive, ulong sector, uchar far * buff)
{}
~
	public	_read_hsec
_read_hsec	proc	near ; {
	push	BP
	mov	BP, SP
IF USING_BIG_DISKS
	sub	SP, 8
ELSE
	sub	SP, 6
ENDIF
	push	SI
	push	DI

; 	[bp+12] = FP_SEG(buff)
;	[bp+10] = FP_OFF(buff)
;	[bp+08] = upper 16 bits of 32-bit sector number
;	[bp+06] = lower 16 bits of 32-bit sector number
;	[bp+04] = drive
; 	[BP-02] = unsigned sectrak;
; 	DI      = unsigned trak;
; 	[BP-03] = uchar    head;
; 	[BP-04] = uchar    sect;
; 	[bp-06] = int      errcnt;
;       [bp-08] = unsigned funccount

   ;
   ;	{
   ;	extern struct hdsize drvparm[];
   ;
   ;	struct hdsize * dp = drvparm+(drive-0x80);
   ;

IF USING_BIG_DISKS
	; We need the function number to be variable, either 2 or 42h
	; depending whether we have LBA support for this drive. We always
	; read a single sector. This value well be loaded into AX just
	; before calling the BIOS to read the disk.
	;
	mov	[bp-8], ((BIOSDISK_READ shl 8) + 1)
ENDIF

	mov	dl, byte ptr [bp+4]
	mov	al, dl
	sub	al, 80h
	call	GetBiosDriveParameterTable

IF USING_BIG_DISKS
IF USE_186 EQ 0
.386
ENDIF   ;; USE_186
	test	[si].BDP_uEBiosAttributes, EBIOS_HAS_LBA_DISK_SUPPORT
	jz   	RHS_NotLBADrive

        ; IR 3802 - NEC BIOS on Intel/NEC "Alliance" machines disables
        ; LBA calls at boot sector processing time. This is a workaround -
        ; if they fix their BIOS this the next 2 code lines can be removed.
        ;
        ; Additionally, if we are below the boundary, use CHS instead
        ;
	mov	di, word ptr [si].BLP_TotalSectors[2]
        cmp     word ptr [bp+06][2], di
        jb      RHS_UseCHS
	ja	RHS_UseLBA
	mov	di, word ptr [si].BLP_TotalSectors
        cmp     word ptr [bp+06], di
        jb      RHS_UseCHS
RHS_UseLBA:
IF USE_186 EQ 0

	; If we have LBA support for this drive then
	; 0) set size of address packet to fix tasm?/tlink? bug
	; 1) make SI point to our local Device Address Packet (DAP).
	; 2) adjust the BIOS function number from 2h to 42h.
	; 3) load the block count, starting sector number and buffer
	;    addresses into the local DAP
	;
	push	eax
	mov	si, GOFFSET sEbiosPacket

	or	byte ptr [bp-7], 40h
	mov	sEbiosPacket.DAP_ucBlockCount, 1
	mov	sEbiosPacket.DAP_ucPacketSize, 10h

	mov   	eax, [bp+06]
	mov	sEbiosPacket.DAP_ulStartingLBALow, eax
	xor	eax, eax
	mov	sEbiosPacket.DAP_ulStartingLBAHigh, eax

	mov	eax, [bp+10]
	mov	sEbiosPacket.DAP_lpBuffer, eax

	pop	eax
ELSE    ;; USE_186
        push    dx
        push    ax
	mov	si, GOFFSET sEbiosPacket

	or	byte ptr [bp-7], 40h
	mov	sEbiosPacket.DAP_ucBlockCount, 1
	mov	sEbiosPacket.DAP_ucPacketSize, 10h

        mov     ax, word ptr [bp+6]
        mov     dx, word ptr [bp+8]
        mov     word ptr sEbiosPacket.DAP_ulStartingLBALow, ax
        mov     word ptr sEbiosPacket.DAP_ulStartingLBALow[2], dx
        xor     ax, ax
        mov     word ptr sEbiosPacket.DAP_ulStartingLBAHigh, ax
        mov     word ptr sEbiosPacket.DAP_ulStartingLBAHigh[2], ax

        mov     ax, word ptr [bp+10]
        mov     dx, word ptr [bp+12]
        mov     word ptr sEbiosPacket.DAP_lpBuffer, ax
        mov     word ptr sEbiosPacket.DAP_lpBuffer[2], dx

        pop     ax
        pop     dx
ENDIF   ;; USE_186
	jmp	short RHS_ReadLoop


   RHS_UseCHS:
   RHS_NotLBADrive:
.8086
ENDIF

   ;	/* determine trak/head/sect from abs sector */
   ;	trak = sector / ((int)dp->xheads * dp->xspt);
   ;
	mov	AL, byte ptr [SI.BLP_SectorsPerTrack]
	mul	byte ptr [SI.BLP_Heads]
	mov	CX, AX
	mov	DX, word ptr [bp+8]
	mov	AX, word ptr [bp+6]
	div	CX
	mov	DI, AX		; di = trak
   ;
   ;	sector -= (ulong)trak * ((int)dp->xheads * dp->xspt);
   ;
	mov	AL, byte ptr [SI.BLP_SectorsPerTrack]
	mul	byte ptr [SI.BLP_Heads]
	mul	DI
	sub	word ptr [bp+6], AX
	sbb	word ptr [bp+8], DX
   ;
   ;	head = sector / dp->xspt;
   ;
	mov	AX, word ptr [bp+6]
	mov	DX, word ptr [bp+8]
	mov	CH, 0
	mov	CL, byte ptr [SI.BLP_SectorsPerTrack]
	div	CX	; sector(DX:AX) / dp->xspt(CX);
	mov	byte ptr [bp-3], al
   ;
   ;	sect = sector - (head * dp->xspt) + 1;
   ;
	mov	AL, byte ptr [BP-3]	; head
	mul	byte ptr [SI.BLP_SectorsPerTrack]	; dp->xspt
	mov	DX, word ptr [bp+8]
	mov	CX, word ptr [bp+6]	; sector(DX:CX)
	sub	CX, AX
	sbb	DX, 0
	inc	CX
	mov	byte ptr [bp-4], CL	; sect
   ;
   ;	/* convert trak and sector into a BIOS usable form */
   ;	sectrak = ((trak&0xFF)<<8) | ((trak&0x300)>>2) | sect;
   ;
	mov	ax,di
	and	ax,255
	mov	cl,8
	shl	ax,cl
	mov	dx,di
	and	dx,768
	shr	dx,1
	shr	dx,1
	or	ax,dx
	mov	dl,byte ptr [bp-4]
	mov	dh,0
	or	ax,dx
	mov	word ptr [bp-2],ax
   ;
   ;
   ;	/* call the BIOS to read the sector */
   ;	for(errcnt=0; errcnt<3; ++errcnt)
   ;
   RHS_ReadLoop:
	mov	word ptr [bp-6],0
	jmp	short @8@122
@8@50:
   ;
   ;	{
   ;		_ES = FP_SEG(buff);
   ;		_BX = FP_OFF(buff);
   ;
	les	bx,dword ptr [bp+10]
   ;
   ;	_AX = BIOSDISK_READ
   ;	_AL = 1;
   ;	_CX = sectrak;
   ;	_DH = head;
   ;	_DL = drive;
   ;	geninterrupt(BIOSDISK);
   ;
IF USING_BIG_DISKS
	; SI will already point to the DAP and won't get changed in this loop.
	; All we really need to do is load the function number and the drive
	; if we are using LBA but if we are use CHS then we need lots more
	; registers loaded. The extra register loads in the LBA case are
	; inefficient but don't conflict with the LBA interface and letting
	; them get loaded all the time results in simpler code.
	;
	mov	ax, [bp-8]
ELSE
	mov	AH, BIOSDISK_READ
	mov	AL, 1
ENDIF
	mov	CX, word ptr [BP-2]
	mov	DH, byte ptr [BP-3]
	mov	DL, byte ptr [BP+4]
	clc
	sti			; ETR 3367
	int	BIOSDISK
   ;
   ;	if((_FLAGS & CARRY) == 0)
   ;
	jc	short @8@98
   ;
   ;	   return TRUE;
   ;
	mov	ax,1
	jmp	short @8@170
@8@98:
	inc	word ptr [bp-6]
@8@122:
	cmp	word ptr [bp-6],3
	jl	short @8@50
   ;
   ;	}
   ;	return FALSE;
   ;
	xor	ax,ax
@8@170:
   ;
   ;	}
   ;
	pop	DI
	pop	SI
	mov	SP, BP
	pop	BP
	ret
_read_hsec	endp ; }
ENDIF ;; (HARDX OR FDHDX)


IF (FLOPX OR FDHDX)

comment ~ ; prototype ;
/*
    Calculate sectors per cluster for FAT12/FAT16 drives based on the
    partition size in sectors.

    Returns the number of Sectors per Cluster needed for the drive.

    FAT      Min    Min       Max         SPC    Cluster
    Type    Size   Sectors   Sectors              Size

    12        0    00003FC0                4       2K
    12       8M    00007F80                8       4K

    16      16M    0003FFC0                4       2K
    16     128M    0007FF80                8       4K
    16     256M    000FFF00               16       8k

    16     512M    001FFE00               32      16K
    16       1G    003FFC00               64      32K

    32     512M    00100000                8       4K
    32       8G    01000000               16       8K
    32      16G    02000000               32      16K
    32      32G    04000000   FFFFFFFF    64      32K

*/
int calcspc(unsigned long len)
{}

~
    public _calcspc
_calcspc proc near ; {
   push  BP
   mov   BP,SP
   dec   SP
   dec   SP
   ;
   ;    {
   ;	   unsigned char val = (len-1)/0xFFF0;
   ;	   unsigned char shift;
   ;
	mov	DX,WORD PTR [BP+6]
	mov	AX,WORD PTR [BP+4]
	sub	AX,1
	sbb	DX,0
	mov	CX, 0FFF0H
	div	CX
	mov	byte ptr [bp-1], al
   ;
   ;	   /* small partition, either 8 or 4 spc */
   ;	   if(val<=1)
   ;	   {
   ;
	cmp	al,1    			; len <= 0FFF0h sectors
	ja	cspc0a
   ;
   ;	      if(len <= MAX8SPC)		; len <= 07F80h sectors (FF0*8)
   ;	         return 8;
   ;
	cmp	word ptr [bp+6],0
	jnz	cspc0
	cmp	word ptr [bp+4],MAX8SPC
	ja	short cspc0
	mov	ax,8
	jmp	short cspc6
cspc0:
   ;
   ;	      return 4;
   ;	   }
   ;
	mov	ax,4
	jmp	short cspc6

   ;
   ;		shift = 8;
   ;
cspc0a:
	mov	byte ptr [bp-2], 8
	jmp	short cspc2
cspc1:
   ;
   ;		while((val&0x80) == 0)
   ;		{
   ;			val = val<<1;
   ;			--shift;
   ;
	shl	byte ptr [bp-1], 1	; val = val<<1
	add	byte ptr [bp-2], 255	; --shift
cspc2:
	test	byte ptr [bp-1], 80H	; val&80H
	je	short cspc1
   ;
   ;		}
   ;		val = 1;
   ;
	mov	byte ptr [bp-1],1
	jmp	short cspc4
cspc3:
   ;
   ;		while(shift--)
   ;			val = val<<1;
   ;
	mov	al,byte ptr [bp-1]
	shl	al,1
	mov	byte ptr [bp-1],al
cspc4:	mov	al,byte ptr [bp-2]
	dec	byte ptr [bp-2]
	or	al,al
	jne	short cspc3
   ;
   ;		return val;
   ;
	mov	al,byte ptr [bp-1]
	mov	ah,0
   ;
   ;	}
   ;
cspc6:
	mov	sp,bp
	pop	bp
	ret
_calcspc	endp ; }


IF USING_FAT32
IF USE_186 EQ 0
.386
ENDIF
comment ~ ; prototype ;
/*
	Calculate sectors per cluster for FAT32 drives based on the
	partition size in sectors.

	Returns the number of Sectors per Cluster needed for the drive.
	or zero if the drive is too small for FAT32.

	FAT   	Min 	Min		Max	 	SPC	Cluster
	Type	Size 	Sectors		Sectors			Size

	12	  0			00003FC0	 4	 2K
	12	  8M    		00007F80 	 8	 4K

	16       16M	   		0003FFC0	 4       2K
	16      128M   			0007FF80	 8       4K
	16      256M			000FFF00	16	 8k

	16	512M			001FFE00	32	16K
	16        1G                   	003FFC00	64      32K

	32	512M	00100000			 8	 4K
	32	  8G	01000000			16	 8K
	32       16G    02000000          	        32      16K
	32	 32G 	04000000        FFFFFFFF   	64      32K

*/
int calcspc32(unsigned long len)
{}

~
	public	_calcspc32
_calcspc32	proc	near ; {
	push	bp
	mov	bp,sp
IF USE_186 EQ 0
	push	ebx
	push	ecx
ELSE    ;; USE_186
        push    bx
        push    cx
        push    si
        push    di
ENDIF   ;; USE_186

	xor	ax,  ax
IF USE_186 EQ 0
	mov	ecx, [bp+4]			; get sector count of drive
	cmp	ecx, MIN_FAT32_SECTORS		; big enough for FAT32?
	jb	CSPC32_done
ELSE    ;; USE_186
        ; get sector count of drive
        mov     cx, word ptr [bp+4]
        mov     bx, word ptr [bp+6]
        ; big enough for FAT32?
        cmp     bx, MIN_FAT32_SECTORS_H
        jb      CSPC32_done
        ja      CSPC32_1
        cmp     cx, MIN_FAT32_SECTORS_L
        jb      CSPC32_done
    CSPC32_1:
ENDIF   ;; USE_186

	mov	ax,  MIN_FAT32_SPC		; start with 8 SPC

IF USE_186 EQ 0
	mov	ebx, MIN_FAT32_16_SPC_DRIVE	; min sectors to use 16 SPC
	cmp	ecx, ebx
	jb	CSPC32_done
ELSE    ;; USE_186
        ; min sectors to use 16 SPC
        mov     si, MIN_FAT32_16_SPC_DRIVE_L
        mov     di, MIN_FAT32_16_SPC_DRIVE_H
        cmp     bx, di
        jb      CSPC32_done
        ja      CSPC32_2
        cmp     cx, si
        jb      CSPC32_done
    CSPC32_2:
ENDIF   ;; USE_186

	shl	ax,  1				; specify 16 SPC
IF USE_186 EQ 0
	shl	ebx, 1				; get lower limit for 32 SPC
	cmp	ecx, ebx
	jb	CSPC32_done

	shl	ax,  1				; specify 32 SPC
	shl	ebx, 1				; get lower limit for 64 SPC
	cmp	ecx, ebx
	jb	CSPC32_done
ELSE    ;; USE_186
        M32_SHL di,si,1                         ; get lower limit for 32 SPC
        cmp     bx, di
        jb      CSPC32_done
        ja      CSPC32_3
        cmp     cx, si
        jb      CSPC32_done

    CSPC32_3:
        shl     ax, 1                           ; specify 32 SPC
        M32_SHL di, si, 1                       ; get lower limit for 64 SPC
        cmp     bx, di
        jb      CSPC32_done
        ja      CSPC32_4
        cmp     cx, si
        jb      CSPC32_done
    CSPC32_4:

ENDIF   ;; USE_186

	shl	ax,  1				; specify 64 SPC

    CSPC32_done:
IF USE_186 EQ 0
	pop	ecx
	pop	ebx
ELSE    ;; USE_186
        pop     di
        pop     si
        pop     cx
        pop     bx
ENDIF   ;; USE_186
	mov	sp,bp
	pop	bp
	ret
_calcspc32	endp ; }
.8086
ENDIF



COMMENT ~ ; prototype ;
--------------------------------------------------------------

   For use by IOCTL 440DH, minor function 66H.  Determines
   the type of floppy/hard disk and adjusts the structure.

--------------------------------------------------------------
void init_type(uchar drive, uchar unit)
{}
~
	public	init_type
init_type	proc	near ; {
	push	BP
	mov	BP, SP
	push	SI
	push	DI

	; get pointer to start of this device type structure
	mov	AL, byte ptr P+2[BP]	; unit
	call	getDriveTable

	; is this a floppy or harddisk?
	test	byte ptr P[BP], 80H
	jz	type_flop

	;  dv->ddt_dtype = 5;   /* fixed disk */
	;  dv->ddt_dattr = 1;   /* non-removable media */
type_hard:
	mov	byte ptr [si.ddt_dtype], 5
IF USING_BIG_DISKS
	mov	di, init_dattr_fLBARequired
	or	di, DATTR_NOTREMOVABLE OR DATTR_ACTIVE_UNIT_FOR_SHARED_DEVICE
	or	word ptr [si.ddt_dattr], di
ELSE ;; IF USING_BIG_DISKS
	or	word ptr [si.ddt_dattr], DATTR_NOTREMOVABLE OR DATTR_ACTIVE_UNIT_FOR_SHARED_DEVICE
ENDIF ;; IF USING_BIG_DISKS
	jmp	it_done

type_flop:
	; no floppies, don't do type
	cmp	num_flop_drives, 0
	jz	it_360

	; ask BIOS what type of floppy this is
	mov	DL, P[BP]
	xor	BX, BX			; type 0 if nothing else
IFDEF ADDED_RESET
; ETR 3367 - Must perform a reset before function 08h for the correct parameters to
;                    be returned from buggy BIOS/BIOS extensions
;
	push	dx
	xor	ax, ax
	int	13h
	pop	dx
ENDIF ; ADDED_RESET

	mov	AH, BIOSDISK_PARM	; Return Drive Parameters
	clc
	push	si
	sti			; ETR 3367
	int	BIOSDISK
	pop	si
	jc	it_360
	or	CH, CH		; # traks can't be 0
	jz	it_360
	or	CL, CL		; # spt can't be 0
	jnz	it_gotparm

	; hard code for 360K disk
it_360:	mov	BL, 1		; 360K
	mov	CX, 2709H	; 28H traks (0-27), 9 spt (1-9)
	mov	DH, 1		; 2 sides (0-1)

it_gotparm:
	; save traks/heads/spt for later use
	mov	AL, DH
	inc	AL
	mov	byte ptr [_hhead], AL
	mov	AL, CL
	and	AL, 3FH
	mov	byte ptr [_hsect], AL
	mov	AH, CL
	mov	CL, 6
	shr	AH, CL
	mov	AL, CH
	inc	AX
	mov	word ptr [_htrak], AX

	; dv->DDT_dcyl = ch + 1;
	mov	word ptr [si.DDT_dcyl], AX

	; BL = drive type from int 13 fn 8 {1,2,3,4}.
	;  --bl;
	;  if(bl >= 3)	      	; if was 4 (1.44M) or greater then assume 7
	;    dv->ddt_dtype = 7; ; 7 => 1.44M
	;
	dec	BL
	cmp	BL, 3
	jb	bl_not_other
	mov	byte ptr [si.ddt_dtype], 7	; type other
	jmp	short got_bl

	;  else
	;    dv->ddt_dtype = bl; ; enum dtype ={360K=0,1.2M,720K}
bl_not_other:
	mov	byte ptr [si.ddt_dtype], BL
got_bl:

	;
	;  if(bl!=0)		 ; if this isn't a 360K drive
	;    dv->ddt_dattr = 2;  ; start by assuming change line status works
	;
	or	BL, BL
	jz	it_getbpb
	or	word ptr [si+ddt_dattr], DATTR_SUPPORTS_CHANGELINE

	; ask BIOS the status of the change line
	;
	mov	dl, P[BP]
	mov	ah, BIOSDISK_CHG
	sti			; ETR 3367
	int	BIOSDISK
	jnc	it_getbpb       		; of no error, great

	cmp	ah, BDISKERR_BAD_COMMAND	; else if not supported
	jne	it_getbpb

	and	word ptr [si].ddt_dattr, NOT DATTR_SUPPORTS_CHANGELINE	; don't ever ask again

	; type 0-3 (BIOS CMOS type 1-4), could be hard-coded BPB
it_getbpb:
	cmp	BL, 4
	jae	other_type

	; make sure # traks agrees with hard-coded BPB
	xor	BH, BH
	cmp	[hardtraks+BX], CH
	jnz	other_type

	; get the hard-coded BPB for this drive
	mov	SI, GOFFSET FD_bpb
	cmp	BL, 0
	jz	it_copy_bpb
	mov	AL, BL		; guaranteed to be 1-3
	dec	AL
	mov	AH, (SIZE BiosParameterBlock)
	mul	AH
	add	AX, GOFFSET hardbpb
	xchg	SI, AX
	jmp	short it_copy_bpb

	; use 1.44 as template, to build BPB
other_type:
	mov	BL, 7			; type other
	mov	SI, GOFFSET hardbpb + (2 * SIZE BiosParameterBlock)

	; copy the appropriate BPB
it_copy_bpb:
	xchg	DI, SI			; save src BPB in DI
	mov	AL, P+2[BP]		; unit #
	call	getDriveTable
	add	SI, ddt_defbpb		; dst BPB in SI
	xchg	SI, DI			; now reverse them, src=SI, dst=DI
	mov	CX, (SIZE BiosParameterBlock)
	push	DS
	pop	ES

IF USING_FAT32
IF USE_186 EQ 0
.386
ENDIF   ;; USE_186

IF USE_186 EQ 0
    	mov	[si].BPB_ulSectorsPerFat, 0	; sectors per FAT
ELSE    ;; USE_186
        ; sectors per FAT
    	mov	word ptr [si].BPB_ulSectorsPerFat, 0
    	mov	word ptr [si].BPB_ulSectorsPerFat[2], 0
ENDIF   ;; USE_186

    	mov	[si].BPB_uExtendedFlags, 0	; extended flags (defined below)
    	mov	[si].BPB_uFileSystemVersion, 0	; File system version number
IF USE_186 EQ 0
    	mov	[si].BPB_ulRootDirStartCluster,0; Root dir start (can move)
ELSE    ;; USE_186
        ; Root dir start (can move)
    	mov	word ptr [si].BPB_ulRootDirStartCluster, 0
    	mov	word ptr [si].BPB_ulRootDirStartCluster[2], 0
ENDIF   ;; USE_186
    	mov	[si].BPB_uFSInfoSector, -1	; sector # of FSINFO struc  (-1 if none)
    	mov	[si].BPB_uBackUpBootSector, -1	; sector # of backup boot sector (-1 if none)
IF USE_186 EQ 0
	mov	dword ptr [si].BPB_reserved, 0
ELSE    ;; USE_186
	mov	word ptr [si].BPB_reserved, 0
	mov	word ptr [si].BPB_reserved[2], 0
ENDIF   ;; USE_186
	mov	word ptr [si].BPB_reserved[4], 0
.8086
ENDIF
	cld
	rep	movsb

	; for other types, calculate the BPB
	cmp	BL, 4
	jb	it_done
	sub	DI, (SIZE BiosParameterBlock)	; restore ptr to BPB
	mov	byte ptr [DI].BPB_sec_per_clus, 2	; set BPB_sec_per_clus
IF USING_FAT32
	mov	word ptr [DI].BPB_uDirEntries, 240	; set BPB_dir_ent
ELSE
	mov	word ptr [DI].BPB_dir_ent, 240		; set BPB_dir_ent
ENDIF
	mov	AL, byte ptr [_hhead]
	mov	byte ptr [DI].BPB_sides, AL		; set heads
	mov	AL, byte ptr [_hsect]
	mov	byte ptr [DI].BPB_sec_per_trak, AL	; set BPB_sec_per_trak
	mul	byte ptr [DI].BPB_sides
	mul	word ptr [_htrak]
	mov	word ptr [DI].BPB_num_sec, AX	; traks*heads*spt = BPB_num_sec
	or	dx, dx				; if num secs <= FFFF
	jz	have_spc

get_spc:
	push	dx				; else calc spc value
	push	ax
	call	_calcspc
	mov	byte ptr [di].BPB_sec_per_clus, al
	pop	ax
	pop	dx
	mov	word ptr [di].BPB_num_sec, 0	; update total sectors
	mov	word ptr [di].BPB_lnumsec, ax
	mov	word ptr [di].BPB_lnumsec[2], dx

	; calculate FAT size for this BPB
	; clusters = bpb->BPB_num_sec / bpb->BPB_sec_per_clus
	; if(clusters > 0xFF0)
	;	fatbytes = clusters * 2;
	; else
	;	fatbytes = (clusters * 3) / 2;
	; bpb->fat_size = fatbytes / bpb->BPB_sec_size + 1;
	;
have_spc:
	mov	CL, byte ptr [DI+BPB_sec_per_clus]
	xor	CH, CH
	div	CX
	cmp	AX, 0FF0H	; clusters
	jbe	fat_12bit

	; compute bytes in fat from cluster count, change "FAT12" to "FAT16"
	;
	mov	DX, 2
	mul	DX
	mov	byte ptr [di][ddt_fatstr+4-ddt_defbpb], '6'
	jmp	short gotfat

fat_12bit:
	mov	DX, 3
	mul	DX
	shr	AX, 1

gotfat:
 	div	word ptr [DI]
	inc	AX
IF USING_FAT32
	mov	word ptr [di].BPB_uFatSectors, ax
ELSE
	mov	word ptr [di].BPB_fat_size, ax
ENDIF

it_done:
	pop	DI
	pop	SI
	pop	BP
	ret
init_type	endp ; }


;------------------------
;  Swap an interrupt vector with
;  On Entry
;	0:BX = interrupt offset
;	DS:SI = address to save old routine
;	DX:AX = new interrupt routine
;  On Exit
;	DX:AX = old interrupt address
swapint proc near
	xor	CX, CX
	mov	ES, CX
	xchg	AX, ES:[BX]
	xchg	DX, ES:[BX+2]
	mov	word ptr [SI], AX
	mov	word ptr [SI+2], DX
	ret
swapint	endp

;------------------------------------------------------
;  This routine sets INT 13H to point to our routine in
;  the DOS data area.  Some BIOSes turn off the HMA when
;  accessing a disk, and so any code calling or returning
;  from INT 13H must be in lower memory.
;
	public	set_new_13_handler
set_new_13_handler proc near

	; retrieve old Disk I/O handler, and set new one
	mov	BX, BIOSDISK*4
	mov	DX, DS
	mov	AX, GOFFSET hma_int_13
	mov	SI, GOFFSET old13
	call	swapint
	mov	word ptr [reboot13], AX		; save address of old
	mov	word ptr [reboot13+2], DX	; handler to restore on
						; reboot

	; retrieve old INT 19H reboot handler, and set new one
	mov	BX, BIOSREBOOT*4
	mov	DX, DS
	mov	AX, GOFFSET hma_int_19
	mov	SI, GOFFSET old19
	call	swapint

	ret
set_new_13_handler endp
ENDIF ;; (FLOPX OR FDHDX)

IFDEF DEBUG_DEVICE_INIT
;---------------------------------------------------------
;
;   Write a Hex Word to Console (BIOS INT 10H)
;
;   Assumes string is in CS:[SI]
;   note: preserves all registers
;---------------------------------------------------------
;
COMMENT ; prototype
void bios_puts()
{}
;
bios_putx   proc near


   push  BX
   push  AX       ; AX has our value, save it

   jc    @@no_leading_space

   ; start off with a leading space " "
   mov   ax,0E20h
   mov   bx,0
   int   10h

@@no_leading_space:

   pop   AX       ; restore our AX, but keep it on the stack for later
   push  AX
   mov   AL,AH    ; first byte to write is in AH
   and   AX,00F0h ; mask bits
   shr   AX,4     ; and shift

   call  bios_putal

   pop   AX       ; restore our AX, but keep it on the stack for later
   push  AX
   mov   AL,AH    ; first byte to write is in AH
   and   AX,000Fh ; mask bits

   call  bios_putal

   pop   AX       ; restore our AX, but keep it on the stack for later
   push  AX
   and   AX,00F0h ; mask bits
   shr   AX,4     ; and shift

   call  bios_putal

   pop   AX       ; restore our AX, but keep it on the stack for later
   push  AX
   and   AX,000Fh ; mask bits

   call  bios_putal

   pop   AX
   pop   BX

   ret
bios_putx   endp



; This mini-function takes the value in AL, converts it to ASCII,
; and displays it TTY fashion via Int 21 function 0E
;
bios_putal  proc near
   add   AL,30h   ; move it up to "number" range
   cmp   AL,39h   ;
   jbe   @@output

   ; 3A becomes 41, 3F becomes 46
   ;
   add   AL,07h   ; keep going to lower alpha range
@@output:
   mov   ah,0Eh
   mov   bx,0
   int   10h
   ret
bios_putal  endp

ENDIF ; IFDEF DEBUG_DEVICE_INIT

cEndCode

   END