//  $Id: DOSIGNON.C 1.8 2003/03/20 16:50:46 thomd Exp $
//
//  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//  Copyright (c) 1997-2003 Datalight, Inc.
//  All Rights Reserved
//
//  Datalight, Inc. is a Washington corporation located at:
//
//  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
//  Bothell, WA  98021                    Fax: +1.425.951.8094
//  USA                                   Http://www.datalight.com
//
//  This software, including without limitation all source code and
//  documentation, is the confidential, trade secret property of
//  Datalight, Inc., and is protected under the copyright laws of
//  the United States and other jurisdictions.  Portions of the
//  software may also be subject to one or more the following US
//  patents: US#5860082, US#6260156.
//
//  In addition to civil penalties for infringement of copyright
//  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//  penalties for violation of (a) the restrictions on circumvention
//  of copyright protection systems found in 17 U.S.C. 1201 and
//  (b) the protections for the integrity of copyright management
//  information found in 17 U.S.C. 1202.
//
//  U.S. Government Restricted Rights.  Use, duplication,
//  reproduction, or transfer of this commercial product and
//  accompanying documentation is restricted in accordance with
//  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
//  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
//  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//  THIS SOFTWARE IN ERROR.
//
/*********************************************************

   DOSIGNON.C   created 03/19/97  by Drew Gislason

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	This file defines what signon message occurs (Starting
	ROM-DOS...) and how long it waits before going on.

**********************************************************/

// Defines the key to nag people with about registering.
// They must press this key to get past the Evaluation kit's
// starting_msg.
//
#define ESCKEY 	27

#ifndef EVALKIT
#if ELAN400 | ELAN300 | EXPLOREII | ELAN520 | STPC | NATIONAL
#define EVALKIT 1
#endif
#endif

#if !EVALKIT
char starting_msg[]= "\nStarting ROM-DOS...\n";
int  cfg_seconds = 3;
char nagware_key = 0;
#else

char starting_msg[] =
	"\n"
	"Datalight ROM-DOS\n"
	"Copyright (c) 1989-2002 Datalight, Inc.\n"
	"\n"
#ifdef ELAN400
	"Configured for the Elan SC400 Development Board.\n"
#elif ELAN300
	"Configured for the Elan SC300/310 Development Board.\n"
#elif ELAN520
	"Configured for the Elan SC520 CDP.\n"
#elif STPC
	"Configured for the STPC Evaluation board family.\n"
#elif NATIONAL
	"Configured for the National Semiconductor MediaGX Evaluation board family.\n"
#elif EXPLOREII
	"Configured for the Intel 386EX Explorer II Development Board.\n"
#endif
	"For Evaluation Purposes Only.\n"
	"\n"
	"Please register with Datalight to receive a copy of ROM-DOS without\n"
	"this message.  ROM-DOS must be licensed from Datalight to be included\n"
	"in any product.\n"
	"\n"
	"To register, contact Datalight at:\n"
	"Mail:  21520 30th Dr. SE, St.110  Email: register@datalight.com\n"
	"       Bothell, WA 98021          Web:   http://www.datalight.com\n"
	"Phone: (800) 221-6630             Fax:   (425) 951-8095\n"
	"\n"
	"Press Esc to continue...\n";

int  cfg_seconds = 30;
char nagware_key = ESCKEY;

#endif

#if UNIT_TEST

#include <stdio.h>
void main(void)
{
	printf(starting_msg);
}
#endif
