;  $Id: SYSGEN.ASM 1.14 2003/03/20 17:09:16 thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1992-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:SYSGEN.ASM
;
; Copyright (c) 1992-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This file contains all user definable options for the ROM-DOS
; kernel. The options are divided into three sections:
;
; 1) Always check/set these options
; 2) Occasionally modified options
; 3) Rarely modified options
;
; Most of these options are available through the BUILD utility.
; Those that are not may be set manually in this file. For example,
; setting the order of character or disk devices requires modifying
; the array "_built_in".
;
; $DOCHISTORY
; 09/21/1998 de  Moved GoAskRPL() and getmemtop() to DOSINIT.ASM to
;		 shrink resident code.
; 08/20/1998 dg  Added Super-Boot capability
; 10/12/1992 dg  Created by Drew Gislason
;--------------------------------------------------------------------

include macros.inc

;include dostruct.inc
IFDEF FAT32
USING_FAT32	= 	1	; enables FAT32 support
USING_BIG_DISKS	=	1       ; enables EBIOS fixed disk extensions
ELSE
USING_FAT32	= 	0
ENDIF


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;	Section 1) Common Options
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; UMBTESTING = 1

	;-------------------------------------------------
	; 1) Set Assemble-time Defines
	;
	;  There is no need to set these if you are using the
	;  BUILD utility to make ROM-DOS.  BUILD generates the
	;  appropriate ones automatically.  These options are
	;  explained in the manual and/or READ.ME.
	;
	;  BCHECK=1	Print boot diagnostics 'B','0'-'9'
	;  BEXT=1	Boot from BIOS extension (always if ROM-DOS
	;               is in ROM, never for ROM-DOS on disk)
	;  BOOTDEV=#	Hard-code the boot device, this can be ROM,
	;		Floppy, or Hard (10H, 00H, 80H respectively)
	;  BOOTDRV=n	Hard-code the boot drive (0=A, 1=B, 2=C...)
	;  BOOTMENU=1	Allow user to pick from a menu on bootup
	;  DATASEG=seg	Hard-code the DATA segment so ROM-DOS has
	;		NO fixups.  ROM-DOS data is copied to the
	;		segment specified. ie /DDATASEG=70H
	;  FLOPCFG=1	If a floppy disk is in the drive (and door is
	;		closed) that drive automatically becomes the
	;		default drive.
	;  FLOPCHK=1	Can floppy disk DOS superscede ROM-DOS in ROM?
	;  GENERIC=1	Include Generic Memory Disk Driver?
	;  HARDCHK=1	Can bootable hard disk partition superscede
	;		ROM-DOS in ROM?
	;  NOFLOP=1	No floppy or harddisk is desired (ROM disk
	;		only).  This can save some ROM space (~3K)
	;  NOROM=1	No ROM-DISK is desired.
	;  RAMBOOT=seg	Copy ROM-DOS from ROM to RAM upon boot, where
	;		it executes just like it was loaded off disk.
	;  RDISK=seg	Segment to start searching for a ROM-DISK
	;  USERTC=1	Use the Real Time Clock, not 'ticks' for time
	;
	;  If not using BUILD, here is an example command line:
	;
	;	C>TASM /Mx /DBEXT=1 /DRAMBOOT=70 SYSGEN;


	;---------------------------------------------------------------
	; 2) A NULL Terminated Array of Built-in Devices
	;
	;  _nulx	null device driver	(uses no BIOS calls)
	;  _conx	console device driver	(INT 10H,16H)
	;  _clkx	clock device driver	(INT 1AH)
	;  _comx	com1 port driver	(INT 11H,14H)
	;  _prnx	lpt1 printer driver	(INT 11H,17H)
	;  _fdhdx	floppy/hard disk driver	(INT 10H,11H,13H,16H,1AH,1EH)
	;
	;  The default array of built-in devices (both character
	;  and disk) must be terminated by a NULL.  The NUL device
	;  driver must be first in the list, and there must be at
	;  least 1 valid disk to boot from.
	;
	;
_DEVDATA segment byte public 'DEVDATA'
	ASSUME DS:_DEVDATA
	extrn _nulx:byte	; BUILT-IN NULL DRIVER
	extrn _conx:byte	; BUILT-IN CONSOLE DRIVER
	extrn _clkx:byte	; BUILT-IN CLOCK DRIVER
	extrn _comx:byte	; BUILT-IN COM PORT DRIVER
	extrn _prnx:byte	; BUILT-IN PRINTER DRIVER

IFNDEF NOFLOP
	extrn _fdhdx:byte	; BUILT-IN FLOPPY/HARD DISK DRIVER
ENDIF
IFNDEF NOROM
	extrn _romx:byte	; BUILT-IN ROM-DISK DRIVER
ENDIF
IFDEF GENERIC
	extrn _memx:byte	; BUILT-IN Generic Memory Disk Driver
ENDIF
_DEVDATA ENDS

cBegData
	public	_built_in
	_built_in	LABEL WORD

	; built-in character devices
	dw	OFFSET DGROUP:_nulx	; MUST be 1st
	dw	OFFSET _DEVDATA:_conx	; MUST be 2nd
	dw	OFFSET _DEVDATA:_clkx	; MUST be 3rd
	dw	OFFSET _DEVDATA:_comx	; not required
	dw	OFFSET _DEVDATA:_prnx	; not required
	; warning: while the COM and PRN(LPT) drivers are
	; not required, the absence of them can cause somewhat
	; odd behavior in some programs.

	; Built-in Disk Devices
	; All of them are optional, but at least 1 disk
	; must be built-in or there's nowhere for ROM-DOS
	; to boot from.

IFNDEF NOFLOP
	dw	OFFSET _DEVDATA:_fdhdx	; optional
ENDIF
IFNDEF NOROM
	dw	OFFSET _DEVDATA:_romx	; optional
ENDIF
IFDEF GENERIC
	dw	OFFSET _DEVDATA:_memx	; optional
ENDIF

	dw	0	; NULL terminator for list


	;---------------------------------------------------------
	; 3) Power Save Option
	;
	;  This variable, if true, tells ROM-DOS NOT to continually
	;  poll for character input, but to wait in INT 16H, sub-
	;  function 00H for a key, allowing the BIOS to do whatever
	;  is necessary to prevent wasting battery power.  A side
	;  effect is that INT 28H is disabled when "powersave" is
	;  on.
	;
	c_public	powersave
	_powersave	db	0


	;---------------------------------------------------------
	; 4) The CONFIG.SYS Defaults
	;
	;  The following data items define the defaults for
	;  CONFIG.SYS.  Each of these items can be overridden
	;  by statements in the file CONFIG.SYS.
	;
	;  A word of explanation for BUFFERS.  The default
	;  behavior is to calculate the optimum # based on the
	;  amount of RAM.  The value 0 in those fields indicates
	;  ROM-DOS should calculate the value.  You may set the
	;  values explicitly.  For minimum size, we suggest
	;  FILES=8 and BUFFERS=2.
	;
	c_public	init_break,init_files,init_buffers
	c_public	init_fcbs,init_lastdrive,init_shell
	_init_break	db 0			; BREAK=OFF
	_init_files	dw 8			; FILES=8 (0=calc)
	_init_buffers	dw 0			; BUFFERS= (0=calc)
	_init_fcbs	dw 2			; FCBS=2
	_init_lastdrive	db 'E'			; LASTDRIVE=E
	_init_shell	db "COMMAND.COM /P",0	; SHELL=COMMAND.COM /P

   c_public confirm_row, F5_bypass, F8_confirm
   c_public title_msg
   ;
   ;  The confirm message appears on the row specified in confirm_row
   ;  when a MENU is found in the CONFIG.SYS processing.
   ;  To hide the message, specify a value of 0FFh in the confirm_row
   ;
   ;  F5 is the key used to bypass all the startup files
   ;  F8 is the key used to trigger confirmation of each line
   ;
   _confirm_row   db 24

   _F5_bypass     dw 3F00h ; scancode of bypass key combination
   _F8_confirm    dw 4200h ; scancode of confirm key combination

   ;
   ;  If using menus, this message is displayed to title the menu.
   ;  It must be zero terminated...
   ;
   _title_msg     db "ROM-DOS Startup Menu",0

   c_public time_row, time_col
   ;
   ;  When MENUDEFAULT is encountered in the CONFIG.SYS processing,
   ;  one of it's options is for a timeout value.  The message and
   ;  countdown traditionally appear to the right of the menu.
   ;
   _time_row      db 1     ;    row for "Time Remaining: ##" message
   _time_col      db 40    ; column for "Time Remaining: ##" message


	;----------------------------------------------------------
	; 5) DOS Version
	;
	;  You may set this version to anything you wish, but be
	;  aware that all the internal structures work like DOS 6.x
	;  regardless of the version # reported.
	;
	public	_dos_ver
IF USING_FAT32
_dos_ver	label	word
	db	07H		; AL = major version (DOS 7.1)
	db	0AH		; AH = minor version (7.10)
else
_dos_ver	label	word
	db	06H		; AL = major version (DOS 6)
	db	16H		; AH = minor version (6.22)
ENDIF

	;----------------------------------------------------------
	; 6) The Default Environment
	;
	;  A list of NULL terminated strings with two NULLS at
	;  the end.  This is the environment as it comes up in
	;  COMMAND.COM.  Also state here the number of paragraphs
	;  allowed for the original environment.
	;
	c_public	env_para,env_string
	_env_para	dw 10H		; 10H paras = 256 bytes
	_env_string	db "PATH=",0
			db "PROMPT=$p$g",0
			db 0

	;----------------------------------------------------------
	; 7) The ROM Disk Search Segment
	;
	;  This segment value tells the ROMDISK driver where to
	;  begin searching for the disk (ie C000:0).  The ROMDISK
	;  driver will search every paragraph of memory until it
	;  reaches FFFF:0.
	;
	c_public	romdisk
IFDEF RDISK
	_romdisk	dw	RDISK	; segment of ROM Disk
ELSE
	_romdisk	dw	0C000H	; segment of ROM Disk
ENDIF

	;----------------------------------------------------------
	; 8) The Real Time Clock
	;
	;  Standard desktop DOS uses the BIOS tick count to read
	;  the time of day and keep trak of date roll-over.  The
	;  Real Time Clock is read only once on startup.  ROM-DOS
	;  offers an alternative - reading the RTC always.
	;
	c_public	clk_use_rtc
IFDEF USERTC
	_clk_use_rtc	db	1
ELSE
	_clk_use_rtc	db	0
ENDIF

	;----------------------------------------------------------
	; 9) The Floppy/Hard-disk device driver
	;
	; MS-DOS' floppy/hard-disk driver insists that all drives
	; have two FATs. This may not always be the behaviour you
	; want (with PC memory cards, etc.). If TRUST_ME is defined,
	; then we will believe the BPB on the disk. Otherwise we
	; will "fix" the BPB in the same way as MS-DOS.
	;
	c_public	trustMe
IFDEF TRUST_ME
	_trustMe	db	1
ELSE
	_trustMe	db	0
ENDIF

cEndData

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;	Section 2) Occasionally modified options
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;-------------------------------------------------
	;
	;   BIOS RESOURCES USED
	;
	;   This area defines all the possible BIOS calls
	;   that can be called in SYSGEN.ASM.  Many are
	;   not required, but are used by certain options.
	;
	BIOSVID		EQU 10H	; Video calls
	BIOSMEM		EQU 12H	; Get total memory in K
	BIOSDISK	EQU 13H	; Disk calls
	BIOSKEY		EQU 16H ; Keyboard calls
	DOSFUNC		EQU 21H	; DOS calls

	BIOSDISK_READ	EQU 02H ; INT 13H, Read a sector
	BIOSKEY_GETKEY	EQU 00H	; INT 16H, Get a key
	BIOSKEY_CHKKEY	EQU 01H ; INT 16H, Keys available?
	BIOSKEY_SHSTAT	EQU 02H	; INT 16H, Check shift status
	BIOSCLK_GETTICK EQU 00H	; INT 1AH, determine ticks
	BIOSVID_CTTY	EQU 0EH	; INT 10H, Output a character

	;-------------------------------------------------
	;
	;   FATAL ERROR ROUTINE
	;
cBegCode
COMMENT ~ ;prototype;
/*
	As we peer through the jungle (of code), we find
	In its heart
	That most sacred of places
	That most sought after place
	That place where the giant ones go to die
	The secret_elephant_burial_grounds...

	This is the fatal error routine.  ROM-DOS has found
	a condition from which it cannot recover, so it
	comes here to die.  The user may replace this
	routine so that it does something more useful than
	halt the machine.

	Note that "assert" is the only routine which can
	call this halt routine.  That means a message will
	have been displayed to the BIOS via INT 10H, 0EH,
	hence no "error code" is passed through to here.
*/
void secret_elephant_burial_grounds(void)
{}
~
c_func	secret_elephant_burial_grounds
	sti
x1:	jmp	x1	; Halt the system with interrupts enabled
c_endp	secret_elephant_burial_grounds

cEndCode

	;-------------------------------------------------
	;
	;	BOOTING METHODS AND OPTIONS
	;
	;  ROM-DOS can be told which drive from which to read
	;  CONFIG.SYS (the default drive) through the initial
	;  contents of the INT 21H vector.
	;
	;  A variable called "drive_code" is set by the ROM-DOS
	;  Kernel upon boot if the segment if INT 21H = 0FFFFH.
	;  The "drive_code" is retrieved from the low byte of
	;  the 4 byte vector.
	;
	;  Example:
	;
	;     FFFF:0080H	<- contents of INT 21H (address 0:84H)
	;
	;  Tells ROM-DOS to set "drive_code" to 80H.
	;
	;  The boot sectors on floppy and hard disks set this to
	;  00H (floppy) or 80H (hard disk).  The BIOS extension
	;  which boots ROM-DOS in ROM may also set this.
	;
	;  The "get_default_drive" routine uses "drive_code" to
	;  determine the default drive (and where to get CONFIG.SYS)
	;
cBegUdata
	PUBLIC	_drive_code
	_drive_code	DB	?	; 00=floppy, 80=hard, 10=ROM disk

cEndUdata

cBegData

   ; IF none of the added options are turned on, we can do
   ; a quick method to get to beg_text.  Assume yes for now...
   ;
   QUICK_BOOT = 1

IFNDEF NOFLOP ; {  /* NOFLOP will exclude floppy/hard drivers */
	extrn	_SuperBootDrive:byte
	extrn	_min_flops:byte
IFDEF FLOPCFG
	c_extrn	disk_in_drive,byte	; TRUE if floppy disk in the drive
	extrn	base_flop_drive:byte	; 0=A, 1=B, etc..

	cfglabel  db	"A:CONFIG.SYS",0
ENDIF
ENDIF ; }

cEndData


cBegCode
	c_extrn	dev_to_drv,near
	c_extrn	GoAskRPL,near

COMMENT ~ ;prototype;
/*
   int get_default_drive(void);

   Determine the default drive to for reading CONFIG.SYS.
   This drive can be A:, B:, C: etc...

   This is a C function and so must follow C conventions.
   It must preserve registers SI,DI,BP and DS and return
   the default drive # in AX.  Drive A=0, B=1, C=2, etc...

   Several options, such as "BOOTDRV", "FLOPCFG", and
   "NOFLOP" can modify the behaviour of this function,
   but...

   The STANDARD method works like this:

   IF the BOOTSECTOR (ie Sector 0 of Floppy/Hard Disk)
      has been run, the "_drive_code" will contain a
      00H for Floppy, or an 80H for Hard Disk, SO boot
      from that drive (whatever drive corresponds to
      the Floppy or Hard Disk, usually A: or C:)
   OTHERWISE if a ROMDISK is PRESENT, boot from that
      drive.
   IF none of these conditions exist, boot from DRIVE A:

   Feel free to MODIFY or REPLACE this routine as needed
   for your hardware and software needs.  This routine
   can do ANY sort of checking/computations to determine
   the default drive; simply return a number where 0=A, 1=B,
   2=C and so on.

   For example, say you wish to hard-code the default drive
   to drive B:.  Simply place the following code at the
   start of the "get_default_drive" function below:

      MOV     AX, 1      ; 1 = drive B:
      RET
*/
int get_default_drive(void)
{}
~
c_func	get_default_drive ; {

	; if no other options are set, the default drive is A:
	mov	AL, 0	; A=0, B=1, C=2, etc...
	xor	CX, CX	; unit 0

IFDEF BOOTMENU
	; see if drive code was from boot menu
	test	byte ptr _drive_code, 40H
	jz	not_menu
	and	byte ptr _drive_code, 0BFH	; turn off bit 40H
IFNDEF NOFLOP
	; only look for floppy or hard disk if driver included
	jmp	test_drive_code
ENDIF
not_menu:
ENDIF

	; user specified the EXACT drive letter to boot from...
IFDEF BOOTDRV
	mov	AL, BOOTDRV	; 0=A:, 1=B:, etc...
	jmp	drv_ok
ENDIF

IFNDEF NOFLOP ; {  /* NOFLOP will exclude floppy/hard drivers */

IFDEF FLOPCFG ; {
	; is a disk in the floppy drive? (and the door closed!)
	cmp	disk_in_drive, 0
	jz	test_drive_code

	; we have a disk in the drive, try reading CONFIG.SYS
	mov	AL, base_flop_drive
	add	byte ptr cfglabel, AL
	mov	DX, GOFFSET cfglabel
	mov	AX, 3D00H
	int	DOSFUNC
	jc	test_drive_code
	mov	BX, AX
	mov	AH, 3EH
	int	DOSFUNC
	jmp	short use_fd

ENDIF ; } look for CONFIG.SYS on floppy

	; Check the "drive_code" to see if we should boot
	; from Floppy, Hard or ROM Disk
test_drive_code:
	mov	AL, _drive_code
	and	AL, 0F0H

	; BOOT SECTOR says LOAD CONFIG.SYS FROM FLOPPY
	cmp	AL, 00H
	jnz	test_hd
use_fd:	mov	DX, offset _fdhdx
	mov	CL, _drive_code		; 0=A, 1=B
	jmp	short found

	; BOOT SECTOR says LOAD CONFIG.SYS FROM HARD DISK
test_hd:
use_hd:	cmp	AL, 80H
	jnz	use_rd

	; we're booting from the HD driver
	mov	DX, offset _fdhdx

	; booting from a Super-Boot partition?
	cmp	_SuperBootDrive, 0FFH
	jz	NotSuperBootDrive
	mov	CL, _SuperBootDrive
	jmp	short found
    NotSuperBootDrive:

    	; normally boot from first HD (drive C:)
	mov	CL, [_min_flops]
	jmp	short found

ENDIF ; } exclude floppy/hard drivers

use_rd:
IFDEF GENERIC
	; DEFAULT to Generic Memory Disk
	mov	DX, offset _memx
ENDIF
IFNDEF NOROM
	; DEFAULT to ROM-DISK
	mov	DX, offset _romx

ENDIF

	; convert device offset into drive #
found:	push	CX		; save unit (CL)
	push	DX		; device ptr
	call	dev_to_drv	; int dev_to_drv(void * device);
	pop	DX
	pop	CX
	cmp	AL, 0FFH
	jnz	drv_ok
	xor	AL, AL		; device not found, use drive A:

	; drive code in AL, this function returns an int
drv_ok:	xor	AH, AH
	add	AL, CL		; add in unit
	ret

c_endp	get_default_drive ; }

cEndCode



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;	Section 3) Rarely modified options
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cBegCode
comment ~ ;prototype;
/*
   If DATASEG is defined, then ROM-DOS will have no fixups.
   It also means that the RAM location for DEVDATA will be
   set at LINK time instead of at LOCATE time.

   Example (no fixups): MASM /Mx /DDATASEG=70H sysgen;
   Example (1 fixup)  : MASM /Mx sysgen;

   DEVDATA contains the ROM-DOS internal device headers.
*/
unsigned getDEVDATA(void)
{}
~
c_func	getDEVDATA
IFNDEF	DATASEG
	MOV	AX, seg _DEVDATA
ELSE
	MOV	AX, DATASEG
ENDIF
	RET
c_endp	getDEVDATA


comment ~ ;prototype;
/*
   This function returns TRUE if ROM-DOS is in ROM, FALSE
   if not.  ROM-DOS is only in ROM if it is installed via
   BIOS extension AND is not copied to ram
*/
int is_DOS_in_ROM(void)
{}
~
c_func	is_DOS_in_ROM
IFDEF BEXT
 IFDEF RAMBOOT 			; copied to RAM, so...
	xor	AX, AX		; no, NOT in ROM
 ELSE
	mov	AX, 1		; yes, in ROM
 ENDIF
ELSE				; not a BIOS extension, so...
	xor	AX, AX		; no, NOT in ROM
ENDIF
	ret
c_endp	is_DOS_in_ROM


;
;   This function provides debugging during boot-up time.
;   Set BCHECK to TRUE
;
COMMENT ~ ;prototype;
void PASCAL bios_putc(uchar c)
{}
~
	public	BIOS_PUTC
BIOS_PUTC	PROC NEAR
IFDEF	BCHECK
	push	BP
	mov	BP, SP
	push	bx

	mov	AL, P[BP]

	mov	AH, BIOSVID_CTTY
	mov	BH, 0
	int	BIOSVID

	pop	bx
	pop	BP
ENDIF
	ret	2
BIOS_PUTC	ENDP

cEndCode

cBegCode
	extrn	__astart:near, beg_text:near, beg_lfn_text:far

c_func	set_bootdev

IFDEF	BOOTDEV
	; read CONFIG.SYS from a specific device
	push	DS
	xor	AX, AX
	mov	DS, AX
	mov	word ptr DS:[INT21H], BOOTDEV
	mov	word ptr DS:[INT21H+2], 0FFFFH
	pop	DS
ENDIF
	ret
c_endp	set_bootdev

cEndCode

cBegData
	extrn	beg_bss:byte
cEndData

_LFN_TEXT segment para public 'CODE'
_LFN_TEXT ends

_BIOSEXT SEGMENT PARA PUBLIC 'BIOSEXT'
	assume	CS:_BIOSEXT,DS:NOTHING

INT19H	 equ	19H*4	; boot vector
INT21H	 equ	21H*4	; send a message to ROM-DOS Kernel
LOADADDR equ	7C00H	; Address at which INT 19H normally loads DOS

;----------------------------------------------------------
;
;  The BEXT option allows ROM-DOS to boot from a BIOS extension.
;  The following code installs itself into INT 19H so that the
;  BIOS, when done initializing, will pass control to the ROM-DOS
;  Kernel in ROM.
;
IFDEF BEXT ; {

	START_LABEL equ bios_ext_signature
extend_bios proc far

	; The following 6 bytes MUST not be changed!  These
	; signature bytes are detected by the BIOS, which
	; then executes this BIOS extension.  The checksum
	; byte will be modified by the LOCATOR after ROM-DOS
	; has been LINKed.
bios_ext_signature:
	dw	0AA55H	; BIOS extension id
	db	4	; size of extension in 512 byte pages
			; (always claim 2K for simplicity)
	jmp	short bios_extension
	db	0FFH	; checksum byte, will be modified by LOC.EXE

	; This code is the actual workhorse of the BIOS
	; extension, whose simple job is to install the
	; address of ROM-DOS at the boot vector (INT 19H).

	PUBLIC	bios_extension
bios_extension:
	; save the registers we use, in case BIOS doesn't
	push	DS
	push	AX
	push	BX
	push	CX

IFDEF	BCHECK
	; boot diagnostics: display a 'B' to the console
	mov	AL,'B'
	mov	AH, BIOSVID_CTTY
	mov	BH, 0
	int	BIOSVID
ENDIF
	; point to vector table
	xor	AX, AX
	mov	DS, AX

	; point INT 19H to our ROM-DOS startup routine
	mov	word ptr DS:[INT19H], offset __loader
	mov	word ptr DS:[INT19H+2], CS

	; and return to the BIOS
	pop	CX
	pop	BX
	pop	AX
	pop	DS
	retf		; return back to BIOS
extend_bios endp

ENDIF	; } BIOS extension

;---------------------------------------------------------
;
;  The loader determines where to load ROM-DOS from (ROM,
;  floppy, or harddisk), and where to execute ROM-DOS (in
;  place in ROM, or in RAM).  It then passes control to
;  ROM-DOS, so ROM-DOS can boot.
;
	PUBLIC	__loader
__loader:

;---------------------------------------------------
;
;   BOOTMENU brings up a menu which outlines various
;   booting choices (from floppy/hard/rom disk, etc).
;   The alt-key must be depressed to activate this
;   menu.
;
;   ROM-DOS boot options:
;
;   1. Load DOS off floppy
;   2. Load DOS off hard disk
;   3. Make floppy default drive
;   4. Make hard disk default drive
;   5. Make ROM disk default drive
;   6. Continue as if Alt key not pressed
;
;   Choose option:
IFDEF BOOTMENU ; {

   QUICK_BOOT = 0

	; is the alt-key depressed?
	mov	AH, BIOSKEY_SHSTAT
	int	BIOSKEY		; AL = Ins Cap Num Scr Alt Ctl Lsh Rsh
	test	AL, 08H		; xxxx 1xxx = alt
	jnz	present_menu
	jmp	nada_boot

	; present menu
present_menu:
	mov	SI, offset CS:menumsg
	call	print_message

	; get user response
menu_getkey:
	mov	AH, BIOSKEY_GETKEY
	int	BIOSKEY		; AL = keycode

	; display choice
	push	AX
	mov	AH, BIOSVID_CTTY
	mov	BX, 7
	int	BIOSVID
	pop	AX

	; don't allow invalid choices
	cmp	AL, '1'
	jb	present_menu
	cmp	AL, '6'
	ja	present_menu

	; go do user choice
	mov	SI, offset CS:menufunc
	sub	AL, '1'
	xor	AH, AH
	shl	AX, 1
	add	SI, AX
	jmp	word ptr CS:[SI]

	; 1. Load DOS off floppy
menu1:	mov	AL, 0
	call	readsector
menu1a:	jc	menu1b
	db	0EAH		; jump far to 0:7C00H
	dd	LOADADDR

	; failed, halt!
menu1b:	mov	SI, offset CS:haltmsg
	call	print_message
	mov	AH, BIOSKEY_GETKEY
	int	BIOSKEY
	int	19H

	; 2. Load DOS off hard disk
menu2:	mov	AL, 80H
	call	readsector
	jmp	short menu1a

	; 3. Run in ROM, but Read CONFIG.SYS off floppy
menu3:	mov	AL, 00H
	jmp	short menu5a

	; 4. Run in ROM, but Read CONFIG.SYS off hard disk
menu4:	mov	AL, 80H
	jmp	short menu5a

	; 5. Run in ROM, but Read CONFIG.SYS off rom disk
menu5:	mov	AL, 10H
menu5a:	or	AL, 40H		; say this is from boot menu
	xor	BX, BX
	mov	DS, BX
	mov	word ptr DS:[INT21H], AX
	mov	word ptr DS:[INT21H+2], 0FFFFH
	jmp	boot_from_rom

	; 6. Continue
menu6:	jmp	nada_boot

haltmsg db 13,10,10
	db "Failed to read disk!",13,10
	db "Strike a key to reboot...",0

menumsg	db 13,10,10
	db "ROM-DOS boot options:",13,10,10
	db "1. Load DOS off floppy",13,10
	db "2. Load DOS off hard disk",13,10
	db "3. Make floppy default drive",13,10
	db "4. Make hard disk default drive",13,10
	db "5. Make ROM disk default drive",13,10
	db "6. Continue as if Alt key not pressed",13,10,10
	db "Choose option: ",0

menufunc dw	menu1, menu2, menu3, menu4, menu5, menu6

;
;   Displays a message using the BIOS
;
;   On Entry:	CS:SI = 0 terminated message
;   On Exit:	SI, BX, AX changed
print_message:
	mov	AL, byte ptr CS:[SI]
	cmp	AL, 0
	jz	print_done
	mov	AH, BIOSVID_CTTY
	mov	BX, 7
	int	BIOSVID
	inc	SI
	jmp	short print_message	; go on to next character
print_done:
	ret

;
;   Try to read a sector into memory at 0:7C00H.  Will
;   try to read up to 3 times.  Verifies that the sector
;   is indeed a "boot" sector.
;
;   On Entry:  AL = BIOS drive #
;   On Exit:   carry set if failed, clear if worked
;
readsector:
	; save drive # in DL
	mov	DL, AL

	; try to read up to 3 times
	mov	CX, 3
rd_chk_again:
	push	CX
	push	DX
	xor	AX, AX
	mov	ES, AX
	mov	BX, LOADADDR
	mov	CX, 1
	xor	DH, DH
	mov	AX, (BIOSDISK_READ * 100H) + 01H
	int	BIOSDISK
	jnc	rd_verify

	; reset the disk and try again
	pop	AX
	push	AX
	int	BIOSDISK

	; try again, may work, may fail
	pop	DX
	pop	CX
	dec	CX
	cmp	CX, 0
	jnz	rd_chk_again

	; failed
rd_fail:
	stc
	ret

	; read worked, now verify it's really a boot sector
rd_verify:
	pop	DX
	pop	CX
	cmp	word ptr ES:[BX+1FEH], 0AA55H
	jnz	rd_fail
	clc
	ret

nada_boot:

ENDIF ; } BOOTMENU

;---------------------------------------------------
;
;  FLOPCHK is the option that tells ROM-DOS boot DOS
;  off the floppy if a floppy is in the drive (ala a
;  standard PC).
;
IFDEF FLOPCHK ; {

   QUICK_BOOT = 0

	mov	AL, 0
	call	readsector
	jnc	got_boot_sector

IFDEF HARDCHK ; {
	jmp	short check_hard
ELSE
	jmp	boot_from_rom
ENDIF	; }

	; we now KNOW we have a valid boot sector, go boot it!
got_boot_sector:
	db	0EAH		; jump far to 0:7C00H
	dd	LOADADDR

;---------------------------------------------------
;
;   HARDCHK is the option that tells ROM-DOS to boot
;   DOS off the hard disk if there is a valid boot
;   partition.
;
IFDEF HARDCHK ; {
check_hard:
	mov	AL, 80H
	call	readsector
	jnc	chk_part
	jmp	boot_from_rom

	; check partition table for bootable partition
chk_part:
	add	BX, 1BEH
try_next_entry:
	cmp	byte ptr ES:[BX], 80H
	jz	got_boot_sector		; found HD part - boot!
	add	BX, 10H
	cmp	BX, LOADADDR + 1FEH
	jb	try_next_entry
	jmp	boot_from_rom

ENDIF	; } HARDCHK

IFNDEF BOOTMENU ; {

;
;   This readsector is identical to the one above, and will
;   only be included if BOOTMENU is not ALREADY included.
;
;   Try to read a sector into memory at 0:7C00H.  Will
;   try to read up to 3 times.  Verifies that the sector
;   is indeed a "boot" sector.
;
;   On Entry:  AL = BIOS drive #
;   On Exit:   carry set if failed, clear if worked
;
readsector:
	; save drive # in DL
	mov	DL, AL

	; try to read up to 3 times
	mov	CX, 3
rd_chk_again:
	push	CX
	push	DX
	xor	AX, AX
	mov	ES, AX
	mov	BX, LOADADDR
	mov	CX, 1
	xor	DH, DH
	mov	AX, (BIOSDISK_READ * 100H) + 01H
	int	BIOSDISK
	jnc	rd_verify

	; reset the disk and try again
	pop	AX
	push	AX
	int	BIOSDISK

	; try again, may work, may fail
	pop	DX
	pop	CX
	dec	CX
	cmp	CX, 0
	jnz	rd_chk_again

	; failed
rd_fail:
	stc
	ret

	; read worked, now verify it's really a boot sector
rd_verify:
	pop	DX
	pop	CX
	cmp	word ptr ES:[BX+1FEH], 0AA55H
	jnz	rd_fail
	clc
	ret
ENDIF ; } IFNDEF BOOTMENU

ENDIF	; } IFDEF FLOPCHK

	; use the ROM-DOS that is in ROM
boot_from_rom:

;----------------------------------------------------------
;
;  RAMBOOT is the option that tells ROM-DOS to copy itself
;  into RAM to run there (rather than running in place in
;  ROM).  This can have significant speed advantages.

IFDEF RAMBOOT ; {

	; find start of ROM-DOS code in ROM
	mov	AX, offset _BIOSEXT:beg_text
	mov	CL, 4
	shr	AX, CL
	mov	DX, CS
	add	AX, DX
	mov	DS, AX
	xor	SI, SI

	; find destination segment for CODE + DATA
	mov	BX, RAMBOOT
	mov	ES, BX
	xor	DI, DI

	; determine size of CODE+DATA
	;
	mov	AX, offset _TEXT:beg_lfn_text + 15
	shr	AX, CL
	mov	dx, ax
	mov	ax, offset _LFN_TEXT:beg_bss+15
	shr	AX, CL
	add	dx, ax	; DX = move size in para
	add	bx, dx	; BX = stack segment

	; Make a new stack of 100h+ bytes just past the end
	; of the memory our where ROM image is copied to RAM
	;
	mov	ss, bx
	mov	sp, 110h

	; Put the start of romdos code on the stack
	;
	push	ES
	push	di

	; We will make two moves normalizing the addresses in between.
	; determine the size of each move
	;

	mov	ax, dx
	mov	cl, 3
	shl	ax, cl ; AX = Half of the size of the move

	; Set the size of the move and save the size of the next
	; move on the stack
	;
	mov	cx, ax
	push	cx

	; move part of ROM-DOS to new location
	;
	cld
	rep	movsb

	; Normalize the source and destination addresses
	;
	mov	cl, 4

	mov	dx, ds
	mov	bx, si
	and	si, 0fh
	shr	bx, cl
	add	dx, bx
	mov	ds, dx

	mov	dx, es
	mov	bx, di
	and	di, 0fh
	shr	bx, cl
	add	dx, bx
	mov	es, dx

	; Set the size of the move and perform the move
	;
	pop	cx
	rep	movsb

	; jump to following label in RAM.
	;
	; Destination already on the stack
	;

	retf
ELSE

IFDEF BEXT

	; No other boot method was established, Jump to ROM-DOS
	mov	DX, offset _BIOSEXT:beg_text
	mov	CL, 4
	shr	DX, CL
	mov	AX, CS
	add	DX, AX

	xor	AX, AX	; _astart MUST be at _TEXT:0
	push	DX
	push	AX
	retf

ELSE ; IFDEF BEXT

	; Hard coded!!! BIOS extension fragment must be 10h away from _TEXT
	;  (except in the bootmenu case, where it's further away...)
   ;

IF QUICK_BOOT

	mov	dx, cs
	inc	dx

ELSE

	; No other boot method was established, Jump to ROM-DOS
	mov	DX, offset _BIOSEXT:beg_text
	mov	CL, 4
	shr	DX, CL
	mov	AX, CS
	add	DX, AX

ENDIF

	xor	AX, AX	; _astart MUST be at _TEXT:0
	push	DX
	push	AX
	retf

IF USING_FAT32

	db	"KFAT32",0

ELSE ; IF USING_FAT32

	db	"KFAT16",0

ENDIF ; IF USING_FAT32

ENDIF ; IFDEF BEXT

ENDIF ; IFDEF RAMBOOT

_BIOSEXT ends

	END	__loader
