//  $Id: DL64.H 1.8 2003/02/14 17:51:00 peterb Exp $
//
//  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//  Copyright (c) 1999-2003 Datalight, Inc.
//  All Rights Reserved
//
//  Datalight, Inc. is a Washington corporation located at:
//
//  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
//  Bothell, WA  98021                    Fax: +1.425.951.8094
//  USA                                   Http://www.datalight.com
//
//  This software, including without limitation all source code and
//  documentation, is the confidential, trade secret property of
//  Datalight, Inc., and is protected under the copyright laws of
//  the United States and other jurisdictions.  Portions of the
//  software may also be subject to one or more the following US
//  patents: US#5860082, US#6260156.
//
//  In addition to civil penalties for infringement of copyright
//  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//  penalties for violation of (a) the restrictions on circumvention
//  of copyright protection systems found in 17 U.S.C. 1201 and
//  (b) the protections for the integrity of copyright management
//  information found in 17 U.S.C. 1202.
//
//  U.S. Government Restricted Rights.  Use, duplication,
//  reproduction, or transfer of this commercial product and
//  accompanying documentation is restricted in accordance with
//  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
//  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
//  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//  THIS SOFTWARE IN ERROR.
//
/********************************************************************
	$DOCMODULE:DL64.H

	Copyright (c) 1999-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	Routines for handling 64-bit math.

	$DOCHISTORY
	02/21/1999 dg  Created by Drew Gislason.
*********************************************************************/

#if !defined( DL64_H )
#define 		  DL64_H	1

#define ONE_GIG 	(1l*1024l*1024l*1024l)

// a 64-bit number
struct UnsignedQuad
{
	unsigned long ulLo;
	unsigned long ulHi;
};
typedef struct UnsignedQuad uquad;

// helper structure, used internally with 64-bit math routines
// not useful to the user.
typedef union
{
	ulong ulValue;
	struct
	{
		unsigned uLo;
		unsigned uHi;
	} u;
}  QuadHelp;


#define GetQuadLoDword(pQuad) ((pQuad)->ulLo)
#define GetQuadHiDword(pQuad) ((pQuad)->ulHi)
#define IsQuadZero(pQuad) ((pQuad)->ulHi == 0 && (pQuad)->ulLo == 0)

// Four Gigabytes is 4 * 1024 * 1024 * 1024,
// and in hex that's 0000 0001 0000 0000
//
#define IsQuadGTFourGig(pQuad) ((pQuad)->ulHi > 1l) || \
                               (((pQuad)->ulHi == 1l) && ((pQuad)->ulLo > 0l))

// 64-bit math operations
void PASCAL ZeroQuad(uquad * pQuad);
void PASCAL SetQuadZX(uquad * pQuad, ulong ulValue);
bool PASCAL AddQuadLong(uquad *pQuad, ulong ulValue);
bool PASCAL AddQuad(uquad * pDstQuad, uquad * pSrcQuad);
void PASCAL DivideQuadByUnsigned(uquad *uqpQuad, unsigned uDivisor,
					unsigned *upRemainder, uquad * puqResult );
uquad PASCAL QuadMultiply(ulong ulValue1, ulong ulValue2);

// DlScaleQuadToMegabytes:dlscale.c
// converts a quad to an ascii form, scales to megabytes. Returns # chars
// in string.
//
int PASCAL DlScaleQuadToMegabytes(char szStr[], uquad uqValue, bool fCommas);

#endif
