//  $Id: COMPILER.H 1.6 2003/03/20 16:58:36 thomd Exp $
//
//  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//  Copyright (c) 1993-2003 Datalight, Inc.
//  All Rights Reserved
//
//  Datalight, Inc. is a Washington corporation located at:
//
//  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
//  Bothell, WA  98021                    Fax: +1.425.951.8094
//  USA                                   Http://www.datalight.com
//
//  This software, including without limitation all source code and
//  documentation, is the confidential, trade secret property of
//  Datalight, Inc., and is protected under the copyright laws of
//  the United States and other jurisdictions.  Portions of the
//  software may also be subject to one or more the following US
//  patents: US#5860082, US#6260156.
//
//  In addition to civil penalties for infringement of copyright
//  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//  penalties for violation of (a) the restrictions on circumvention
//  of copyright protection systems found in 17 U.S.C. 1201 and
//  (b) the protections for the integrity of copyright management
//  information found in 17 U.S.C. 1202.
//
//  U.S. Government Restricted Rights.  Use, duplication,
//  reproduction, or transfer of this commercial product and
//  accompanying documentation is restricted in accordance with
//  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
//  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
//  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//  THIS SOFTWARE IN ERROR.
//
/********************************************************************
	$DOCMODULE:COMPILER.H

	Copyright (c) 1993-2002 Datalight, Inc.
	All Rights Reserved.
	Datalight Confidential and Proprietary

	This file defines 80x86 specific C language constructs that change
	among compilers vendors and versions.

	Support is provided for:
	Borland C/C++ 2.0, 4.5
	Microsoft C 5.0, 6.0 and MSVC 1.52
*********************************************************************/

#define PASCAL pascal

/* Turbo C, Borland C */
#ifdef __TURBOC__
#define ASM asm
#pragma inline
#define INTERRUPT interrupt

/* MSC 5.0, MSC 6.0 */
#elif (_MSC_VER >= 500) && (_MSC_VER < 700)
#define ASM _asm
#define INTERRUPT (void far interrupt)
#define MK_FP(seg,off) \
	((void far *)(((unsigned long)(seg)<<16) | (unsigned)(off)))
#define inportb(port)		inp(port)
#define outportb(port,val)	outp(port,val)
#define inport(port)			inpw(port)
#define outport(port,val)	outpw(port,val)

/* MSC 7.0+ */
#elif (_MSC_VER >= 700) || (_MSC_VER < 500)

#define ASM __asm
#define INTERRUPT (void far __interrupt)
#define inportb(port)		 _inp(port)
#define outportb(port,val)	 _outp(port,val)
#define inport(port)			 _inpw(port)
#define outport(port,val)	 _outpw(port,val)
#define itoa(val,buff,base) _itoa(val,buff,base)
#define bdos(ah,dx,al)      _bdos(ah,dx,al)

/* unknown */
#else
#error Unknown Compiler Version
#endif
