;  $Id: CMD.ASM 1.5 2003/03/20 17:20:18 thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1992-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
;  CMD.ASM  created  September, 1992
;
;  Copyright (c) 1992-2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;
;  This file is the startup code and general assembly
;  for miniCMD.COM.  This is a true COM file, that is
;  CS = DS = SS.
;
include macros.inc

STACKSIZE equ 512
INT23	equ	4*23H
INT24	equ	4*24H

	DGROUP GROUP _TEXT, _DATA, _BSS, _STACK

; Define segment ordering
cBegCode
cEndCode
cBegData
cEndData
cBegUdata
cEndUdata
_STACK segment public para 'STACK'
_STACK ends


cBegData
	extrn	_Got_Cntl_C:near
cEndData

cBegCode

	extrn _do_prompt:near, _get_string:near
	extrn _main:near, _main_loop:near , _puts:near

	public  _exit

	ORG	100H
_astart:
	mov	BX, DS
	mov	AX, CS

	cli
	mov	DS, AX
	mov	SS, AX
	mov	ES, AX
	mov	SP, offset DGROUP:Stack_end
	sti

	mov	word ptr _psp + 2, BX	; Save PSP segment

	mov	BX, offset DGROUP:Stack_end	; Allocate only needed memory
	shr	BX,1
	shr	BX,1
	shr	BX,1
	shr	BX,1
	add	BX, 11H			; PSP and 1 for fudge factor
	mov	AX, _psp+2
	push	ES
	mov	ES, AX
	mov	AX, 4A00H
	int	21H
	pop	ES

	mov	AX, 3524H		; Get old int 24
	int	21H
	mov	word ptr cs:old_int24, bx
	mov	word ptr cs:old_int24+2, es

	mov	ax, 2523H 		; Set Cntl C (int 23H) to our routine
	mov	dx, Offset _int23
	push	cs
	pop	ds
	int	21H

	mov	ax, 2524H 		; Set Crittical Error interrupt
	mov	dx, Offset _int24 	; (int 24H) to our routine
	push	cs
	pop	ds
	int	21H

	push	cs
	pop	ds

	mov	AX, 55AAH		; Set Stack end byte for stack
	mov	stack_chk, AX		; Checking

	push	_psp+2
	mov	ax,81H
	push	ax
	call	_main

comment ~ ; prototype ;
void exit(void)
{}
~
_exit:
	mov	AX, 4C00H		; Exit to ROM-DOS
	int	21H

chk_stack:
	mov	AX, DS:stack_chk
	cmp	AX, 55AAH
	jnz	chk;
	ret
chk:	mov	DX, offset DGROUP:Stk_Ovl
	push	DX
	call	_puts
	jmp	$


_int23:
	mov	CS:byte ptr _Got_Cntl_C, 1

renter:
	push	CS
	pop	AX

	cli
	mov	DS, AX
	mov	SS, AX
	mov	ES, AX
	mov	SP, offset DGROUP:Stack_end
	sti

	call	_main_loop


_int24:
	pushf
	call	DWORD ptr CS:[old_int24]

	cmp	al, 2		; Did they request an abort?
	jz	renter
	iret

old_int24:	dd	0	; Original Interrupt 24 vector

cEndCode

cBegData
	Public	_psp, __errno, __acrtused;

_return	db	0DH, 0AH, '$'

__acrtused	equ $		; This label is for use with Microsoft C

_copyright db	"Copyright (C) Datalight 1992", 0AH, 0DH, 0AH, 0DH, '$';

Stk_Ovl	db	0AH, 0DH, "mini-Command Stack overflow; System Halted$"


_psp	dw 	0,0		; Standard C psp segment

cEndData

cBegUdata
__errno	dw	?		; Standard C error number

int22	dw	?,?		; Original Exit addr in PSP

cEndUdata

_STACK segment
	stack_chk  dw	1 dup (?)	; Stack overflow Check word
	stack_top  dw STACKSIZE dup (?)
	stack_end  label word
_STACK ends

cBegCode

comment ~ ; prototype ;
void get_cwd(unsigned drive, char *path)
{}
~
c_func	get_cwd
	push	BP
	mov	BP, SP
	push	SI
	mov	AH, 47H
	mov	DL, P[BP]
	mov	SI, P+2[BP]
	int	21H
	pop	SI
	pop	BP
	ret
c_endp get_cwd


comment ~ ; prototype ;
int set_cwd(char *path)
{}
~
	public	_set_cwd
_set_cwd:
	push	BP
	mov	BP, SP
	mov	AH, 3BH
	mov	DX, P[BP]
	jmp	short generic_21


comment ~ ; prototype ;
/*
 * dosopen
 *
 * This basic library function opens a file.
 *
 * Return
 * 	the file handle.
 */
int dosopen(char *file, unsigned mode)
{}
~
	public	_dosopen
_dosopen:
	push	BP
	mov	BP, SP

	mov	AH, 3DH
	mov	AL, P+2[BP]	; mode
	mov	DX, P[BP]	; file
generic_21:
	mov	word ptr __errno, 0
	int	21H
	jnc	open_ok
	mov	__errno, AX
	mov	AX, -1
open_ok:
	pop	BP
	ret


comment ~ ; prototype ;
int doscreate(char *file)
{}
~
	public	_doscreate
_doscreate:
	push	BP
	mov	BP, SP

	mov	AH, 3CH
	xor	CX, CX
	mov	DX, P[BP]
	jmp	generic_21


comment ~ ; prototype ;
/*
 * dosclose
 *
 * This basic library function closes a file.
 *
 * Return
 * 	None.
 */
void dosclose(unsigned handle)
{}
~
	public	_dosclose
_dosclose:
	push	BP
	mov	BP, SP

	mov	AH, 3Eh
	mov	BX, P[BP]	; handle
	jmp	short generic_21


comment ~ ; prototype ;
void dosdelete(char *file)
{}
~
	public	_dosdelete
_dosdelete:
	push	BP
	mov	BP, SP
	mov	AH, 41H
	mov	DX, P[BP]	; file
	jmp	generic_21


comment ~ ; prototype ;
/*
 * doslseek
 *
 * This basic library function lseeks around in a file.
 *
 * Returns current file position if worked.
 * Sets "_errno" on error, return is meaningless.
 *
 */
long doslseek(unsigned handle, long pos, unsigned mode)
{}
~
	public	_doslseek
_doslseek:
	push	BP
	mov	BP, SP

	mov	AH, 42H
	mov	AL, P+6[BP]	; mode
	mov	BX, P[BP]	; handle
	mov	DX, P+2[BP]
	mov	CX, P+4[BP]	; CS:DX = pos
	jmp	generic_21


comment ~ ; prototype
unsigned dosread(unsigned handle, char far *buffer, unsigned count)
{}
~
	public	_dosread
_dosread:
	push	BP
	mov	BP, SP

	mov	AH, 3FH
rdwr:	mov	word ptr __errno, 0
	push	DS
	lds	BX, P+2[BP]
	xchg	DX, BX		; DS:DX = buffer
	mov	BX, P[BP]	; BX = handle
	mov	CX, P+6[BP]	; CX = count
	int	21H
	pop	DS
	jnc	read_worked
	mov	__errno, AX
	mov	AX, -1
read_worked:
	pop	BP
	ret

comment ~ ; prototype ;
unsigned doswrite(unsigned handle, char far *buffer, unsigned count)
{}
~
	public	_doswrite
_doswrite:
	push	BP
	mov	BP, SP
	mov	AH, 40H
	jmp	short	rdwr

comment ~ ; prototype ;
/*
 * exec
 *
 * This function calls DOS to execute an EXE or COM file.
 *
 * Return
 * 	the return code.
 */
int exec_func(char *progname, void *args)
{}
~
c_func	exec_func
	push	BP
	mov	BP, SP

	mov	word ptr __errno, 0
	mov	AX, 4B00H
	push	DS
	pop	ES
	mov	BX, P+2[BP]	; args
	mov	DX, P[BP]	; progname
	int	21H
	jnc	exec_worked
	mov	__errno, AX
exec_worked:
	mov	AX, __errno
	pop	BP
	ret
c_endp	exec_func


comment ~ ; prototype ;
void far * dosmalloc(unsigned para)
{}
~
c_func	dosmalloc
	push	BP
	mov	BP, SP
	mov	word ptr __errno, 0
	mov	AX, 4800H
	mov	BX, P[BP]	; para
	int	21H
	jnc	alloc_worked
	mov	__errno, AX
	xor	AX, AX
alloc_worked:
	mov	DX, AX
	xor	AX, AX
	pop	BP
	ret
c_endp	dosmalloc

comment ~ ; prototype ;
void dosfree(void far *mem_ptr)
{}
~
c_func	dosfree
	push	BP
	mov	BP, SP
	mov	AX, 4900H
	mov	ES, P+2[BP]
	int	21H
	pop	BP
	ret
c_endp	dosfree

comment ~ ; prototype ;
int get_dos_mem_position(void)
{}
~
c_func	get_dos_mem_position
	mov	AX, 3306H
	int	21H
	xor	AX, AX
	mov	AL, DH
	ret
c_endp	get_dos_mem_position


comment ~ ; prototype ;
/*
 * putc
 *
 * This basic library function displays a character using DOS.  It also
 * converts '\n' into '\n\r'.
 *
 * Return
 * 	None
 */
void putc(char c)
{}
~
c_func	putc
	push	BP
	mov	BP, SP

	; display cr/lf pairs
	cmp	byte ptr P[BP], 0AH
	jnz	normal_put
	mov	AL, 0DH
	push	AX
	call	putc
	pop	AX

normal_put:
	mov	AH, 2
	mov	DL, P[BP]
	int	21H

	pop	BP
	ret
c_endp	putc

comment ~ ; prototype ;
/*
 * get_current_drive
 *
 * This basic DOS function returns the current Disk drive.
 *
 * Returns Drive # where A=1, B=2, etc...
 *
 */
int get_current_drive(void)
{}
~
c_func	get_current_drive
	mov	AH, 19H
	int	21H
	xor	AH, AH
	inc	AL
	ret
c_endp	get_current_drive

comment ~ ; prototype ;
/*
 * set_current_drive
 *
 * This DOS funcntion sets the default drive.  For
 * drived passed, 1=A, 2=B, etc...
 *
 */
void set_current_drive(unsigned drive)
{}
~
c_func	set_current_drive
	push	BP
	mov	BP, SP
	mov	AH, 0EH
	mov	DL, P[BP]	; drive
	dec	DL
	int	21H
	pop	BP
	ret
c_endp	set_current_drive

comment ~ ; prototype ;
/*
 * parse_fcb.
 *
 * This basic DOS function parses an fcb using DOS.
 *
 * Return
 * 	None
 */
void * parse_fcb(char *cmd, struct fcb *fcb)
{}
~
c_func	parse_fcb
	push	BP
	mov	BP, SP
	push	SI
	push	DI

	mov	AX, 2900H
	mov	SI, P[BP]	; DS:SI = cmd
	push	DS
	pop	ES
	mov	DI, P+2[BP]	; ES:DI = fcb
	int	21H
	mov	AX, SI

	pop	DI
	pop	SI
	pop	BP
	ret
c_endp	parse_fcb

comment ~ ; prototype ;
/*
 * get_dos_buffered_input
 *
 * This basic DOS function uses DOS to get a string from the console.
 *
 * Return
 * 	None
 */
void get_dos_bufferd_input(char *dos_str)
{}
~
c_func	get_dos_bufferd_input
	push	BP
	mov	BP, SP
	mov	AH, 0AH
	mov	DX, P[BP]	; dos_str
	int	21H
	pop	BP
	ret
c_endp	get_dos_bufferd_input


comment ~ ; prototype ;
/*
 * findfirst
 *
 * This DOS function finds a file/sub-dir given a path.  The path may have
 * wild cards in it.
 *
 * Return
 * 	Found/Not-found code.
 */
int findfirst(char *file, struct FFBLK *ffblk, unsigned attr)
{}
~
	public	_findfirst
_findfirst:
	push	BP
	mov	BP, SP

	mov	word ptr __errno, 0

	; set DTA to point to ffblk
	mov	AH, 1AH
	mov	DX, P+2[BP]
	int	21H

	; actually find the file
	mov	AH, 4EH
	mov	CX, P+4[BP]	; attr
	mov	DX, P[BP]	; file
findit:
	int	21H
	jnc	find_worked
	mov	__errno, AX
find_worked:
	mov	AX, __errno
	pop	BP
	ret


comment ~ ; prototype ;
/*
 * findnext
 *
 * This DOS function finds a follow-on file/sub-dir given a path.
 * The findfirst call must have beenn made first.
 *
 * Return
 * 	Found/Not-found code.
 */
int findnext(struct FFBLK *ffblk)
{}
~
	public	_findnext
_findnext:
	push	BP
	mov	BP, SP

	; set DTA to point to ffblk
	mov	AH, 1AH
	mov	DX, P[BP]
	int	21H

	mov	AH, 4FH
	jmp	short findit

IF 0
comment ~ ; prototype ;
void far * MK_FP(unsigned seg, unsigned off)
{}
~
c_func	MK_FP
	push	BP
	mov	BP, SP
	mov	DX, P[BP]
	mov	AX, P+2[BP]
	pop	BP
	ret
c_endp	MK_FP

comment ~ ; prototype ;
unsigned FP_SEG(void far * ptr)
{}
~
c_func	FP_SEG
	push	BP
	mov	BP, SP
	mov	AX, P+2[BP]
	pop	BP
	ret
c_endp	FP_SEG


comment ~ ; prototype ;
unsigned FP_OFF(void far * ptr)
{}
~
c_func	FP_OFF
	push	BP
	mov	BP, SP
	mov	AX, P[BP]
	pop	BP
	ret
c_endp	FP_OFF
ENDIF


cEndCode

	END _astart
