//
//   $Id: BASIC.C 1.2 2002/10/16 15:58:32 peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
 * This RXE-Test Program is designed to run and test some of
 *	the special issues faced by the RXE environment!
 */

#include <stdio.h>
#include <stdlib.h>
#include "compiler.h"

void _setargv__(void);
unsigned getCS(void);
unsigned getDS(void);
unsigned getSS(void);
void main(int argc, char *argv[]);

int *TmpPtr;
void (*MainFunc)();

#ifdef __TURBOC__
char *Compiler = "Borland C";
#else
char *Compiler = "Microsoft C";
#endif

unsigned getCS()
{
	unsigned SegValue;
	ASM	mov	ax, cs
	ASM	mov	SegValue, ax
	return (SegValue);
}

unsigned getDS()
{
	unsigned SegValue;
	ASM	mov	ax, ds
	ASM	mov	SegValue, ax
	return (SegValue);
}

unsigned getSS()
{
	unsigned SegValue;
	ASM	mov	ax, ss
	ASM	mov	SegValue, ax
	return (SegValue);
}



void _setargv__(void)
{}



void main(int argc, char *argv[])
{
	int i;
	char *Model;

	if(sizeof(void *) == 2)
		Model = "Small";
	else
		Model = "Large";

	printf("RXE Test Program!\n");

	printf("CS = 0x%04X DS = %04X Stack = %04X:%04X\n", getCS(), getDS(), getSS(), &i);

	printf("Appears RXE-Test has %s been converted to an RXE\n", getCS() >  getDS() ? "" : "NOT");

	printf("RXE-Test compiled with %s using %s Memory Model on %s\n", Compiler, Model,  __DATE__);

	for(i=0; i<argc; ++i)
		printf("Argv[%d] = %s\n", i, argv[i]);

	printf("Malloc(2048) = %p\n", malloc(2048));

	printf("Malloc(2048) = %p\n", malloc(2048));

	printf("Malloc(2048) = %p\n", malloc(2048));

}

