;
;   $Id: DLSPAWN.ASM 1.2 2002/10/16 16:01:24 peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
;  $DOCFILE:DLSPAWN.ASM
;  Copyright (c) 1998 Datalight, Inc.
;  All rights reserved.
;  Datalight Confidential and Proprietary.
;
;  This module contains simplified spawnl() and spawnv() functions.
;  These functions are DLSpawnL() and DLSpawnV().
;
;  Public functions:
;  ---------------------
;  unsigned GetPSP(void);
;  void ConvertToCmdLine(void *pCmdline, char *argv[]);
;  int DLSpawnL(int mode, char *path, char *arg0, ...);
;  int DLSpawnV(int mode, char *path, char *argv[]);
;
;  DLSpawnL() and DLSpawnV() exactly mimic their C library
;  counterparts with the following differences:
;
;  1. The path must be exact. Examples "hello.exe" or "d:\path\x.com"
;  2. These functions are ROMable and work in RXEs
;
;  $DOCHISTORY
;  10/06/1998 dg  Created by Drew Gislason.
;--------------------------------------------------------------------
include datalght.inc

InitModel %MEMMODEL, C, use16

    CR		equ	13
    PSP_ENV	equ	2Ch

    ; DOS EXE parameter block (see Int 21h fn 4Bh)
    PARMBLK	STRUC
	pblk_envseg	dw	?
	pblk_cmdline	dd	?
	pblk_fcb1	dd	?
	pblk_fcb2	dd	?
    PARMBLK	ENDS

.data

.data?

	; DOS EXE parameter block
	_parmBlk	PARMBLK	<>
	fcb1		db  16 dup (?)
	fcb2		db  16 dup (?)
	szCmdline	db 128 dup (?)

.code

;--------------------------------------------------------------------
; $DOCPROC:GetPSP
; Returns the current DOS PSP in AX.
;--------------------------------------------------------------------
ProcBegin	GetPSP, PUBLIC
ProcSetup
	mov	ah, 51h
	int	21h		; returns PSP in BX
	xchg	bx, ax		; mov PSP to AX
ProcEnd

;--------------------------------------------------------------------
; $DOCPROC:ConvertToCmdLine
;
; Converts an array of pointers to a single cmdline. Separates each
; argument by a space. Cmdline is in the form of:
;
;	<len>, " cmdline chars",CR
;
; On Entry
;	pCmdline	ptr to cmdline
;	pArgv		pointer to an array of ptrs (ala argv[])_
; On Exit
;	pCmdline	filled in with cmdline
;--------------------------------------------------------------------
ProcBegin	ConvertToCmdLine, PUBLIC
ProcArgs	pCmdline:PTR, pArgv:PTR
ProcUses	ds, di, si
ProcSetup

	; dst points to cmdline
	lptr_es	di, pCmdline
	inc	di		; skip len byte

	; up to 126 characters (128 - 2 for len and CR)
	mov	cx, 126
	lptr_ds	bx, pArgv	; ds:bx pts to array of ptrs

	; loop getting each argv[n] string
    MoreArgv:

	; are we at the end of argv[]? (null terminated)
    IF @DataSize
	cmp	word ptr ds:[bx+2], 0
	jnz	NotNull
    ENDIF
	cmp	word ptr ds:[bx], 0	; null offset
	jz	DoneCmdline
    NotNull:

	; get ptr to this string
    IF @DataSize
	push	ds
    ENDIF
	lptr_ds	si, [bx]	; get ptr to "string"

	; a space separates each argv[n]
	jcxz	PopDs		; don't exceed 128 chars total
	mov	al, ' '
	cld
	stosb
	dec	cx

	; copy argv[n] into cmdline
    CopyNextChar:
	jcxz	PopDs		; don't exceed 128 chars total
	cld
	lodsb
	cmp	al, 0
	jz	NextArgv
	stosb
	dec	cx
	jmp	CopyNextChar

	; on to next string
    NextArgv:
    IF @DataSize
	pop	ds
	add	bx, 4		; 4 bytes per far ptr
    ELSE
	add	bx, 2		; 2 bytes per near ptr
    ENDIF
	jmp	MoreArgv

	; CX was 0, terminated loop early, restore DS
    PopDs:
    IF @DataSize
	pop	ds
    ENDIF

	; store CR at end of cmdline
    DoneCmdline:
	mov	byte ptr es:[di], CR

	; put a NULL on the end if there's room
	jcxz	NoNull
	mov	byte ptr es:[di+1], 0
    NoNull:

	; store len byte at start of cmdline
	mov	ax, di
	lptr_es	di, pCmdline
	sub	ax, di
	dec	ax
	mov	es:[di], al
ProcEnd

;--------------------------------------------------------------------
; $DOCPROC:Fcb2Spaces
;
; Internal function
;--------------------------------------------------------------------
ProcBegin	Fcb2Spaces, PASCAL
ProcSetup
	; copy 11 spaces to FCB
	mov	cx, 11
    AgainSpace:
	mov	byte ptr [bx], ' '
	inc	bx
	loop	AgainSpace
ProcEnd

;--------------------------------------------------------------------
; $DOCPROC:DLSpawn
;
; Internal helper function to DLSpawnL() and DLSpawnV(). This
; function does the brunt of the work to call DOS to spawn a program
; via Int 21h fn 4Bh.
;
; OnEntry
;    pArgv	Null terminated array of char ptrs
;    pPath	must be full path. Examples: "hello.exe"  "d:\dir\x.com"
;    cmdline	filled in with user requested cmdline
; OnExit
;    Returns -1 if couldn't spawn program. Returns program code
;    otherwise.
;--------------------------------------------------------------------
ProcBegin	DLSpawn, PASCAL
ProcArgs	pPath:PTR, pArgv:PTR
ProcUses	ds
ProcSetup

	; convert argv[] to cmdline
    IF @DataSize
	push	word ptr pArgv+2
    ENDIF
	push	word ptr pArgv
    IF @DataSize
	mov	ax, seg szCmdline
	push	ax
    ENDIF
	mov	ax, offset szCmdLine
	push	ax
	call	ConvertToCmdLine
    IF @DataSize
	add	sp, 8		; 2 far ptrs
    ELSE
	add	sp, 4		; 2 near ptrs
    ENDIF

	; point parmBlk cmdline to cmdline
	mov	ax, seg szCmdline
	mov	word ptr _parmBlk.pblk_cmdline+2, ax
	mov	ax, offset szCmdline
	mov	word ptr _parmBlk.pblk_cmdline, ax

	; get envseg for parmBlk
	call	GetPSP
	mov	es, ax
	mov	ax, es:[PSP_ENV]
	mov	_parmBlk.pblk_envseg, ax	; env seg

	; Set up FCBs
	mov	bx, offset fcb1
	mov	word ptr _parmBlk.pblk_fcb1, bx
	call	Fcb2Spaces
	mov	bx, offset fcb2
	mov	word ptr _parmBlk.pblk_fcb2, bx
	call	Fcb2Spaces
	mov	ax, seg fcb1
	mov	word ptr _parmBlk.pblk_fcb1+2, ax
	mov	word ptr _parmBlk.pblk_fcb2+2, ax

	; call DOS to spawn the program
	lptr_ds	dx, pPath		; DS:DX pts to filename
	mov	bx, seg _parmBlk
	mov	es, bx
	mov	bx, offset _parmBlk	; ES:BX ptr to exec block
	mov	ax, 4B00h
	clc
	int	21h

	; error loading exe
	jc	ExeError

	; get return code
	mov	ah, 4Dh
	int	21h
	jmp	short DoneExe

    ExeError:
	mov	ax, -1

    DoneExe:
ProcEnd


;--------------------------------------------------------------------
; $DOCPROC:DLSpawnL
;
; int DLSpawnL(int mode, char *path, char *arg0, ..., NULL);
;
; Just like the C spawnl() function, but doesn't save anything in the
; code segment. Safe to place in ROM or an RXE.
;
; OnEntry
;    mode	ignored
;    path	must be full path. Examples: "hello.exe"  "d:\dir\x.com"
;    arg0	ignored
;    arg1...n	null terminated list of cmdline args
; OnExit
;    Returns -1 if couldn't spawn program. Returns program code
;    otherwise.
;--------------------------------------------------------------------
ProcBegin	DLSpawnL, public
ProcArgs	wMode:word, pPath:PTR, pArg0:PTR
ProcSetup

	; call helper function to spawn a sub-program
    IF @DataSize
	push	word ptr pPath+2
    ENDIF
	push	word ptr pPath	; push "path" first (DLSpawn is PASCAL)

	lea	bx, pArg0
    IF @DataSize
	add	bx, 4		; skip arg0
	push	ss
    ELSE
	add	bx, 2		; skip arg0
    ENDIF
	push	bx		; push argv[] next (DLSpawn is PASCAL)
	call	DLSpawn
ProcEnd

;--------------------------------------------------------------------
; $DOCPROC:DLSpawnV
;
; int DLSpawnV(int mode, char *path, char *argv[]);
;
; Just like the C spawnv() function, but doesn't save anything in the
; code segment. Safe to place in ROM or an RXE.
;
; OnEntry
;    mode	ignored
;    path	must be full path. Examples: "hello.exe"  "d:\dir\x.com"
;    argv	a null terminated array of cmdline args
; OnExit
;    Returns -1 if couldn't spawn program. Returns program code
;    otherwise.
;
;--------------------------------------------------------------------
ProcBegin	DLSpawnV, public
ProcArgs	wMode:word, pPath:PTR, pArgV:PTR
ProcSetup
	; call helper function to spawn a sub-program
    IF @DataSize
	push	word ptr pPath+2
    ENDIF
	push	word ptr pPath	; push "path" first (DLSpawn is PASCAL)

	lptr_es	bx, pArgV
    IF @DataSize
	add	bx, 4		; skip arg0
	push	es
    ELSE
	add	bx, 2		; skip arg0
    ENDIF
	push	bx		; push "argv[]" next
	call	DLSpawn
ProcEnd

	END
