//
//   $Id: TSTSPAWN.C 1.2 2002/10/16 16:01:26 peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/********************************************************************
	$DOCFILE:TSTSPAWN.C
	Copyright (c) 1998 Datalight, Inc.
	All rights reserved.
	Datalight Confidential and Proprietary.

	This program tests the Datalight spawn() functions.

	$DOCHISTORY
	10/06/1998 dg  Created by Drew Gislason
*********************************************************************/
#include <stdio.h>
#include <string.h>

// prototypes
void ConvertToCmdLine(void *pCmdline, char *argv[]);
int DLSpawnL(int mode, char *path, char *arg0, ...);
int DLSpawnV(int mode, char *path, char *argv[]);

//
//  Test Data
//
char * argv[] =
{
	"hello",
	0,
	0
};

char * tooLongArgv[] =
{
	"123456789ABCDEF",	// 16
	"123456789ABCDEF",	// 32
	"123456789ABCDEF",	// 48
	"123456789ABCDEF",	// 64
	"123456789ABCDEF",	// 80
	"123456789ABCDEF",	// 96
	"123456789ABCDEF",	// 112
	"123456789ABCDEF",	// 128
	0
};

char * nullArgv[] =
{
	0
};

char * spawnArgv[] =
{
	"argv0",
	"argv1",
	0
};

char szCmdline[129];

//  Test the Datalight spawn functions
int main(void)
{
	static char szNotThereExe[] = "nothere.exe";
	static char szArgExe[]      = "arg.exe";
	char	szWorld[20];
	int	retCode;


	//
	// Test ConvertToCmdLine()
	//

	// first, in large data model, make sure ptrs are to different
	// segments. Convert to "hello world" cmdline.
	strcpy(szWorld, "world");
	argv[1] = szWorld;
	ConvertToCmdLine(szCmdline, argv);
	printf("len %d %s\n",*szCmdline,szCmdline+1);

	// convert an empty cmdline (no args)
	ConvertToCmdLine(szCmdline, nullArgv);
	printf("len %d %s\n",*szCmdline,szCmdline+1);

	// convert a cmdline that is too large
	ConvertToCmdLine(szCmdline, tooLongArgv);
	printf("len %d %s\n",*szCmdline,szCmdline+1);


	//
	// Test DLSpawnL()
	//

	// try to run a program that is not there
	retCode = DLSpawnL(0, szNotThereExe, szNotThereExe, NULL);
	printf("DLSpawnL(%s) retCode %d\n",szNotThereExe,retCode);

	// run a sub-program that displays arguments
	retCode = DLSpawnL(0, szArgExe, szArgExe, "Hello", NULL);
	printf("DLSpawnL(%s) retCode %d\n",szArgExe,retCode);


	//
	// Test DLSpawnV()
	//

	// try to run a program that is not there
	retCode = DLSpawnV(0, szNotThereExe, spawnArgv);
	printf("DLSpawnV(%s) retCode %d\n",szNotThereExe,retCode);

	// run a sub-program that displays arguments
	retCode = DLSpawnV(0, szArgExe, spawnArgv);
	printf("DLSpawnV(%s) retCode %d\n",szArgExe,retCode);

	// no errors
	return 0;
}
