//  $Id: CAPI.C 1.9 2003/07/03 21:59:24 johnb Exp $
//
//  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//  Copyright (c) 1996-2003 Datalight, Inc.
//  All Rights Reserved
//
//  Datalight, Inc. is a Washington corporation located at:
//
//  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
//  Bothell, WA  98021                    Fax: +1.425.951.8094
//  USA                                   Http://www.datalight.com
//
//  This software, including without limitation all source code and
//  documentation, is the confidential, trade secret property of
//  Datalight, Inc., and is protected under the copyright laws of
//  the United States and other jurisdictions.  Portions of the
//  software may also be subject to one or more the following US
//  patents: US#5860082, US#6260156.
//
//  In addition to civil penalties for infringement of copyright
//  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//  penalties for violation of (a) the restrictions on circumvention
//  of copyright protection systems found in 17 U.S.C. 1201 and
//  (b) the protections for the integrity of copyright management
//  information found in 17 U.S.C. 1202.
//
//  U.S. Government Restricted Rights.  Use, duplication,
//  reproduction, or transfer of this commercial product and
//  accompanying documentation is restricted in accordance with
//  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
//  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
//  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//  THIS SOFTWARE IN ERROR.
//
/************************************************************************
	CAPI.C

	Copyright (c) 1996-2002 Datalight, Inc.
	Confidential and Proprietary
	All Rights Reserved

	Provides the Sockets Compatible API (CAPI)


	History
04/01/2003	gvn conditionals to create library
30/11/2002	gvn (re)fixed return value for SetAsyncNotification
10/03/2001 jmb added DJGPP support
		  -------
	1.00 1999-03-18 Starting version control, code usable for Microsoft
		or Borland compilers
	1.01 1999-04-29 fix set_opt() parameter
	1.02 1999-05-27 New version using Datalight Coding guidelines
	1.03 2000-07-11 Added MSVC compatibilaty
	1.10 2000-11-29 pkg Extensive changes to make the code more portable
	1.11 2000-12-15 RWK added function headers
 ************************************************************************
To only compile specific modules, define _CAPI_LIBRARY and only the
specific module(s).
*/

#ifndef _CAPI_LIBRARY
#define _CAPI_BASE
#define _CAPI_GETSOCKETSVERSION
#define _CAPI_DISABLEASYNCNOTIFICATION
#define _CAPI_ENABLEASYNCNOTIFICATION
#define _CAPI_ISSOCKET
#define _CAPI_GETDCSOCKET
#define _CAPI_GETSOCKET
#define _CAPI_GETVERSION
#define _CAPI_CONVERTDCSOCKET
#define _CAPI_EOFSOCKET
#define _CAPI_FLUSHSOCKET
#define _CAPI_RELEASESOCKET
#define _CAPI_RELEASEDCSOCKETS
#define _CAPI_ABORTSOCKET
#define _CAPI_ABORTDCSOCKETS
#define _CAPI_SHUTDOWNNET
#define _CAPI_GETADDRESS
#define _CAPI_GETPEERADDRESS
#define _CAPI_GETKERNELINFORMATION
#define _CAPI_ICMPPING
#define _CAPI_GETKERNELCONFIG
#define _CAPI_GETNETINFO
#define _CAPI_CONNECTSOCKET
#define _CAPI_LISTENSOCKET
#define _CAPI_LISTENACCEPTSOCKET
#define _CAPI_ACCEPTSOCKET
#define _CAPI_SELECTSOCKET
#define _CAPI_READSOCKET
#define _CAPI_READFROMSOCKET
#define _CAPI_WRITESOCKET
#define _CAPI_WRITETOSOCKET
#define _CAPI_SETALARM
#define _CAPI_SETASYNCNOTIFICATION
#define _CAPI_RESOLVENAME
#define _CAPI_PARSEADDRESS
#define _CAPI_SETSOCKETOPTION
#define _CAPI_JOINGROUP
#define _CAPI_LEAVEGROUP
#define _CAPI_IFACEIOCTL
#define _CAPI_ARPAPI
#define _CAPI_ASYNCNOTIFICATIONHANDLER
#define _CAPI_DPMICBREGS
#endif

#include <dos.h>

#ifdef __DJGPP__
#include <dpmi.h>
#include <go32.h>
#endif

#include "compiler.h"
#include "capi.h"


extern int iNetErrNo;
extern int iNetSubErrNo;
extern DPMI_CB_REGS(cb_regs);


#ifdef _CAPI_BASE
/*
	Publicly available error variables that futher describe
	the details of failures while talking with the Sockets
	kernel.  These are set immediately following a call into
	the CAPI and are only valid if the previous function
	call indicated a failure.
*/
int iNetErrNo;
int iNetSubErrNo;

DPMI_CB_REGS(cb_regs);

#endif


/*
	Parameters
	none

	Description
	Returns the version number of the Sockets API

	Returns
	On success, previous state of notification
	On error, -1 if the Sockets API is not found
*/
#ifdef _CAPI_GETSOCKETSVERSION
int GetSocketsVersion(void)
{
	X86Regs r;

	/* Set the function number to call */
	r.ax = GET_SOCKETS_VERSION << 8;
	return CallSocketsDosApi(&r);
}
#endif

/*
	Parameters
	None

	Description
	Disables Asynchronous notifications (callbacks).

	Returns
	On success, 0 for disabled, 1 for enabled.
	On error, -1 with both iNetErrNo and iNetSubErr set
*/
#ifdef _CAPI_DISABLEASYNCNOTIFICATION
int DisableAsyncNotification(void)
{
	X86Regs r;

	/* Set the function number to call */
	r.ax = DISABLE_ASYNC_NOTIFICATION << 8;
	return CallSocketsDosApi(&r);
}
#endif

/*
	Parameters
	None

	Description
	Enables asynchronous notifications (callbacks).

	Returns
	On success, previous state of notification
	On error, -1 with both iNetErrNo and iNetSubErr set
*/
#ifdef _CAPI_ENABLEASYNCNOTIFICATION
int EnableAsyncNotification(void)
{
	X86Regs r;
	r.ax = ENABLE_ASYNC_NOTIFICATION << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	iSocket
	Dos Compatible socket handle for the connection

	Description
	Checks a Dos Compatible socket for validity.

	Returns
	On success, 0
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_ISSOCKET
int IsSocket(int iSocket)
{
	X86Regs r;

	r.bx = iSocket;
	r.ax = IS_SOCKET << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	None

	Description
	Gets a DOS-compatible socket handle. This function calls DOS to
	open a DOS file handle.

	Returns
	On success, socket handle.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_GETDCSOCKET
int GetDCSocket(void)
{
	X86Regs r;

	r.ax = GET_DC_SOCKET << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	None

	Description
	Gets a socket handle.

	Returns
	On success, socket handle.
	On error, -1 with iNetErrNo containing the error code.

*/
#ifdef _CAPI_GETSOCKET
int GetSocket(void)
{
	X86Regs r;

	r.ax = GET_SOCKET << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	None

	Description
	Gets the version number of the Compatible API.

	Returns
	On success, 0x214.
	On error,  -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_GETVERSION
int GetVersion(void)
{
	X86Regs r;

	r.ax = GET_NET_VERSION << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	none

	Description
	Changes a Dos Compatible socket handle into a normal socket handle.
	This function calls DOS to close a DOS file handle.

	Returns
	On success, returns socket handle.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_CONVERTDCSOCKET
int ConvertDCSocket(int iSocket)
{
	X86Regs r;

	r.bx = iSocket;
	r.ax = CONVERT_DC_SOCKET << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	Description
	Closes the STREAM (TCP) connection (sends a FIN).
	After EofSocket() has been called, no WriteSocket() calls may be made.
	The socket, however, remains open for reading until the peer closes the
	connection.

	Returns
	On success, 0.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_EOFSOCKET
int EofSocket(int iSocket)
{
	X86Regs r;

	r.bx = iSocket;
	r.ax = EOF_SOCKET << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	Description
	Flushes any output data still queued for a TCP connection.

	Returns
	On success, 0
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_FLUSHSOCKET
int FlushSocket(int iSocket)
{
	X86Regs r;

	r.bx = iSocket;
	r.ax = FLUSH_SOCKET << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	Description
	Closes connection and release all resources. On a STREAM (TCP) connection,
	this function should only be called once the connection has been closed
	from both sides otherwise a reset (ungraceful close) can result.

	Returns
	On success, socket handle.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_RELEASESOCKET
int ReleaseSocket(int iSocket)
{
	X86Regs r;

	r.bx = iSocket;
	r.ax = RELEASE_SOCKET << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	Description
	Closes all connections and releases all resources associated with
	Dos Compatible sockets.

	Returns
	On success, 0.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_RELEASEDCSOCKETS
int ReleaseDCSockets(void)
{
	X86Regs r;

	r.ax = RELEASE_DC_SOCKETS << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	Description
	Aborts the network connection and releases all resources.
	This function causes an unpredictable close (reset) on a STREAM connection.

	Returns
	On success, returns socket handle.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_ABORTSOCKET
int AbortSocket(int iSocket)
{
	X86Regs r;

	r.ax = ABORT_SOCKET << 8;
	r.bx = iSocket;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	None

	Description
	Aborts all Dos Compatible socket connections.

	Returns
	On success, 0.
	On error, -1 with iNetErrNo containing the error code.

*/
#ifdef _CAPI_ABORTDCSOCKETS
int AbortDCSockets(void)
{
	X86Regs r;

	r.ax = ABORT_DC_SOCKETS << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	None

	Description
	Shuts down the network and unloads the Sockets TCP/IP kernel.

	Returns
	On success, 0.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_SHUTDOWNNET
int ShutDownNet(void)
{
	X86Regs r;

	r.ax = SHUT_DOWN_NET << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	iSocket, socket number to check

	Description
	Gets the local IP address of a connection.  In the case of
	a single interface host, this is the IP address of the host.
	In the case of more than one interface, the IP address of
	the interface being used to route the traffic for the
	specific connection is given.

	Returns
	On success, IP address.
	On error, zero with iNetErrNo containg the error code.
*/
#ifdef _CAPI_GETADDRESS
DWORD GetAddress(int iSocket)
{
	DWORD dwAddress;
	X86Regs r;

	r.bx = iSocket;
	r.ax = GET_ADDRESS << 8;

	if(-1 == CallSocketsDosApi(&r))
		return 0L;

	dwAddress = (((DWORD) r.dx << 16) + r.ax);
	return dwAddress;
}
#endif

/*
	Parameters
	None

	Description
	Gets peer address information on a connected socket.

	Returns
	On success, 0 and NET_ADDR structure filled in.
	On error, -1 with iNetErrNo containing the error
*/
#ifdef _CAPI_GETPEERADDRESS
int GetPeerAddress(int iSocket, NET_ADDR *psAddr)
{
	int iReturn;
	X86Regs r;
	DPMIINFO(iAddr);

	DPMIINFO_INIT(iAddr);
	DPMIINFO_ALLOC(iAddr, sizeof(NET_ADDR));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_SET(iAddr,psAddr,sizeof(NET_ADDR));

	r.ds = REALMODE_SEGMENT(iAddr);
	r.dx = REALMODE_OFFSET(iAddr);
	r.bx = iSocket;
	r.ax = GET_PEER_ADDRESS << 8;
	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_GET(iAddr, psAddr, sizeof(NET_ADDR));
	DPMIINFO_FREE(iAddr);

	return iReturn;
}
#endif

/*
	Parameters
	iReserved
	Reserved value, set to zero.

	bCode
	Code specifying kernel info to retrieve:
	K_INF_HOST_TABLE	Gets name of file containing host table.
	K_INF_DNS_SERVERS	Gets IP addresses of DNS Servers.
	K_INF_TCP_CONS	Gets number of Sockets (DC + normal).
	K_INF_BCAST_ADDR	Gets broadcast IP address.
	K_INF_IP_ADDR	Gets IP address of first interface.
	K_INF_SUBNET_MASK	Gets netmask of first interface.

	pData
	Pointer to data area to receive kernel information.

	puSize
	Pointer to WORD containing length of data area.

	Description
	Gets specified information from the kernel.

	Returns
	On success returns 0 with data area and size word filled in.
	On error, -1 with iNetErrNo containing the error on failure.
*/
#ifdef _CAPI_GETKERNELINFORMATION
int GetKernelInformation(int iReserved, BYTE bCode, BYTE bDevID,
						 void *pData, WORD *pwSize)
{
	int iReturn;
	X86Regs r;
	DPMIINFO(iSize);
	DPMIINFO(iData);

	//
	// iData -> pData
	// iSize -> pwSize
	//
	DPMIINFO_INIT(iData);
	DPMIINFO_ALLOC(iData, *pwSize);
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_INIT(iSize);
	DPMIINFO_ALLOC(iSize, sizeof(WORD));
	if (iNetErrNo == ERR_NO_MEM)
	{
		DPMIINFO_FREE(iData);
		return -1;
	}
	DPMIINFO_SET(iData, pData, *pwSize);
	DPMIINFO_SET(iSize, pwSize, sizeof(WORD));

	r.si = REALMODE_OFFSET(iData);
	if(pData)
	{
		r.ds = REALMODE_SEGMENT(iData);
	}
	else
		r.ds = 0;

	r.di = REALMODE_OFFSET(iSize);
	if(pwSize)
	{
		r.es = REALMODE_SEGMENT(iSize);
	}
	else
		r.es = 0;

	r.bx = iReserved;
	r.dx = ((WORD)bCode << 8) + bDevID;
	r.ax = GET_KERNEL_INFO << 8;
	iReturn = CallSocketsDosApi(&r);

	if (iReturn != -1)
	{
		DPMIINFO_GET(iSize, pwSize, sizeof(WORD));
		DPMIINFO_GET(iData, pData, *pwSize);
	}
	DPMIINFO_FREE(iData);
	DPMIINFO_FREE(iSize);

	return iReturn;
}
#endif
/*
	Parameters
	dwHost
	IP address of host to ping.

	iLength
	Number of data bytes in ping request.

	Description
	Sends an ICMP ping (echo request) and waits until a response is received
	or for six seconds if no response is received.  ICMPPing() is always a
	blocking function.

	Returns
	On success, 0.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_ICMPPING
int ICMPPing(DWORD dwHost, int iLength)
{
	X86Regs r;
	r.bx = (WORD) (dwHost & 0xFFFFL);
	r.dx = (WORD) (dwHost >> 16);

	r.cx = iLength;
	r.ax = ICMP_PING << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	psKc
	Pointer to KERNEL_CONFIG structure.
	bKMaxTcp	Number of TCP sockets allowed.
	BKMaxUdp	Number of UDP sockets allowed.
	bKMaxIp	Number of IP sockets allowed (0).
	bKMaxRaw	Number of RAW_NET sockets allowed (0).
	bKActTcp	Number of TCP sockets in use.
	bKActUdp	Number of UDP sockets in use.
	bKActIp	Number of IP sockets in use (0).
	bKActRaw	Number of RAW_NET sockets in use (0).
	wKActDCS	Number of active Dos Compatible Sockets.
	wKActSoc	Number of active normal Sockets.
	bKMaxLnh	Maximum header on an attached network.
	bKMaxLnt	Maximum trailer on an attached network.
	bKLBUF_SIZE	Size of a large packet buffer.
	bKNnet	Number of network interfaces attached.
	dwKCticks	Milliseconds since kernel started.
	dwKBroadcast	IP broadcast address in use.

	Description
	Gets the kernel configuration.

	Returns
	On success, 0 with KERNEL_CONFIG structure filled in.
	On error,  -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_GETKERNELCONFIG
int GetKernelConfig(KERNEL_CONFIG *psKC)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iKC);

	DPMIINFO_INIT(iKC);
	DPMIINFO_ALLOC(iKC, sizeof(KERNEL_CONFIG));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_SET(iKC, psKC, sizeof(KERNEL_CONFIG));
	r.ds = REALMODE_SEGMENT(iKC);
	r.si = REALMODE_OFFSET(iKC);

	r.ax = GET_KERNEL_CONFIG << 8;

	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_GET(iKC, psKC, sizeof(KERNEL_CONFIG));
	DPMIINFO_FREE(iKC);

	return iReturn;
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	psNI
	Pointer to NET_INFO structure.  The following members of NET_INFO are
	obtained:
	DwIPAddress
	dwIPSubnet
	iUp
	iLanLen
	pLanAddr

	Description
	Gets information about the network.

	Returns
	On success, 0 with NET_INFO structure filled .
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_GETNETINFO
int GetNetInfo(int iSocket, NET_INFO *psNI)
{
	X86Regs r;
	int iReturn;

	DPMIINFO(iNI);

	DPMIINFO_INIT(iNI);
	DPMIINFO_ALLOC(iNI, sizeof(NET_INFO));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_SET(iNI, psNI, sizeof(NET_INFO));

	r.ds = REALMODE_SEGMENT(iNI);
	r.si = REALMODE_OFFSET(iNI);
	r.bx = iSocket;
	r.ax = GET_NET_INFO << 8;
	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_GET(iNI, psNI, sizeof(NET_INFO));
	DPMIINFO_FREE(iNI);

	return iReturn;
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	iType
	Type of connection: STREAM or DATAGRAM.

	psAddr
	Pointer to NET_ADDR structure.

	Description
	Makes a network connection. If iSocket is specified as -1, a
	Dos Compatible socket is assigned.  In this case only, DOS is called
	to open a file handle.  If iSocket specifies a non-blocking socket or
	iType specifies a DATAGRAM connection, this call returns immediately.
	In the case of a STREAM connection, the connection may not yet be
	established.  ReadSocket() can be used to test for connection
	establishment. As long as ReadSocket() returns an ERR_NOT_ESTAB code,
	the connection is not established. A good return or an error return
	with ERR_WOULD_BLOCK indicates an establishedconnection. A more complex
	method uses SetAsyncNotify() with NET_AS_OPEN to test for connection
	establishment. NET_AS_ERROR should also be set to be notified of a
	failed open attempt.

	Returns
	On success, socket.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_CONNECTSOCKET
int ConnectSocket(int iSocket, int iType, NET_ADDR *psAddr)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iAddr);

	psAddr->bProtocol = 6;

	DPMIINFO_INIT(iAddr);
	DPMIINFO_ALLOC(iAddr, sizeof(NET_ADDR));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_SET(iAddr, psAddr, sizeof(NET_ADDR));

	r.ds = REALMODE_SEGMENT(iAddr);
	r.si = REALMODE_OFFSET(iAddr);
	r.bx = iSocket;
	r.dx = iType;
	r.ax = CONNECT_SOCKET << 8;
	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_GET(iAddr, psAddr, sizeof(NET_ADDR));
	DPMIINFO_FREE(iAddr);

	return iReturn;
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	iType
	Type of connection:  STREAM or DATAGRAM.

	psAddr
	Pointer to NET_ADDR structure.

	Description
	Listens for a network connection. If iSocket is specified as -1, a Dos Compatible
	socket is assigned. In this case only, DOS is called to open a file handle.
	If iSocket specifies a non-blocking socket or iType specifies a DATAGRAM connection,
	this call returns immediately.  In the case of a STREAM connection, the connection
	may not be established yet.  ReadSocket() can be used to test for connection establishment.
	As long as ReadSocket() returns an ERR_NOT_ESTAB code, the connection is not established.
	A good return or an error return with ERR_WOULD_BLOCK indicates connection establishment.
	A more complex method is to use SetAsyncNotify() with NET_AS_OPEN to test for connection
	establishment.  NET_AS_ERROR should also be set to be notified of a failed open attempt.

	Returns
	On success, returns socket handle on success.
	On error, -1 on failure with iNetErrNo containing the error code.
*/
#ifdef _CAPI_LISTENSOCKET
int ListenSocket(int iSocket, int iType, NET_ADDR *psAddr)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iAddr);

	psAddr->bProtocol = 6;

	DPMIINFO_INIT(iAddr);
	DPMIINFO_ALLOC(iAddr, sizeof(NET_ADDR));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_SET(iAddr, psAddr, sizeof(NET_ADDR));

	r.ds = REALMODE_SEGMENT(iAddr);
	r.si = REALMODE_OFFSET(iAddr);
	r.bx = iSocket;
	r.dx = iType;
	r.ax = LISTEN_SOCKET << 8;
	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_GET(iAddr, psAddr, sizeof(NET_ADDR));
	DPMIINFO_FREE(iAddr);

	return iReturn;
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	iType
	Type of connection:  STREAM or DATAGRAM.

	iConnections
	Number of connections to be queued pending AcceptSocket().

	psAddr
	Pointer to NET_ADDR structure.

	Description
	Listens for network connections. If iSocket is specified as -1, a Dos Compatible
	socket is assigned. In this case only, DOS is called to open a file handle.
	This call returns immediately. If iType specifies a DATAGRAM connection, this call
	acts exactly the same as a ListenSocket(). If iType specifies a STREAM connection,
	AcceptSocket() must be used to accept incoming connections on iSocket, which will
	remain listening for new connections. Up to iConnections incoming connections may be
	received before an AcceptSocket() must be issued to prevent further connections
	to be refused.

	Returns
	Success: returns socket handle on success.
	Error: -1 on failure with iNetErrNo containing the error code.
*/
#ifdef _CAPI_LISTENACCEPTSOCKET
int ListenAcceptSocket(int iSocket, int iType, int iConnections, NET_ADDR *psAddr)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iAddr);

	psAddr->bProtocol = 6;

	DPMIINFO_INIT(iAddr);
	DPMIINFO_ALLOC(iAddr, sizeof(NET_ADDR));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_SET(iAddr, psAddr, sizeof(NET_ADDR));

	r.ds = REALMODE_SEGMENT(iAddr);
	r.si = REALMODE_OFFSET(iAddr);
	r.bx = iSocket;
	r.cx = iConnections;
	r.dx = iType;
	r.ax = LISTEN_ACCEPT_SOCKET << 8;
	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_GET(iAddr, psAddr, sizeof(NET_ADDR));
	DPMIINFO_FREE(iAddr);

	return iReturn;
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the listen/accept connection.

	iType
	Type of connection:  STREAM.

	psAddr
	Pointer to NET_ADDR structure.

	Description
	Accepts network connections on a listen/accept socket and returns a normal socket
	on the new connection. The returned socket must be used to operate on the
	connection. If no incoming connection has been received on a blocking socket,
	AcceptSocket() will block until a connection has been received or a time-out
	occurs. On a non-blocking socket ERR_WOULD_BLOCK will be returned.

	Returns
	Success: returns socket handle on success.
	Error: -1 on failure with iNetErrNo containing the error code.
*/
#ifdef _CAPI_ACCEPTSOCKET
int AcceptSocket(int iSocket, int iType, NET_ADDR *psAddr)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iAddr);

	psAddr->bProtocol = 6;

	DPMIINFO_INIT(iAddr);
	DPMIINFO_ALLOC(iAddr, sizeof(NET_ADDR));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;

	if (psAddr)
	{
		DPMIINFO_SET(iAddr, psAddr, sizeof(NET_ADDR));
		r.ds = REALMODE_SEGMENT(iAddr);
		r.si = REALMODE_OFFSET(iAddr);
	}
	else
		r.ds = r.si = 0;
	r.bx = iSocket;
	r.dx = iType;
	r.ax = ACCEPT_SOCKET << 8;
	iReturn = CallSocketsDosApi(&r);

	if (psAddr)
	{
		DPMIINFO_GET(iAddr, psAddr, sizeof(NET_ADDR));
	}
	DPMIINFO_FREE(iAddr);

	return iReturn;
}
#endif
/*
	Parameters
	iMaxid
	Number of sockets to test.

	plIflags
	Pointer to input flags indicating receive data availability.

	plOflags
	Pointer to output flags indicating readiness to write.

	Description
	Tests all Dos Compatible sockets for data availability and readiness
	to write.  A 32-bit DWORD representing 32 DC sockets is filled in for
	each socket with receive data, and another 32-bit DWORD for DC sockets
	ready for writing.  The least-significant bit represents the socket with
	value 0 and the most-significant bit represents the socket with value 31.
	Bits representing unused sockets are left unchanged.

	Returns
	On success, returns 0 with *plIflags and *plOflags filled in with current status.
	On error, -1 on failure with iNetErrNo containing the error code.
*/
#ifdef _CAPI_SELECTSOCKET
int SelectSocket(int iMaxID, long *plIflags, long *plOflags)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iOflags);
	DPMIINFO(iIflags);

	// iIflags will contain data for plIflags
	// iOflags will contain data for plOflags

	DPMIINFO_INIT(iOflags);
	DPMIINFO_INIT(iIflags);

	DPMIINFO_ALLOC(iOflags, sizeof(long));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_ALLOC(iIflags, sizeof(long));
	if (iNetErrNo == ERR_NO_MEM)
	{
		DPMIINFO_FREE(iOflags);
		return -1;
	}
	DPMIINFO_SET(iOflags, plOflags, sizeof(long));
	DPMIINFO_SET(iIflags, plIflags, sizeof(long));

	r.ds = REALMODE_SEGMENT(iIflags);
	r.dx = REALMODE_OFFSET(iIflags);
	r.es = REALMODE_SEGMENT(iOflags);
	r.di = REALMODE_OFFSET(iOflags);
	r.bx = iMaxID;
	r.ax = SELECT_SOCKET << 8;
	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_GET(iOflags, plOflags, sizeof(long));
	DPMIINFO_GET(iIflags, plIflags, sizeof(long));
	DPMIINFO_FREE(iOflags);
	DPMIINFO_FREE(iIflags);

	return iReturn;
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	pcBuf
	Pointer to buffer to receive data.

	wLen
	Length of buffer, ie maximum number of bytes to read.

	psFrom
	Pointer to NET_ADDR structure to receive address information about
	local and remote ports and remote IP address.

	wFlags
	Flags governing operation. Any combination of:
	NET_FLG_PEEK	Don't dequeue data.
	NET_FLG_NON_BLOCKING	Don't block.

	Description
	Reads from the network using a socket. Returns as soon as any non-zero
	amount of data is available, regardless of the blocking state. If the
	operation is non-blocking, either by having used SetSocketOption() with
	the NET_OPT_NON_BLOCKING option or specifying wFlags with
	NET_FLG_NON_BLOCKING, ReadSocket() returns immediately with the count
	of available data or an error of ERR_WOULD_BLOCK.

	In the case of a STREAM (TCP) socket, record boundaries do not exist
	and any amount of data can be read at any time regardless of the way
	it was sent by the peer.  No data is truncated or lost even if more data
	than the buffer size is available.  What is not returned on one call, is
	returned on subsequent calls.  If a NULL buffer is specified, the number
	of bytes on the receive queue is returned.

	In the case of a DATAGRAM (UDP) socket, the entire datagram is returned
	in one call, unless the buffer is too small in which case the data is
	truncated, thereby preserving record boundaries.  Truncated data is lost.
	If data is available and both the NET_FLG_PEEK and NET_FLG_NON_BLOCKING
	flags are specified, the number of datagrams on the receive queue is
	returned.  If data is available and NET_FLG_PEEK is set and a NULL buffer
	is specified, the number of bytes in the next datagram is returned.

	Returns
	On success, returns number of bytes read.
	On error, -1 on failure with iNetErrNo containing the error code.
	A return code of 0 indicates that the peer has closed the connection.
*/
#ifdef _CAPI_READSOCKET
int ReadSocket(int iSocket, char *pcBuf, WORD wLen,
				NET_ADDR *psFrom, WORD wFlags)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iBuf);
	DPMIINFO(iFrom);

	// iFrom -> psFrom
	// iBuf -> pcBuf

	DPMIINFO_INIT(iBuf);
	DPMIINFO_INIT(iFrom);
	DPMIINFO_ALLOC(iFrom, sizeof(NET_ADDR));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_ALLOC(iBuf, wLen);
	if (iNetErrNo == ERR_NO_MEM)
	{
		DPMIINFO_FREE(iFrom);
		return -1;
	}

	if (pcBuf)
	{
		DPMIINFO_SET(iBuf, pcBuf, wLen);
		r.ds = REALMODE_SEGMENT(iBuf);
		r.si = REALMODE_OFFSET(iBuf);
	}
	else
	{
		r.ds = 0;
		r.si = 0;
	}

	if (psFrom)
	{
		DPMIINFO_SET(iFrom, psFrom, sizeof(NET_ADDR));
		r.es = REALMODE_SEGMENT(iFrom);
		r.di = REALMODE_OFFSET(iFrom);
	}
	else
	{
		r.es = 0;
		r.di = 0;
	}

	r.dx = wFlags;
	r.cx = wLen;
	r.bx = iSocket;
	r.ax = READ_SOCKET << 8;
	iReturn = CallSocketsDosApi(&r);

	if (psFrom)
	{
		DPMIINFO_GET(iFrom, psFrom, sizeof(NET_ADDR));
	}
	if (pcBuf)
	{
		DPMIINFO_GET(iBuf, pcBuf, r.cx);
	}

	DPMIINFO_FREE(iFrom);
	DPMIINFO_FREE(iBuf);

	if (iReturn != -1)
		iReturn = r.cx;

	return iReturn;
}
#endif
/*
	Parameters
	iSocket
	Socket socket for the connection.

	pcBuf
	Pointer to buffer to receive data.

	wLen
	Length of buffer, ie maximum number of bytes to read.

	psFrom
	Pointer to NET_ADDR structure to receive address information about local
	and remote ports and remote IP address.

	wFlags
	Flags governing operation. Any combination of:
	NET_FLG_PEEK	Don't dequeue data.
	NET_FLG_NON_BLOCKING	Don't block.

	Description
	Reads from the network using a socket and is only intended to be used on
	DATAGRAM sockets. All datagrams from the IP address and port matching the
	values in the NET_ADDR structure are returned while others are discarded.
	A zero value for dwRemoteHost is used as a wildcard to receive from any
	host and a zero value for wRemotePort is used as a wildcard to receive
	from any port. The local port, wLocalPort , can not be specified as zero.

	In other respects ReadFromSocket() behaves the same as ReadSocket().

	Returns
	On success, returns number of bytes read.
	On error, -1 with iNetErrNo containing the error code.

	A return code of 0 indicates that the peer has closed the connection.
	Note the following anomaly:
	If blocking is disabled, a failure with an error code of ErrWouldBlock
	is completely normal and only means that no data is currently available.
*/
#ifdef _CAPI_READFROMSOCKET
int ReadFromSocket(int iSocket, char *pcBuf, WORD wLen,
					NET_ADDR *psFrom, WORD wFlags)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iBuf);
	DPMIINFO(iFrom);

	DPMIINFO_INIT(iBuf);
	DPMIINFO_INIT(iFrom);
	DPMIINFO_ALLOC(iFrom, sizeof(NET_ADDR));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_ALLOC(iBuf, wLen);
	if (iNetErrNo == ERR_NO_MEM)
	{
		DPMIINFO_FREE(iFrom);
		return -1;
	}

	if (pcBuf)
	{
		DPMIINFO_SET(iBuf, pcBuf, wLen);
		r.ds = REALMODE_SEGMENT(iBuf);
		r.si = REALMODE_OFFSET(iBuf);
	}
	else
	{
		r.ds = 0;
		r.si = 0;
	}

	if (psFrom)
	{
		DPMIINFO_SET(iFrom, psFrom, sizeof(NET_ADDR));
		r.es = REALMODE_SEGMENT(iFrom);
		r.di = REALMODE_OFFSET(iFrom);
	}
	else
	{
		r.es = 0;
		r.di = 0;
	}

	r.dx = wFlags;
	r.cx = wLen;
	r.bx = iSocket;
	r.ax = READ_FROM_SOCKET << 8;

	iReturn = CallSocketsDosApi(&r);

	if (psFrom)
	{
		DPMIINFO_GET(iFrom, psFrom, sizeof(NET_ADDR));
	}
	if (pcBuf)
	{
		DPMIINFO_GET(iBuf, pcBuf, r.cx);
	}

	DPMIINFO_FREE(iFrom);
	DPMIINFO_FREE(iBuf);

	return iReturn;
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	pcBuf
	Pointer to buffer to containing send data.

	wLen
	Length of buffer, ie number of bytes to write.

	wFlags
	Flags governing operation; can be any combination of:
	NET_FLG_OOB	Send out of band data (TCP only).
	NET_FLG_PUSH	Disregard Nagle heuristic (TCP only).
	NET_FLG_NON_BLOCKING	Don't block.
	NET_FLG_BROADCAST	Broadcast data (UDP only).
	NET_FLG_MC_NOECHO	Suppress the local echo of a multicast datagram.

	Description
	Writes to the network using a socket.

	Returns
	On success, returns number of bytes written.
	On error, -1 on failure with iNetErrNo containing the error code.

	The number of bytes actually written on a non-blocking write, can be less
	than wLen.  In such a case, the writing of the unwritten bytes must be
	retried, preferably after some delay.
*/
#ifdef _CAPI_WRITESOCKET
int WriteSocket(int iSocket, char *pcBuf, WORD wLen, WORD wFlags)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iBuf);

	DPMIINFO_INIT(iBuf);
	DPMIINFO_ALLOC(iBuf, wLen);
	if (iNetErrNo == ERR_NO_MEM)
		return -1;

	DPMIINFO_SET(iBuf, pcBuf, wLen);

	r.ds = REALMODE_SEGMENT(iBuf);
	r.si = REALMODE_OFFSET(iBuf);
	r.bx = iSocket;
	r.cx = wLen;
	r.dx = wFlags;
	r.ax = WRITE_SOCKET << 8;
	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_FREE(iBuf);

	return iReturn;
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	pcBuf
	Pointer to buffer to containing send data.

	wLen
	Length of buffer, ie number of bytes to write.

	psTo
	Pointer to NET_ADDR structure containing local port to write from and remote port and
	IP address to write to.

	wFlags
	Flags governing operation. Any combination of:
	NET_FLG_NON_BLOCKING	Don't block.
	NET_FLG_BROADCAST	Broadcast data (UDP only).

	Description
	Writes to the network using a network address (UDP only).

	Returns
	On success, returns number of bytes written.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_WRITETOSOCKET
int WriteToSocket(int iSocket, char *pcBuf, WORD wLen,
				  NET_ADDR *psTo, WORD wFlags)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iBuf);
	DPMIINFO(iTo);


	DPMIINFO_INIT(iBuf);
	DPMIINFO_INIT(iTo);
	DPMIINFO_ALLOC(iBuf, wLen);
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_ALLOC(iTo, sizeof(NET_ADDR));
	if (iNetErrNo == ERR_NO_MEM)
	{
		DPMIINFO_FREE(iBuf);
		return -1;
	}

	DPMIINFO_SET(iBuf, pcBuf, wLen);
	DPMIINFO_SET(iTo, psTo, sizeof(NET_ADDR));

	r.ds = REALMODE_SEGMENT(iBuf);
	r.si = REALMODE_OFFSET(iBuf);
	if (psTo)
	{
		r.es = REALMODE_SEGMENT(iTo);
		r.di = REALMODE_OFFSET(iTo);
	}
	else
	{
		r.es = 0;
		r.di = 0;
	}


	r.bx = iSocket;
	r.cx = wLen;
	r.dx = wFlags;
	r.ax = WRITE_TO_SOCKET << 8;
	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_FREE(iBuf);
	DPMIINFO_FREE(iTo);

	return iReturn;
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	dwTime
	Timer delay in milliseconds.

	lpHandler
	Far address of alarm callback.  See the description of  SetAsyncNotification() for the
	format of the callback function.

	dwHint
	Argument to be passed to callback function.

	Description
	The SetAlarm() function sets an alarm timer.

	Returns
	On success, returns socket handle.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_SETALARM
DPMI_CB_INFO(alarm_info);

int SetAlarm(int iSocket, DWORD dwTime,
			 int (D_FAR *lpHandler)(), DWORD dwHint)
{
	X86Regs r;

	DPMI_CB_ALLOCRETF(alarm_info, lpHandler, cb_regs);
	if (iNetErrNo == ERR_NO_MEM)
		// unable to allocate callback, return failure
		return -1;

	r.ds = REALMODE_SEGMENT(alarm_info);
	r.si = REALMODE_OFFSET(alarm_info);


	r.cx = (WORD) (dwTime >> 16);
	r.dx = (WORD) (dwTime & 0xFFFFL);

	r.es = (WORD) (dwHint >> 16);
	r.di = (WORD) (dwHint & 0xFFFFL);

	r.bx = iSocket;
	r.ax = SET_ALARM << 8;
	return CallSocketsDosApi(&r);
}
#endif
/*
	Parameters
	iSocket
	Socket handle for the connection.

	iEvent
	Event which is being set:
	NET_AS_OPEN	Connection has opened.
	NET_AS_RCV	Data has been received.
	NET_AS_XMT	Ready to transmit.
	NET_AS_FCLOSE	Peer has closed connection.
	NET_AS_CLOSE	Connection has been closed.
	NET_AS_ERROR	Connection has been reset.

	lpHandler
	Far address of callback function.

	dwHint
	Argument to be passed to callback function
	The handler is not compatible with C calling conventions but is called
	by a far call with the following parameters:
	BX = Socket handle.
	CX = Event.
	ES:DI = dwHint argument passed to SetAsyncNotification() or SetAlarm().
	DS:DX = SI:DX = variable argument depending on event:
	NET_AS_OPEN
	NET_AS_CLOSE	Pointer to NET_ADDR address structure.
	NET_AS_FCLOSE
	NET_AS_RCV
	NET_AS_ALARM	Zero.
	NET_AS_XMT	Byte count which can be sent without blocking.
	NET_AS_ERROR	Error code -ERR_TERMINATING, ERR_TIME_OUT or ERR_RESET.

	Description
	Sets an asynchronous notification (callback) for a specific event.

	Other CAPI functions may be called in the callback, with the exception of
	ResolveName() which may call DOS.  The callback is not compatible with C
	argument-passing conventions and some care must be taken.  Some CPU
	register manipulation is required.  This can be done by referencing CPU
	registers, such as _BX, or by means of assembler instructions.

	In the callback, the stack is supplied by Sockets and may be quite small
	depending on the /s= command line option when loading Sockets.  The stack
	segment is obviously not equal to the data segment, which can cause
	problems when the Tiny, Small or Medium memory model is used.
	The simplest way to overcome the problem is to use the Compact, Large
	or Huge memory model.  Other options - use the DS != SS compiler option
	or do a stack switch to a data segment stack .

	If the callback is written in C or C++, the _loadds modifier can be used
	to set the data segment to that of the module, which destroys the DS used
	for the variable argument.  (This is why DS == SI on entry for Sockets
	version 1.04 and later.)  An alternate method is to use the argument passed
	to SetAsyncNotification() in ES:DI as a pointer to a structure that is
	accessible from both the main code and the callback.  If DS is not set
	to the data segment of the module, then the functions in CAPI.C do not
	work: Don't use them in the callback.

	The callback will probably be performed at interrupt time with no
	guarantee of reentry to DOS.  Do not use any function, such as putchar()
	or printf(), in the callback which may cause DOS to be called.

	It is good programming practice to do as little as possible in the
	callback.  The setting of event flags which trigger an operation at a
	more stable time is recommended.

	Callback functions do not nest.  The callback function is not called
	while a callback is still in progress, even if other CAPI functions
	are called.

	To alleviate the problems in items 2, 3 and 4 above, a handler is
	provided in CAPI.C which uses the dwHint parameter to pass the address
	of a C-compatible handler, with a stack which is also C-compatible.
	This handler is named AsyncNotificationHandler.  A user handler named
	MyHandler below, is called in the normal way with a stack of 500 bytes
	long.  The stack size value can be set by changing the HANDLER_STACK_SIZE
	constant in CAPI.C.

	Returns
	On success, returns pointer to the previous callback handler.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_SETASYNCNOTIFICATION
DPMI_CB_INFO(async_info);

int D_FAR *SetAsyncNotification(int iSocket, int iEvent,
					int (D_FAR *lpHandler)(), DWORD dwHint)
{

	X86Regs r;
	int iReturn;
	DWORD lpPrevHandler;

	DPMI_CB_ALLOCRETF(async_info, lpHandler, cb_regs);
	if (iNetErrNo == ERR_NO_MEM)
	{
		lpPrevHandler = -1l;
		return (int D_FAR *)lpPrevHandler;
	}

	r.ds = REALMODE_SEGMENT(async_info);
	r.dx = REALMODE_OFFSET(async_info);
	r.si = REALMODE_OFFSET(async_info);

	r.es = (WORD) (dwHint >> 16);
	r.di = (WORD) (dwHint & 0xFFFFL);

	r.bx = iSocket;
	r.cx = iEvent;
	r.ax = SET_ASYNC_NOTIFICATION << 8;


	iReturn = CallSocketsDosApi(&r);
	if(iReturn == -1)
		lpPrevHandler = -1L;
	else
		lpPrevHandler = (long)MAKE_REAL_POINTER(r.ds, r.dx);

	return (int D_FAR *)lpPrevHandler;
}
#endif


/*
	Parameters
	pszName
	Pointer to string containing symbolic name.

	pcCname
	Pointer to buffer to receive canonical name.

	ICnameLen
	Length of buffer pointed to by pcName.

	Description
	Resolves IP address from symbolic name.

	Returns
	On success, returns IP address.
	On failure, 0 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_RESOLVENAME
DWORD ResolveName(char *pszName, char *pszCName, int iCNameLen)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iCName);
	DPMIINFO(iName);

	// iName -> pszName
	// iCName -> pszCName

	DPMIINFO_INIT(iName);
	DPMIINFO_INIT(iCName);

	DPMIINFO_ALLOC(iName, strlen(pszName));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_ALLOC(iCName, iCNameLen);
	if (iNetErrNo == ERR_NO_MEM)
	{
		DPMIINFO_FREE(iName);
		return -1;
	}

	DPMIINFO_SET(iCName, pszCName, iCNameLen);
	DPMIINFO_SET(iName, pszName, strlen(pszName)+1);
	/*
		Pointers within this module may or may not be far
		depending on the memory model used by the compiler.
		The following code will ensure that the far pointer
		passed into Sockets is entirely zero if the offset
		of the pointer is zero.
	*/
	r.dx = REALMODE_OFFSET(iName);
	if(pszName)
	{
		r.ds = REALMODE_SEGMENT(iName);
	}
	else
		r.ds = 0;

	r.di = REALMODE_OFFSET(iCName);
	if(pszCName)
	{
		r.es = REALMODE_SEGMENT(iCName);
	}
	else
		r.es = 0;

	r.cx = iCNameLen;
	r.ax = RESOLVE_NAME << 8;

	iReturn = CallSocketsDosApi(&r);

	// no error, retrieve the string from the transfer buffer
	if (iReturn != -1)
	{
		DPMIINFO_GET(iCName, pszCName, iCNameLen);
	}

	// free the transfer buffers
	DPMIINFO_FREE(iCName);
	DPMIINFO_FREE(iName);

	if (iReturn == -1)
		// if there was an error return 0
		return 0L;
	else
		// return address
		return ((DWORD)r.dx << 16) + r.ax;
}
#endif

/*
	Parameters
	pszName
	Pointer to string containing dotted decimal address.

	Description
	Gets IP address from dotted decimal address.

	Returns
	On success, returns IP address.
	On error, 0 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_PARSEADDRESS
DWORD ParseAddress(char *pszName)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iName);

	DPMIINFO_INIT(iName);
	DPMIINFO_ALLOC(iName, strlen(pszName));
	if (iNetErrNo == ERR_NO_MEM)
		return -1L;
	DPMIINFO_SET(iName, pszName, strlen(pszName)+1);

	r.ds = REALMODE_SEGMENT(iName);
	r.dx = REALMODE_OFFSET(iName);

	r.ax = PARSE_ADDRESS << 8;

	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_FREE(iName);

	if(iReturn == -1)
		return 0L;
	else
		return (((DWORD) r.dx << 16) + r.ax);
}
#endif

/*
	Parameters
	iSocket
	Socket handle for the connection.

	iLevel
	Level of option. This value is ignored.

	iOption
	Option to set.
	NET_OPT_NON_BLOCKING	Set blocking off if dwOptionValue is non-zero.
	NET_OPT_TIMEOUT	Set the timeout to dwOptionValue milliseconds.
			Turn off timeout if dwOptionValue is zero.
	NET_OPT_WAIT_FLUSH	Wait for flush if dwOptionValue is non-zero.

	dwOptionValue
	Option value.

	iLen
	Length of dwOptionValue, 4 in all cases.

	Description
	Sets an option on the socket.

	Returns
	On success, returns global socket.
	On error, -1 with iNetErrNo containing the error code.
*/
#ifdef _CAPI_SETSOCKETOPTION
int SetSocketOption(int iSocket, int iLevel, int iOption,
					DWORD dwOptionValue, int iLen)
{
	X86Regs r;

#ifdef __DJGPP__
	r.ds = (WORD) (dwOptionValue >> 16);
	r.dx = (WORD) (dwOptionValue & 0xFFFFL);
#else
	r.ds = (WORD) (dwOptionValue >> 16);
	r.dx = (WORD) (dwOptionValue & 0xFFFFL);
#endif

	r.bx = iSocket;
	r.cx = iLen;
	r.si = iLevel;
	r.di = iOption;
	r.ax = SET_OPTION << 8;

	return CallSocketsDosApi(&r);
}
#endif

/*
	Parameters
	dwGroupAddress
	The group address on which to receive multicast datagrams.

	dwIPAddress
	The IP adress for the interface to use.  The first interface to be
	specified in SOCKET.CFG is the default interface in the case where
	dwIPAddress == 0.

	Description
	Causes Sockets to join a multicast group.

	Returns
	On success, 0.
	On error, any other integer value contains the error code.
*/
#ifdef _CAPI_JOINGROUP
int JoinGroup(DWORD dwGroupAddress, DWORD dwInterfaceAddress)
{
	X86Regs r;
	GROUP_ADDR sGroupAd;
	GROUP_ADDR *psGroupAd = &sGroupAd ;
	int iReturn;
	DPMIINFO(iGroupAd);

	sGroupAd.dwGroupAddr = dwGroupAddress;
	sGroupAd.dwIFAddr = dwInterfaceAddress;

	DPMIINFO_INIT(iGroupAd);
	DPMIINFO_ALLOC(iGroupAd, sizeof(GROUP_ADDR));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_SET(iGroupAd, psGroupAd, sizeof(GROUP_ADDR));

	r.ds = REALMODE_SEGMENT(iGroupAd);
	r.si = REALMODE_OFFSET(iGroupAd);
	r.ax = JOIN_GROUP << 8;

	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_FREE(iGroupAd);

	return iReturn;

}
#endif

/*
	Parameters
	dwGroupAddress
	The group address on which multicast datagrams are being received.

	dwIPAddress
	The IP adress for the interface being used.  The first interface to be
	specified in SOCKET.CFG is the default interface in the case where
	dwIPAddress == 0.

	Description
	The LeaveGroup() function causes Sockets to leave a multicast group.

	Returns
	On success, returns 0.
	On error, any other integer value contains the error code.
*/
#ifdef _CAPI_LEAVEGROUP
int LeaveGroup(DWORD dwGroupAddress, DWORD dwInterfaceAddress)
{
	X86Regs r;
	GROUP_ADDR sGroupAd;
	GROUP_ADDR *psGroupAd = &sGroupAd;
	int iReturn;
	DPMIINFO(iGroupAd);

	sGroupAd.dwGroupAddr = dwGroupAddress;
	sGroupAd.dwIFAddr = dwInterfaceAddress;

	DPMIINFO_INIT(iGroupAd);
	DPMIINFO_ALLOC(iGroupAd, sizeof(GROUP_ADDR));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_SET(iGroupAd, psGroupAd, sizeof(GROUP_ADDR));

	r.ds = REALMODE_SEGMENT(iGroupAd);
	r.si = REALMODE_OFFSET(iGroupAd);
	r.ax = LEAVE_GROUP << 8;
	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_FREE(iGroupAd);

	return iReturn;
}
#endif

/*
	Parameters
	pszName
	Pointer to interface name.

	WFunction
	Function to perform:
	IOCTL_CONNECT	Start dial operation
	IOCTL_DISCONNECT	Disconnect modem
	IOCTL_ENABLEPORT	Enable communications port
	IOCTL_DISABLEPORT	Disable communications port
	IOCTL_ENABLEDOD	Enable dial-on-demand
	IOCTL_DISABLEDOD	Disable dial-on-demand
	IOCTL_GETSTATUS	Get modem/connection status

	Description
	The IfaceIOCTL function controls asynchronous interfaces.

	Returns
	On success, returns >=0.
	On error, returns -1.

	IOCTL_GETSTATUS returns the following bits:
	ST_DTR	0x01	Data Terminal Ready
	ST_RTS	0x02	Request To Send
	ST_CTS	0x10	Clear To Send
	ST_DSR	0x20	Data Set Ready
	ST_RI	0x40	Ring Indicator
	ST_DCD	0x80	Data Carrier Detect
	ST_CONNECTED	0x100	Modem is connected
	ST_MODEMSTATE	0xe00	Modem state mask
	STM_NONE	0x000	No modem on port
	STM_IDLE	0x200	Modem is idle
	STM_INITIALIZING	0x400	Modem is initializing
	STM_DIALING	0x600	Modem is dialing
	STM_CONNECTING	0x800	Modem is connecting
	STM_ANSWERING	0xa00	Modem is answering
*/
#ifdef _CAPI_IFACEIOCTL
int IfaceIOCTL(char *pszName, WORD wFunction)
{
	X86Regs r;
	int iReturn;
	DPMIINFO(iName);

	DPMIINFO_INIT(iName);
	DPMIINFO_ALLOC(iName, strlen(pszName));
	if (iNetErrNo == ERR_NO_MEM)
		return -1;
	DPMIINFO_SET(iName, pszName, strlen(pszName)+1);

	r.ds = REALMODE_SEGMENT(iName);
	r.si = REALMODE_OFFSET(iName);
	r.ax = (IFACE_IOCTL << 8) + (wFunction & 0x00FF);

	iReturn = CallSocketsDosApi(&r);

	DPMIINFO_FREE(iName);

	return iReturn;
}
#endif

#ifdef _CAPI_ARPAPI
int ArpApi(WORD wFunction,WORD wHardware, DWORD dwIpAddress, void D_FAR **ppArpTab)
{
	X86Regs r;
	int iReturn;

	r.ax = (ARP_API << 8) | wFunction;
	r.bx = wHardware;
	r.cx = (WORD)(dwIpAddress >> 16);
	r.dx = (WORD)dwIpAddress;
	iReturn = CallSocketsDosApi(&r);
	if (ppArpTab) {
		*ppArpTab = (void D_FAR *)MAKE_REAL_POINTER(r.es,r.si);
	}
	return iReturn;
}
#endif

