//
//   $Id: CGIDEMO.C 1.3 2002/10/16 16:57:00 peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	$DOCFILE:CGIDEMO.C

	Copyright (C) 1999-2001 Datalight, Inc.
	All Rights Reserved

	Combined extension CGI program providing:
	"CGI" forms program for Sockets HTTP server
	"CGI" forms data echo program
	"CGI" Page visited counter

	WARNING: This sample has only been tested with the Borland C compiler and may
	need modification if another compiler is used.

	$DOCHISTORY:

   11/02/2001  jmb added check for additional data and to return
                   to wait for more data if data is not available.
	2001-07-14  gvn adapted from CGIFORM, NUM and ECHO
	2001-05-11	gvn cleanup
	2001-05-02	jmb corrected back button to point to caform.htm
	2001-05-01	jmb fixed "back" button to point to cgiform.htm
	2000-05-18	jvn first version
*/

#include <stdio.h>
#include <io.h>
#include <dos.h>
#include <process.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <ctype>
#include "cgiadap.h"


// Make the heap and stack smaller so as not to waste memory when going resident
// _stklen should be at least 1000 + the stack required for the callback
extern unsigned _stklen = 3000;
extern unsigned _heaplen = 2000;

void GoDOS(void);
int far FormCallback(HTTP_PARAMS far* psParams);
int far NumCallback(HTTP_PARAMS far* psParams);
int far EchoCallback(HTTP_PARAMS far* psParams);

FILE *fp;
int number = 0;

void main(int iArgc, char *pArgs[])
{
	char buf[100];

	if(HttpRegister("num.htm", NumCallback, F_OVERLAP, 0) != NONE) {
		printf("Error: cannot register num.htm\n");
		HttpDeRegister("num.htm");
	}
	else if ((fp = fopen("num.htm","rt")) != 0) {
		while (fgets(buf,sizeof(buf),fp) != 0) {
			if (strncmp(buf,"Number=",7) == 0) {
				sscanf(buf + 7,"%d",&number);
				break;
			}
		}
		fclose(fp);
	}

	if(HttpRegister("cgiform.htm", FormCallback, F_OVERLAP | F_ENV, 0) != NONE) {
		printf("Error: cannot register cgiform.htm\n");
		HttpDeRegister("cgiform.htm");
	}

	if(HttpRegister("echo.htm", EchoCallback, F_OVERLAP, 0) != NONE) {
		HttpDeRegister("echo.htm");
		printf("Error: cannot register echo.htm\n");
		exit(-1);
	}

	if (iArgc > 1 && strcmp(pArgs[1], "/t") == 0)
		GoDOS();
	else {
		/*
			PLEASE NOTE: take care when calculating the amount of memory to save
				as different memory models use different memory layouts
		 */
		int iSize = _SS - _psp + (_SP - 1000) / 16 + 1;
		printf("Resident program at %04x, Callback stack at %04x:%04x\n"
				 "Size = %u bytes, 0x%x paragraphs\n",_psp,
				 GetStackSegment(),GetStackPointer(),iSize * 16, iSize);
		keep(0, iSize);//go tsr
	}

	// update num.htm
	if ((fp = fopen("num.htm","wt")) != 0) {
		fprintf(fp,"<html>\n<strong>\nNumber=%d\n</strong>\n</html>",++number);
		fclose(fp);
	}

	printf("Program exiting\n");
	HttpDeRegister("num.htm");
	HttpDeRegister("cgiform.htm");
	HttpDeRegister("echo.htm");
}

// Format of input:
// loginname=gerrit&password=van+niekerk&submit=Submit
// clear=Clear+all

// Forms demo

int check_password(char *pname,char *ppass);

int far FormCallback(HTTP_PARAMS far* psParams)
{
	char buf[200],*p,*pname,*ppass;
	int iReadCount;
	char rgcResponse[400];
	char *pResp = rgcResponse;
	int rc;

	*buf = 0;

  //	printf("There are %d headers\n", psParams->iEnvSize);
  //	for (rc = 0; rc < psParams->iEnvSize; rc++)
  //		printf("header %d = %Fs\n", rc, psParams->ppEnv[rc]);

	iReadCount = _fstrlen(psParams->szQuery);
	if (iReadCount)
		_fmemcpy (buf,psParams->szQuery, iReadCount);
	//read 1 shot would block or buffer full and handle
   rc = HttpGetData(psParams->iHandle, buf + iReadCount, 200 - iReadCount);
   if (rc < 0)
   {
      if (rc == -WOULDBLK)
         return RET_OK;
      else
         goto bad_input;
   }
   iReadCount += rc;

#if 0

11/06/2001 jmb this code could be dangerous.  If all of the data is not
               present, should we wait or give an error?  If all of the
 					data has not been delivered then the code below will catch
					erroneous data.

   if (iReadCount < psParams->lContentLen)
      return RET_OK;

#endif

	pResp += sprintf(pResp, "HTTP/1.0 200 OK\r\nContent-type: text/html\r\n\r\n<html><h1>");
	if (strncmp(buf,"loginname=", 10) == 0) {
		pname = buf + 10;
		if ((p = strchr(pname,'&')) == 0)
			goto bad_input;
		*p++ = 0;
		if ((ppass = strchr(p,'=')) == 0)
			goto bad_input;
		if ((p = strchr(++ppass,'&')) == 0)
			goto bad_input;
		*p = 0;
		if ((rc = check_password(pname,ppass)) < -1)
			pResp += sprintf(pResp, "Sorry %s, we have a system problem",pname);
		else if (rc < 0)
			pResp += sprintf(pResp, "Sorry %s, you entered the wrong password",pname);
		else if (rc == 0)
			pResp += sprintf(pResp, "User %s logged in",pname);
		else
			pResp += sprintf(pResp, "Welcome %s, you are now registered",pname);
	}
	else if (strncmp(buf,"clear=",6) == 0) {
		pResp += sprintf(pResp, "You asked for it!<p>All users cleared out.");
		unlink("users.dat");
	}
	else {
		int iMethod;
		bad_input:
		iMethod = psParams->iValue;
		pResp += sprintf(pResp, "Bad input<p>Method: %s<p>%s<p>",
						iMethod == RQ_GET ? "Get" :
						iMethod == RQ_POST ? "Post" : "Unkown", buf);
		/*
		for (env = environ;*env;env++) {
			printf("%s<p>\n",*env);
		}
		*/
	}
	pResp += sprintf(pResp, "<P><P><A HREF=\"/caform.htm\">Back</A>.</html>\n");
	HttpSendData(psParams->iHandle, rgcResponse, pResp - rgcResponse);
	return RET_DONE;
}

int check_password(char *pname,char *ppass)
{
	FILE *fp;
	char name[40],pass[40], *mode = "r+t";
	int rc = 1;

	if (access("users.dat",0) != 0)
		mode = "w+t";
	if ((fp = fopen("users.dat",mode)) == 0) {
		printf("Fopen error: %s\n", sys_errlist[errno]);

		return -2;
	}
	while (fgets(name,40,fp) != 0) {
		name[strlen(name) - 1] = 0;
		fgets(pass,40,fp);
		pass[strlen(pass) - 1] = 0;
		if (strcmp(pname,name) == 0) {
			rc = strcmp(ppass,pass) ? -1 : 0;
			break;
		}
	}
	if (rc == 1)
		fprintf(fp,"%s\n%s\n",pname,ppass);
	fclose(fp);
	return rc;
}


void GoDOS(void)
{
	char *argvl[2];

	if ((argvl[0] = getenv("COMSPEC")) == 0)
		argvl[0] = "\\COMMAND.COM";
	argvl[1] = 0;
	printf("Type 'exit' to unload program\n");
	spawnvp(P_WAIT,argvl[0],argvl);
}

// Page visited counter

int far NumCallback(HTTP_PARAMS far* psParams)
{
	static char *pXX = 0;
	static char pszResponse[] = "HTTP/1.0 200 OK\r\n"
		"Content-type: text/html\r\n\r\n"
		"<html><h1>This page has been visited XXXXXXX times</h1>"
		"<P><P><A HREF=\"/index.htm\">Back</A>.</html>";

	if (!pXX)
		pXX = strstr(pszResponse, "XXX");
	sprintf(pXX, "%7d", number++);
	pXX[7] = ' ';	//un-terminate
	HttpSendData(psParams->iHandle, pszResponse, strlen(pszResponse));
	return RET_DONE;
}

// Echo forms data

static int iHitcount = 0;

static char *szResponse =
	"HTTP/1.0 200 OK\r\n\r\n"
	"<HTML><TITLE>Welcome %s!</TITLE><BODY bgcolor=green>"
	"<FONT color=blue>"
	"<H1 align=center>A warm welcome to %s!</H1>"
	"<FONT size=5 color=yellow>"
	"<P align=center>"
	"Your call was received at %s"
	"<BR>You are user number <U>%u</U> to call"
	"<BR>Your password is <I>%s</I>"
	"<BR>Your number is <B>%s</B>"
	"<BR><BR>Goodbye!"
	"</P></BODY></HTML>";

void DoResponse(int iHandle, char *szQuery)
{
	char *pName, *pPass, *pNo, *pTerm;
	char szString[400];
	int iSize;
	time_t tNow = time(0);

	//parse string

	pName = strstr(szQuery, "name=") + 5;
	pPass = strstr(szQuery, "pass=") + 5;
	pNo = strstr(szQuery, "number=") + 7;
	pTerm = szQuery;
	while ((pTerm = strchr(pTerm, '&')) != 0)
		*pTerm++ = 0;

	//test username and password for validity

	//test number for validity
	pTerm = pNo;
	while (*pTerm != 0 && isdigit(*pTerm))
		pTerm++;
	if (*pTerm != 0 || pNo == pTerm)	//invalid number
		pNo = "INVALID";
	if (*pName == 0)
		pName = "~Unknown~";
	if (*pPass == 0)
		pPass = "not supplied";

	iSize = sprintf(szString, szResponse, pName, pName, ctime(&tNow),
		++iHitcount, pPass, pNo);

	HttpSendData(iHandle, szString, iSize);
}

int far EchoCallback(HTTP_PARAMS far* psParams)
{
	char arReadbuf[200];
	int iRet;


	iRet = HttpGetData(psParams->iHandle, arReadbuf, 200);
	if (iRet <= 0)
   {
      if (iRet == (-WOULDBLK))
   		return RET_OK;
      else
         return RET_ERR;
   }
   
   // all of the expected data read?
   if (iRet < psParams->lContentLen)
      // no, wait for it all.
      return RET_OK;

	arReadbuf[iRet] = 0;
	DoResponse(psParams->iHandle, arReadbuf);
	return RET_DONE;
}

// Trick startup code into only allocating 20 file handles
unsigned int _nfile = 20;

