//
//   $Id: NUM.C 1.4 2002/10/16 16:57:00 peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	$DOCFILE:NUM.C

	Copyright (C) 1999-2001 Datalight, Inc.
	All Rights Reserved

	Simple "Page visited counter" CGI extension program
	for Sockets HTTP server

	$DOCHISTORY:

	2001-07-14  gvn fixed resident sizes
	2001-05-11	GPvN cleanup
	2000-05-18	GVvN first version
 */

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>

#include "cgiadap.h"

FILE *fp;
int number = 0;

//Make the heap and stack smaller as not to waste memory when going resident
//_stklen should be greater than GetStackPointer() (defualt 1000) for the sake of callbacks
extern unsigned _stklen = 2000;
extern unsigned _heaplen = 1000;

void GoDOS(void);
int far Callback(HTTP_PARAMS far* psParams);

// Page visited counter
void main(int iArgc, char *pArgs[])
{
	char buf[100];

	if(HttpRegister("num.htm", Callback, F_OVERLAP, 0) != NONE) {
		printf("cannot register\n");
		HttpDeRegister("num.htm");
		exit(-1);
	}

	if ((fp = fopen("num.htm","rt")) != 0) {
		while (fgets(buf,sizeof(buf),fp) != 0) {
			if (strncmp(buf,"Number=",7) == 0) {
				sscanf(buf + 7,"%d",&number);
				break;
			}
		}
		fclose(fp);
	}

	if (iArgc > 1 && strcmp(pArgs[1], "/t") == 0)
		GoDOS();
	else {
		/*
			PLEASE NOTE: take care when calculating the amount of memory to save
				as different memory models use different memory layouts
		 */
		int iSize = _SS - _psp + (_SP - 1000) / 16 + 1;
		printf("Resident program at %04x, Callback stack at %04x:%04x\n"
				 "Size = %u bytes, 0x%x paragraphs\n",_psp,
				 GetStackSegment(),GetStackPointer(),iSize * 16, iSize);
		keep(0, iSize);//go tsr
	}

	// update it
	if ((fp = fopen("num.htm","wt")) != 0) {
		fprintf(fp,"<html>\n<strong>\nNumber=%d\n</strong>\n</html>",++number);
		fclose(fp);
	}

	printf("Program exiting\n");
	HttpDeRegister("num.htm");
}

void GoDOS(void)
{
	char *argvl[2];

	if ((argvl[0] = getenv("COMSPEC")) == 0)
		argvl[0] = "\\COMMAND.COM";
	argvl[1] = 0;
	printf("Type 'exit' to unload program\n");
	spawnvp(P_WAIT,argvl[0],argvl);
}




int far Callback(HTTP_PARAMS far* psParams)
{
	static char *pXX = 0;
	static char pszResponse[] = "HTTP/1.0 200 OK\r\n"
		"Content-type: text/html\r\n\r\n"
		"<html><h1>This page has been visited XXXXXXX times</h1>"
		"<P><P><A HREF=\"/index.htm\">Back</A>.</html>";

	if (!pXX)
		pXX = strstr(pszResponse, "XXX");
	sprintf(pXX, "%7d", number++);
	pXX[7] = ' ';	//un-terminate
	HttpSendData(psParams->iHandle, pszResponse, strlen(pszResponse));
	return RET_DONE;
}
