//
//   $Id: SSI.C 1.4 2002/10/16 16:57:00 peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	$DOCFILE:SSI.C

	Copyright (C) 1999-2001 Datalight, Inc.
	All Rights Reserved

	Server Side Include (SSI) demonstration program
	for Sockets HTTP server

	WARNING: This sample has only been tested with the Borland C compiler and may
	need modification if another compiler is used.

	$DOCHISTORY:

   2001-07-14  gvn fixed resident sizes
	2001-05-11	GPvN cleanup
	2000-05-18	GVvN first version
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <process.h>
#include <time.h>
#include "cgiadap.h"
#include "ssi.h"

// Make the heap and stack smaller so as not to waste memory when going resident
// _stklen should be at least 1000 + the stack required for the callback
extern unsigned _stklen = 4000;
extern unsigned _heaplen = 4000;

void GoDOS(void)
{
	char *argvl[2];

	if ((argvl[0] = getenv("COMSPEC")) == 0)
		argvl[0] = "\\COMMAND.COM";
	argvl[1] = 0;
	printf("Type 'exit' to unload program\n");
	spawnvp(P_WAIT,argvl[0],argvl);
}


void main(int iArgc, char *pArgs[])
{
	if(CgiInit("ssi.htm") != OK) {
		printf("Error: can't register ssi.htm\n");
		CgiQuit();
		return;
	}

	if (iArgc > 1 && strcmp(pArgs[1], "/t") == 0)
		GoDOS();
	else {
		int iSize = _SS - _psp + ((_SP + 100)/16);
		printf("Going resident: size = %u bytes\n", iSize * 16);
		keep(0, iSize);//go tsr
	}
	CgiQuit();
	printf("Program exiting\n");
}

//called by ssi interface
void SetVariables(char *pszQuery, int iHandle)
{
	char rgBuf[50];
	long lColor = ((long)random(0x1000) << 12) | (long)random(0x1000) | 0xc0c0c0L;
	time_t tTime = time(0);

	SetFile(iHandle, "template.htm");

	AddVar(iHandle, "bgcolor", ltoa(lColor, rgBuf, 16));
	AddVar(iHandle, "fgcolor", ltoa(lColor & 0x7f3f3fL, rgBuf, 16));
	AddVar(iHandle, "time", ctime(&tTime));
	AddVar(iHandle, "query", pszQuery);
	AddVar(iHandle, "random", itoa(random(1000), rgBuf, 10));
	sprintf(rgBuf, "img%d.jpg", random(6) + 1);
	AddVar(iHandle, "image", rgBuf);
}

