//
//   $Id: FTPTEST.C 1.10 2003/10/01 19:49:32 johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// FTPTEST.C
// Copyright (c) 2001 Datalight, Inc.
// Portions copyright (c) GPvNO 2001
// All Rights Reserved
// Datalight Confidential and Proprietary
//
// Tests for FTPAPI.EXE
//
// Revision History
// 10/01/2003 jmb changed putch to printf to allow ftptest to work
//                on console redirected systems.
// 04/23/2003 gvn handle new status returns
// 06/27/2001 jmb added code to support new PORT command
// 05/21/2001 jmb added MSVC compatibility.
// 04/30/2001 jmb used ROMDOS version number and copyright info.
// 04/30/2001 jmb created header
//
//

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include <ctype.h>
#include "ftpapi.h"

char *get_err(int err);
char *getsw(char *str);
char *getpar(char *ptr);
int send(FTPPar far *pf,int command,int compar);

union REGS r;
FTPPar op;		// open parameters
FTPPar com;		// command parameters

#define NUM_SESSIONS	10
int sessions[NUM_SESSIONS][2];
int current_session;
char szHelp[] =
	"Commands (may be abbreviated):\n"
	"? - this help\n"
	"open <ip address> <username> <password>\n"
	"close [<sesion_number>]\n"
	"connection status\n"
	"exit\n"
	"session [<session_number>]\n"
	"dir [<filespec>]\n"
	"ls [<filespec>]\n"
	"get <remote_filename> [<local_filename>]\n"
	"put <local_filename> [<remote_filename>]\n"
	"append <local_filename> [<remote_filename>]\n"
	"binary\n"
	"ascii\n"
	"port <n>\n"
   "pasv <on>/<off>\n"
	"... any other command is sent verbatim to server\n";
void main(/*int argc,char *argv[]*/)
{
	char buf[80],buf1[80],*p1,*p2,*p3;
	int len,session_number;

	printf("FTP test client/server version 2.12(dt)\n");
	printf("Copyright (C) 1999-2003 Datalight, Inc.\nAll Rights Reserved\n"
			 "Portions copyright (c) GPvNO 2003\n\n");
#ifdef _MSC_VER
	if (_dos_getvect(FTP_INT) == 0) 
#else
	if (getvect(FTP_INT) == 0) 
#endif
	{
		printf("FTPAPI not loaded\n");
		return;
	}
	printf(szHelp);
	while (1) 
	{
		getsw(buf);
		if (!*buf || *buf == '?') 
		{
			printf(szHelp);
			continue;
		}
		strcpy(buf1,buf);
		p1 = getpar(buf);
		p2 = getpar(p1);
		p3 = getpar(p2);
		getpar(p3);
		len = strlen(buf);
		if (strncmp(buf,"open",len) == 0) {
			for (session_number = 0;session_number < NUM_SESSIONS;++session_number) 
			{
				if (sessions[session_number][0] == 0)
					break;
			}
			if (session_number == NUM_SESSIONS) 
			{
				printf("All available sessions in use\n");
				continue;
			}
			op.par1 = p1;
			op.par2 = p2;
			op.par3 = p3;
			if (send(&op,OpenFTPSession,0) == 0) 
			{
				sessions[session_number][0] = op.par5;
				sessions[session_number][1] = op.par6;
				current_session = session_number;
				printf("Session %d ID %04x%04x\n",current_session,
					sessions[current_session][0],sessions[current_session][1]);
			}
		}
		else if (strncmp(buf,"close",len) == 0) 
		{
			send(&com,CloseFTPSession,0);
			sessions[current_session][0] = 0;
			for (session_number = 0;session_number < NUM_SESSIONS;++session_number) 
			{
				if (sessions[session_number][0] != 0)
					break;
			}
			if (session_number == NUM_SESSIONS) 
			{
				printf("All sessions closed\n");
				current_session = 0;
			}
			else 
			{
				current_session = session_number;
				printf("Session %d ID %04x%04x\n",current_session,
					sessions[current_session][0],sessions[current_session][1]);
			}
		}
		else if (strncmp(buf,"exit",len) == 0) 
		{
			for (current_session = 0;current_session < NUM_SESSIONS;++current_session) 
			{
				if (sessions[current_session][0] != 0)
					send(&com,CloseFTPSession,0);
			}
			break;
		}
		else if (strncmp(buf,"connection status",len) == 0) 
		{
			send(0,CallResident,XSF_STATUS);
		}
		else if (strncmp(buf,"session",len) == 0) 
		{
			if (*p1 == 0) 
			{
				printf("Session %d ID %04x%04x\n",current_session,
					sessions[current_session][0],sessions[current_session][1]);
				continue;
			}
			session_number = atoi(p1);
			if (session_number < NUM_SESSIONS) 
			{
				if (sessions[session_number][0] == 0) 
				{
					printf("Session %d is not open\n",session_number);
				}
				else 
				{
					current_session = session_number;
					printf("Session %d ID %04x%04x\n",current_session,
						sessions[current_session][0],sessions[current_session][1]);
				}
			}
			else 
			{
				printf("Invalid session number: %d\n",session_number);
			}
		}
		else if (strncmp(buf,"dir",len) == 0) 
		{
			com.par4 = 1;
			goto dolist;
		}
		else if (strncmp(buf,"ls",len) == 0) 
		{
			com.par4 = 0;
			dolist:
			com.par1 = p1;
			com.par2 = "con";
			send(&com,GetFTPDirectory,0);
		}
		else if (strncmp(buf,"get",len) == 0) 
		{
			com.par1 = p1;
			com.par2 = p2;
			send(&com,GetFTPFile,0);
		}
		else if (strncmp(buf,"put",len) == 0) 
		{
			com.par4 = 0;
			goto doput;
		}
		else if (strncmp(buf,"append",len) == 0) 
		{
			com.par4 = 1;
			doput:
			com.par1 = p1;
			com.par2 = p2;
			send(&com,SendFTPFile,0);
		}
		else if (strncmp(buf,"binary",len) == 0) 
		{
			com.par4 = 1;
			goto set;
		}
		else if (strncmp(buf,"ascii",len) == 0) 
		{
			com.par4 = 0;
			set:
			send(&com,SetFTPType,0);
		}
		else if (strncmp(buf,"port",len) == 0) 
		{
			static int port = 21;

			if (p1)
				port = atoi(p1);
			com.par4 = port;
			send(&com,SetFTPPort,0);
			printf("Port = %u\n",com.par4);
		}
		else if (strnicmp(buf, "pasv", len) == 0)
		{
			static int flag = 1;
			if (p1)
			{
				if (strncmp(p1, "off", strlen(p1)) == 0)
					flag = 0;
				else if (strncmp(p1, "on", strlen(p1)) == 0)
					flag = 1;
				else
				{
					printf("PASV: unknown state -- setting to previous state\n");
				}
			}
			com.par4 = flag;
			send(&com, SetPassiveMode, 0);
			printf("Passive mode: %s.\n", flag ? "ON" : "OFF");
		}
		else 
		{
			com.par1 = buf1;
			send(&com,SendFTPCommmand,0);
		}
	}
}

int send(FTPPar far *pf,int command,int compar)
{
	if (pf) 
	{
		r.x.bx = FP_SEG(pf);
		r.x.cx = FP_OFF(pf);
		pf->par5 = sessions[current_session][0];
		pf->par6 = sessions[current_session][1];
	}
	else
		r.x.bx = r.x.cx = 0;
	r.h.ah = command;
	r.h.al = compar;
	int86(FTP_INT,&r,&r);
	if (r.x.ax)
		printf("Session %d error: %s\n",current_session,get_err(r.x.ax));
	return r.x.ax;
}

char *getpar(char *ptr)
{
	if (ptr == 0)
		return 0;
	while (*ptr) 
	{
		if (*ptr == ' ') 
		{
			*ptr++ = 0;
			break;
		}
		++ptr;
	}
	while (*ptr) 
	{
		if (*ptr != ' ') 
		{
			return ptr;
		}
		++ptr;
	}
	return 0;
}

char StatBuf[100];
FTPPar StatPar = {StatBuf};

char*	getsw(char *str)
{
	static int iPreviousStatus;
	int i = 0;
	int x,y;
	char ch;
	FTPPar far *pStatPar = &StatPar;

	while (1) 
	{
		while(!kbhit()) 
		{
			r.h.ah = CheckFTPStatus;
			r.x.bx = FP_SEG(pStatPar);
			r.x.cx = FP_OFF(pStatPar);

			int86(FTP_INT,&r,&r);
			if ((r.x.ax ^ iPreviousStatus) & FSTAT_SENDINGRECVING) 
			{
				if ((r.x.ax ^ iPreviousStatus) & FSTAT_SENDING)
					printf("Sending %s\n",r.x.ax & FSTAT_SENDING ?
										"started" : "stopped");
				if ((r.x.ax ^ iPreviousStatus) & FSTAT_RECEIVING)
					printf("Receiving %s\n",r.x.ax & FSTAT_RECEIVING ?
										"started" : "stopped");
				iPreviousStatus = r.x.ax;
			}
			switch (r.x.ax & ~FSTAT_SENDINGRECVING) 
			{
			case 0:
				break;
			case FSTAT_LINE_RECEIVED:
				printf("%04x%04x: %s\n",StatPar.par5,StatPar.par6,StatBuf);
				break;
			case FSTAT_RX_OK:
			case FSTAT_TX_OK:
			case FSTAT_RX_ERR:
			case FSTAT_TX_ERR:
				printf("%04x%04x: Server %s: %s\n",StatPar.par5,StatPar.par6,StatBuf,get_err(r.x.ax));
				break;
			default:
				printf("%04x%04x: Status: %s\n",StatPar.par5,StatPar.par6,get_err(r.x.ax));
				break;
			}
		}
		if((ch = getch()) == 0) 
		{
			getch();
			continue;
		}

		if (ch == '\r') 
		{
			str[i] = 0;
         printf("\r");
         printf("\n");
			return str;
		}
		else if (ch == '\b' && i) 
		{
			--i;
         printf("\b");
         printf(" ");
         printf("\b");
		}
		else if (isprint(ch) && i < 79) 
		{
         printf("%c", ch);
			str[i++] = ch;
		}
	}
}

struct errs 
{
	int err;
	char *str;
};

struct errs errstr[] = 
{
	{FSTAT_TX_ERR,				"TX_ERR"},
	{FSTAT_RX_ERR,				"RX_ERR"},
	{FSTAT_TX_OK,				"TX_OK"},
	{FSTAT_RX_OK,				"RX_OK"},
	{FSTAT_LINE_RECEIVED,	"LINE_RECEIVED"},
	{FERR_UNKNOWN_CALL,		"UNKNOWN_CALL"},
	{FERR_SESSION_OPEN,		"SESSION_OPEN"},
	{FERR_SESSION_CLOSED,	"SESSION_CLOSED"},
	{FERR_UNKNOWN_HOST,		"UNKNOWN_HOST"},
	{FERR_NO_MEMORY,			"NO_MEMORY"},
	{FERR_TRANSFERRING,		"TRANSFERRING"},
	{FERR_PARAMETER_ERROR,	"PARAMETER_ERROR"},
	{FERR_FILE_OPEN,			"FILE_OPEN"},
	{FERR_DIR_LIST,			"DIR_LIST"},
	{FERR_CANT_CREATE,		"CANT_CREATE"},
	{0,""}
};

char *get_err(int err)
{
	struct errs *perr;
	static char str[16];

	for (perr = errstr;perr->err;++perr) 
	{
	   if (perr->err == err)
	      return perr->str;
	}
	sprintf(str,"Error %u",err);
	return str;
}
